#!/usr/bin/env node

// Generated by Haxe 4.0.0 (git build development @ 3018ab1)
(function ($global) { "use strict";
var $hxClasses = {},$estr = function() { return js_Boot.__string_rec(this,''); };
function $extend(from, fields) {
	function Inherit() {} Inherit.prototype = from; var proto = new Inherit();
	for (var name in fields) proto[name] = fields[name];
	if( fields.toString !== Object.prototype.toString ) proto.toString = fields.toString;
	return proto;
}
var DateTools = function() { };
$hxClasses["DateTools"] = DateTools;
DateTools.__name__ = ["DateTools"];
DateTools.__format_get = function(d,e) {
	switch(e) {
	case "%":
		return "%";
	case "A":
		return DateTools.DAY_NAMES[d.getDay()];
	case "B":
		return DateTools.MONTH_NAMES[d.getMonth()];
	case "C":
		return StringTools.lpad(Std.string(d.getFullYear() / 100 | 0),"0",2);
	case "D":
		return DateTools.__format(d,"%m/%d/%y");
	case "F":
		return DateTools.__format(d,"%Y-%m-%d");
	case "I":case "l":
		var hour = d.getHours() % 12;
		return StringTools.lpad(Std.string(hour == 0 ? 12 : hour),e == "I" ? "0" : " ",2);
	case "M":
		return StringTools.lpad(Std.string(d.getMinutes()),"0",2);
	case "R":
		return DateTools.__format(d,"%H:%M");
	case "S":
		return StringTools.lpad(Std.string(d.getSeconds()),"0",2);
	case "T":
		return DateTools.__format(d,"%H:%M:%S");
	case "Y":
		return Std.string(d.getFullYear());
	case "a":
		return DateTools.DAY_SHORT_NAMES[d.getDay()];
	case "b":case "h":
		return DateTools.MONTH_SHORT_NAMES[d.getMonth()];
	case "d":
		return StringTools.lpad(Std.string(d.getDate()),"0",2);
	case "e":
		return Std.string(d.getDate());
	case "H":case "k":
		return StringTools.lpad(Std.string(d.getHours()),e == "H" ? "0" : " ",2);
	case "m":
		return StringTools.lpad(Std.string(d.getMonth() + 1),"0",2);
	case "n":
		return "\n";
	case "p":
		if(d.getHours() > 11) {
			return "PM";
		} else {
			return "AM";
		}
		break;
	case "r":
		return DateTools.__format(d,"%I:%M:%S %p");
	case "s":
		return Std.string(d.getTime() / 1000 | 0);
	case "t":
		return "\t";
	case "u":
		var t = d.getDay();
		if(t == 0) {
			return "7";
		} else if(t == null) {
			return "null";
		} else {
			return "" + t;
		}
		break;
	case "w":
		return Std.string(d.getDay());
	case "y":
		return StringTools.lpad(Std.string(d.getFullYear() % 100),"0",2);
	default:
		throw new js__$Boot_HaxeError("Date.format %" + e + "- not implemented yet.");
	}
};
DateTools.__format = function(d,f) {
	var r_b = "";
	var p = 0;
	while(true) {
		var np = f.indexOf("%",p);
		if(np < 0) {
			break;
		}
		var len = np - p;
		r_b += len == null ? HxOverrides.substr(f,p,null) : HxOverrides.substr(f,p,len);
		r_b += Std.string(DateTools.__format_get(d,HxOverrides.substr(f,np + 1,1)));
		p = np + 2;
	}
	var len1 = f.length - p;
	r_b += len1 == null ? HxOverrides.substr(f,p,null) : HxOverrides.substr(f,p,len1);
	return r_b;
};
DateTools.format = function(d,f) {
	return DateTools.__format(d,f);
};
var EReg = function(r,opt) {
	this.r = new RegExp(r,opt.split("u").join(""));
};
$hxClasses["EReg"] = EReg;
EReg.__name__ = ["EReg"];
EReg.prototype = {
	match: function(s) {
		if(this.r.global) {
			this.r.lastIndex = 0;
		}
		this.r.m = this.r.exec(s);
		this.r.s = s;
		return this.r.m != null;
	}
	,matched: function(n) {
		if(this.r.m != null && n >= 0 && n < this.r.m.length) {
			return this.r.m[n];
		} else {
			throw new js__$Boot_HaxeError("EReg::matched");
		}
	}
	,matchedLeft: function() {
		if(this.r.m == null) {
			throw new js__$Boot_HaxeError("No string matched");
		}
		return HxOverrides.substr(this.r.s,0,this.r.m.index);
	}
	,matchedRight: function() {
		if(this.r.m == null) {
			throw new js__$Boot_HaxeError("No string matched");
		}
		var sz = this.r.m.index + this.r.m[0].length;
		return HxOverrides.substr(this.r.s,sz,this.r.s.length - sz);
	}
	,matchedPos: function() {
		if(this.r.m == null) {
			throw new js__$Boot_HaxeError("No string matched");
		}
		return { pos : this.r.m.index, len : this.r.m[0].length};
	}
	,matchSub: function(s,pos,len) {
		if(len == null) {
			len = -1;
		}
		if(this.r.global) {
			this.r.lastIndex = pos;
			this.r.m = this.r.exec(len < 0 ? s : HxOverrides.substr(s,0,pos + len));
			var b = this.r.m != null;
			if(b) {
				this.r.s = s;
			}
			return b;
		} else {
			var b1 = this.match(len < 0 ? HxOverrides.substr(s,pos,null) : HxOverrides.substr(s,pos,len));
			if(b1) {
				this.r.s = s;
				this.r.m.index += pos;
			}
			return b1;
		}
	}
	,map: function(s,f) {
		var offset = 0;
		var buf_b = "";
		while(true) {
			if(offset >= s.length) {
				break;
			} else if(!this.matchSub(s,offset)) {
				buf_b += Std.string(HxOverrides.substr(s,offset,null));
				break;
			}
			var p = this.matchedPos();
			buf_b += Std.string(HxOverrides.substr(s,offset,p.pos - offset));
			buf_b += Std.string(f(this));
			if(p.len == 0) {
				buf_b += Std.string(HxOverrides.substr(s,p.pos,1));
				offset = p.pos + 1;
			} else {
				offset = p.pos + p.len;
			}
			if(!this.r.global) {
				break;
			}
		}
		if(!this.r.global && offset > 0 && offset < s.length) {
			buf_b += Std.string(HxOverrides.substr(s,offset,null));
		}
		return buf_b;
	}
	,__class__: EReg
};
var HxOverrides = function() { };
$hxClasses["HxOverrides"] = HxOverrides;
HxOverrides.__name__ = ["HxOverrides"];
HxOverrides.dateStr = function(date) {
	var m = date.getMonth() + 1;
	var d = date.getDate();
	var h = date.getHours();
	var mi = date.getMinutes();
	var s = date.getSeconds();
	return date.getFullYear() + "-" + (m < 10 ? "0" + m : "" + m) + "-" + (d < 10 ? "0" + d : "" + d) + " " + (h < 10 ? "0" + h : "" + h) + ":" + (mi < 10 ? "0" + mi : "" + mi) + ":" + (s < 10 ? "0" + s : "" + s);
};
HxOverrides.strDate = function(s) {
	var _g = s.length;
	switch(_g) {
	case 8:
		var k = s.split(":");
		var d = new Date();
		d["setTime"](0);
		d["setUTCHours"](k[0]);
		d["setUTCMinutes"](k[1]);
		d["setUTCSeconds"](k[2]);
		return d;
	case 10:
		var k1 = s.split("-");
		return new Date(k1[0],k1[1] - 1,k1[2],0,0,0);
	case 19:
		var k2 = s.split(" ");
		var y = k2[0].split("-");
		var t = k2[1].split(":");
		return new Date(y[0],y[1] - 1,y[2],t[0],t[1],t[2]);
	default:
		throw new js__$Boot_HaxeError("Invalid date format : " + s);
	}
};
HxOverrides.cca = function(s,index) {
	var x = s.charCodeAt(index);
	if(x != x) {
		return undefined;
	}
	return x;
};
HxOverrides.substr = function(s,pos,len) {
	if(len == null) {
		len = s.length;
	} else if(len < 0) {
		if(pos == 0) {
			len = s.length + len;
		} else {
			return "";
		}
	}
	return s.substr(pos,len);
};
HxOverrides.remove = function(a,obj) {
	var i = a.indexOf(obj);
	if(i == -1) {
		return false;
	}
	a.splice(i,1);
	return true;
};
HxOverrides.iter = function(a) {
	return { cur : 0, arr : a, hasNext : function() {
		return this.cur < this.arr.length;
	}, next : function() {
		return this.arr[this.cur++];
	}};
};
var IntIterator = function(min,max) {
	this.min = min;
	this.max = max;
};
$hxClasses["IntIterator"] = IntIterator;
IntIterator.__name__ = ["IntIterator"];
IntIterator.prototype = {
	__class__: IntIterator
};
var Lambda = function() { };
$hxClasses["Lambda"] = Lambda;
Lambda.__name__ = ["Lambda"];
Lambda.has = function(it,elt) {
	var x = $getIterator(it);
	while(x.hasNext()) {
		var x1 = x.next();
		if(x1 == elt) {
			return true;
		}
	}
	return false;
};
Math.__name__ = ["Math"];
var Reflect = function() { };
$hxClasses["Reflect"] = Reflect;
Reflect.__name__ = ["Reflect"];
Reflect.field = function(o,field) {
	try {
		return o[field];
	} catch( e ) {
		var e1 = (e instanceof js__$Boot_HaxeError) ? e.val : e;
		return null;
	}
};
Reflect.fields = function(o) {
	var a = [];
	if(o != null) {
		var hasOwnProperty = Object.prototype.hasOwnProperty;
		for( var f in o ) {
		if(f != "__id__" && f != "hx__closures__" && hasOwnProperty.call(o,f)) {
			a.push(f);
		}
		}
	}
	return a;
};
Reflect.isFunction = function(f) {
	if(typeof(f) == "function") {
		return !(f.__name__ || f.__ename__);
	} else {
		return false;
	}
};
Reflect.compare = function(a,b) {
	if(a == b) {
		return 0;
	} else if(a > b) {
		return 1;
	} else {
		return -1;
	}
};
Reflect.isEnumValue = function(v) {
	if(v != null) {
		return v.__enum__ != null;
	} else {
		return false;
	}
};
Reflect.deleteField = function(o,field) {
	if(!Object.prototype.hasOwnProperty.call(o,field)) {
		return false;
	}
	delete(o[field]);
	return true;
};
Reflect.copy = function(o) {
	var o2 = { };
	var _g = 0;
	var _g1 = Reflect.fields(o);
	while(_g < _g1.length) {
		var f = _g1[_g];
		++_g;
		o2[f] = Reflect.field(o,f);
	}
	return o2;
};
var Std = function() { };
$hxClasses["Std"] = Std;
Std.__name__ = ["Std"];
Std.string = function(s) {
	return js_Boot.__string_rec(s,"");
};
Std.parseInt = function(x) {
	var v = parseInt(x,10);
	if(v == 0 && (HxOverrides.cca(x,1) == 120 || HxOverrides.cca(x,1) == 88)) {
		v = parseInt(x);
	}
	if(isNaN(v)) {
		return null;
	}
	return v;
};
Std.random = function(x) {
	if(x <= 0) {
		return 0;
	} else {
		return Math.floor(Math.random() * x);
	}
};
var StringBuf = function() {
	this.b = "";
};
$hxClasses["StringBuf"] = StringBuf;
StringBuf.__name__ = ["StringBuf"];
StringBuf.prototype = {
	__class__: StringBuf
};
var StringTools = function() { };
$hxClasses["StringTools"] = StringTools;
StringTools.__name__ = ["StringTools"];
StringTools.startsWith = function(s,start) {
	if(s.length >= start.length) {
		return HxOverrides.substr(s,0,start.length) == start;
	} else {
		return false;
	}
};
StringTools.endsWith = function(s,end) {
	var elen = end.length;
	var slen = s.length;
	if(slen >= elen) {
		return HxOverrides.substr(s,slen - elen,elen) == end;
	} else {
		return false;
	}
};
StringTools.isSpace = function(s,pos) {
	var c = HxOverrides.cca(s,pos);
	if(!(c > 8 && c < 14)) {
		return c == 32;
	} else {
		return true;
	}
};
StringTools.ltrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,r)) ++r;
	if(r > 0) {
		return HxOverrides.substr(s,r,l - r);
	} else {
		return s;
	}
};
StringTools.rtrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,l - r - 1)) ++r;
	if(r > 0) {
		return HxOverrides.substr(s,0,l - r);
	} else {
		return s;
	}
};
StringTools.trim = function(s) {
	return StringTools.ltrim(StringTools.rtrim(s));
};
StringTools.lpad = function(s,c,l) {
	if(c.length <= 0) {
		return s;
	}
	while(s.length < l) s = c + s;
	return s;
};
StringTools.replace = function(s,sub,by) {
	return s.split(sub).join(by);
};
StringTools.hex = function(n,digits) {
	var s = "";
	var hexChars = "0123456789ABCDEF";
	while(true) {
		s = hexChars.charAt(n & 15) + s;
		n >>>= 4;
		if(!(n > 0)) {
			break;
		}
	}
	if(digits != null) {
		while(s.length < digits) s = "0" + s;
	}
	return s;
};
StringTools.quoteUnixArg = function(argument) {
	if(argument == "") {
		return "''";
	}
	if(!new EReg("[^a-zA-Z0-9_@%+=:,./-]","").match(argument)) {
		return argument;
	}
	return "'" + StringTools.replace(argument,"'","'\"'\"'") + "'";
};
StringTools.quoteWinArg = function(argument,escapeMetaCharacters) {
	if(!new EReg("^[^ \t\\\\\"]+$","").match(argument)) {
		var result_b = "";
		var needquote = argument.indexOf(" ") != -1 || argument.indexOf("\t") != -1 || argument == "";
		if(needquote) {
			result_b += "\"";
		}
		var bs_buf = new StringBuf();
		var _g1 = 0;
		var _g = argument.length;
		while(_g1 < _g) {
			var i = _g1++;
			var _g2 = HxOverrides.cca(argument,i);
			if(_g2 == null) {
				var c = _g2;
				if(bs_buf.b.length > 0) {
					result_b += Std.string(bs_buf.b);
					bs_buf = new StringBuf();
				}
				result_b += String.fromCharCode(c);
			} else {
				switch(_g2) {
				case 34:
					var bs = bs_buf.b;
					result_b += bs == null ? "null" : "" + bs;
					result_b += bs == null ? "null" : "" + bs;
					bs_buf = new StringBuf();
					result_b += "\\\"";
					break;
				case 92:
					bs_buf.b += "\\";
					break;
				default:
					var c1 = _g2;
					if(bs_buf.b.length > 0) {
						result_b += Std.string(bs_buf.b);
						bs_buf = new StringBuf();
					}
					result_b += String.fromCharCode(c1);
				}
			}
		}
		result_b += Std.string(bs_buf.b);
		if(needquote) {
			result_b += Std.string(bs_buf.b);
			result_b += "\"";
		}
		argument = result_b;
	}
	if(escapeMetaCharacters) {
		var result_b1 = "";
		var _g11 = 0;
		var _g3 = argument.length;
		while(_g11 < _g3) {
			var i1 = _g11++;
			var c2 = HxOverrides.cca(argument,i1);
			if(StringTools.winMetaCharacters.indexOf(c2) >= 0) {
				result_b1 += "^";
			}
			result_b1 += String.fromCharCode(c2);
		}
		return result_b1;
	} else {
		return argument;
	}
};
var Sys = function() { };
$hxClasses["Sys"] = Sys;
Sys.__name__ = ["Sys"];
Sys.println = function(v) {
	process.stdout.write(Std.string(v));
	process.stdout.write("\n");
};
Sys.systemName = function() {
	var _g = process.platform;
	switch(_g) {
	case "darwin":
		return "Mac";
	case "freebsd":
		return "BSD";
	case "linux":
		return "Linux";
	case "win32":
		return "Windows";
	default:
		var other = _g;
		return other;
	}
};
var haxe_io_Output = function() { };
$hxClasses["haxe.io.Output"] = haxe_io_Output;
haxe_io_Output.__name__ = ["haxe","io","Output"];
haxe_io_Output.prototype = {
	writeByte: function(c) {
		throw new js__$Boot_HaxeError("Not implemented");
	}
	,writeBytes: function(s,pos,len) {
		if(pos < 0 || len < 0 || pos + len > s.length) {
			throw new js__$Boot_HaxeError(haxe_io_Error.OutsideBounds);
		}
		var b = s.b;
		var k = len;
		while(k > 0) {
			this.writeByte(b[pos]);
			++pos;
			--k;
		}
		return len;
	}
	,writeFullBytes: function(s,pos,len) {
		while(len > 0) {
			var k = this.writeBytes(s,pos,len);
			pos += k;
			len -= k;
		}
	}
	,writeString: function(s) {
		var b = haxe_io_Bytes.ofString(s);
		this.writeFullBytes(b,0,b.length);
	}
	,__class__: haxe_io_Output
};
var _$Sys_FileOutput = function(fd) {
	this.fd = fd;
};
$hxClasses["_Sys.FileOutput"] = _$Sys_FileOutput;
_$Sys_FileOutput.__name__ = ["_Sys","FileOutput"];
_$Sys_FileOutput.__super__ = haxe_io_Output;
_$Sys_FileOutput.prototype = $extend(haxe_io_Output.prototype,{
	writeByte: function(c) {
		js_node_Fs.writeSync(this.fd,String.fromCharCode(c));
	}
	,writeBytes: function(s,pos,len) {
		var data = s.b;
		return js_node_Fs.writeSync(this.fd,new js_node_buffer_Buffer(data.buffer,data.byteOffset,s.length),pos,len);
	}
	,writeString: function(s) {
		js_node_Fs.writeSync(this.fd,s);
	}
	,__class__: _$Sys_FileOutput
});
var ValueType = $hxClasses["ValueType"] = { __ename__ : ["ValueType"], __constructs__ : ["TNull","TInt","TFloat","TBool","TObject","TFunction","TClass","TEnum","TUnknown"] };
ValueType.TNull = ["TNull",0];
ValueType.TNull.toString = $estr;
ValueType.TNull.__enum__ = ValueType;
ValueType.TInt = ["TInt",1];
ValueType.TInt.toString = $estr;
ValueType.TInt.__enum__ = ValueType;
ValueType.TFloat = ["TFloat",2];
ValueType.TFloat.toString = $estr;
ValueType.TFloat.__enum__ = ValueType;
ValueType.TBool = ["TBool",3];
ValueType.TBool.toString = $estr;
ValueType.TBool.__enum__ = ValueType;
ValueType.TObject = ["TObject",4];
ValueType.TObject.toString = $estr;
ValueType.TObject.__enum__ = ValueType;
ValueType.TFunction = ["TFunction",5];
ValueType.TFunction.toString = $estr;
ValueType.TFunction.__enum__ = ValueType;
ValueType.TClass = function(c) { var $x = ["TClass",6,c]; $x.__enum__ = ValueType; $x.toString = $estr; return $x; };
ValueType.TEnum = function(e) { var $x = ["TEnum",7,e]; $x.__enum__ = ValueType; $x.toString = $estr; return $x; };
ValueType.TUnknown = ["TUnknown",8];
ValueType.TUnknown.toString = $estr;
ValueType.TUnknown.__enum__ = ValueType;
var Type = function() { };
$hxClasses["Type"] = Type;
Type.__name__ = ["Type"];
Type.getClassName = function(c) {
	var a = c.__name__;
	if(a == null) {
		return null;
	}
	return a.join(".");
};
Type.getEnumName = function(e) {
	var a = e.__ename__;
	return a.join(".");
};
Type.resolveClass = function(name) {
	var cl = $hxClasses[name];
	if(cl == null || !cl.__name__) {
		return null;
	}
	return cl;
};
Type.resolveEnum = function(name) {
	var e = $hxClasses[name];
	if(e == null || !e.__ename__) {
		return null;
	}
	return e;
};
Type.createEnum = function(e,constr,params) {
	var f = Reflect.field(e,constr);
	if(f == null) {
		throw new js__$Boot_HaxeError("No such constructor " + constr);
	}
	if(Reflect.isFunction(f)) {
		if(params == null) {
			throw new js__$Boot_HaxeError("Constructor " + constr + " need parameters");
		}
		return f.apply(e,params);
	}
	if(params != null && params.length != 0) {
		throw new js__$Boot_HaxeError("Constructor " + constr + " does not need parameters");
	}
	return f;
};
Type["typeof"] = function(v) {
	var _g = typeof(v);
	switch(_g) {
	case "boolean":
		return ValueType.TBool;
	case "function":
		if(v.__name__ || v.__ename__) {
			return ValueType.TObject;
		}
		return ValueType.TFunction;
	case "number":
		if(Math.ceil(v) == v % 2147483648.0) {
			return ValueType.TInt;
		}
		return ValueType.TFloat;
	case "object":
		if(v == null) {
			return ValueType.TNull;
		}
		var e = v.__enum__;
		if(e != null) {
			return ValueType.TEnum(e);
		}
		var c = js_Boot.getClass(v);
		if(c != null) {
			return ValueType.TClass(c);
		}
		return ValueType.TObject;
	case "string":
		return ValueType.TClass(String);
	case "undefined":
		return ValueType.TNull;
	default:
		return ValueType.TUnknown;
	}
};
var archive_Archiver = function() { };
$hxClasses["archive.Archiver"] = archive_Archiver;
archive_Archiver.__name__ = ["archive","Archiver"];
archive_Archiver.prototype = {
	__class__: archive_Archiver
};
var archive_Scanner = function() { };
$hxClasses["archive.Scanner"] = archive_Scanner;
archive_Scanner.__name__ = ["archive","Scanner"];
archive_Scanner.prototype = {
	__class__: archive_Scanner
};
var archive_scanner_AsysScanner = function(path,root) {
	this.path = path;
	this.root = root == null ? haxe_io_Path.withoutDirectory(path) : root;
};
$hxClasses["archive.scanner.AsysScanner"] = archive_scanner_AsysScanner;
archive_scanner_AsysScanner.__name__ = ["archive","scanner","AsysScanner"];
archive_scanner_AsysScanner.__interfaces__ = [archive_Scanner];
archive_scanner_AsysScanner.prototype = {
	scan: function() {
		return tink_streams__$Stream_Stream_$Impl_$.promise(tink_core__$Promise_Promise_$Impl_$.next(this._scan(this.path,this.root),function(entries) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_streams__$Stream_Stream_$Impl_$.ofIterator(HxOverrides.iter(entries))));
		}));
	}
	,_scan: function(directory,root) {
		var _gthis = this;
		var ret = [];
		return tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Promise_Promise_$Impl_$.next(asys_FileSystem.readDirectory(directory),function(files) {
			var _g = [];
			var _g1 = 0;
			while(_g1 < files.length) {
				var f = files[_g1];
				++_g1;
				var path = [haxe_io_Path.join([directory,f])];
				var relativePath = [haxe_io_Path.join([root,f])];
				_g.push(tink_core__$Future_Future_$Impl_$.next(asys_FileSystem.isDirectory(path[0]),(function(relativePath1,path1) {
					return function(isDir) {
						if(isDir) {
							return tink_core__$Promise_Promise_$Impl_$.next(_gthis._scan(path1[0],relativePath1[0]),(function() {
								return function(entries) {
									ret = ret.concat(entries);
									return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
								};
							})());
						} else {
							return tink_core__$Promise_Promise_$Impl_$.next(asys_FileSystem.stat(path1[0]),(function(relativePath2,path2) {
								return function(stat) {
									var relativePath3 = relativePath2[0];
									var stat1 = stat.size;
									var stat2 = stat.mode;
									var stat3 = stat.mtime;
									var stat4 = stat.uid;
									var stat5 = stat.gid;
									var tmp = asys_io_File.readStream(path2[0]);
									ret.push({ name : relativePath3, size : stat1, mode : stat2, mtime : stat3, uid : stat4, gid : stat5, source : tmp});
									return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
								};
							})(relativePath1,path1));
						}
					};
				})(relativePath,path)));
			}
			return tink_core__$Promise_Promise_$Impl_$.inParallel(_g);
		}),function(_) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(ret));
		});
	}
	,__class__: archive_scanner_AsysScanner
};
var archive_zip_Zip = function() { };
$hxClasses["archive.zip.Zip"] = archive_zip_Zip;
archive_zip_Zip.__name__ = ["archive","zip","Zip"];
archive_zip_Zip.__interfaces__ = [archive_Archiver];
var archive_zip_NodeZip = function() {
};
$hxClasses["archive.zip.NodeZip"] = archive_zip_NodeZip;
archive_zip_NodeZip.__name__ = ["archive","zip","NodeZip"];
archive_zip_NodeZip.__interfaces__ = [archive_zip_Zip];
archive_zip_NodeZip.prototype = {
	pack: function(files) {
		var pack = require("archiver")("zip",{ zlib : { level : 9}});
		files.forEach(tink_streams__$Stream_Handler_$Impl_$.ofSafe(function(file) {
			pack.append(tink_io__$Source_Source_$Impl_$.toNodeStream(file.source),{ name : file.name, stats : { size : file.size}});
			return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_streams_Handled.Resume));
		})).handle(function(o) {
			switch(o[1]) {
			case 0:
				throw new js__$Boot_HaxeError("unreachable");
			case 2:
				var e = o[2];
				pack.emit("error",new Error(e.message));
				break;
			case 3:
				pack.finalize();
				break;
			}
		});
		var options = null;
		if(options == null) {
			options = { };
		}
		return tink_io_nodejs_NodejsSource.wrap("Zip package",pack,options.chunkSize,options.onEnd);
	}
	,__class__: archive_zip_NodeZip
};
var asys_FileSystem = function() { };
$hxClasses["asys.FileSystem"] = asys_FileSystem;
asys_FileSystem.__name__ = ["asys","FileSystem"];
asys_FileSystem.stat = function(path) {
	var trigger = new tink_core_FutureTrigger();
	js_node_Fs.stat(path,function(err,stat) {
		var tmp = err == null ? tink_core_Outcome.Success({ gid : stat.gid, uid : stat.uid, atime : stat.atime, mtime : stat.mtime, ctime : stat.ctime, size : stat.size | 0, dev : stat.dev, ino : stat.ino | 0, nlink : stat.nlink, rdev : stat.rdev, mode : stat.mode}) : tink_core_Outcome.Failure(tink_core_TypedError.withData(null,err.message,err,{ fileName : "asys/FileSystem.hx", lineNumber : 52, className : "asys.FileSystem", methodName : "stat"}));
		trigger.trigger(tmp);
	});
	return trigger;
};
asys_FileSystem.isDirectory = function(path) {
	var trigger = new tink_core_FutureTrigger();
	js_node_Fs.stat(path,function(err,stat) {
		var tmp = err == null && stat.isDirectory();
		trigger.trigger(tmp);
	});
	return trigger;
};
asys_FileSystem.readDirectory = function(path) {
	var trigger = new tink_core_FutureTrigger();
	js_node_Fs.readdir(path,function(err,files) {
		var tmp = err == null ? tink_core_Outcome.Success(files) : tink_core_Outcome.Failure(tink_core_TypedError.withData(null,err.message,err,{ fileName : "asys/FileSystem.hx", lineNumber : 143, className : "asys.FileSystem", methodName : "readDirectory"}));
		trigger.trigger(tmp);
	});
	return trigger;
};
var asys_io_File = function() { };
$hxClasses["asys.io.File"] = asys_io_File;
asys_io_File.__name__ = ["asys","io","File"];
asys_io_File.readStream = function(path,binary) {
	if(binary == null) {
		binary = true;
	}
	var r = js_node_Fs.createReadStream(path);
	var options = null;
	if(options == null) {
		options = { };
	}
	return tink_io_nodejs_NodejsSource.wrap("asys read stream",r,options.chunkSize,options.onEnd);
};
asys_io_File.getContent = function(path) {
	var trigger = new tink_core_FutureTrigger();
	js_node_Fs.readFile(path,"utf8",function(err,data) {
		var tmp = err == null ? tink_core_Outcome.Success(data) : tink_core_Outcome.Failure(tink_core_TypedError.withData(null,err.message,err,{ fileName : "asys/io/File.hx", lineNumber : 40, className : "asys.io.File", methodName : "getContent"}));
		trigger.trigger(tmp);
	});
	return trigger;
};
var aws_cognito_CognitoAuth = require("amazon-cognito-auth-js").CognitoAuth;
var haxe_StackItem = $hxClasses["haxe.StackItem"] = { __ename__ : ["haxe","StackItem"], __constructs__ : ["CFunction","Module","FilePos","Method","LocalFunction"] };
haxe_StackItem.CFunction = ["CFunction",0];
haxe_StackItem.CFunction.toString = $estr;
haxe_StackItem.CFunction.__enum__ = haxe_StackItem;
haxe_StackItem.Module = function(m) { var $x = ["Module",1,m]; $x.__enum__ = haxe_StackItem; $x.toString = $estr; return $x; };
haxe_StackItem.FilePos = function(s,file,line,column) { var $x = ["FilePos",2,s,file,line,column]; $x.__enum__ = haxe_StackItem; $x.toString = $estr; return $x; };
haxe_StackItem.Method = function(classname,method) { var $x = ["Method",3,classname,method]; $x.__enum__ = haxe_StackItem; $x.toString = $estr; return $x; };
haxe_StackItem.LocalFunction = function(v) { var $x = ["LocalFunction",4,v]; $x.__enum__ = haxe_StackItem; $x.toString = $estr; return $x; };
var haxe_IMap = function() { };
$hxClasses["haxe.IMap"] = haxe_IMap;
haxe_IMap.__name__ = ["haxe","IMap"];
var haxe_Http = function(url) {
	this.params = [];
	this.headers = { };
	this.url = tink__$Url_Url_$Impl_$.fromString(url);
};
$hxClasses["haxe.Http"] = haxe_Http;
haxe_Http.__name__ = ["haxe","Http"];
haxe_Http.prototype = {
	setHeader: function(header,value) {
		var _g = this.headers[header];
		if(_g == null) {
			this.headers[header] = [value];
		} else {
			var v = _g;
			v.push(value);
		}
		return this;
	}
	,setPostData: function(data) {
		this.rawPostData = data;
	}
	,setParameter: function(header,value) {
		var this1 = this.params;
		this1.push(tink_url__$Portion_Portion_$Impl_$.ofString(header) + "=" + tink_url__$Portion_Portion_$Impl_$.ofString(value));
		return this;
	}
	,onData: function(s) {
	}
	,onError: function(s) {
	}
	,onStatus: function(i) {
	}
	,request: function(post) {
		var _gthis = this;
		if(this.rawPostData != null) {
			post = true;
		}
		if(post == null) {
			post = false;
		}
		var params = this.params.join("&");
		var _g = this.url.scheme;
		var tmp = tink_url__$Host_Host_$Impl_$.get_name(this.url.host);
		var tmp1 = tink_url__$Host_Host_$Impl_$.get_port(this.url.host);
		var this1 = this.url;
		var tmp2;
		if(params == "") {
			tmp2 = "";
		} else if(post == null) {
			var v = params;
			tmp2 = (this.url.query == null ? "?" : "&") + v;
		} else if(post == true) {
			tmp2 = "";
		} else {
			var v1 = params;
			tmp2 = (this.url.query == null ? "?" : "&") + v1;
		}
		var _g2 = this.rawPostData;
		var tmp3;
		if(_g2 == null) {
			tmp3 = post ? params : null;
		} else {
			var v2 = _g2;
			tmp3 = v2;
		}
		(_g == null ? js_node_Http.request : _g == "https" ? js_node_Https.request : js_node_Http.request)({ hostname : tmp, port : tmp1, protocol : this.url.scheme + ":", method : post ? "POST" : "GET", path : (this1.query == null ? this1.path : this1.path + "?" + this1.query) + tmp2, headers : this.headers},function(res) {
			var parts = [];
			res.on("end",function() {
				_gthis.onData(js_node_buffer_Buffer.concat(parts).toString());
			});
			res.on("data",$bind(parts,$arrayPush));
			res.on("error",function(e) {
				_gthis.onError(Std.string(e));
			});
		}).on("error",function(e1) {
			_gthis.onError(Std.string(e1));
		}).end(tmp3);
	}
	,__class__: haxe_Http
};
var haxe_Serializer = function() {
	this.buf = new StringBuf();
	this.cache = [];
	this.useCache = haxe_Serializer.USE_CACHE;
	this.useEnumIndex = haxe_Serializer.USE_ENUM_INDEX;
	this.shash = new haxe_ds_StringMap();
	this.scount = 0;
};
$hxClasses["haxe.Serializer"] = haxe_Serializer;
haxe_Serializer.__name__ = ["haxe","Serializer"];
haxe_Serializer.prototype = {
	toString: function() {
		return this.buf.b;
	}
	,serializeString: function(s) {
		var _this = this.shash;
		var x = __map_reserved[s] != null ? _this.getReserved(s) : _this.h[s];
		if(x != null) {
			this.buf.b += "R";
			this.buf.b += x == null ? "null" : "" + x;
			return;
		}
		var _this1 = this.shash;
		var value = this.scount++;
		if(__map_reserved[s] != null) {
			_this1.setReserved(s,value);
		} else {
			_this1.h[s] = value;
		}
		this.buf.b += "y";
		s = encodeURIComponent(s);
		this.buf.b += Std.string(s.length);
		this.buf.b += ":";
		this.buf.b += s == null ? "null" : "" + s;
	}
	,serializeRef: function(v) {
		var vt = typeof(v);
		var _g1 = 0;
		var _g = this.cache.length;
		while(_g1 < _g) {
			var i = _g1++;
			var ci = this.cache[i];
			if(typeof(ci) == vt && ci == v) {
				this.buf.b += "r";
				this.buf.b += i == null ? "null" : "" + i;
				return true;
			}
		}
		this.cache.push(v);
		return false;
	}
	,serializeFields: function(v) {
		var _g = 0;
		var _g1 = Reflect.fields(v);
		while(_g < _g1.length) {
			var f = _g1[_g];
			++_g;
			this.serializeString(f);
			this.serialize(Reflect.field(v,f));
		}
		this.buf.b += "g";
	}
	,serialize: function(v) {
		var _g = Type["typeof"](v);
		switch(_g[1]) {
		case 0:
			this.buf.b += "n";
			break;
		case 1:
			var v1 = v;
			if(v1 == 0) {
				this.buf.b += "z";
				return;
			}
			this.buf.b += "i";
			this.buf.b += v1 == null ? "null" : "" + v1;
			break;
		case 2:
			var v2 = v;
			if(isNaN(v2)) {
				this.buf.b += "k";
			} else if(!isFinite(v2)) {
				this.buf.b += v2 < 0 ? "m" : "p";
			} else {
				this.buf.b += "d";
				this.buf.b += v2 == null ? "null" : "" + v2;
			}
			break;
		case 3:
			this.buf.b += v ? "t" : "f";
			break;
		case 4:
			if(js_Boot.__instanceof(v,Class)) {
				var className = Type.getClassName(v);
				this.buf.b += "A";
				this.serializeString(className);
			} else if(js_Boot.__instanceof(v,Enum)) {
				this.buf.b += "B";
				this.serializeString(Type.getEnumName(v));
			} else {
				if(this.useCache && this.serializeRef(v)) {
					return;
				}
				this.buf.b += "o";
				this.serializeFields(v);
			}
			break;
		case 5:
			throw new js__$Boot_HaxeError("Cannot serialize function");
		case 6:
			var c = _g[2];
			if(c == String) {
				this.serializeString(v);
				return;
			}
			if(this.useCache && this.serializeRef(v)) {
				return;
			}
			switch(c) {
			case Array:
				var ucount = 0;
				this.buf.b += "a";
				var l = v["length"];
				var _g1 = 0;
				var _g2 = l;
				while(_g1 < _g2) {
					var i = _g1++;
					if(v[i] == null) {
						++ucount;
					} else {
						if(ucount > 0) {
							if(ucount == 1) {
								this.buf.b += "n";
							} else {
								this.buf.b += "u";
								this.buf.b += ucount == null ? "null" : "" + ucount;
							}
							ucount = 0;
						}
						this.serialize(v[i]);
					}
				}
				if(ucount > 0) {
					if(ucount == 1) {
						this.buf.b += "n";
					} else {
						this.buf.b += "u";
						this.buf.b += ucount == null ? "null" : "" + ucount;
					}
				}
				this.buf.b += "h";
				break;
			case Date:
				var d = v;
				this.buf.b += "v";
				this.buf.b += Std.string(d.getTime());
				break;
			case haxe_ds_IntMap:
				this.buf.b += "q";
				var v3 = v;
				var k = v3.keys();
				while(k.hasNext()) {
					var k1 = k.next();
					this.buf.b += ":";
					this.buf.b += k1 == null ? "null" : "" + k1;
					this.serialize(v3.h[k1]);
				}
				this.buf.b += "h";
				break;
			case haxe_ds_List:
				this.buf.b += "l";
				var v4 = v;
				var _g_head = v4.h;
				while(_g_head != null) {
					var val = _g_head.item;
					_g_head = _g_head.next;
					var i1 = val;
					this.serialize(i1);
				}
				this.buf.b += "h";
				break;
			case haxe_ds_ObjectMap:
				this.buf.b += "M";
				var v5 = v;
				var k2 = v5.keys();
				while(k2.hasNext()) {
					var k3 = k2.next();
					var id = Reflect.field(k3,"__id__");
					Reflect.deleteField(k3,"__id__");
					this.serialize(k3);
					k3["__id__"] = id;
					this.serialize(v5.h[k3.__id__]);
				}
				this.buf.b += "h";
				break;
			case haxe_ds_StringMap:
				this.buf.b += "b";
				var v6 = v;
				var k4 = v6.keys();
				while(k4.hasNext()) {
					var k5 = k4.next();
					this.serializeString(k5);
					this.serialize(__map_reserved[k5] != null ? v6.getReserved(k5) : v6.h[k5]);
				}
				this.buf.b += "h";
				break;
			case haxe_io_Bytes:
				var v7 = v;
				this.buf.b += "s";
				this.buf.b += Std.string(Math.ceil(v7.length * 8 / 6));
				this.buf.b += ":";
				var i2 = 0;
				var max = v7.length - 2;
				var b64 = haxe_Serializer.BASE64_CODES;
				if(b64 == null) {
					var this1 = new Array(haxe_Serializer.BASE64.length);
					b64 = this1;
					var _g11 = 0;
					var _g3 = haxe_Serializer.BASE64.length;
					while(_g11 < _g3) {
						var i3 = _g11++;
						b64[i3] = HxOverrides.cca(haxe_Serializer.BASE64,i3);
					}
					haxe_Serializer.BASE64_CODES = b64;
				}
				while(i2 < max) {
					var b1 = v7.b[i2++];
					var b2 = v7.b[i2++];
					var b3 = v7.b[i2++];
					this.buf.b += String.fromCharCode(b64[b1 >> 2]);
					this.buf.b += String.fromCharCode(b64[(b1 << 4 | b2 >> 4) & 63]);
					this.buf.b += String.fromCharCode(b64[(b2 << 2 | b3 >> 6) & 63]);
					this.buf.b += String.fromCharCode(b64[b3 & 63]);
				}
				if(i2 == max) {
					var b11 = v7.b[i2++];
					var b21 = v7.b[i2++];
					this.buf.b += String.fromCharCode(b64[b11 >> 2]);
					this.buf.b += String.fromCharCode(b64[(b11 << 4 | b21 >> 4) & 63]);
					this.buf.b += String.fromCharCode(b64[b21 << 2 & 63]);
				} else if(i2 == max + 1) {
					var b12 = v7.b[i2++];
					this.buf.b += String.fromCharCode(b64[b12 >> 2]);
					this.buf.b += String.fromCharCode(b64[b12 << 4 & 63]);
				}
				break;
			default:
				if(this.useCache) {
					this.cache.pop();
				}
				if(v.hxSerialize != null) {
					this.buf.b += "C";
					this.serializeString(Type.getClassName(c));
					if(this.useCache) {
						this.cache.push(v);
					}
					v.hxSerialize(this);
					this.buf.b += "g";
				} else {
					this.buf.b += "c";
					this.serializeString(Type.getClassName(c));
					if(this.useCache) {
						this.cache.push(v);
					}
					this.serializeFields(v);
				}
			}
			break;
		case 7:
			var e = _g[2];
			if(this.useCache) {
				if(this.serializeRef(v)) {
					return;
				}
				this.cache.pop();
			}
			this.buf.b += Std.string(this.useEnumIndex ? "j" : "w");
			this.serializeString(Type.getEnumName(e));
			if(this.useEnumIndex) {
				this.buf.b += ":";
				this.buf.b += Std.string(v[1]);
			} else {
				this.serializeString(v[0]);
			}
			this.buf.b += ":";
			var l1 = v["length"];
			this.buf.b += Std.string(l1 - 2);
			var _g12 = 2;
			var _g4 = l1;
			while(_g12 < _g4) {
				var i4 = _g12++;
				this.serialize(v[i4]);
			}
			if(this.useCache) {
				this.cache.push(v);
			}
			break;
		default:
			throw new js__$Boot_HaxeError("Cannot serialize " + Std.string(v));
		}
	}
	,__class__: haxe_Serializer
};
var haxe_Timer = function(time_ms) {
	var me = this;
	this.id = setInterval(function() {
		me.run();
	},time_ms);
};
$hxClasses["haxe.Timer"] = haxe_Timer;
haxe_Timer.__name__ = ["haxe","Timer"];
haxe_Timer.delay = function(f,time_ms) {
	var t = new haxe_Timer(time_ms);
	t.run = function() {
		t.stop();
		f();
	};
	return t;
};
haxe_Timer.prototype = {
	stop: function() {
		if(this.id == null) {
			return;
		}
		clearInterval(this.id);
		this.id = null;
	}
	,run: function() {
	}
	,__class__: haxe_Timer
};
var haxe__$Unserializer_DefaultResolver = function() {
};
$hxClasses["haxe._Unserializer.DefaultResolver"] = haxe__$Unserializer_DefaultResolver;
haxe__$Unserializer_DefaultResolver.__name__ = ["haxe","_Unserializer","DefaultResolver"];
haxe__$Unserializer_DefaultResolver.prototype = {
	resolveClass: function(name) {
		return Type.resolveClass(name);
	}
	,resolveEnum: function(name) {
		return Type.resolveEnum(name);
	}
	,__class__: haxe__$Unserializer_DefaultResolver
};
var haxe_Unserializer = function(buf) {
	this.buf = buf;
	this.length = buf.length;
	this.pos = 0;
	this.scache = [];
	this.cache = [];
	var r = haxe_Unserializer.DEFAULT_RESOLVER;
	if(r == null) {
		r = new haxe__$Unserializer_DefaultResolver();
		haxe_Unserializer.DEFAULT_RESOLVER = r;
	}
	this.resolver = r;
};
$hxClasses["haxe.Unserializer"] = haxe_Unserializer;
haxe_Unserializer.__name__ = ["haxe","Unserializer"];
haxe_Unserializer.initCodes = function() {
	var codes = [];
	var _g1 = 0;
	var _g = haxe_Unserializer.BASE64.length;
	while(_g1 < _g) {
		var i = _g1++;
		codes[haxe_Unserializer.BASE64.charCodeAt(i)] = i;
	}
	return codes;
};
haxe_Unserializer.prototype = {
	readDigits: function() {
		var k = 0;
		var s = false;
		var fpos = this.pos;
		while(true) {
			var c = this.buf.charCodeAt(this.pos);
			if(c != c) {
				break;
			}
			if(c == 45) {
				if(this.pos != fpos) {
					break;
				}
				s = true;
				this.pos++;
				continue;
			}
			if(c < 48 || c > 57) {
				break;
			}
			k = k * 10 + (c - 48);
			this.pos++;
		}
		if(s) {
			k *= -1;
		}
		return k;
	}
	,readFloat: function() {
		var p1 = this.pos;
		while(true) {
			var c = this.buf.charCodeAt(this.pos);
			if(c != c) {
				break;
			}
			if(c >= 43 && c < 58 || c == 101 || c == 69) {
				this.pos++;
			} else {
				break;
			}
		}
		return parseFloat(HxOverrides.substr(this.buf,p1,this.pos - p1));
	}
	,unserializeObject: function(o) {
		while(true) {
			if(this.pos >= this.length) {
				throw new js__$Boot_HaxeError("Invalid object");
			}
			if(this.buf.charCodeAt(this.pos) == 103) {
				break;
			}
			var k = this.unserialize();
			if(typeof(k) != "string") {
				throw new js__$Boot_HaxeError("Invalid object key");
			}
			var v = this.unserialize();
			o[k] = v;
		}
		this.pos++;
	}
	,unserializeEnum: function(edecl,tag) {
		if(this.buf.charCodeAt(this.pos++) != 58) {
			throw new js__$Boot_HaxeError("Invalid enum format");
		}
		var nargs = this.readDigits();
		if(nargs == 0) {
			return Type.createEnum(edecl,tag);
		}
		var args = [];
		while(nargs-- > 0) args.push(this.unserialize());
		return Type.createEnum(edecl,tag,args);
	}
	,unserialize: function() {
		var _g = this.buf.charCodeAt(this.pos++);
		switch(_g) {
		case 65:
			var name = this.unserialize();
			var cl = this.resolver.resolveClass(name);
			if(cl == null) {
				throw new js__$Boot_HaxeError("Class not found " + name);
			}
			return cl;
		case 66:
			var name1 = this.unserialize();
			var e = this.resolver.resolveEnum(name1);
			if(e == null) {
				throw new js__$Boot_HaxeError("Enum not found " + name1);
			}
			return e;
		case 67:
			var name2 = this.unserialize();
			var cl1 = this.resolver.resolveClass(name2);
			if(cl1 == null) {
				throw new js__$Boot_HaxeError("Class not found " + name2);
			}
			var o = Object.create(cl1.prototype);
			this.cache.push(o);
			o.hxUnserialize(this);
			if(this.buf.charCodeAt(this.pos++) != 103) {
				throw new js__$Boot_HaxeError("Invalid custom data");
			}
			return o;
		case 77:
			var h = new haxe_ds_ObjectMap();
			this.cache.push(h);
			var buf = this.buf;
			while(this.buf.charCodeAt(this.pos) != 104) {
				var s = this.unserialize();
				h.set(s,this.unserialize());
			}
			this.pos++;
			return h;
		case 82:
			var n = this.readDigits();
			if(n < 0 || n >= this.scache.length) {
				throw new js__$Boot_HaxeError("Invalid string reference");
			}
			return this.scache[n];
		case 97:
			var buf1 = this.buf;
			var a = [];
			this.cache.push(a);
			while(true) {
				var c = this.buf.charCodeAt(this.pos);
				if(c == 104) {
					this.pos++;
					break;
				}
				if(c == 117) {
					this.pos++;
					var n1 = this.readDigits();
					a[a.length + n1 - 1] = null;
				} else {
					a.push(this.unserialize());
				}
			}
			return a;
		case 98:
			var h1 = new haxe_ds_StringMap();
			this.cache.push(h1);
			var buf2 = this.buf;
			while(this.buf.charCodeAt(this.pos) != 104) {
				var s1 = this.unserialize();
				var value = this.unserialize();
				if(__map_reserved[s1] != null) {
					h1.setReserved(s1,value);
				} else {
					h1.h[s1] = value;
				}
			}
			this.pos++;
			return h1;
		case 99:
			var name3 = this.unserialize();
			var cl2 = this.resolver.resolveClass(name3);
			if(cl2 == null) {
				throw new js__$Boot_HaxeError("Class not found " + name3);
			}
			var o1 = Object.create(cl2.prototype);
			this.cache.push(o1);
			this.unserializeObject(o1);
			return o1;
		case 100:
			return this.readFloat();
		case 102:
			return false;
		case 105:
			return this.readDigits();
		case 106:
			var name4 = this.unserialize();
			var edecl = this.resolver.resolveEnum(name4);
			if(edecl == null) {
				throw new js__$Boot_HaxeError("Enum not found " + name4);
			}
			this.pos++;
			var index = this.readDigits();
			var tag = edecl.__constructs__.slice()[index];
			if(tag == null) {
				throw new js__$Boot_HaxeError("Unknown enum index " + name4 + "@" + index);
			}
			var e1 = this.unserializeEnum(edecl,tag);
			this.cache.push(e1);
			return e1;
		case 107:
			return NaN;
		case 108:
			var l = new haxe_ds_List();
			this.cache.push(l);
			var buf3 = this.buf;
			while(this.buf.charCodeAt(this.pos) != 104) l.add(this.unserialize());
			this.pos++;
			return l;
		case 109:
			return -Infinity;
		case 110:
			return null;
		case 111:
			var o2 = { };
			this.cache.push(o2);
			this.unserializeObject(o2);
			return o2;
		case 112:
			return Infinity;
		case 113:
			var h2 = new haxe_ds_IntMap();
			this.cache.push(h2);
			var buf4 = this.buf;
			var c1 = this.buf.charCodeAt(this.pos++);
			while(c1 == 58) {
				var i = this.readDigits();
				var value1 = this.unserialize();
				h2.h[i] = value1;
				c1 = this.buf.charCodeAt(this.pos++);
			}
			if(c1 != 104) {
				throw new js__$Boot_HaxeError("Invalid IntMap format");
			}
			return h2;
		case 114:
			var n2 = this.readDigits();
			if(n2 < 0 || n2 >= this.cache.length) {
				throw new js__$Boot_HaxeError("Invalid reference");
			}
			return this.cache[n2];
		case 115:
			var len = this.readDigits();
			var buf5 = this.buf;
			if(this.buf.charCodeAt(this.pos++) != 58 || this.length - this.pos < len) {
				throw new js__$Boot_HaxeError("Invalid bytes length");
			}
			var codes = haxe_Unserializer.CODES;
			if(codes == null) {
				codes = haxe_Unserializer.initCodes();
				haxe_Unserializer.CODES = codes;
			}
			var i1 = this.pos;
			var rest = len & 3;
			var size = (len >> 2) * 3 + (rest >= 2 ? rest - 1 : 0);
			var max = i1 + (len - rest);
			var bytes = new haxe_io_Bytes(new ArrayBuffer(size));
			var bpos = 0;
			while(i1 < max) {
				var c11 = codes[buf5.charCodeAt(i1++)];
				var c2 = codes[buf5.charCodeAt(i1++)];
				bytes.b[bpos++] = (c11 << 2 | c2 >> 4) & 255;
				var c3 = codes[buf5.charCodeAt(i1++)];
				bytes.b[bpos++] = (c2 << 4 | c3 >> 2) & 255;
				var c4 = codes[buf5.charCodeAt(i1++)];
				bytes.b[bpos++] = (c3 << 6 | c4) & 255;
			}
			if(rest >= 2) {
				var c12 = codes[buf5.charCodeAt(i1++)];
				var c21 = codes[buf5.charCodeAt(i1++)];
				bytes.b[bpos++] = (c12 << 2 | c21 >> 4) & 255;
				if(rest == 3) {
					var c31 = codes[buf5.charCodeAt(i1++)];
					bytes.b[bpos++] = (c21 << 4 | c31 >> 2) & 255;
				}
			}
			this.pos += len;
			this.cache.push(bytes);
			return bytes;
		case 116:
			return true;
		case 118:
			var d;
			if(this.buf.charCodeAt(this.pos) >= 48 && this.buf.charCodeAt(this.pos) <= 57 && this.buf.charCodeAt(this.pos + 1) >= 48 && this.buf.charCodeAt(this.pos + 1) <= 57 && this.buf.charCodeAt(this.pos + 2) >= 48 && this.buf.charCodeAt(this.pos + 2) <= 57 && this.buf.charCodeAt(this.pos + 3) >= 48 && this.buf.charCodeAt(this.pos + 3) <= 57 && this.buf.charCodeAt(this.pos + 4) == 45) {
				d = HxOverrides.strDate(HxOverrides.substr(this.buf,this.pos,19));
				this.pos += 19;
			} else {
				d = new Date(this.readFloat());
			}
			this.cache.push(d);
			return d;
		case 119:
			var name5 = this.unserialize();
			var edecl1 = this.resolver.resolveEnum(name5);
			if(edecl1 == null) {
				throw new js__$Boot_HaxeError("Enum not found " + name5);
			}
			var e2 = this.unserializeEnum(edecl1,this.unserialize());
			this.cache.push(e2);
			return e2;
		case 120:
			throw js__$Boot_HaxeError.wrap(this.unserialize());
		case 121:
			var len1 = this.readDigits();
			if(this.buf.charCodeAt(this.pos++) != 58 || this.length - this.pos < len1) {
				throw new js__$Boot_HaxeError("Invalid string length");
			}
			var s2 = HxOverrides.substr(this.buf,this.pos,len1);
			this.pos += len1;
			s2 = decodeURIComponent(s2.split("+").join(" "));
			this.scache.push(s2);
			return s2;
		case 122:
			return 0;
		default:
		}
		this.pos--;
		throw new js__$Boot_HaxeError("Invalid char " + this.buf.charAt(this.pos) + " at position " + this.pos);
	}
	,__class__: haxe_Unserializer
};
var haxe_io_Bytes = function(data) {
	this.length = data.byteLength;
	this.b = new Uint8Array(data);
	this.b.bufferValue = data;
	data.hxBytes = this;
	data.bytes = this.b;
};
$hxClasses["haxe.io.Bytes"] = haxe_io_Bytes;
haxe_io_Bytes.__name__ = ["haxe","io","Bytes"];
haxe_io_Bytes.alloc = function(length) {
	return new haxe_io_Bytes(new ArrayBuffer(length));
};
haxe_io_Bytes.ofString = function(s) {
	var a = [];
	var i = 0;
	while(i < s.length) {
		var c = s.charCodeAt(i++);
		if(55296 <= c && c <= 56319) {
			c = c - 55232 << 10 | s.charCodeAt(i++) & 1023;
		}
		if(c <= 127) {
			a.push(c);
		} else if(c <= 2047) {
			a.push(192 | c >> 6);
			a.push(128 | c & 63);
		} else if(c <= 65535) {
			a.push(224 | c >> 12);
			a.push(128 | c >> 6 & 63);
			a.push(128 | c & 63);
		} else {
			a.push(240 | c >> 18);
			a.push(128 | c >> 12 & 63);
			a.push(128 | c >> 6 & 63);
			a.push(128 | c & 63);
		}
	}
	return new haxe_io_Bytes(new Uint8Array(a).buffer);
};
haxe_io_Bytes.ofData = function(b) {
	var hb = b.hxBytes;
	if(hb != null) {
		return hb;
	}
	return new haxe_io_Bytes(b);
};
haxe_io_Bytes.fastGet = function(b,pos) {
	return b.bytes[pos];
};
haxe_io_Bytes.prototype = {
	blit: function(pos,src,srcpos,len) {
		if(pos < 0 || srcpos < 0 || len < 0 || pos + len > this.length || srcpos + len > src.length) {
			throw new js__$Boot_HaxeError(haxe_io_Error.OutsideBounds);
		}
		if(srcpos == 0 && len == src.b.byteLength) {
			this.b.set(src.b,pos);
		} else {
			this.b.set(src.b.subarray(srcpos,srcpos + len),pos);
		}
	}
	,sub: function(pos,len) {
		if(pos < 0 || len < 0 || pos + len > this.length) {
			throw new js__$Boot_HaxeError(haxe_io_Error.OutsideBounds);
		}
		return new haxe_io_Bytes(this.b.buffer.slice(pos + this.b.byteOffset,pos + this.b.byteOffset + len));
	}
	,getString: function(pos,len) {
		if(pos < 0 || len < 0 || pos + len > this.length) {
			throw new js__$Boot_HaxeError(haxe_io_Error.OutsideBounds);
		}
		var s = "";
		var b = this.b;
		var fcc = String.fromCharCode;
		var i = pos;
		var max = pos + len;
		while(i < max) {
			var c = b[i++];
			if(c < 128) {
				if(c == 0) {
					break;
				}
				s += fcc(c);
			} else if(c < 224) {
				s += fcc((c & 63) << 6 | b[i++] & 127);
			} else if(c < 240) {
				var c2 = b[i++];
				s += fcc((c & 31) << 12 | (c2 & 127) << 6 | b[i++] & 127);
			} else {
				var c21 = b[i++];
				var c3 = b[i++];
				var u = (c & 15) << 18 | (c21 & 127) << 12 | (c3 & 127) << 6 | b[i++] & 127;
				s += fcc((u >> 10) + 55232);
				s += fcc(u & 1023 | 56320);
			}
		}
		return s;
	}
	,toString: function() {
		return this.getString(0,this.length);
	}
	,__class__: haxe_io_Bytes
};
var haxe_ds_BalancedTree = function() {
};
$hxClasses["haxe.ds.BalancedTree"] = haxe_ds_BalancedTree;
haxe_ds_BalancedTree.__name__ = ["haxe","ds","BalancedTree"];
haxe_ds_BalancedTree.__interfaces__ = [haxe_IMap];
haxe_ds_BalancedTree.prototype = {
	set: function(key,value) {
		this.root = this.setLoop(key,value,this.root);
	}
	,get: function(key) {
		var node = this.root;
		while(node != null) {
			var c = this.compare(key,node.key);
			if(c == 0) {
				return node.value;
			}
			if(c < 0) {
				node = node.left;
			} else {
				node = node.right;
			}
		}
		return null;
	}
	,exists: function(key) {
		var node = this.root;
		while(node != null) {
			var c = this.compare(key,node.key);
			if(c == 0) {
				return true;
			} else if(c < 0) {
				node = node.left;
			} else {
				node = node.right;
			}
		}
		return false;
	}
	,setLoop: function(k,v,node) {
		if(node == null) {
			return new haxe_ds_TreeNode(null,k,v,null);
		}
		var c = this.compare(k,node.key);
		if(c == 0) {
			return new haxe_ds_TreeNode(node.left,k,v,node.right,node == null ? 0 : node._height);
		} else if(c < 0) {
			var nl = this.setLoop(k,v,node.left);
			return this.balance(nl,node.key,node.value,node.right);
		} else {
			var nr = this.setLoop(k,v,node.right);
			return this.balance(node.left,node.key,node.value,nr);
		}
	}
	,balance: function(l,k,v,r) {
		var hl = l == null ? 0 : l._height;
		var hr = r == null ? 0 : r._height;
		if(hl > hr + 2) {
			var _this = l.left;
			var _this1 = l.right;
			if((_this == null ? 0 : _this._height) >= (_this1 == null ? 0 : _this1._height)) {
				return new haxe_ds_TreeNode(l.left,l.key,l.value,new haxe_ds_TreeNode(l.right,k,v,r));
			} else {
				return new haxe_ds_TreeNode(new haxe_ds_TreeNode(l.left,l.key,l.value,l.right.left),l.right.key,l.right.value,new haxe_ds_TreeNode(l.right.right,k,v,r));
			}
		} else if(hr > hl + 2) {
			var _this2 = r.right;
			var _this3 = r.left;
			if((_this2 == null ? 0 : _this2._height) > (_this3 == null ? 0 : _this3._height)) {
				return new haxe_ds_TreeNode(new haxe_ds_TreeNode(l,k,v,r.left),r.key,r.value,r.right);
			} else {
				return new haxe_ds_TreeNode(new haxe_ds_TreeNode(l,k,v,r.left.left),r.left.key,r.left.value,new haxe_ds_TreeNode(r.left.right,r.key,r.value,r.right));
			}
		} else {
			return new haxe_ds_TreeNode(l,k,v,r,(hl > hr ? hl : hr) + 1);
		}
	}
	,compare: function(k1,k2) {
		return Reflect.compare(k1,k2);
	}
	,__class__: haxe_ds_BalancedTree
};
var haxe_ds_TreeNode = function(l,k,v,r,h) {
	if(h == null) {
		h = -1;
	}
	this.left = l;
	this.key = k;
	this.value = v;
	this.right = r;
	if(h == -1) {
		var tmp;
		var _this = this.left;
		var _this1 = this.right;
		if((_this == null ? 0 : _this._height) > (_this1 == null ? 0 : _this1._height)) {
			var _this2 = this.left;
			tmp = _this2 == null ? 0 : _this2._height;
		} else {
			var _this3 = this.right;
			tmp = _this3 == null ? 0 : _this3._height;
		}
		this._height = tmp + 1;
	} else {
		this._height = h;
	}
};
$hxClasses["haxe.ds.TreeNode"] = haxe_ds_TreeNode;
haxe_ds_TreeNode.__name__ = ["haxe","ds","TreeNode"];
haxe_ds_TreeNode.prototype = {
	__class__: haxe_ds_TreeNode
};
var haxe_ds_EnumValueMap = function() {
	haxe_ds_BalancedTree.call(this);
};
$hxClasses["haxe.ds.EnumValueMap"] = haxe_ds_EnumValueMap;
haxe_ds_EnumValueMap.__name__ = ["haxe","ds","EnumValueMap"];
haxe_ds_EnumValueMap.__interfaces__ = [haxe_IMap];
haxe_ds_EnumValueMap.__super__ = haxe_ds_BalancedTree;
haxe_ds_EnumValueMap.prototype = $extend(haxe_ds_BalancedTree.prototype,{
	compare: function(k1,k2) {
		var d = k1[1] - k2[1];
		if(d != 0) {
			return d;
		}
		var p1 = k1.slice(2);
		var p2 = k2.slice(2);
		if(p1.length == 0 && p2.length == 0) {
			return 0;
		}
		return this.compareArgs(p1,p2);
	}
	,compareArgs: function(a1,a2) {
		var ld = a1.length - a2.length;
		if(ld != 0) {
			return ld;
		}
		var _g1 = 0;
		var _g = a1.length;
		while(_g1 < _g) {
			var i = _g1++;
			var d = this.compareArg(a1[i],a2[i]);
			if(d != 0) {
				return d;
			}
		}
		return 0;
	}
	,compareArg: function(v1,v2) {
		if(Reflect.isEnumValue(v1) && Reflect.isEnumValue(v2)) {
			return this.compare(v1,v2);
		} else if((v1 instanceof Array) && v1.__enum__ == null && ((v2 instanceof Array) && v2.__enum__ == null)) {
			return this.compareArgs(v1,v2);
		} else {
			return Reflect.compare(v1,v2);
		}
	}
	,__class__: haxe_ds_EnumValueMap
});
var haxe_ds_IntMap = function() {
	this.h = { };
};
$hxClasses["haxe.ds.IntMap"] = haxe_ds_IntMap;
haxe_ds_IntMap.__name__ = ["haxe","ds","IntMap"];
haxe_ds_IntMap.__interfaces__ = [haxe_IMap];
haxe_ds_IntMap.prototype = {
	keys: function() {
		var a = [];
		for( var key in this.h ) if(this.h.hasOwnProperty(key)) {
			a.push(key | 0);
		}
		return HxOverrides.iter(a);
	}
	,__class__: haxe_ds_IntMap
};
var haxe_ds_List = function() {
	this.length = 0;
};
$hxClasses["haxe.ds.List"] = haxe_ds_List;
haxe_ds_List.__name__ = ["haxe","ds","List"];
haxe_ds_List.prototype = {
	add: function(item) {
		var x = new haxe_ds__$List_ListNode(item,null);
		if(this.h == null) {
			this.h = x;
		} else {
			this.q.next = x;
		}
		this.q = x;
		this.length++;
	}
	,iterator: function() {
		return new haxe_ds__$List_ListIterator(this.h);
	}
	,__class__: haxe_ds_List
};
var haxe_ds__$List_ListNode = function(item,next) {
	this.item = item;
	this.next = next;
};
$hxClasses["haxe.ds._List.ListNode"] = haxe_ds__$List_ListNode;
haxe_ds__$List_ListNode.__name__ = ["haxe","ds","_List","ListNode"];
haxe_ds__$List_ListNode.prototype = {
	__class__: haxe_ds__$List_ListNode
};
var haxe_ds__$List_ListIterator = function(head) {
	this.head = head;
};
$hxClasses["haxe.ds._List.ListIterator"] = haxe_ds__$List_ListIterator;
haxe_ds__$List_ListIterator.__name__ = ["haxe","ds","_List","ListIterator"];
haxe_ds__$List_ListIterator.prototype = {
	hasNext: function() {
		return this.head != null;
	}
	,next: function() {
		var val = this.head.item;
		this.head = this.head.next;
		return val;
	}
	,__class__: haxe_ds__$List_ListIterator
};
var haxe_ds_ObjectMap = function() {
	this.h = { __keys__ : { }};
};
$hxClasses["haxe.ds.ObjectMap"] = haxe_ds_ObjectMap;
haxe_ds_ObjectMap.__name__ = ["haxe","ds","ObjectMap"];
haxe_ds_ObjectMap.__interfaces__ = [haxe_IMap];
haxe_ds_ObjectMap.assignId = function(obj) {
	return obj.__id__ = ++haxe_ds_ObjectMap.count;
};
haxe_ds_ObjectMap.getId = function(obj) {
	return obj.__id__;
};
haxe_ds_ObjectMap.prototype = {
	set: function(key,value) {
		var id = key.__id__ || (key.__id__ = ++haxe_ds_ObjectMap.count);
		this.h[id] = value;
		this.h.__keys__[id] = key;
	}
	,keys: function() {
		var a = [];
		for( var key in this.h.__keys__ ) {
		if(this.h.hasOwnProperty(key)) {
			a.push(this.h.__keys__[key]);
		}
		}
		return HxOverrides.iter(a);
	}
	,__class__: haxe_ds_ObjectMap
};
var haxe_ds_Option = $hxClasses["haxe.ds.Option"] = { __ename__ : ["haxe","ds","Option"], __constructs__ : ["Some","None"] };
haxe_ds_Option.Some = function(v) { var $x = ["Some",0,v]; $x.__enum__ = haxe_ds_Option; $x.toString = $estr; return $x; };
haxe_ds_Option.None = ["None",1];
haxe_ds_Option.None.toString = $estr;
haxe_ds_Option.None.__enum__ = haxe_ds_Option;
var haxe_ds_StringMap = function() {
	this.h = { };
};
$hxClasses["haxe.ds.StringMap"] = haxe_ds_StringMap;
haxe_ds_StringMap.__name__ = ["haxe","ds","StringMap"];
haxe_ds_StringMap.__interfaces__ = [haxe_IMap];
haxe_ds_StringMap.prototype = {
	setReserved: function(key,value) {
		if(this.rh == null) {
			this.rh = { };
		}
		this.rh["$" + key] = value;
	}
	,getReserved: function(key) {
		if(this.rh == null) {
			return null;
		} else {
			return this.rh["$" + key];
		}
	}
	,existsReserved: function(key) {
		if(this.rh == null) {
			return false;
		}
		return this.rh.hasOwnProperty("$" + key);
	}
	,keys: function() {
		return HxOverrides.iter(this.arrayKeys());
	}
	,arrayKeys: function() {
		var out = [];
		for( var key in this.h ) {
		if(this.h.hasOwnProperty(key)) {
			out.push(key);
		}
		}
		if(this.rh != null) {
			for( var key in this.rh ) {
			if(key.charCodeAt(0) == 36) {
				out.push(key.substr(1));
			}
			}
		}
		return out;
	}
	,__class__: haxe_ds_StringMap
};
var haxe_io_Error = $hxClasses["haxe.io.Error"] = { __ename__ : ["haxe","io","Error"], __constructs__ : ["Blocked","Overflow","OutsideBounds","Custom"] };
haxe_io_Error.Blocked = ["Blocked",0];
haxe_io_Error.Blocked.toString = $estr;
haxe_io_Error.Blocked.__enum__ = haxe_io_Error;
haxe_io_Error.Overflow = ["Overflow",1];
haxe_io_Error.Overflow.toString = $estr;
haxe_io_Error.Overflow.__enum__ = haxe_io_Error;
haxe_io_Error.OutsideBounds = ["OutsideBounds",2];
haxe_io_Error.OutsideBounds.toString = $estr;
haxe_io_Error.OutsideBounds.__enum__ = haxe_io_Error;
haxe_io_Error.Custom = function(e) { var $x = ["Custom",3,e]; $x.__enum__ = haxe_io_Error; $x.toString = $estr; return $x; };
var haxe_io_Path = function(path) {
	switch(path) {
	case ".":case "..":
		this.dir = path;
		this.file = "";
		return;
	}
	var c1 = path.lastIndexOf("/");
	var c2 = path.lastIndexOf("\\");
	if(c1 < c2) {
		this.dir = HxOverrides.substr(path,0,c2);
		path = HxOverrides.substr(path,c2 + 1,null);
		this.backslash = true;
	} else if(c2 < c1) {
		this.dir = HxOverrides.substr(path,0,c1);
		path = HxOverrides.substr(path,c1 + 1,null);
	} else {
		this.dir = null;
	}
	var cp = path.lastIndexOf(".");
	if(cp != -1) {
		this.ext = HxOverrides.substr(path,cp + 1,null);
		this.file = HxOverrides.substr(path,0,cp);
	} else {
		this.ext = null;
		this.file = path;
	}
};
$hxClasses["haxe.io.Path"] = haxe_io_Path;
haxe_io_Path.__name__ = ["haxe","io","Path"];
haxe_io_Path.withoutDirectory = function(path) {
	var s = new haxe_io_Path(path);
	s.dir = null;
	return s.toString();
};
haxe_io_Path.directory = function(path) {
	var s = new haxe_io_Path(path);
	if(s.dir == null) {
		return "";
	}
	return s.dir;
};
haxe_io_Path.join = function(paths) {
	var paths1 = paths.filter(function(s) {
		if(s != null) {
			return s != "";
		} else {
			return false;
		}
	});
	if(paths1.length == 0) {
		return "";
	}
	var path = paths1[0];
	var _g1 = 1;
	var _g = paths1.length;
	while(_g1 < _g) {
		var i = _g1++;
		path = haxe_io_Path.addTrailingSlash(path);
		path += paths1[i];
	}
	return haxe_io_Path.normalize(path);
};
haxe_io_Path.normalize = function(path) {
	var slash = "/";
	path = path.split("\\").join(slash);
	if(path == slash) {
		return slash;
	}
	var target = [];
	var _g = 0;
	var _g1 = path.split(slash);
	while(_g < _g1.length) {
		var token = _g1[_g];
		++_g;
		if(token == ".." && target.length > 0 && target[target.length - 1] != "..") {
			target.pop();
		} else if(token != ".") {
			target.push(token);
		}
	}
	var tmp = target.join(slash);
	var regex_r = new RegExp("([^:])/+","g".split("u").join(""));
	var result = tmp.replace(regex_r,"$1" + slash);
	var acc_b = "";
	var colon = false;
	var slashes = false;
	var _g11 = 0;
	var _g2 = tmp.length;
	while(_g11 < _g2) {
		var i = _g11++;
		var _g21 = tmp.charCodeAt(i);
		switch(_g21) {
		case 47:
			if(!colon) {
				slashes = true;
			} else {
				var i1 = _g21;
				colon = false;
				if(slashes) {
					acc_b += "/";
					slashes = false;
				}
				acc_b += String.fromCharCode(i1);
			}
			break;
		case 58:
			acc_b += ":";
			colon = true;
			break;
		default:
			var i2 = _g21;
			colon = false;
			if(slashes) {
				acc_b += "/";
				slashes = false;
			}
			acc_b += String.fromCharCode(i2);
		}
	}
	return acc_b;
};
haxe_io_Path.addTrailingSlash = function(path) {
	if(path.length == 0) {
		return "/";
	}
	var c1 = path.lastIndexOf("/");
	var c2 = path.lastIndexOf("\\");
	if(c1 < c2) {
		if(c2 != path.length - 1) {
			return path + "\\";
		} else {
			return path;
		}
	} else if(c1 != path.length - 1) {
		return path + "/";
	} else {
		return path;
	}
};
haxe_io_Path.removeTrailingSlashes = function(path) {
	_hx_loop1: while(true) {
		var _g = HxOverrides.cca(path,path.length - 1);
		if(_g == null) {
			break;
		} else {
			switch(_g) {
			case 47:case 92:
				path = HxOverrides.substr(path,0,-1);
				break;
			default:
				break _hx_loop1;
			}
		}
	}
	return path;
};
haxe_io_Path.isAbsolute = function(path) {
	if(StringTools.startsWith(path,"/")) {
		return true;
	}
	if(path.charAt(1) == ":") {
		return true;
	}
	if(StringTools.startsWith(path,"\\\\")) {
		return true;
	}
	return false;
};
haxe_io_Path.prototype = {
	toString: function() {
		return (this.dir == null ? "" : this.dir + (this.backslash ? "\\" : "/")) + this.file + (this.ext == null ? "" : "." + this.ext);
	}
	,__class__: haxe_io_Path
};
var haxe_remoting_AsyncConnection = function() { };
$hxClasses["haxe.remoting.AsyncConnection"] = haxe_remoting_AsyncConnection;
haxe_remoting_AsyncConnection.__name__ = ["haxe","remoting","AsyncConnection"];
haxe_remoting_AsyncConnection.prototype = {
	__class__: haxe_remoting_AsyncConnection
};
var haxe_remoting_HttpAsyncConnection = function(data,path) {
	this.__data = data;
	this.__path = path;
};
$hxClasses["haxe.remoting.HttpAsyncConnection"] = haxe_remoting_HttpAsyncConnection;
haxe_remoting_HttpAsyncConnection.__name__ = ["haxe","remoting","HttpAsyncConnection"];
haxe_remoting_HttpAsyncConnection.__interfaces__ = [haxe_remoting_AsyncConnection];
haxe_remoting_HttpAsyncConnection.urlConnect = function(url) {
	return new haxe_remoting_HttpAsyncConnection({ url : url, error : function(e) {
		throw js__$Boot_HaxeError.wrap(e);
	}},[]);
};
haxe_remoting_HttpAsyncConnection.prototype = {
	resolve: function(name) {
		var c = new haxe_remoting_HttpAsyncConnection(this.__data,this.__path.slice());
		c.__path.push(name);
		return c;
	}
	,setErrorHandler: function(h) {
		this.__data.error = h;
	}
	,call: function(params,onResult) {
		var h = new haxe_Http(this.__data.url);
		var s = new haxe_Serializer();
		s.serialize(this.__path);
		s.serialize(params);
		h.setHeader("X-Haxe-Remoting","1");
		h.setParameter("__x",s.toString());
		var error = this.__data.error;
		h.onData = function(response) {
			var ok = true;
			var ret;
			try {
				if(HxOverrides.substr(response,0,3) != "hxr") {
					throw new js__$Boot_HaxeError("Invalid response : '" + response + "'");
				}
				var s1 = new haxe_Unserializer(HxOverrides.substr(response,3,null));
				ret = s1.unserialize();
			} catch( err ) {
				ret = null;
				ok = false;
				error((err instanceof js__$Boot_HaxeError) ? err.val : err);
			}
			if(ok && onResult != null) {
				onResult(ret);
			}
		};
		h.onError = error;
		h.request(true);
	}
	,__class__: haxe_remoting_HttpAsyncConnection
};
var haxeshim__$Env_Env_$Impl_$ = {};
$hxClasses["haxeshim._Env.Env_Impl_"] = haxeshim__$Env_Env_$Impl_$;
haxeshim__$Env_Env_$Impl_$.__name__ = ["haxeshim","_Env","Env_Impl_"];
haxeshim__$Env_Env_$Impl_$.ofVars = function(vars) {
	var this1 = { };
	var ret = this1;
	var _g = 0;
	var _g1 = Reflect.fields(vars);
	while(_g < _g1.length) {
		var k = _g1[_g];
		++_g;
		ret[haxeshim_Os.IS_WINDOWS ? k.toUpperCase() : k] = vars[k];
	}
	var this2 = ret;
	return this2;
};
haxeshim__$Env_Env_$Impl_$.ofMap = function(map) {
	var this1 = { };
	var ret = this1;
	var k = map.keys();
	while(k.hasNext()) {
		var k1 = k.next();
		ret[haxeshim_Os.IS_WINDOWS ? k1.toUpperCase() : k1] = __map_reserved[k1] != null ? map.getReserved(k1) : map.h[k1];
	}
	var this2 = ret;
	return this2;
};
haxeshim__$Env_Env_$Impl_$.vars = function(this1) {
	return this1;
};
haxeshim__$Env_Env_$Impl_$.toVars = function(this1) {
	return Reflect.copy(this1);
};
haxeshim__$Env_Env_$Impl_$.get = function(this1,s) {
	return this1[haxeshim_Os.IS_WINDOWS ? s.toUpperCase() : s];
};
haxeshim__$Env_Env_$Impl_$.mergeInto = function(this1,that) {
	var _g = haxeshim__$Env_Env_$Impl_$.vars(that);
	if(this1 == null) {
		var v = _g;
		var this2 = v;
		return this2;
	} else if(_g == null) {
		var v1 = this1;
		var this3 = v1;
		return this3;
	} else {
		var a = this1;
		var b = _g;
		var this4 = { };
		var ret = this4;
		var _g1 = 0;
		var _g11 = [b,a];
		while(_g1 < _g11.length) {
			var vars = _g11[_g1];
			++_g1;
			var _g2 = 0;
			var _g3 = Reflect.fields(vars);
			while(_g2 < _g3.length) {
				var k = _g3[_g2];
				++_g2;
				ret[k] = vars[k];
			}
		}
		var this5 = ret;
		return this5;
	}
};
var haxeshim_Exec = function() { };
$hxClasses["haxeshim.Exec"] = haxeshim_Exec;
haxeshim_Exec.__name__ = ["haxeshim","Exec"];
haxeshim_Exec.die = function(code,reason) {
	new _$Sys_FileOutput(2).writeString("" + reason + "\n");
	process.exit(code);
	throw new js__$Boot_HaxeError("unreachable");
};
haxeshim_Exec.mergeEnv = function(env) {
	return haxeshim__$Env_Env_$Impl_$.mergeInto(env,haxeshim__$Env_Env_$Impl_$.ofVars(process.env));
};
haxeshim_Exec.shell = function(cmd,cwd,env) {
	try {
		return tink_core_Outcome.Success(js_node_ChildProcess.execSync(cmd,{ cwd : cwd, stdio : "inherit", env : haxeshim__$Env_Env_$Impl_$.toVars(haxeshim_Exec.mergeEnv(env))}));
	} catch( e ) {
		var e1 = (e instanceof js__$Boot_HaxeError) ? e.val : e;
		return tink_core_Outcome.Failure(new tink_core_TypedError(e1.status,"Failed to invoke `" + cmd + "` because " + Std.string(e1),{ fileName : "haxeshim/Exec.hx", lineNumber : 32, className : "haxeshim.Exec", methodName : "shell"}));
	}
};
haxeshim_Exec.sync = function(cmd,cwd,args,env) {
	var _g = js_node_ChildProcess.spawnSync(cmd,args,{ cwd : cwd, stdio : "inherit", env : haxeshim__$Env_Env_$Impl_$.toVars(haxeshim_Exec.mergeEnv(env))});
	var x = _g;
	if(x.error == null) {
		return tink_core_Outcome.Success(x.status);
	} else {
		var e = _g.error;
		return tink_core_Outcome.Failure(new tink_core_TypedError(null,"Failed to call " + cmd + " because " + Std.string(e),{ fileName : "haxeshim/Exec.hx", lineNumber : 39, className : "haxeshim.Exec", methodName : "sync"}));
	}
};
var haxeshim_Fs = function() { };
$hxClasses["haxeshim.Fs"] = haxeshim_Fs;
haxeshim_Fs.__name__ = ["haxeshim","Fs"];
haxeshim_Fs.get = function(path,pos) {
	var _e = path;
	return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_core_TypedError.catchExceptions(function() {
		return js_node_Fs.readFileSync(_e,{ encoding : "utf8"});
	},function(data) {
		return tink_core_TypedError.withData(null,"failed to get content of " + path,data,pos);
	},{ fileName : "haxeshim/Fs.hx", lineNumber : 14, className : "haxeshim.Fs", methodName : "get"})));
};
haxeshim_Fs.ensureDir = function(dir) {
	var isDir = StringTools.endsWith(dir,"/") || StringTools.endsWith(dir,"\\");
	if(isDir) {
		dir = haxe_io_Path.removeTrailingSlashes(dir);
	}
	var parent = haxe_io_Path.directory(dir);
	if(haxe_io_Path.removeTrailingSlashes(parent) == dir) {
		return;
	}
	if(!sys_FileSystem.exists(parent)) {
		haxeshim_Fs.ensureDir(haxe_io_Path.addTrailingSlash(parent));
	}
	if(isDir && !sys_FileSystem.exists(dir)) {
		sys_FileSystem.createDirectory(dir);
	}
};
haxeshim_Fs.copy = function(src,target,filter,overwrite) {
	var copy = null;
	copy = function(src1,target1,ensure) {
		if(filter == null || filter(src1)) {
			if(sys_FileSystem.isDirectory(src1)) {
				haxeshim_Fs.ensureDir(haxe_io_Path.addTrailingSlash(target1));
				var _g = 0;
				var _g1 = js_node_Fs.readdirSync(src1);
				while(_g < _g1.length) {
					var entry = _g1[_g];
					++_g;
					copy("" + src1 + "/" + entry,"" + target1 + "/" + entry,false);
				}
			} else {
				if(ensure) {
					haxeshim_Fs.ensureDir(target1);
				}
				if(!sys_FileSystem.exists(target1) || overwrite == null || overwrite({ src : src1, dest : target1})) {
					sys_io_File.copy(src1,target1);
				}
			}
		}
	};
	var copy1 = copy;
	copy1(src,target,true);
};
haxeshim_Fs.ls = function(dir,filter) {
	var _g = [];
	var _g1 = 0;
	var _g2 = js_node_Fs.readdirSync(dir);
	while(_g1 < _g2.length) {
		var entry = _g2[_g1];
		++_g1;
		var _g3 = "" + dir + "/" + entry;
		var included = _g3;
		var tmp;
		if(filter == null || filter(included)) {
			tmp = included;
		} else {
			continue;
		}
		_g.push(tmp);
	}
	return _g;
};
haxeshim_Fs["delete"] = function(path) {
	if(sys_FileSystem.isDirectory(path)) {
		var _g = 0;
		var _g1 = haxeshim_Fs.ls(path);
		while(_g < _g1.length) {
			var file = _g1[_g];
			++_g;
			haxeshim_Fs["delete"](file);
		}
		js_node_Fs.rmdirSync(path);
	} else {
		js_node_Fs.unlinkSync(path);
	}
};
haxeshim_Fs.peel = function(file,depth) {
	var start = 0;
	var _g1 = 0;
	var _g = depth;
	while(_g1 < _g) {
		var i = _g1++;
		var _g2 = file.indexOf("/",start);
		if(_g2 == -1) {
			return haxe_ds_Option.None;
		} else {
			var v = _g2;
			start = v + 1;
		}
	}
	return haxe_ds_Option.Some(HxOverrides.substr(file,start,null));
};
haxeshim_Fs.findNearest = function(name,dir) {
	while(true) if(sys_FileSystem.exists("" + dir + "/" + name)) {
		return haxe_ds_Option.Some("" + dir + "/" + name);
	} else {
		var _g = haxe_io_Path.directory(dir);
		var same = _g;
		if(dir == same) {
			return haxe_ds_Option.None;
		} else {
			var parent = _g;
			dir = parent;
		}
	}
};
var haxeshim_HaxeCli = function(scope) {
	this.scope = scope;
};
$hxClasses["haxeshim.HaxeCli"] = haxeshim_HaxeCli;
haxeshim_HaxeCli.__name__ = ["haxeshim","HaxeCli"];
haxeshim_HaxeCli.prototype = {
	installLibs: function(silent) {
		var i = this.scope.getInstallationInstructions();
		var code = 0;
		var _g = i.missing;
		if(_g.length != 0) {
			var v = _g;
			code = 404;
			var _g1 = 0;
			while(_g1 < v.length) {
				var m = v[_g1];
				++_g1;
				new _$Sys_FileOutput(2).writeString("" + m.lib + " has no install instruction for missing classpath " + m.cp + "\n");
			}
		}
		var _g11 = 0;
		var _g2 = [i.instructions.install,i.instructions.postInstall];
		while(_g11 < _g2.length) {
			var cmds = _g2[_g11];
			++_g11;
			var _g3 = 0;
			while(_g3 < cmds.length) {
				var cmd = cmds[_g3];
				++_g3;
				if(!silent) {
					process.stdout.write(cmd == null ? "null" : "" + cmd);
					process.stdout.write("\n");
				}
				var _g4 = haxeshim_Exec.shell(cmd,process.cwd());
				if(_g4[1] == 1) {
					var e = _g4[2];
					code = e.code;
				}
			}
		}
		process.exit(code);
	}
	,__class__: haxeshim_HaxeCli
};
var haxeshim_Os = function() { };
$hxClasses["haxeshim.Os"] = haxeshim_Os;
haxeshim_Os.__name__ = ["haxeshim","Os"];
haxeshim_Os.slashes = function(path) {
	if(haxeshim_Os.IS_WINDOWS) {
		return StringTools.replace(path,"/","\\");
	} else {
		return path;
	}
};
var haxeshim_HaxeInstallation = function(path,version,haxelibRepo) {
	this.path = path;
	this.version = version;
	this.compiler = "" + path + "/haxe" + haxeshim_HaxeInstallation.EXT;
	this.haxelib = "" + path + "/haxelib" + haxeshim_HaxeInstallation.EXT;
	this.stdLib = "" + path + "/std";
	this.haxelibRepo = haxelibRepo;
};
$hxClasses["haxeshim.HaxeInstallation"] = haxeshim_HaxeInstallation;
haxeshim_HaxeInstallation.__name__ = ["haxeshim","HaxeInstallation"];
haxeshim_HaxeInstallation.prototype = {
	env: function() {
		var ret = haxeshim__$Env_Env_$Impl_$.ofVars({ HAXE_STD_PATH : this.stdLib, HAXEPATH : this.path, HAXELIB_PATH : this.haxelibRepo, HAXE_VERSION : this.version});
		return haxeshim__$Env_Env_$Impl_$.mergeInto(ret,haxeshim_Neko.ENV);
	}
	,__class__: haxeshim_HaxeInstallation
};
var haxeshim_HaxelibCli = function(scope) {
	haxeshim_Neko.setEnv();
	this.scope = scope;
	this.installation = scope.haxeInstallation;
};
$hxClasses["haxeshim.HaxelibCli"] = haxeshim_HaxelibCli;
haxeshim_HaxelibCli.__name__ = ["haxeshim","HaxelibCli"];
haxeshim_HaxelibCli.exit = function(o) {
	switch(o[1]) {
	case 0:
		process.exit(0);
		break;
	case 1:
		var e = o[2];
		haxeshim_Exec.die(e.code,e.message);
		break;
	}
};
haxeshim_HaxelibCli.exitWithCode = function(o) {
	switch(o[1]) {
	case 0:
		var code = o[2];
		process.exit(code);
		break;
	case 1:
		var e = o[2];
		haxeshim_Exec.die(e.code,e.message);
		break;
	}
};
haxeshim_HaxelibCli.prototype = {
	callHaxelib: function(args) {
		haxeshim_HaxelibCli.exitWithCode(haxeshim_Exec.sync(this.installation.haxelib,process.cwd(),args,this.installation.env()));
	}
	,run: function(args) {
		var _gthis = this;
		this.scope.getLibCommand(args).handle(function(o) {
			switch(o[1]) {
			case 0:
				var cmd = o[2];
				haxeshim_HaxelibCli.exit(cmd());
				break;
			case 1:
				var e = o[2];
				var tmp = ["run"].concat(args);
				_gthis.callHaxelib(tmp);
				break;
			}
		});
	}
	,__class__: haxeshim_HaxelibCli
};
var tink_core__$Lazy_LazyObject = function() { };
$hxClasses["tink.core._Lazy.LazyObject"] = tink_core__$Lazy_LazyObject;
tink_core__$Lazy_LazyObject.__name__ = ["tink","core","_Lazy","LazyObject"];
tink_core__$Lazy_LazyObject.prototype = {
	__class__: tink_core__$Lazy_LazyObject
};
var tink_core__$Lazy_LazyConst = function(value) {
	this.value = value;
};
$hxClasses["tink.core._Lazy.LazyConst"] = tink_core__$Lazy_LazyConst;
tink_core__$Lazy_LazyConst.__name__ = ["tink","core","_Lazy","LazyConst"];
tink_core__$Lazy_LazyConst.__interfaces__ = [tink_core__$Lazy_LazyObject];
tink_core__$Lazy_LazyConst.prototype = {
	get: function() {
		return this.value;
	}
	,map: function(f) {
		var _gthis = this;
		return new tink_core__$Lazy_LazyFunc(function() {
			return f(_gthis.value);
		});
	}
	,__class__: tink_core__$Lazy_LazyConst
};
var haxeshim_Scope = function(haxeshimRoot,isGlobal,scopeDir,cwd) {
	this.haxeshimRoot = haxeshimRoot;
	this.isGlobal = isGlobal;
	this.scopeDir = scopeDir;
	this.scopeLibDir = "" + scopeDir + "/haxe_libraries";
	this.cwd = cwd;
	this.configFile = "" + scopeDir + "/" + haxeshim_Scope.CONFIG_FILE;
	this.versionDir = "" + haxeshimRoot + "/versions";
	this.haxelibRepo = "" + haxeshimRoot + "/haxelib";
	this.libCache = "" + haxeshimRoot + "/haxe_libraries";
};
$hxClasses["haxeshim.Scope"] = haxeshim_Scope;
haxeshim_Scope.__name__ = ["haxeshim","Scope"];
haxeshim_Scope.create = function(at,config) {
	js_node_Fs.writeFileSync("" + at + "/" + haxeshim_Scope.CONFIG_FILE,JSON.stringify(config));
};
haxeshim_Scope.exists = function(at) {
	return sys_FileSystem.exists("" + at + "/" + haxeshim_Scope.CONFIG_FILE);
};
haxeshim_Scope.seek = function(options) {
	if(options == null) {
		options = { };
	}
	var cwd;
	var _g = options.cwd;
	if(_g == null) {
		cwd = process.cwd();
	} else {
		var v = _g;
		cwd = v;
	}
	var startLookingIn;
	var _g1 = options.startLookingIn;
	if(_g1 == null) {
		startLookingIn = cwd;
	} else {
		var v1 = _g1;
		startLookingIn = v1;
	}
	var haxeshimRoot;
	var _g2 = options.haxeshimRoot;
	if(_g2 == null) {
		haxeshimRoot = haxeshim_Scope.DEFAULT_ROOT;
	} else {
		var v2 = _g2;
		haxeshimRoot = v2;
	}
	var f = function(haxeshimRoot1,isGlobal,scopeDir,cwd1) {
		return new haxeshim_Scope(haxeshimRoot1,isGlobal,scopeDir,cwd1);
	};
	var haxeshimRoot2 = haxeshimRoot;
	var cwd2 = cwd;
	var make = function(isGlobal1,scopeDir1) {
		return f(haxeshimRoot2,isGlobal1,scopeDir1,cwd2);
	};
	var ret;
	var _g3 = haxeshim_Fs.findNearest(haxeshim_Scope.CONFIG_FILE,js_node_Path.resolve(startLookingIn));
	switch(_g3[1]) {
	case 0:
		var v3 = _g3[2];
		ret = make(false,haxe_io_Path.directory(v3));
		break;
	case 1:
		ret = make(true,haxeshimRoot);
		break;
	}
	ret.reload();
	return ret;
};
haxeshim_Scope.env = function(s) {
	var _g = process.env[s];
	if(_g == null) {
		return haxe_ds_Option.None;
	} else if(_g == "") {
		return haxe_ds_Option.None;
	} else {
		var v = _g;
		return haxe_ds_Option.Some(v);
	}
};
haxeshim_Scope.prototype = {
	reload: function() {
		var src;
		try {
			src = js_node_Fs.readFileSync(this.configFile,{ encoding : "utf8"});
		} catch( e ) {
			throw new js__$Boot_HaxeError(this.isGlobal ? "Global config file " + this.configFile + " does not exist or cannot be opened" : "Unable to open file " + this.configFile + " because " + Std.string((e instanceof js__$Boot_HaxeError) ? e.val : e));
		}
		var tmp;
		try {
			tmp = JSON.parse(src);
		} catch( e1 ) {
			var e2 = (e1 instanceof js__$Boot_HaxeError) ? e1.val : e1;
			new _$Sys_FileOutput(2).writeString("Invalid JSON in file " + this.configFile + ":\n\n" + src + "\n\n");
			throw js__$Boot_HaxeError.wrap(e2);
		}
		this.setConfig(tmp);
	}
	,setConfig: function(config) {
		if(config.version == null) {
			throw new js__$Boot_HaxeError("No version set in " + this.configFile);
		}
		if(config.resolveLibs == null) {
			config.resolveLibs = this.isGlobal ? "mixed" : "scoped";
		}
		var _g = config.resolveLibs;
		switch(_g) {
		case "haxelib":case "mixed":case "scoped":
			break;
		default:
			var v = _g;
			throw new js__$Boot_HaxeError("invalid value " + v + " for `resolveLibs` in " + this.configFile);
		}
		this.config = config;
		this.haxeInstallation = this.getInstallation(config.version);
		this.resolver = new haxeshim_Resolver(this.cwd,this.scopeLibDir,config.resolveLibs,$bind(this,this.getDefault));
	}
	,getDefault: function(variable) {
		switch(variable) {
		case "HAXESHIM_LIBCACHE":case "HAXE_LIBCACHE":
			return this.libCache;
		case "SCOPE_DIR":
			return this.scopeDir;
		default:
			return null;
		}
	}
	,'delete': function() {
		js_node_Fs.unlinkSync(this.configFile);
	}
	,reconfigure: function(changed) {
		this.setConfig(changed);
		js_node_Fs.writeFileSync(this.configFile,JSON.stringify(this.config,null,"  "));
	}
	,path: function(v) {
		if(haxe_io_Path.isAbsolute(v)) {
			return haxe_ds_Option.Some(v);
		} else if(StringTools.startsWith(v,"./") || StringTools.startsWith(v,"../")) {
			return haxe_ds_Option.Some("" + this.cwd + "/" + v);
		} else {
			return haxe_ds_Option.None;
		}
	}
	,getInstallation: function(version) {
		var _g = this.path(version);
		switch(_g[1]) {
		case 0:
			var path = _g[2];
			return new haxeshim_HaxeInstallation(path,version,this.haxelibRepo);
		case 1:
			return new haxeshim_HaxeInstallation("" + this.versionDir + "/" + version,version,this.haxelibRepo);
		}
	}
	,interpolate: function(value) {
		return haxeshim_Resolver.interpolate(value,$bind(this,this.getDefault));
	}
	,parseDirectives: function(raw) {
		var ret = new haxe_ds_StringMap();
		var _g = 0;
		var _g1 = raw.split("\n").map(StringTools.trim);
		while(_g < _g1.length) {
			var line = _g1[_g];
			++_g;
			if(StringTools.startsWith(line,"#")) {
				var content = StringTools.ltrim(HxOverrides.substr(line,1,null));
				if(StringTools.startsWith(content,"@")) {
					var _g2 = content.indexOf(":");
					if(_g2 != -1) {
						var v = _g2;
						var name = content.substring(1,v);
						var tmp;
						var _g21 = __map_reserved[name] != null ? ret.getReserved(name) : ret.h[name];
						if(_g21 == null) {
							var v1 = [];
							if(__map_reserved[name] != null) {
								ret.setReserved(name,v1);
							} else {
								ret.h[name] = v1;
							}
							tmp = v1;
						} else {
							var v2 = _g21;
							tmp = v2;
						}
						tmp.push(StringTools.ltrim(HxOverrides.substr(content,v + 1,null)));
					}
				}
			}
		}
		return ret;
	}
	,getDirectives: function(lib) {
		return tink_core__$Promise_Promise_$Impl_$.next(haxeshim_Fs.get(haxeshim_Resolver.libHxml(this.scopeLibDir,lib),{ fileName : "haxeshim/Scope.hx", lineNumber : 203, className : "haxeshim.Scope", methodName : "getDirectives"}),tink_core__$Promise_Next_$Impl_$.ofSafeSync($bind(this,this.parseDirectives)));
	}
	,getLibCommand: function(args) {
		var _gthis = this;
		args = args.map($bind(this,this.interpolate));
		var lib = args.shift();
		return tink_core__$Promise_Promise_$Impl_$.next(this.getDirectives(lib),function(d) {
			var _g = __map_reserved["run"] != null ? d.getReserved("run") : d.h["run"];
			if(_g == null) {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"no @run directive found for library " + lib,{ fileName : "haxeshim/Scope.hx", lineNumber : 212, className : "haxeshim.Scope", methodName : "getLibCommand"})));
			} else {
				switch(_g.length) {
				case 0:
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"no @run directive found for library " + lib,{ fileName : "haxeshim/Scope.hx", lineNumber : 212, className : "haxeshim.Scope", methodName : "getLibCommand"})));
				case 1:
					var cmd = _g[0];
					var cmd1 = [_gthis.interpolate(cmd)];
					var cmd2 = haxeshim_Os.IS_WINDOWS ? function(argument) {
						return StringTools.quoteWinArg(argument,true);
					} : StringTools.quoteUnixArg;
					var cmd3 = cmd1.concat(args.map(cmd2)).join(" ");
					var cwd = process.cwd();
					var env = _gthis.haxeInstallation.env();
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(function() {
						return haxeshim_Exec.shell(cmd3,cwd,env);
					}));
				default:
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"more than one @run directive for library " + lib,{ fileName : "haxeshim/Scope.hx", lineNumber : 217, className : "haxeshim.Scope", methodName : "getLibCommand"})));
				}
			}
		});
	}
	,getInstallationInstructions: function() {
		var missing = [];
		var instructions = { install : [], postInstall : []};
		var _g = 0;
		var _g1 = js_node_Fs.readdirSync(this.scopeLibDir);
		while(_g < _g1.length) {
			var child = _g1[_g];
			++_g;
			var path = "" + this.scopeLibDir + "/" + child;
			if(!sys_FileSystem.isDirectory(path) && StringTools.endsWith(path,".hxml")) {
				var hxml = js_node_Fs.readFileSync(path,{ encoding : "utf8"});
				var args = haxeshim_Resolver.parseLines(hxml);
				var pos = 0;
				var max = args.length;
				while(pos < max) {
					var _g2 = args[pos++];
					if(_g2 == "-cp") {
						var cp = this.interpolate(args[pos++]);
						if(!sys_FileSystem.exists(cp)) {
							var dir = this.parseDirectives(hxml);
							var _g21 = __map_reserved["install"] != null ? dir.getReserved("install") : dir.h["install"];
							if(_g21 == null) {
								missing.push({ lib : child, cp : cp});
							} else if(_g21.length == 0) {
								missing.push({ lib : child, cp : cp});
							} else {
								var v = _g21;
								var _g22 = 0;
								while(_g22 < v.length) {
									var i = v[_g22];
									++_g22;
									instructions.install.push(i);
								}
								var _g23 = __map_reserved["post-install"] != null ? dir.getReserved("post-install") : dir.h["post-install"];
								if(_g23 != null) {
									var v1 = _g23;
									var _g24 = 0;
									while(_g24 < v1.length) {
										var i1 = v1[_g24];
										++_g24;
										instructions.postInstall.push(this.interpolate(i1));
									}
								}
							}
							pos = max;
						}
					}
				}
			}
		}
		return { missing : missing, instructions : instructions};
	}
	,__class__: haxeshim_Scope
};
var haxeshim_Neko = function() { };
$hxClasses["haxeshim.Neko"] = haxeshim_Neko;
haxeshim_Neko.__name__ = ["haxeshim","Neko"];
haxeshim_Neko.setEnv = function() {
	if(haxeshim_Neko.isset) {
		if(haxeshim_Os.IS_WINDOWS) {
			var _g = 0;
			var this1 = haxeshim_Neko.ENV;
			var _g1 = this1 == null ? [] : Reflect.fields(this1);
			while(_g < _g1.length) {
				var k = _g1[_g];
				++_g;
				var v = haxeshim__$Env_Env_$Impl_$.get(haxeshim_Neko.ENV,k);
				process.env[k] = v;
			}
		}
		haxeshim_Neko.isset = false;
	}
};
var haxeshim_Resolver = function(cwd,libDir,mode,defaults) {
	this.cwd = haxe_io_Path.addTrailingSlash(haxe_io_Path.normalize(cwd));
	this.libDir = libDir;
	this.mode = mode;
	this.defaults = defaults;
};
$hxClasses["haxeshim.Resolver"] = haxeshim_Resolver;
haxeshim_Resolver.__name__ = ["haxeshim","Resolver"];
haxeshim_Resolver.interpolate = function(s,defaults) {
	if(s.indexOf("${") == -1) {
		return s;
	}
	var ret_b = "";
	var pos = 0;
	while(pos < s.length) {
		var _g = s.indexOf("${",pos);
		if(_g == -1) {
			ret_b += HxOverrides.substr(s,pos,null);
			break;
		} else {
			var v = _g;
			var len = v - pos;
			ret_b += len == null ? HxOverrides.substr(s,pos,null) : HxOverrides.substr(s,pos,len);
			var start = v + 2;
			var end;
			var _g1 = s.indexOf("}",start);
			if(_g1 == -1) {
				throw new js__$Boot_HaxeError("unclosed interpolation in " + s);
			} else {
				var v1 = _g1;
				end = v1;
			}
			var name = HxOverrides.substr(s,start,end - start);
			var x;
			var _g11 = process.env[name];
			if(_g11 == null) {
				var _g12 = defaults(name);
				if(_g12 == null) {
					throw new js__$Boot_HaxeError("unknown variable " + name);
				} else {
					var v2 = _g12;
					x = v2;
				}
			} else if(_g11 == "") {
				var _g13 = defaults(name);
				if(_g13 == null) {
					throw new js__$Boot_HaxeError("unknown variable " + name);
				} else {
					var v3 = _g13;
					x = v3;
				}
			} else {
				var v4 = _g11;
				x = v4;
			}
			ret_b += Std.string(x);
			pos = end + 1;
		}
	}
	return ret_b;
};
haxeshim_Resolver.libHxml = function(libDir,libName) {
	return "" + libDir + "/" + libName + ".hxml";
};
haxeshim_Resolver.parseLines = function(source,normalize) {
	if(normalize == null) {
		normalize = function(x) {
			return [x];
		};
	}
	var ret = [];
	var _g = 0;
	var _g1 = source.split("\n").map(StringTools.trim);
	while(_g < _g1.length) {
		var line = _g1[_g];
		++_g;
		var _g2 = line.charAt(0);
		if(_g2 != null) {
			switch(_g2) {
			case "#":
				break;
			case "-":
				var _g21 = line.indexOf(" ");
				if(_g21 == -1) {
					ret.push(line);
				} else {
					var v = _g21;
					ret.push(HxOverrides.substr(line,0,v));
					ret.push(StringTools.trim(HxOverrides.substr(line,v,null)));
				}
				break;
			default:
				var _g22 = StringTools.trim(line);
				if(_g22 != "") {
					var v1 = _g22;
					var _g23 = 0;
					var _g3 = normalize(v1);
					while(_g23 < _g3.length) {
						var a = _g3[_g23];
						++_g23;
						ret.push(a);
					}
				}
			}
		}
	}
	return ret;
};
haxeshim_Resolver.prototype = {
	__class__: haxeshim_Resolver
};
var httpstatus__$HttpStatusMessage_HttpStatusMessage_$Impl_$ = {};
$hxClasses["httpstatus._HttpStatusMessage.HttpStatusMessage_Impl_"] = httpstatus__$HttpStatusMessage_HttpStatusMessage_$Impl_$;
httpstatus__$HttpStatusMessage_HttpStatusMessage_$Impl_$.__name__ = ["httpstatus","_HttpStatusMessage","HttpStatusMessage_Impl_"];
httpstatus__$HttpStatusMessage_HttpStatusMessage_$Impl_$.fromCode = function(statusCode) {
	switch(statusCode) {
	case 100:
		return "Continue";
	case 101:
		return "Switching Protocols";
	case 102:
		return "Processing";
	case 200:
		return "OK";
	case 201:
		return "Created";
	case 202:
		return "Accepted";
	case 203:
		return "Non-Authoritative Information";
	case 204:
		return "No Content";
	case 205:
		return "Reset Content";
	case 206:
		return "Partial Content";
	case 207:
		return "Multi-Status";
	case 208:
		return "Already Reported";
	case 226:
		return "IM Used";
	case 300:
		return "Multiple Choices";
	case 301:
		return "Moved Permanently";
	case 302:
		return "Found";
	case 303:
		return "See Other";
	case 304:
		return "Not Modified";
	case 305:
		return "Use Proxy";
	case 306:
		return "Switch Proxy";
	case 307:
		return "Temporary Redirect";
	case 308:
		return "Permanent Redirect";
	case 400:
		return "Bad Request";
	case 401:
		return "Unauthorized";
	case 402:
		return "Payment Required";
	case 403:
		return "Forbidden";
	case 404:
		return "Not Found";
	case 405:
		return "Method Not Allowed";
	case 406:
		return "Not Acceptable";
	case 407:
		return "Proxy Authentication Required";
	case 408:
		return "Request Timeout";
	case 409:
		return "Conflict";
	case 410:
		return "Gone";
	case 411:
		return "Length Required";
	case 412:
		return "Precondition Failed";
	case 413:
		return "Payload Too Large";
	case 414:
		return "URI Too Long";
	case 415:
		return "Unsupported Media Type";
	case 416:
		return "Range Not Satisfiable";
	case 417:
		return "Expectation Failed";
	case 418:
		return "I'm a teapot";
	case 421:
		return "Misdirected Request";
	case 422:
		return "Unprocessable Entity";
	case 423:
		return "Locked";
	case 424:
		return "Failed Dependency";
	case 426:
		return "Upgrade Required";
	case 428:
		return "Precondition Required";
	case 429:
		return "Too Many Requests";
	case 431:
		return "Request Header Fields Too Large";
	case 451:
		return "Unavailable For Legal Reasons";
	case 500:
		return "Internal Server Error";
	case 501:
		return "Not Implemented";
	case 502:
		return "Bad Gateway";
	case 503:
		return "Service Unavailable";
	case 504:
		return "Gateway Timeout";
	case 505:
		return "HTTP Version Not Supported";
	case 506:
		return "Variant Also Negotiates";
	case 507:
		return "Insufficient Storage";
	case 508:
		return "Loop Detected";
	case 510:
		return "Not Extended";
	case 511:
		return "Network Authentication Required";
	default:
		return "Unknown Status";
	}
};
var js__$Boot_HaxeError = function(val) {
	Error.call(this);
	this.val = val;
	if(Error.captureStackTrace) {
		Error.captureStackTrace(this,js__$Boot_HaxeError);
	}
};
$hxClasses["js._Boot.HaxeError"] = js__$Boot_HaxeError;
js__$Boot_HaxeError.__name__ = ["js","_Boot","HaxeError"];
js__$Boot_HaxeError.wrap = function(val) {
	if((val instanceof Error)) {
		return val;
	} else {
		return new js__$Boot_HaxeError(val);
	}
};
js__$Boot_HaxeError.__super__ = Error;
js__$Boot_HaxeError.prototype = $extend(Error.prototype,{
	__class__: js__$Boot_HaxeError
});
var js_Boot = function() { };
$hxClasses["js.Boot"] = js_Boot;
js_Boot.__name__ = ["js","Boot"];
js_Boot.getClass = function(o) {
	if((o instanceof Array) && o.__enum__ == null) {
		return Array;
	} else {
		var cl = o.__class__;
		if(cl != null) {
			return cl;
		}
		var name = js_Boot.__nativeClassName(o);
		if(name != null) {
			return js_Boot.__resolveNativeClass(name);
		}
		return null;
	}
};
js_Boot.__string_rec = function(o,s) {
	if(o == null) {
		return "null";
	}
	if(s.length >= 5) {
		return "<...>";
	}
	var t = typeof(o);
	if(t == "function" && (o.__name__ || o.__ename__)) {
		t = "object";
	}
	switch(t) {
	case "function":
		return "<function>";
	case "object":
		if((o instanceof Array)) {
			if(o.__enum__) {
				if(o.length == 2) {
					return o[0];
				}
				var str = o[0] + "(";
				s += "\t";
				var _g1 = 2;
				var _g = o.length;
				while(_g1 < _g) {
					var i = _g1++;
					if(i != 2) {
						str += "," + js_Boot.__string_rec(o[i],s);
					} else {
						str += js_Boot.__string_rec(o[i],s);
					}
				}
				return str + ")";
			}
			var l = o.length;
			var i1;
			var str1 = "[";
			s += "\t";
			var _g11 = 0;
			var _g2 = l;
			while(_g11 < _g2) {
				var i2 = _g11++;
				str1 += (i2 > 0 ? "," : "") + js_Boot.__string_rec(o[i2],s);
			}
			str1 += "]";
			return str1;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( e ) {
			var e1 = (e instanceof js__$Boot_HaxeError) ? e.val : e;
			return "???";
		}
		if(tostr != null && tostr != Object.toString && typeof(tostr) == "function") {
			var s2 = o.toString();
			if(s2 != "[object Object]") {
				return s2;
			}
		}
		var k = null;
		var str2 = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		for( var k in o ) {
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str2.length != 2) {
			str2 += ", \n";
		}
		str2 += s + k + " : " + js_Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str2 += "\n" + s + "}";
		return str2;
	case "string":
		return o;
	default:
		return String(o);
	}
};
js_Boot.__interfLoop = function(cc,cl) {
	if(cc == null) {
		return false;
	}
	if(cc == cl) {
		return true;
	}
	var intf = cc.__interfaces__;
	if(intf != null) {
		var _g1 = 0;
		var _g = intf.length;
		while(_g1 < _g) {
			var i = _g1++;
			var i1 = intf[i];
			if(i1 == cl || js_Boot.__interfLoop(i1,cl)) {
				return true;
			}
		}
	}
	return js_Boot.__interfLoop(cc.__super__,cl);
};
js_Boot.__instanceof = function(o,cl) {
	if(cl == null) {
		return false;
	}
	switch(cl) {
	case Array:
		if((o instanceof Array)) {
			return o.__enum__ == null;
		} else {
			return false;
		}
		break;
	case Bool:
		return typeof(o) == "boolean";
	case Dynamic:
		return true;
	case Float:
		return typeof(o) == "number";
	case Int:
		if(typeof(o) == "number") {
			return ((o | 0) === o);
		} else {
			return false;
		}
		break;
	case String:
		return typeof(o) == "string";
	default:
		if(o != null) {
			if(typeof(cl) == "function") {
				if((o instanceof cl)) {
					return true;
				}
				if(js_Boot.__interfLoop(js_Boot.getClass(o),cl)) {
					return true;
				}
			} else if(typeof(cl) == "object" && js_Boot.__isNativeObj(cl)) {
				if((o instanceof cl)) {
					return true;
				}
			}
		} else {
			return false;
		}
		if(cl == Class ? o.__name__ != null : false) {
			return true;
		}
		if(cl == Enum ? o.__ename__ != null : false) {
			return true;
		}
		return o.__enum__ == cl;
	}
};
js_Boot.__nativeClassName = function(o) {
	var name = js_Boot.__toStr.call(o).slice(8,-1);
	if(name == "Object" || name == "Function" || name == "Math" || name == "JSON") {
		return null;
	}
	return name;
};
js_Boot.__isNativeObj = function(o) {
	return js_Boot.__nativeClassName(o) != null;
};
js_Boot.__resolveNativeClass = function(name) {
	return $global[name];
};
var js_node_ChildProcess = require("child_process");
var js_node_Fs = require("fs");
var js_node_Http = require("http");
var js_node_Https = require("https");
var js_node_Os = require("os");
var js_node_Path = require("path");
var js_node_Readline = require("readline");
var js_node_Url = require("url");
var js_node_buffer_Buffer = require("buffer").Buffer;
var js_node_buffer__$Buffer_Helper = function() { };
$hxClasses["js.node.buffer._Buffer.Helper"] = js_node_buffer__$Buffer_Helper;
js_node_buffer__$Buffer_Helper.__name__ = ["js","node","buffer","_Buffer","Helper"];
js_node_buffer__$Buffer_Helper.bytesOfBuffer = function(b) {
	var o = Object.create(haxe_io_Bytes.prototype);
	o.length = b.byteLength;
	o.b = b;
	b.bufferValue = b;
	b.hxBytes = o;
	b.bytes = b;
	return o;
};
var js_node_http_Server = require("http").Server;
var js_node_stream_PassThrough = require("stream").PassThrough;
var lix_Auth = function() {
	this.auth = new lix_CognitoAuth();
};
$hxClasses["lix.Auth"] = lix_Auth;
lix_Auth.__name__ = ["lix","Auth"];
lix_Auth.prototype = {
	getSession: function() {
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			var container = new tink_http_containers_NodeContainer(tink_http_containers__$NodeContainer_ServerKindBase.Port(51379));
			var router = new tink_web_routing_Router0(new lix_Root(_gthis.auth));
			container.run(new tink_http_SimpleHandler(function(req) {
				var this1 = tink_web_routing_Context.ofRequest(req);
				var this2 = router.route(this1);
				var f = tink_core__$Promise_Recover_$Impl_$.ofSync(tink_http__$Response_OutgoingResponse_$Impl_$.reportError);
				var ret = this2.flatMap(function(o) {
					switch(o[1]) {
					case 0:
						var d = o[2];
						return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(d));
					case 1:
						var e = o[2];
						return f(e);
					}
				});
				return ret.gather();
			})).handle(function(o1) {
				switch(o1[1]) {
				case 0:
					var state = o1[2];
					tink_core__$Promise_Promise_$Impl_$.next(_gthis.auth.result,function(_) {
						return state.shutdown(false);
					}).eager();
					break;
				case 1:
					var e1 = o1[2];
					cb(tink_core_Outcome.Failure(e1));
					break;
				case 2:
					var tmp = tink_core_Outcome.Failure(new tink_core_TypedError(null,"Unreachable",{ fileName : "lix/Auth.hx", lineNumber : 35, className : "lix.Auth", methodName : "getSession"}));
					cb(tmp);
					break;
				}
			});
			_gthis.auth.result.handle(cb);
			_gthis.auth.impl.getSession();
		});
	}
	,clearSession: function() {
		js_node_Fs.writeFileSync(haxe_io_Path.join([js_node_Os.homedir(),".lix/session"]),"{}");
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
	}
	,__class__: lix_Auth
};
var lix_Root = function(auth) {
	this.auth = auth;
};
$hxClasses["lix.Root"] = lix_Root;
lix_Root.__name__ = ["lix","Root"];
lix_Root.prototype = {
	callback: function() {
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
	}
	,done: function(query) {
		this.auth.impl.parseCognitoWebResponse("http://localhost:51379#" + new tink_querystring_Builder0().stringify(query));
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
	}
	,__class__: lix_Root
};
var lix_FileStorage = function(path) {
	this.path = path;
	sys_FileSystem.createDirectory(haxe_io_Path.directory(path));
};
$hxClasses["lix.FileStorage"] = lix_FileStorage;
lix_FileStorage.__name__ = ["lix","FileStorage"];
lix_FileStorage.prototype = {
	getItem: function(k) {
		return Reflect.field(this.read(),k);
	}
	,setItem: function(k,v) {
		var obj = this.read();
		obj[k] = v;
		this.write(obj);
	}
	,removeItem: function(k) {
		var obj = this.read();
		Reflect.deleteField(obj,k);
		this.write(obj);
	}
	,clear: function() {
		this.write({ });
	}
	,read: function() {
		try {
			return JSON.parse(js_node_Fs.readFileSync(this.path).toString());
		} catch( e ) {
			var e1 = (e instanceof js__$Boot_HaxeError) ? e.val : e;
			return { };
		}
	}
	,write: function(v) {
		js_node_Fs.writeFileSync(this.path,JSON.stringify(v));
	}
	,__class__: lix_FileStorage
};
var lix_CognitoAuth = function() {
	var _gthis = this;
	global.atob = function(str) {
		return js_node_buffer_Buffer.from(str,"base64").toString("binary");
	};
	global.window = { open : function(url) {
		return require("opn")(url,{ wait : false});
	}};
	this.impl = new aws_cognito_CognitoAuth({ ClientId : "fvrf50i7h5od9nr1bq4pefcg3", AppWebDomain : "login.lix.pm", RedirectUriSignIn : "http://localhost:51379/callback", RedirectUriSignOut : "http://localhost:51379/logout", TokenScopesArray : ["openid"], UserPoolId : "us-east-2_qNnxj1mU1", Storage : new lix_FileStorage(haxe_io_Path.join([js_node_Os.homedir(),".lix/session"]))});
	this.result = tink_core__$Future_Future_$Impl_$.async(function(cb) {
		_gthis.impl.userhandler = { onSuccess : function(session) {
			cb(tink_core_Outcome.Success({ idToken : session.idToken.jwtToken, accessToken : session.accessToken.jwtToken, refreshToken : session.refreshToken.refreshToken, scopes : session.tokenScopes.tokenScopes}));
			return;
		}, onFailure : function(e) {
			var tmp = tink_core_Outcome.Failure(tink_core_TypedError.withData(500,e.message,e,{ fileName : "lix/Auth.hx", lineNumber : 130, className : "lix.CognitoAuth", methodName : "new"}));
			cb(tmp);
			return;
		}};
	});
};
$hxClasses["lix.CognitoAuth"] = lix_CognitoAuth;
lix_CognitoAuth.__name__ = ["lix","CognitoAuth"];
lix_CognitoAuth.prototype = {
	__class__: lix_CognitoAuth
};
var lix_Packager = function(zip,scanner,options) {
	this.zip = zip;
	this.scanner = scanner;
	var patterns;
	if(options == null) {
		patterns = [];
	} else if(options.ignore == null) {
		patterns = [];
	} else {
		var v = options.ignore;
		patterns = v.split("\n");
	}
	patterns.push(".git");
	patterns.push(".DS_Store");
	this.ignore = new lix_Ignore(patterns);
};
$hxClasses["lix.Packager"] = lix_Packager;
lix_Packager.__name__ = ["lix","Packager"];
lix_Packager.prototype = {
	pack: function() {
		var _gthis = this;
		return this.zip.pack(this.scanner.scan().filter(tink_streams__$Stream_Filter_$Impl_$.ofPlain(function(entry) {
			return !_gthis.ignore.ignore.ignores(entry.name);
		})));
	}
	,__class__: lix_Packager
};
var lix_Ignore = function(entries) {
	this.ignore = require("ignore")().add(entries);
};
$hxClasses["lix.Ignore"] = lix_Ignore;
lix_Ignore.__name__ = ["lix","Ignore"];
lix_Ignore.prototype = {
	__class__: lix_Ignore
};
var tink_http_ClientObject = function() { };
$hxClasses["tink.http.ClientObject"] = tink_http_ClientObject;
tink_http_ClientObject.__name__ = ["tink","http","ClientObject"];
tink_http_ClientObject.prototype = {
	__class__: tink_http_ClientObject
};
var lix_AuthedClient = function(proxy,getIdToken) {
	this.proxy = proxy;
	this.getIdToken = getIdToken;
};
$hxClasses["lix.AuthedClient"] = lix_AuthedClient;
lix_AuthedClient.__name__ = ["lix","AuthedClient"];
lix_AuthedClient.__interfaces__ = [tink_http_ClientObject];
lix_AuthedClient.prototype = {
	request: function(req) {
		var _gthis = this;
		return tink_core__$Promise_Promise_$Impl_$.next(this.getIdToken(),function(token) {
			return _gthis.proxy.request(new tink_http_OutgoingRequest(req.header.concat([new tink_http_HeaderField("authorization","Bearer" + " " + token)]),req.body));
		});
	}
	,__class__: lix_AuthedClient
};
var lix_Submitter = function(remote,zip,getScanner) {
	this.remote = remote;
	this.zip = zip;
	this.getScanner = getScanner;
};
$hxClasses["lix.Submitter"] = lix_Submitter;
lix_Submitter.__name__ = ["lix","Submitter"];
lix_Submitter.prototype = {
	submit: function(directory) {
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.async(function(__return) {
			try {
				if(directory == null) {
					directory = process.cwd();
				}
				asys_io_File.getContent(haxe_io_Path.join([directory,"lix.json"])).handle(function(__t0) {
					try {
						var __t0_result;
						var _g = tink_await_OutcomeTools.getOutcome(__t0);
						switch(_g[1]) {
						case 0:
							var v = _g[2];
							__t0_result = v;
							break;
						case 1:
							var e = _g[2];
							__return(tink_core_Outcome.Failure(e));
							return;
						}
						var content = __t0_result;
						var manifest = new tink_json_Parser3().parse(content);
						var ret = asys_io_File.getContent(haxe_io_Path.join([directory,".lixignore"])).flatMap(function(o) {
							switch(o[1]) {
							case 0:
								var d = o[2];
								return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(d));
							case 1:
								var e1 = o[2];
								return tink_core__$Future_Future_$Impl_$.NULL;
							}
						});
						ret.gather().handle(function(__t1) {
							try {
								var __t1_result;
								var _g1 = tink_await_OutcomeTools.getOutcome(null,__t1);
								switch(_g1[1]) {
								case 0:
									var v1 = _g1[2];
									__t1_result = v1;
									break;
								case 1:
									var e2 = _g1[2];
									__return(tink_core_Outcome.Failure(e2));
									return;
								}
								var lixignore = __t1_result;
								var packager = new lix_Packager(_gthis.zip,_gthis.getScanner(directory),{ ignore : lixignore});
								_gthis.remote.me().get().handle(function(__t2) {
									try {
										var __t2_result;
										var _g2 = tink_await_OutcomeTools.getOutcome(__t2);
										switch(_g2[1]) {
										case 0:
											var v2 = _g2[2];
											__t2_result = v2;
											break;
										case 1:
											var e3 = _g2[2];
											__return(tink_core_Outcome.Failure(e3));
											return;
										}
										var me = __t2_result;
										var owner = manifest.owner == null ? me.username : manifest.owner;
										var slug = owner + "/" + manifest.name;
										var f = function(e4) {
											if(e4.code == 404) {
												return tink_core__$Promise_Promise_$Impl_$.noise(_gthis.remote.owners().byName(owner).projects().create(manifest));
											} else {
												return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(e4));
											}
										};
										var ret1 = tink_core__$Promise_Promise_$Impl_$.next(_gthis.remote.projects().byId(slug).info(),function(project) {
											return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
										}).flatMap(function(o1) {
											switch(o1[1]) {
											case 0:
												var d1 = o1[2];
												return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(o1));
											case 1:
												var e5 = o1[2];
												return f(e5);
											}
										});
										ret1.gather().handle(function(__t3) {
											try {
												var __t3_result;
												var _g3 = tink_await_OutcomeTools.getOutcome(__t3);
												switch(_g3[1]) {
												case 0:
													var v3 = _g3[2];
													__t3_result = v3;
													break;
												case 1:
													var e6 = _g3[2];
													__return(tink_core_Outcome.Failure(e6));
													return;
												}
												var this1 = _gthis.remote.projects().byId(slug).versions();
												var manifest1 = manifest.version;
												var _g4 = [];
												var _g5 = 0;
												var _g6 = manifest.dependencies;
												while(_g5 < _g6.length) {
													var dep = _g6[_g5];
													++_g5;
													_g4.push({ name : dep.name, constraint : dep.version});
												}
												this1.create({ version : manifest1, dependencies : _g4, haxe : manifest.haxe}).handle(function(__t4) {
													try {
														var __t4_result;
														var _g51 = tink_await_OutcomeTools.getOutcome(__t4);
														switch(_g51[1]) {
														case 0:
															var v4 = _g51[2];
															__t4_result = v4;
															break;
														case 1:
															var e7 = _g51[2];
															__return(tink_core_Outcome.Failure(e7));
															return;
														}
														var version = __t4_result;
														_gthis.remote.projects().byId(slug).versions().byVersion(manifest.version).upload().handle(function(__t5) {
															try {
																var __t5_result;
																var _g61 = tink_await_OutcomeTools.getOutcome(__t5);
																switch(_g61[1]) {
																case 0:
																	var v5 = _g61[2];
																	__t5_result = v5;
																	break;
																case 1:
																	var e8 = _g61[2];
																	__return(tink_core_Outcome.Failure(e8));
																	return;
																}
																var request = __t5_result;
																tink_io_RealSourceTools.all(packager.pack()).handle(function(__t6) {
																	try {
																		var __t6_result;
																		var _g7 = tink_await_OutcomeTools.getOutcome(__t6);
																		switch(_g7[1]) {
																		case 0:
																			var v6 = _g7[2];
																			__t6_result = v6;
																			break;
																		case 1:
																			var e9 = _g7[2];
																			__return(tink_core_Outcome.Failure(e9));
																			return;
																		}
																		var bundle = __t6_result;
																		tink_http__$Fetch_FetchResponse_$Impl_$.all(tink_http_Fetch.fetch(tink__$Url_Url_$Impl_$.fromString(request.url),{ headers : [new tink_http_HeaderField("content-length",Std.string(bundle.getLength())),new tink_http_HeaderField("content-type","application/zip")], method : request.method, body : new tink_streams_Single(new tink_core__$Lazy_LazyConst(bundle))})).handle(function(__t7) {
																			try {
																				var __t7_result;
																				var _g8 = tink_await_OutcomeTools.getOutcome(__t7);
																				switch(_g8[1]) {
																				case 0:
																					var v7 = _g8[2];
																					__t7_result = v7;
																					break;
																				case 1:
																					var e10 = _g8[2];
																					__return(tink_core_Outcome.Failure(e10));
																					return;
																				}
																				var response = __t7_result;
																				__return(tink_core_Outcome.Success(tink_core_Noise.Noise));
																				return;
																			} catch( e11 ) {
																				__return(tink_core_Outcome.Failure((e11 instanceof js__$Boot_HaxeError) ? e11.val : e11));
																			}
																		});
																	} catch( e12 ) {
																		__return(tink_core_Outcome.Failure((e12 instanceof js__$Boot_HaxeError) ? e12.val : e12));
																	}
																});
															} catch( e13 ) {
																__return(tink_core_Outcome.Failure((e13 instanceof js__$Boot_HaxeError) ? e13.val : e13));
															}
														});
													} catch( e14 ) {
														__return(tink_core_Outcome.Failure((e14 instanceof js__$Boot_HaxeError) ? e14.val : e14));
													}
												});
											} catch( e15 ) {
												__return(tink_core_Outcome.Failure((e15 instanceof js__$Boot_HaxeError) ? e15.val : e15));
											}
										});
									} catch( e16 ) {
										__return(tink_core_Outcome.Failure((e16 instanceof js__$Boot_HaxeError) ? e16.val : e16));
									}
								});
							} catch( e17 ) {
								__return(tink_core_Outcome.Failure((e17 instanceof js__$Boot_HaxeError) ? e17.val : e17));
							}
						});
					} catch( e18 ) {
						__return(tink_core_Outcome.Failure((e18 instanceof js__$Boot_HaxeError) ? e18.val : e18));
					}
				});
			} catch( e19 ) {
				__return(tink_core_Outcome.Failure((e19 instanceof js__$Boot_HaxeError) ? e19.val : e19));
			}
		});
	}
	,__class__: lix_Submitter
};
var lix_api_OwnerApi = function() { };
$hxClasses["lix.api.OwnerApi"] = lix_api_OwnerApi;
lix_api_OwnerApi.__name__ = ["lix","api","OwnerApi"];
var lix_api_ProjectsApi = function() { };
$hxClasses["lix.api.ProjectsApi"] = lix_api_ProjectsApi;
lix_api_ProjectsApi.__name__ = ["lix","api","ProjectsApi"];
var lix_api_OwnerProjectsApi = function() { };
$hxClasses["lix.api.OwnerProjectsApi"] = lix_api_OwnerProjectsApi;
lix_api_OwnerProjectsApi.__name__ = ["lix","api","OwnerProjectsApi"];
lix_api_OwnerProjectsApi.__interfaces__ = [lix_api_ProjectsApi];
var lix_api_OwnersApi = function() { };
$hxClasses["lix.api.OwnersApi"] = lix_api_OwnersApi;
lix_api_OwnersApi.__name__ = ["lix","api","OwnersApi"];
var lix_api_ProjectApi = function() { };
$hxClasses["lix.api.ProjectApi"] = lix_api_ProjectApi;
lix_api_ProjectApi.__name__ = ["lix","api","ProjectApi"];
var lix_api_Root = function() { };
$hxClasses["lix.api.Root"] = lix_api_Root;
lix_api_Root.__name__ = ["lix","api","Root"];
var lix_api_UserApi = function() { };
$hxClasses["lix.api.UserApi"] = lix_api_UserApi;
lix_api_UserApi.__name__ = ["lix","api","UserApi"];
var lix_api_VersionApi = function() { };
$hxClasses["lix.api.VersionApi"] = lix_api_VersionApi;
lix_api_VersionApi.__name__ = ["lix","api","VersionApi"];
var lix_api_VersionsApi = function() { };
$hxClasses["lix.api.VersionsApi"] = lix_api_VersionsApi;
lix_api_VersionsApi.__name__ = ["lix","api","VersionsApi"];
var lix_cli_Cli = function() { };
$hxClasses["lix.cli.Cli"] = lix_cli_Cli;
lix_cli_Cli.__name__ = ["lix","cli","Cli"];
lix_cli_Cli.main = function() {
	var tmp = lix_cli_HaxeCmd.ensureScope();
	var args = process.argv.slice(2);
	lix_cli_Command.attempt(tmp,tink_core__$Callback_Callback_$Impl_$.fromNiladic(function() {
		lix_cli_Cli.dispatch(args);
	}));
};
lix_cli_Cli.dispatch = function(args) {
	var version = "15.4.0-rc.1";
	var silent = HxOverrides.remove(args,"--silent");
	var force = HxOverrides.remove(args,"--force");
	var global1 = HxOverrides.remove(args,"--global") || HxOverrides.remove(args,"-g");
	var scope = haxeshim_Scope.seek({ cwd : global1 ? haxeshim_Scope.DEFAULT_ROOT : null});
	var args1 = lix_cli__$Command_CommandExpander_$Impl_$.ofString("+tink install github:haxetink/tink_${0}");
	var args2 = lix_cli__$Command_CommandExpander_$Impl_$.ofString("+coco install github:MVCoconut/coconut.${0}");
	args = lix_cli_Command.expand(args,[args1,args2,lix_cli__$Command_CommandExpander_$Impl_$.ofString("+lib install haxelib:${0}")]);
	var grab = function(name) {
		var _g = args.indexOf(name);
		if(_g == -1) {
			return null;
		} else {
			var v = _g;
			return args.splice(v,2)[1];
		}
	};
	var gitlab = new lix_client_sources_GitLab(grab("--gl-private-token"));
	var _g1 = grab("--gh-credentials");
	var _hx_tmp;
	var github;
	if(_g1 == null) {
		github = null;
	} else {
		_hx_tmp = _g1.split(":");
		if(_hx_tmp.length == 2) {
			var tk = _hx_tmp[1];
			var user = _hx_tmp[0];
			var this1 = "" + user + ":" + tk;
			github = this1;
		} else {
			var v1 = _g1;
			github = haxeshim_Exec.die(422,"`--gh-credentials " + v1 + "` should be `--gh-credentials <user>:<token>`");
		}
	}
	var github1 = new lix_client_sources_GitHub(github);
	var haxelibUrl = tink_url__$Host_Host_$Impl_$._new(grab("--haxelib-url"));
	var sources = [lix_client_sources_Web,new lix_client_sources_Lix(),new lix_client_sources_Haxelib(haxelibUrl),github1,gitlab,new lix_client_sources_Git(github1,gitlab,scope)];
	var _g11 = new haxe_ds_StringMap();
	var _g2 = 0;
	while(_g2 < sources.length) {
		var s = sources[_g2];
		++_g2;
		var _g3 = 0;
		var _g4 = s.schemes();
		while(_g3 < _g4.length) {
			var scheme = _g4[_g3];
			++_g3;
			if(__map_reserved[scheme] != null) {
				_g11.setReserved(scheme,s);
			} else {
				_g11.h[scheme] = s;
			}
		}
	}
	var resolvers = _g11;
	var resolve = function(url) {
		var key = url.scheme;
		var _g21 = __map_reserved[key] != null ? resolvers.getReserved(key) : resolvers.h[key];
		if(_g21 == null) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Unknown scheme in url " + tink__$Url_Url_$Impl_$.toString(url),{ fileName : "Cli.hx", lineNumber : 49, className : "lix.cli.Cli", methodName : "dispatch"})));
		} else {
			var v2 = _g21;
			return v2.processUrl(url);
		}
	};
	var log = silent ? function(_) {
	} : Sys.println;
	var hx = new lix_client_haxe_Switcher(scope,silent,log);
	var libs = new lix_client_Libraries(scope,resolve,function(_1) {
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(501,"not implemented",{ fileName : "Cli.hx", lineNumber : 60, className : "lix.cli.Cli", methodName : "dispatch"})));
	},log,force,silent);
	var auth = new lix_Auth();
	var client = new tink_http_clients_SecureNodeClient();
	var this2 = new tink_web_proxy_Remote0(new lix_AuthedClient(client,function() {
		return tink_core__$Promise_Promise_$Impl_$.next(auth.getSession(),function(session) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(session.idToken));
		});
	}),tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$._new(lix_util_Config.API_SERVER_HOST));
	var remote = this2;
	var this3 = "lix - Libraries for haXe (v" + version + ")";
	var this4 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("install"),"<url> [as <lib[#ver]>]","install lib from specified url",function(args3) {
		if(scope.isGlobal && !global1) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Current scope is global. Please use --global if you intend to install globally, or create a local scope with `lix scope create`.",{ fileName : "Cli.hx", lineNumber : 80, className : "lix.cli.Cli", methodName : "dispatch"})));
		} else {
			switch(args3.length) {
			case 0:
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Missing url",{ fileName : "Cli.hx", lineNumber : 93, className : "lix.cli.Cli", methodName : "dispatch"})));
			case 1:
				var library = args3[0];
				if(tink__$Url_Url_$Impl_$.fromString(library).scheme == null) {
					return libs.install(library);
				} else {
					var url1 = args3[0];
					return libs.installUrl(tink__$Url_Url_$Impl_$.fromString(url1));
				}
				break;
			case 2:
				if(args3[0] == "haxe") {
					var version1 = args3[1];
					return hx.install(version1,{ force : force});
				} else {
					var constraint = args3[1];
					var library1 = args3[0];
					var this5 = new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_semver__$Constraint_Constraint_$Impl_$.parse(constraint)));
					var f = $bind(libs,libs.install);
					var lib = library1;
					return tink_core__$Promise_Promise_$Impl_$.next(this5,function(constraint1) {
						return f(lib,constraint1);
					});
				}
				break;
			case 3:
				if(args3[1] == "as") {
					var alias = args3[2];
					var url2 = args3[0];
					var this6 = tink__$Url_Url_$Impl_$.fromString(url2);
					var this7 = lix_client_LibVersion.parse(alias);
					return libs.installUrl(this6,this7);
				} else {
					var v3 = args3;
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"too many arguments",{ fileName : "Cli.hx", lineNumber : 94, className : "lix.cli.Cli", methodName : "dispatch"})));
				}
				break;
			default:
				var v4 = args3;
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"too many arguments",{ fileName : "Cli.hx", lineNumber : 94, className : "lix.cli.Cli", methodName : "dispatch"})));
			}
		}
	});
	var this8 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("install haxe"),"<version>|<alias>","install specified haxe version",null);
	var this9 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("use"),"haxe <alias>|<version>","use specified haxe version",function(args4) {
		if(args4.length == 2) {
			if(args4[0] == "haxe") {
				var version2 = args4[1];
				return tink_core__$Promise_Promise_$Impl_$.next(hx.resolveInstalled(lix_client_haxe__$UserVersion_UserVersion_$Impl_$.ofString(version2)),$bind(hx,hx.switchTo));
			} else {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"invalid arguments",{ fileName : "Cli.hx", lineNumber : 100, className : "lix.cli.Cli", methodName : "dispatch"})));
			}
		} else {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"invalid arguments",{ fileName : "Cli.hx", lineNumber : 100, className : "lix.cli.Cli", methodName : "dispatch"})));
		}
	});
	var this10 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("download haxe"),"<version>|<alias>","download specified haxe version",null);
	var this11 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("scope"),"[create|delete]","creates or deletes the current scope or\ninspects it if no argument is supplied",function(args5) {
		switch(args5.length) {
		case 0:
			process.stdout.write(Std.string((scope.isGlobal ? "[global]" : "[local]") + (" " + scope.scopeDir)));
			process.stdout.write("\n");
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
		case 1:
			switch(args5[0]) {
			case "create":
				haxeshim_Scope.create(scope.cwd,{ version : scope.config.version, resolveLibs : scope.isGlobal ? "scoped" : scope.config.resolveLibs});
				log("created scope in " + scope.cwd);
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
			case "delete":
				if(scope.isGlobal) {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Cannot delete global scope",{ fileName : "Cli.hx", lineNumber : 114, className : "lix.cli.Cli", methodName : "dispatch"})));
				} else {
					scope["delete"]();
					log("deleted scope in " + scope.scopeDir);
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
				}
				break;
			default:
				var v5 = args5;
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Invalid arguments",{ fileName : "Cli.hx", lineNumber : 126, className : "lix.cli.Cli", methodName : "dispatch"})));
			}
			break;
		default:
			var v6 = args5;
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Invalid arguments",{ fileName : "Cli.hx", lineNumber : 126, className : "lix.cli.Cli", methodName : "dispatch"})));
		}
	});
	var this12 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("haxe-versions"),"","lists currently downloaded versions",function(args6) {
		if(args6.length == 0) {
			return tink_core__$Promise_Promise_$Impl_$.next(hx.officialInstalled(lix_client_haxe_PickOfficial.IncludePrereleases),function(o) {
				return tink_core__$Promise_Promise_$Impl_$.next(hx.nightliesInstalled(),function(n) {
					var highlight = function(s1) {
						if(s1 == scope.config.version) {
							return " -> " + s1;
						} else {
							return "    " + s1;
						}
					};
					process.stdout.write("");
					process.stdout.write("\n");
					process.stdout.write("Official releases:");
					process.stdout.write("\n");
					process.stdout.write("");
					process.stdout.write("\n");
					var v7 = $getIterator(o);
					while(v7.hasNext()) {
						var v8 = v7.next();
						var v9 = highlight(v8);
						process.stdout.write(Std.string(v9));
						process.stdout.write("\n");
					}
					if($getIterator(n).hasNext()) {
						process.stdout.write("");
						process.stdout.write("\n");
						process.stdout.write("Nightly builds:");
						process.stdout.write("\n");
						process.stdout.write("");
						process.stdout.write("\n");
						var v10 = $getIterator(n);
						while(v10.hasNext()) {
							var v11 = v10.next();
							var v12 = highlight(v11.hash) + DateTools.format(v11.published,"  (%Y-%m-%d %H:%M)");
							process.stdout.write(Std.string(v12));
							process.stdout.write("\n");
						}
					}
					process.stdout.write("");
					process.stdout.write("\n");
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
				});
			});
		} else {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"command `list` does expect arguments",{ fileName : "Cli.hx", lineNumber : 163, className : "lix.cli.Cli", methodName : "dispatch"})));
		}
	});
	var this13 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("download"),"[<url[#lib[#ver]]>]","download lib from url if specified,\notherwise download missing libs",function(args7) {
		switch(args7.length) {
		case 0:
			return tink_core__$Promise_Promise_$Impl_$.next(lix_client_haxe_Switcher.ensureNeko(Sys.println),function(_2) {
				var this14 = hx.resolveOnline(lix_client_haxe__$UserVersion_UserVersion_$Impl_$.ofString(scope.config.version));
				var f1 = $bind(hx,hx.download);
				var options = { force : false};
				return tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Promise_Promise_$Impl_$.next(this14,function(version3) {
					return f1(version3,options);
				}),function(_3) {
					new haxeshim_HaxeCli(scope).installLibs(silent);
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
				});
			});
		case 1:
			var _hx_tmp1 = tink__$Url_Url_$Impl_$.fromString(args7[0]);
			var url3 = _hx_tmp1;
			return tink_core__$Promise_Promise_$Impl_$.noise(libs.downloadUrl(url3));
		case 2:
			if(args7[0] == "haxe") {
				var version4 = args7[1];
				return tink_core__$Promise_Promise_$Impl_$.noise(hx.resolveAndDownload(version4,{ force : force}));
			} else {
				var v13 = args7;
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"too many arguments",{ fileName : "Cli.hx", lineNumber : 208, className : "lix.cli.Cli", methodName : "dispatch"})));
			}
			break;
		case 3:
			switch(args7[1]) {
			case "as":
				var legacy = args7[2];
				var url4 = args7[0];
				var target = StringTools.replace(legacy,"#","/");
				var absTarget = scope.libCache + ("/" + target);
				var shorten = function(s2) {
					if(s2.length > 40) {
						return HxOverrides.substr(s2,0,37) + "...";
					} else {
						return s2;
					}
				};
				if(sys_FileSystem.exists(absTarget)) {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"`download <url> as <ver>` is no longer supported",{ fileName : "Cli.hx", lineNumber : 179, className : "lix.cli.Cli", methodName : "dispatch"})));
				} else {
					var v14 = "[WARN]: Processing obsolete `download " + args7.map(shorten).join(" ") + "`.\n        Please reinstall library in a timely manner!\n\n";
					process.stdout.write(Std.string(v14));
					process.stdout.write("\n");
					return tink_core__$Promise_Promise_$Impl_$.noise(tink_core__$Promise_Promise_$Impl_$.next(libs.downloadUrl(tink__$Url_Url_$Impl_$.fromString(url4),{ into : target}),function(a) {
						haxeshim_Fs.ensureDir(absTarget);
						js_node_Fs.renameSync(haxe_io_Path.removeTrailingSlashes("" + a.storageRoot + "/" + a.relRoot),absTarget);
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(a));
					}));
				}
				break;
			case "into":
				var dir = args7[2];
				var url5 = args7[0];
				return tink_core__$Promise_Promise_$Impl_$.noise(libs.downloadUrl(tink__$Url_Url_$Impl_$.fromString(url5),{ into : dir}));
			default:
				var v15 = args7;
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"too many arguments",{ fileName : "Cli.hx", lineNumber : 208, className : "lix.cli.Cli", methodName : "dispatch"})));
			}
			break;
		default:
			var v16 = args7;
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"too many arguments",{ fileName : "Cli.hx", lineNumber : 208, className : "lix.cli.Cli", methodName : "dispatch"})));
		}
	});
	var this15 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("run"),"lib ...args","run a library",function(args8) {
		if(args8.length == 0) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"no library specified",{ fileName : "Cli.hx", lineNumber : 212, className : "lix.cli.Cli", methodName : "dispatch"})));
		} else {
			var args9 = args8;
			return tink_core__$Promise_Promise_$Impl_$.noise(tink_core__$Promise_Promise_$Impl_$.next(scope.getLibCommand(args9),function(cmd) {
				return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(cmd()));
			}));
		}
	});
	var this16 = new lix_cli_Command(["--version","-v"],"","print version",function(args10) {
		if(args10.length > 0) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"too many arguments",{ fileName : "Cli.hx", lineNumber : 218, className : "lix.cli.Cli", methodName : "dispatch"})));
		} else {
			process.stdout.write(version == null ? "null" : "" + version);
			process.stdout.write("\n");
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
		}
	});
	var this17 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("run-haxelib"),"path ...args","invoke a haxelib at a given path following haxelib's conventions",function(args11) {
		if(args11.length == 0) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"no path supplied",{ fileName : "Cli.hx", lineNumber : 226, className : "lix.cli.Cli", methodName : "dispatch"})));
		} else {
			new haxeshim_HaxelibCli(scope).run(args11.slice(1));
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
		}
	});
	var this18 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("login"),"","log in the Lix Registry",function(args12) {
		var ret = tink_core__$Promise_Promise_$Impl_$.next(remote.me().get(),function(user1) {
			if(user1.username == null) {
				var readline = js_node_Readline.createInterface({ input : process.stdin, output : process.stdout});
				return tink_core__$Future_Future_$Impl_$.next(tink_core__$Future_Future_$Impl_$.async(function(cb) {
					readline.question("Please input a username for your Lix account: ",cb);
				}),function(username) {
					readline.close();
					var v17 = username;
					return tink_core__$Future_Future_$Impl_$._tryMap(remote.me().update({ username : haxe_ds_Option.Some(username), nickname : haxe_ds_Option.None}),function(_4) {
						return v17;
					});
				});
			} else {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(user1.username));
			}
		}).map(function(o1) {
			switch(o1[1]) {
			case 0:
				var username1 = o1[2];
				process.stdout.write(Std.string("Logged in as " + username1));
				process.stdout.write("\n");
				return tink_core_Outcome.Success(tink_core_Noise.Noise);
			case 1:
				var e = o1[2];
				process.stdout.write(Std.string(e));
				process.stdout.write("\n");
				return tink_core_Outcome.Failure(e);
			}
		});
		return ret.gather();
	});
	var this19 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("logout"),"","log out from the Lix Registry",function(args13) {
		auth.clearSession();
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
	});
	var this20 = new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("submit"),"[directory]","Submit package to the Lix Registry",function(args14) {
		if(args14.length > 1) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"command `submit` expectes 0 or 1 arguments",{ fileName : "Cli.hx", lineNumber : 263, className : "lix.cli.Cli", methodName : "dispatch"})));
		}
		var f2 = function(path,root) {
			return new archive_scanner_AsysScanner(path,root);
		};
		var submitter = function(path1) {
			return f2(path1,null);
		};
		var submitter1 = new lix_Submitter(remote,new archive_zip_NodeZip(),submitter);
		return submitter1.submit(args14[0]);
	});
	lix_cli_Command.dispatch(args,this3,[this4,this8,this9,this10,this11,this12,this13,this15,this16,this17,this18,this19,this20,new lix_cli_Command(lix_cli__$Command_CommandName_$Impl_$.ofString("owner"),"create <name>","Create an owner (organization) in the Lix Registry",function(args15) {
		if(args15.length == 2) {
			if(args15[0] == "create") {
				var name1 = args15[1];
				return tink_core__$Promise_Promise_$Impl_$.noise(remote.owners().create(name1));
			} else {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Invalid arguments",{ fileName : "Cli.hx", lineNumber : 272, className : "lix.cli.Cli", methodName : "dispatch"})));
			}
		} else {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Invalid arguments",{ fileName : "Cli.hx", lineNumber : 272, className : "lix.cli.Cli", methodName : "dispatch"})));
		}
	})],[]).handle(lix_cli_Command.reportOutcome);
};
var lix_cli__$Command_CommandExpander_$Impl_$ = {};
$hxClasses["lix.cli._Command.CommandExpander_Impl_"] = lix_cli__$Command_CommandExpander_$Impl_$;
lix_cli__$Command_CommandExpander_$Impl_$.__name__ = ["lix","cli","_Command","CommandExpander_Impl_"];
lix_cli__$Command_CommandExpander_$Impl_$.ofString = function(s) {
	var _g = s.indexOf(" ");
	if(_g == -1) {
		throw new js__$Boot_HaxeError("invalid expander syntax in \"" + s + "\"");
	} else {
		var v = _g;
		return lix_cli__$Command_CommandExpander_$Impl_$.make(HxOverrides.substr(s,0,v),HxOverrides.substr(s,v + 1,null));
	}
};
lix_cli__$Command_CommandExpander_$Impl_$.make = function(prefix,rule) {
	var replacer = new EReg("\\$\\{([0-9]+)\\}","g");
	var parts = [];
	var highest = -1;
	replacer.map(rule,function(e) {
		parts.pop();
		var left = e.matchedLeft();
		var right = e.matchedRight();
		parts.push(function(_) {
			return left;
		});
		var pos = Std.parseInt(e.matched(1));
		if(pos > highest) {
			highest = pos;
		}
		parts.push(function(args) {
			return args[pos];
		});
		parts.push(function(_1) {
			return right;
		});
		return "";
	});
	var apply = function(args1) {
		var _g = [];
		var _g2 = 0;
		var _g1 = [];
		var _g21 = 0;
		while(_g21 < parts.length) {
			var p = parts[_g21];
			++_g21;
			_g1.push(p(args1));
		}
		var _g3 = _g1.join("").split(" ");
		while(_g2 < _g3.length) {
			var res = _g3[_g2];
			++_g2;
			var _g4 = StringTools.trim(res);
			var apply1;
			if(_g4 == "") {
				continue;
			} else {
				var v = _g4;
				apply1 = v;
			}
			_g.push(apply1);
		}
		return _g;
	};
	return function(args2) {
		var _g11 = 0;
		var _g5 = args2.length;
		while(_g11 < _g5) {
			var i = _g11++;
			if(args2[i] == prefix) {
				var tmp = args2.slice(0,i);
				var tmp1 = args2.slice(i + 1,i + highest + 2);
				return haxe_ds_Option.Some(tmp.concat(apply(tmp1)).concat(args2.slice(i + highest + 2)));
			}
		}
		return haxe_ds_Option.None;
	};
};
var lix_cli__$Command_CommandName_$Impl_$ = {};
$hxClasses["lix.cli._Command.CommandName_Impl_"] = lix_cli__$Command_CommandName_$Impl_$;
lix_cli__$Command_CommandName_$Impl_$.__name__ = ["lix","cli","_Command","CommandName_Impl_"];
lix_cli__$Command_CommandName_$Impl_$.ofString = function(s) {
	return [s];
};
lix_cli__$Command_CommandName_$Impl_$.toString = function(this1) {
	if(this1.length == 1) {
		var v = this1[0];
		return v;
	} else {
		var a = this1;
		return a.join(" / ");
	}
};
lix_cli__$Command_CommandName_$Impl_$.eq = function(a,b) {
	return a.indexOf(b) != -1;
};
var lix_cli_Command = function(name,args,doc,exec) {
	this.name = name;
	this.args = args;
	this.doc = doc;
	this.exec = exec;
};
$hxClasses["lix.cli.Command"] = lix_cli_Command;
lix_cli_Command.__name__ = ["lix","cli","Command"];
lix_cli_Command.attempt = function(p,andThen) {
	var f = tink_core__$Promise_Recover_$Impl_$.ofSync(lix_cli_Command.reportError);
	var ret = p.flatMap(function(o) {
		switch(o[1]) {
		case 0:
			var d = o[2];
			return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(d));
		case 1:
			var e = o[2];
			return f(e);
		}
	});
	ret.gather().handle(andThen);
};
lix_cli_Command.reportError = function(e) {
	new _$Sys_FileOutput(2).writeString(e.message + "\n\n");
	process.exit(e.code);
	return null;
};
lix_cli_Command.reportOutcome = function(o) {
	if(o[1] == 1) {
		var e = o[2];
		lix_cli_Command.reportError(e);
	}
};
lix_cli_Command.expand = function(args,expanders) {
	var changed = true;
	while(changed) {
		changed = false;
		var _g = 0;
		while(_g < expanders.length) {
			var e = expanders[_g];
			++_g;
			var _g1 = e(args);
			if(_g1[1] == 0) {
				var nu = _g1[2];
				args = nu;
				changed = true;
			}
		}
	}
	return args;
};
lix_cli_Command.dispatch = function(args,title,commands,extras) {
	var _g = args.shift();
	if(_g == null) {
		process.stdout.write(title == null ? "null" : "" + title);
		process.stdout.write("\n");
		process.stdout.write("");
		process.stdout.write("\n");
		var prefix = 0;
		var _g1 = 0;
		while(_g1 < commands.length) {
			var c = commands[_g1];
			++_g1;
			var v = 0;
			var _g11 = 0;
			var _g2 = c.args.split("\n");
			while(_g11 < _g2.length) {
				var line = _g2[_g11];
				++_g11;
				if(line.length > v) {
					v = line.length;
				}
			}
			var longest = v;
			var cur = lix_cli__$Command_CommandName_$Impl_$.toString(c.name).length + longest;
			if(cur > prefix) {
				prefix = cur;
			}
		}
		prefix += 7;
		var pad = function(s) {
			return StringTools.lpad(s," ",prefix);
		};
		process.stdout.write("  Supported commands:");
		process.stdout.write("\n");
		process.stdout.write("");
		process.stdout.write("\n");
		var _g3 = 0;
		while(_g3 < commands.length) {
			var c1 = commands[_g3];
			++_g3;
			var leftCol = c1.args.split("\n");
			var tmp = "  " + lix_cli__$Command_CommandName_$Impl_$.toString(c1.name);
			var _g12 = leftCol[0];
			var tmp1;
			if(_g12 == null) {
				tmp1 = "";
			} else if(_g12 == "") {
				tmp1 = "";
			} else {
				var v1 = _g12;
				tmp1 = " " + v1;
			}
			leftCol[0] = tmp + tmp1 + " : ";
			var _g31 = 1;
			var _g21 = leftCol.length;
			while(_g31 < _g21) {
				var i = _g31++;
				leftCol[i] += "   ";
			}
			var rightCol = c1.doc.split("\n");
			while(leftCol.length < rightCol.length) leftCol.push("");
			while(leftCol.length > rightCol.length) rightCol.push("");
			var _g32 = 0;
			var _g22 = leftCol.length;
			while(_g32 < _g22) {
				var i1 = _g32++;
				var v2 = pad(leftCol[i1]);
				process.stdout.write(Std.string(v2 + rightCol[i1]));
				process.stdout.write("\n");
			}
		}
		var _g4 = 0;
		while(_g4 < extras.length) {
			var e = extras[_g4];
			++_g4;
			process.stdout.write("");
			process.stdout.write("\n");
			process.stdout.write(Std.string("  " + e.name));
			process.stdout.write("\n");
			process.stdout.write("");
			process.stdout.write("\n");
			var _g13 = 0;
			var _g23 = e.value;
			while(_g13 < _g23.length) {
				var e1 = _g23[_g13];
				++_g13;
				var v3 = pad("" + e1.name + " : ") + e1.value;
				process.stdout.write(Std.string(v3));
				process.stdout.write("\n");
			}
		}
		process.stdout.write("");
		process.stdout.write("\n");
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
	} else if(_g == "--help") {
		process.stdout.write(title == null ? "null" : "" + title);
		process.stdout.write("\n");
		process.stdout.write("");
		process.stdout.write("\n");
		var prefix1 = 0;
		var _g5 = 0;
		while(_g5 < commands.length) {
			var c2 = commands[_g5];
			++_g5;
			var v4 = 0;
			var _g14 = 0;
			var _g24 = c2.args.split("\n");
			while(_g14 < _g24.length) {
				var line1 = _g24[_g14];
				++_g14;
				if(line1.length > v4) {
					v4 = line1.length;
				}
			}
			var longest1 = v4;
			var cur1 = lix_cli__$Command_CommandName_$Impl_$.toString(c2.name).length + longest1;
			if(cur1 > prefix1) {
				prefix1 = cur1;
			}
		}
		prefix1 += 7;
		var pad1 = function(s1) {
			return StringTools.lpad(s1," ",prefix1);
		};
		process.stdout.write("  Supported commands:");
		process.stdout.write("\n");
		process.stdout.write("");
		process.stdout.write("\n");
		var _g6 = 0;
		while(_g6 < commands.length) {
			var c3 = commands[_g6];
			++_g6;
			var leftCol1 = c3.args.split("\n");
			var tmp2 = "  " + lix_cli__$Command_CommandName_$Impl_$.toString(c3.name);
			var _g15 = leftCol1[0];
			var tmp3;
			if(_g15 == null) {
				tmp3 = "";
			} else if(_g15 == "") {
				tmp3 = "";
			} else {
				var v5 = _g15;
				tmp3 = " " + v5;
			}
			leftCol1[0] = tmp2 + tmp3 + " : ";
			var _g33 = 1;
			var _g25 = leftCol1.length;
			while(_g33 < _g25) {
				var i2 = _g33++;
				leftCol1[i2] += "   ";
			}
			var rightCol1 = c3.doc.split("\n");
			while(leftCol1.length < rightCol1.length) leftCol1.push("");
			while(leftCol1.length > rightCol1.length) rightCol1.push("");
			var _g34 = 0;
			var _g26 = leftCol1.length;
			while(_g34 < _g26) {
				var i3 = _g34++;
				var v6 = pad1(leftCol1[i3]);
				process.stdout.write(Std.string(v6 + rightCol1[i3]));
				process.stdout.write("\n");
			}
		}
		var _g7 = 0;
		while(_g7 < extras.length) {
			var e2 = extras[_g7];
			++_g7;
			process.stdout.write("");
			process.stdout.write("\n");
			process.stdout.write(Std.string("  " + e2.name));
			process.stdout.write("\n");
			process.stdout.write("");
			process.stdout.write("\n");
			var _g16 = 0;
			var _g27 = e2.value;
			while(_g16 < _g27.length) {
				var e3 = _g27[_g16];
				++_g16;
				var v7 = pad1("" + e3.name + " : ") + e3.value;
				process.stdout.write(Std.string(v7));
				process.stdout.write("\n");
			}
		}
		process.stdout.write("");
		process.stdout.write("\n");
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
	} else {
		var command = _g;
		var _g8 = 0;
		while(_g8 < commands.length) {
			var canditate = commands[_g8];
			++_g8;
			if(lix_cli__$Command_CommandName_$Impl_$.eq(canditate.name,command)) {
				return canditate.exec(args);
			}
		}
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"unknown command " + command,{ fileName : "Command.hx", lineNumber : 193, className : "lix.cli.Command", methodName : "dispatch"})));
	}
};
lix_cli_Command.prototype = {
	__class__: lix_cli_Command
};
var lix_cli_HaxeCmd = function() { };
$hxClasses["lix.cli.HaxeCmd"] = lix_cli_HaxeCmd;
lix_cli_HaxeCmd.__name__ = ["lix","cli","HaxeCmd"];
lix_cli_HaxeCmd.ensureScope = function() {
	if(!haxeshim_Scope.exists(haxeshim_Scope.DEFAULT_ROOT)) {
		haxeshim_Fs.ensureDir(haxeshim_Scope.DEFAULT_ROOT + "/");
		haxeshim_Scope.create(haxeshim_Scope.DEFAULT_ROOT,{ version : "stable", resolveLibs : "mixed"});
	}
	return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
};
var lix_client_ArchiveKind = $hxClasses["lix.client.ArchiveKind"] = { __ename__ : ["lix","client","ArchiveKind"], __constructs__ : ["Zip","Tar","Custom"] };
lix_client_ArchiveKind.Zip = ["Zip",0];
lix_client_ArchiveKind.Zip.toString = $estr;
lix_client_ArchiveKind.Zip.__enum__ = lix_client_ArchiveKind;
lix_client_ArchiveKind.Tar = ["Tar",1];
lix_client_ArchiveKind.Tar.toString = $estr;
lix_client_ArchiveKind.Tar.__enum__ = lix_client_ArchiveKind;
lix_client_ArchiveKind.Custom = function(load) { var $x = ["Custom",2,load]; $x.__enum__ = lix_client_ArchiveKind; $x.toString = $estr; return $x; };
var lix_client_ArchiveDestination = $hxClasses["lix.client.ArchiveDestination"] = { __ename__ : ["lix","client","ArchiveDestination"], __constructs__ : ["Fixed","Computed"] };
lix_client_ArchiveDestination.Fixed = function(path) { var $x = ["Fixed",0,path]; $x.__enum__ = lix_client_ArchiveDestination; $x.toString = $estr; return $x; };
lix_client_ArchiveDestination.Computed = function(f) { var $x = ["Computed",1,f]; $x.__enum__ = lix_client_ArchiveDestination; $x.toString = $estr; return $x; };
var lix_client_ArchiveInfos = function(name,version,classPath,runAs,dependencies,postDownload,postInstall) {
	this.name = name;
	this.version = version;
	this.classPath = classPath;
	this.runAs = runAs;
	this.dependencies = dependencies;
	this.postDownload = postDownload;
	this.postInstall = postInstall;
};
$hxClasses["lix.client.ArchiveInfos"] = lix_client_ArchiveInfos;
lix_client_ArchiveInfos.__name__ = ["lix","client","ArchiveInfos"];
lix_client_ArchiveInfos.prototype = {
	__class__: lix_client_ArchiveInfos
};
var lix_client_DownloadedArchive = function(relRoot,storageRoot,job,infos) {
	this.alreadyDownloaded = true;
	this.storageRoot = storageRoot;
	this.relRoot = relRoot;
	this.job = job;
	var tmp;
	if(infos == null) {
		tmp = lix_client_DownloadedArchive.readInfos(haxe_io_Path.removeTrailingSlashes("" + this.storageRoot + "/" + this.relRoot),job.lib);
	} else {
		var v = infos;
		tmp = v;
	}
	this.infos = tmp;
};
$hxClasses["lix.client.DownloadedArchive"] = lix_client_DownloadedArchive;
lix_client_DownloadedArchive.__name__ = ["lix","client","DownloadedArchive"];
lix_client_DownloadedArchive.escape = function(s) {
	if(s == null) {
		return null;
	}
	var _g1 = 0;
	var _g = lix_client_DownloadedArchive.RESERVED.length;
	while(_g1 < _g) {
		var i = _g1++;
		s = StringTools.replace(s,lix_client_DownloadedArchive.RESERVED.charAt(i),"_");
	}
	return s;
};
lix_client_DownloadedArchive.path = function(parts) {
	return parts.map(lix_client_DownloadedArchive.escape).join("/");
};
lix_client_DownloadedArchive.fresh = function(tmpLoc,storageRoot,targetLoc,job) {
	var curRoot = "" + tmpLoc + "/" + lix_client_DownloadedArchive.seekRoot(tmpLoc);
	var infos = lix_client_DownloadedArchive.readInfos(curRoot,job.lib);
	var relRoot;
	if(targetLoc == null) {
		var _g = job.dest;
		var relRoot1;
		switch(_g[1]) {
		case 0:
			var path = _g[2];
			relRoot1 = path;
			break;
		case 1:
			var f = _g[2];
			relRoot1 = f(infos);
			break;
		}
		relRoot = lix_client_DownloadedArchive.path(relRoot1);
	} else {
		relRoot = targetLoc;
	}
	var ret = new lix_client_DownloadedArchive(relRoot,storageRoot,job,infos);
	ret.alreadyDownloaded = false;
	var archive = null;
	var _g1 = haxe_io_Path.removeTrailingSlashes("" + ret.storageRoot + "/" + ret.relRoot);
	var old = _g1;
	if(sys_FileSystem.exists(old)) {
		archive = "" + old + "-archived@" + new Date().getTime();
		js_node_Fs.renameSync(old,archive);
	}
	haxeshim_Fs.ensureDir(haxe_io_Path.removeTrailingSlashes("" + ret.storageRoot + "/" + ret.relRoot));
	js_node_Fs.renameSync(curRoot,haxe_io_Path.removeTrailingSlashes("" + ret.storageRoot + "/" + ret.relRoot));
	if(archive != null) {
		haxeshim_Fs["delete"](archive);
	}
	if(sys_FileSystem.exists(tmpLoc)) {
		haxeshim_Fs["delete"](tmpLoc);
	}
	return ret;
};
lix_client_DownloadedArchive.existent = function(path,storageRoot,job) {
	return new lix_client_DownloadedArchive(path,storageRoot,job);
};
lix_client_DownloadedArchive.seekRoot = function(path) {
	var _g = js_node_Fs.readdirSync(path);
	if(_g.length == 1) {
		var v = _g[0];
		if(sys_FileSystem.isDirectory("" + path + "/" + v)) {
			return "" + v + "/" + lix_client_DownloadedArchive.seekRoot("" + path + "/" + v);
		} else {
			return "";
		}
	} else {
		return "";
	}
};
lix_client_DownloadedArchive.readInfos = function(root,lib) {
	var files = js_node_Fs.readdirSync(root);
	var guessClassPath = function() {
		if(files.indexOf("src") != -1) {
			return "src";
		} else if(files.indexOf("hx") != -1) {
			return "hx";
		} else {
			return "";
		}
	};
	if(lib == null) {
		lib = lix_client_LibVersion.UNDEFINED;
	}
	if(files.indexOf("haxelib.json") != -1) {
		var info = JSON.parse(js_node_Fs.readFileSync("" + root + "/haxelib.json",{ encoding : "utf8"}));
		var _g4 = info.name;
		var _g3 = info.version;
		var _g2;
		var _g = info.classPath;
		if(_g == null) {
			_g2 = "";
		} else {
			var v = _g;
			_g2 = v;
		}
		var _g1 = info.dependencies;
		var tmp;
		if(_g1 == null) {
			tmp = [];
		} else {
			var deps = _g1;
			var _g11 = [];
			var _g21 = 0;
			var _g31 = Reflect.fields(deps);
			while(_g21 < _g31.length) {
				var name = _g31[_g21];
				++_g21;
				var _g41 = deps[name];
				var _hx_tmp;
				var tmp1;
				if(_g41 == null) {
					_hx_tmp = tink__$Url_Url_$Impl_$.fromString(_g41).scheme;
					if(_hx_tmp == null) {
						var version = _g41;
						tmp1 = tink__$Url_Url_$Impl_$.fromString("haxelib:" + name + "#" + version);
					} else {
						var u = _g41;
						tmp1 = tink__$Url_Url_$Impl_$.fromString(u);
					}
				} else {
					switch(_g41) {
					case "":case "*":
						tmp1 = tink__$Url_Url_$Impl_$.fromString("haxelib:" + name);
						break;
					default:
						_hx_tmp = tink__$Url_Url_$Impl_$.fromString(_g41).scheme;
						if(_hx_tmp == null) {
							var version1 = _g41;
							tmp1 = tink__$Url_Url_$Impl_$.fromString("haxelib:" + name + "#" + version1);
						} else {
							var u1 = _g41;
							tmp1 = tink__$Url_Url_$Impl_$.fromString(u1);
						}
					}
				}
				_g11.push(new tink_core_NamedWith(name,tmp1));
			}
			tmp = _g11;
		}
		return new lix_client_ArchiveInfos(_g4,_g3,_g2,function(ctx) {
			if(sys_FileSystem.exists("" + ctx.libRoot + "/run.n") || info.mainClass != null) {
				return haxe_ds_Option.Some("haxelib run-dir " + info.name + " $" + "{DOWNLOAD_LOCATION}");
			} else {
				return haxe_ds_Option.None;
			}
		},tmp,info.postDownload,info.postInstall);
	} else if(files.indexOf("package.json") != -1) {
		var info1 = JSON.parse(js_node_Fs.readFileSync("" + root + "/package.json",{ encoding : "utf8"}));
		var _g12 = info1.name;
		var _g5 = info1.version;
		return new lix_client_ArchiveInfos(_g12,_g5,guessClassPath(),function(_) {
			return haxe_ds_Option.None;
		},[],null,null);
	} else {
		var o = lib.name;
		var l = new tink_core__$Lazy_LazyConst("untitled");
		var _g13;
		if(o[1] == 0) {
			var v1 = o[2];
			_g13 = v1;
		} else {
			_g13 = l.get();
		}
		var o1 = lib.version;
		var l1 = new tink_core__$Lazy_LazyConst("0.0.0");
		var _g6;
		if(o1[1] == 0) {
			var v2 = o1[2];
			_g6 = v2;
		} else {
			_g6 = l1.get();
		}
		return new lix_client_ArchiveInfos(_g13,_g6,guessClassPath(),function(_1) {
			return haxe_ds_Option.None;
		},[],null,null);
	}
};
lix_client_DownloadedArchive.prototype = {
	__class__: lix_client_DownloadedArchive
};
var lix_client_Download = function() { };
$hxClasses["lix.client.Download"] = lix_client_Download;
lix_client_Download.__name__ = ["lix","client","Download"];
lix_client_Download.text = function(url) {
	return tink_core__$Promise_Promise_$Impl_$.next(lix_client_Download.bytes(url),function(b) {
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(b.toString()));
	});
};
lix_client_Download.bytes = function(url) {
	return lix_client_Download.download(url,function(_,r,cb) {
		lix_client_Download.buffered(r).handle(cb);
	});
};
lix_client_Download.buffered = function(r) {
	return tink_core__$Future_Future_$Impl_$.async(function(cb) {
		var ret = [];
		r.on("data",$bind(ret,$arrayPush));
		r.on("end",function() {
			var tmp = tink_core_Outcome.Success(js_node_buffer__$Buffer_Helper.bytesOfBuffer(js_node_buffer_Buffer.concat(ret)));
			cb(tmp);
		});
	});
};
lix_client_Download.archive = function(url,peel,into,progress) {
	var tmp = lix_client_Download.withProgress(progress,function(finalUrl,res,events) {
		if(res.headers["content-type"] == "application/zip" || StringTools.endsWith(url,".zip") || StringTools.endsWith(finalUrl,".zip")) {
			lix_client_Download.unzip(url,into,peel,res,events);
		} else {
			lix_client_Download.untar(url,into,peel,res,events);
		}
	});
	return lix_client_Download.download(url,tmp);
};
lix_client_Download.unzip = function(src,into,peel,res,events) {
	tink_core__$Promise_Promise_$Impl_$.next(lix_client_Download.buffered(res),function(bytes) {
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			var pos = bytes.length - 4;
			while(pos-- > 0) if(bytes.b[pos] == 80 && bytes.b[pos + 1] == 75 && bytes.b[pos + 2] == 5 && bytes.b[pos + 3] == 6) {
				bytes.b[pos + 20] = 0;
				bytes.b[pos + 21] = 0;
				bytes = bytes.sub(0,pos + 22);
				break;
			}
			if(pos == 0) {
				var this1 = tink_core_Outcome.Failure(new tink_core_TypedError(422,"Unzip failed to find central directory in " + src,{ fileName : "Download.hx", lineNumber : 70, className : "lix.client.Download", methodName : "unzip"}));
				cb(this1);
				return;
			}
			var data = bytes.b;
			lix_client_uncompress_Yauzl.fromBuffer(new js_node_buffer_Buffer(data.buffer,data.byteOffset,bytes.length),function(err,zip) {
				var saved = -1;
				var done = function() {
					saved += 1;
					events.onProgress(saved,zip.entryCount,false);
					if(saved == zip.entryCount) {
						var f = cb;
						var a1 = tink_core_Outcome.Success(into);
						haxe_Timer.delay(function() {
							f(a1);
						},100);
					}
				};
				if(err != null) {
					var this2 = tink_core_Outcome.Failure(new tink_core_TypedError(422,"Failed to unzip " + src + " because " + Std.string(err),{ fileName : "Download.hx", lineNumber : 83, className : "lix.client.Download", methodName : "unzip"}));
					cb(this2);
				}
				zip.on("entry",function(entry) {
					var _g = haxeshim_Fs.peel(entry.fileName,peel);
					switch(_g[1]) {
					case 0:
						var f1 = _g[2];
						var path = "" + into + "/" + f1;
						if(StringTools.endsWith(path,"/")) {
							done();
						} else {
							haxeshim_Fs.ensureDir(path);
							zip.openReadStream(entry,function(e,stream) {
								var out = js_node_Fs.createWriteStream(path);
								stream.pipe(out,{ end : true});
								out.on("close",done);
							});
						}
						break;
					case 1:
						break;
					}
				});
				zip.on("end",function() {
					zip.close();
					done();
				});
			});
		});
	}).handle($bind(events,events.done));
};
lix_client_Download.untar = function(src,into,peel,res,events) {
	return tink_core__$Future_Future_$Impl_$.async(function(cb) {
		var total = 0;
		var written = 0;
		var symlinks = [];
		var update = function() {
			events.onProgress(written,total + 1,true);
		};
		var pending = 1;
		var done = function(progress) {
			if(progress == null) {
				progress = 0;
			}
			written += progress;
			update();
			haxe_Timer.delay(function() {
				if((pending -= 1) <= 0) {
					events.onProgress(total,total,true);
					var _g = [];
					var _g1 = 0;
					while(_g1 < symlinks.length) {
						var link = [symlinks[_g1]];
						++_g1;
						_g.push(tink_core__$Future_Future_$Impl_$.async((function(link1) {
							return function(cb1) {
								js_node_Fs.unlink(link1[0].to,(function(link2) {
									return function(_) {
										js_node_Fs.symlink(link2[0].from,link2[0].to,(function() {
											return function(e) {
												var this1 = e == null ? tink_core_Outcome.Success(tink_core_Noise.Noise) : tink_core_Outcome.Failure(new tink_core_TypedError(null,e.message,{ fileName : "Download.hx", lineNumber : 130, className : "lix.client.Download", methodName : "untar"}));
												cb1(this1);
											};
										})());
									};
								})(link1));
							};
						})(link)));
					}
					tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Promise_Promise_$Impl_$.inParallel(_g),function(_1) {
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(into));
					}).handle(cb);
				}
			},100);
		};
		var error = null;
		var fail = function(message) {
			error = new tink_core_TypedError(null,message,{ fileName : "Download.hx", lineNumber : 142, className : "lix.client.Download", methodName : "untar"});
			cb(tink_core_Outcome.Failure(error));
		};
		lix_client_uncompress_Tar.parse(res,function(entry) {
			if(error != null) {
				return;
			}
			total += entry.size;
			update();
			var skip = function() {
				entry.on("data",function() {
				});
			};
			var _g2 = haxeshim_Fs.peel(entry.path,peel);
			switch(_g2[1]) {
			case 0:
				var f = _g2[2];
				var path = "" + into + "/" + f;
				if(StringTools.endsWith(path,"/")) {
					skip();
				} else {
					haxeshim_Fs.ensureDir(path);
					if(entry.type == "SymbolicLink") {
						skip();
						var this2 = haxe_io_Path.directory(path);
						symlinks.push({ from : haxe_io_Path.join([this2,entry.linkpath]), to : path});
					} else {
						pending += 1;
						var buffer = new js_node_stream_PassThrough();
						var out = js_node_Fs.createWriteStream(path,{ mode : entry.mode});
						entry.pipe(buffer,{ end : true});
						buffer.pipe(out,{ end : true});
						var f1 = done;
						var progress1 = entry.size;
						out.on("close",function() {
							f1(progress1);
						});
					}
				}
				break;
			case 1:
				skip();
				break;
			}
		}).handle(function(o) {
			if(o[1] == 1) {
				var e1 = o[2];
				cb(tink_core_Outcome.Failure(e1));
			} else {
				done();
			}
		});
	}).handle($bind(events,events.done));
};
lix_client_Download.tar = function(url,peel,into,progress) {
	var into1 = into;
	var peel1 = peel;
	return lix_client_Download.download(url,lix_client_Download.withProgress(progress,function(src,res,events) {
		return lix_client_Download.untar(src,into1,peel1,res,events);
	}));
};
lix_client_Download.zip = function(url,peel,into,progress) {
	var into1 = into;
	var peel1 = peel;
	return lix_client_Download.download(url,lix_client_Download.withProgress(progress,function(src,res,events) {
		lix_client_Download.unzip(src,into1,peel1,res,events);
	}));
};
lix_client_Download.withProgress = function(progress,handler) {
	return function(url,msg,cb) {
		if(progress != true || !process.stdout.isTTY) {
			handler(url,msg,{ onProgress : function(_,_1,_2) {
			}, done : cb});
			return;
		}
		var size = Std.parseInt(msg.headers["content-length"]);
		var loaded = 0;
		var saved = 0;
		var total = 1;
		var last = null;
		var progress1 = function(s) {
			if(s == last) {
				return;
			}
			last = s;
			process.stdout.clearLine(0);
			process.stdout.cursorTo(0);
			process.stdout.write(s);
		};
		var pct = function(f) {
			if(!(f <= 1.0)) {
				f = 1;
			}
			var _g = Std.string(Math.round(1000 * f) / 10);
			var pct1;
			var _hx_tmp = _g.indexOf(".");
			if(_hx_tmp == -1) {
				var whole = _g;
				pct1 = "" + whole + ".0";
			} else {
				var v = _g;
				pct1 = v;
			}
			return StringTools.lpad(pct1," ",5) + "%";
		};
		var lastUpdate = new Date(0).getTime();
		var update = function() {
			if(saved == total || saved / total >= 1.0) {
				progress1("Done!\n");
			} else {
				var now = new Date().getTime();
				if(now > lastUpdate + 137) {
					lastUpdate = now;
					var messages = [];
					if(loaded < size) {
						messages.push("Downloaded: " + pct(loaded / size));
					}
					if(saved > 0) {
						messages.push("Saved: " + pct(saved / total));
					}
					var update1 = messages.join("   ");
					progress1(update1);
				}
			}
		};
		msg.on("data",function(buf) {
			loaded += buf.length;
			update();
		});
		var last1 = .0;
		handler(url,msg,{ onProgress : function(_saved,_total,binary) {
			saved = _saved;
			total = _total;
			if(binary) {
				var downloaded = loaded / size;
				var decompressed = saved / total;
				var estimate = downloaded * decompressed;
				if(estimate < last1) {
					estimate = last1;
				}
				last1 = estimate;
				saved = Math.round(estimate * 1000);
				total = 1000;
			}
			update();
		}, done : cb});
	};
};
lix_client_Download.download = function(url,handler) {
	return tink_core__$Future_Future_$Impl_$.async(function(cb) {
		var options = js_node_Url.parse(url);
		options.agent = false;
		if(options.headers == null) {
			options.headers = { };
		}
		options.headers["user-agent"] = lix_client_Download.USER_AGENT;
		var fail = function(e) {
			var fail1 = tink_core_Outcome.Failure(tink_core_TypedError.withData(null,"Failed to download " + url + " because " + e.message,e,{ fileName : "Download.hx", lineNumber : 287, className : "lix.client.Download", methodName : "download"}));
			cb(fail1);
		};
		var req = StringTools.startsWith(url,"https:") ? js_node_Https.get(options) : js_node_Http.get(options);
		req.setTimeout(30000);
		req.on("error",fail);
		req.on("response",function(res) {
			if(res.statusCode >= 400) {
				var tmp = tink_core_Outcome.Failure(tink_core_TypedError.withData(res.statusCode,res.statusMessage,res,{ fileName : "Download.hx", lineNumber : 298, className : "lix.client.Download", methodName : "download"}));
				cb(tmp);
			} else {
				var _g = res.headers["location"];
				if(_g == null) {
					res.on("error",fail);
					handler(url,res,function(v) {
						switch(v[1]) {
						case 0:
							var x = v[2];
							cb(tink_core_Outcome.Success(x));
							break;
						case 1:
							var e1 = v[2];
							cb(tink_core_Outcome.Failure(e1));
							break;
						}
					});
				} else {
					var v1 = _g;
					var _g1 = js_node_Url.parse(v1);
					lix_client_Download.download(_g1.protocol == null ? options.protocol + "//" + options.host + v1 : v1,handler).handle(cb);
				}
			}
		});
	});
};
var lix_client_LibVersion = function(name,version) {
	this.name = name;
	this.version = version;
};
$hxClasses["lix.client.LibVersion"] = lix_client_LibVersion;
lix_client_LibVersion.__name__ = ["lix","client","LibVersion"];
lix_client_LibVersion.parse = function(s) {
	if(s == null) {
		return null;
	} else {
		var _g = s.indexOf("#");
		if(_g == -1) {
			return new lix_client_LibVersion(haxe_ds_Option.Some(s),haxe_ds_Option.None);
		} else {
			var v = _g;
			return new lix_client_LibVersion(haxe_ds_Option.Some(s.substring(0,v)),haxe_ds_Option.Some(s.substring(v + 1)));
		}
	}
};
lix_client_LibVersion.prototype = {
	__class__: lix_client_LibVersion
};
var lix_client_Libraries = function(scope,urlToJob,resolver,log,force,silent) {
	this.scope = scope;
	this.urlToJob = urlToJob;
	this.resolver = resolver;
	this.log = log;
	this.force = force;
	this.silent = silent;
};
$hxClasses["lix.client.Libraries"] = lix_client_Libraries;
lix_client_Libraries.__name__ = ["lix","client","Libraries"];
lix_client_Libraries.prototype = {
	downloadUrl: function(url,options) {
		return this.downloadArchive(this.urlToJob(url),options);
	}
	,downloadArchive: function(a,__tink_tmp11) {
		var _gthis = this;
		if(__tink_tmp11 == null) {
			__tink_tmp11 = { };
		}
		var into = __tink_tmp11.into == null ? null : __tink_tmp11.into;
		return tink_core__$Promise_Promise_$Impl_$.next(a,function(a1) {
			var cacheFile = null;
			if(into == null) {
				var _g = a1.dest;
				switch(_g[1]) {
				case 0:
					var path = _g[2];
					into = lix_client_DownloadedArchive.path(path);
					break;
				case 1:
					cacheFile = "" + _gthis.scope.libCache + "/.cache/libNames/" + lix_client_DownloadedArchive.escape(tink__$Url_Url_$Impl_$.toString(a1.url));
					if(sys_FileSystem.exists(cacheFile)) {
						into = js_node_Fs.readFileSync(cacheFile,{ encoding : "utf8"});
					}
					break;
				}
			}
			var exists = into != null && sys_FileSystem.exists("" + _gthis.scope.libCache + "/" + into);
			if(exists && !_gthis.force) {
				_gthis.log("already downloaded: " + tink__$Url_Url_$Impl_$.toString(a1.normalized));
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(lix_client_DownloadedArchive.existent(into,_gthis.scope.libCache,a1)));
			} else {
				_gthis.log("" + (exists ? "forcedly redownloading" : "downloading") + " " + tink__$Url_Url_$Impl_$.toString(a1.normalized));
				var dest = _gthis.scope.haxeshimRoot + "/downloads/download@" + new Date().getTime();
				var _g1 = a1.kind;
				var tmp;
				if(_g1 == null) {
					tmp = lix_client_Download.archive(tink__$Url_Url_$Impl_$.toString(a1.url),0,dest,!_gthis.silent);
				} else {
					switch(_g1[1]) {
					case 0:
						tmp = lix_client_Download.zip(tink__$Url_Url_$Impl_$.toString(a1.url),0,dest,!_gthis.silent);
						break;
					case 1:
						tmp = lix_client_Download.tar(tink__$Url_Url_$Impl_$.toString(a1.url),0,dest,!_gthis.silent);
						break;
					case 2:
						var load = _g1[2];
						tmp = load({ dest : dest, silent : _gthis.silent, source : a1.normalized, scope : _gthis.scope});
						break;
					}
				}
				return tink_core__$Promise_Promise_$Impl_$.next(tmp,function(dir) {
					var ret = lix_client_DownloadedArchive.fresh(dir,_gthis.scope.libCache,into,a1);
					if(cacheFile != null) {
						haxeshim_Fs.ensureDir(cacheFile);
						js_node_Fs.writeFileSync(cacheFile,ret.relRoot);
					}
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(ret));
				});
			}
		});
	}
	,installMany: function(projects) {
		var _gthis = this;
		return tink_core__$Promise_Promise_$Impl_$.next(this.resolver(projects),function(jobs) {
			var __tmp = [];
			var _g = 0;
			while(_g < jobs.length) {
				var j = jobs[_g];
				++_g;
				__tmp.push(_gthis.installArchive(tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(j))));
			}
			return tink_core__$Promise_Promise_$Impl_$.noise(tink_core__$Promise_Promise_$Impl_$.inSequence(__tmp));
		});
	}
	,install: function(lib,constraint) {
		return this.installMany([{ name : lib, constraint : constraint}]);
	}
	,installUrl: function(url,as) {
		return this.installArchive(this.urlToJob(url),as,true);
	}
	,installArchive: function(a,as,withHaxeLibDependencies) {
		var _gthis = this;
		return tink_core__$Promise_Promise_$Impl_$.next(this.downloadArchive(a),function(a1) {
			var extra;
			var _g = "" + haxe_io_Path.removeTrailingSlashes("" + a1.storageRoot + "/" + a1.relRoot) + "/extraParams.hxml";
			var found = _g;
			extra = sys_FileSystem.exists(found) ? js_node_Fs.readFileSync(found,{ encoding : "utf8"}) : "";
			if(as == null) {
				as = new lix_client_LibVersion(haxe_ds_Option.None,haxe_ds_Option.None);
			}
			var infos = a1.infos;
			var o = as.name;
			var l = new tink_core__$Lazy_LazyConst(infos.name);
			var name;
			if(o[1] == 0) {
				var v = o[2];
				name = v;
			} else {
				name = l.get();
			}
			var o1 = as.version;
			var l1 = new tink_core__$Lazy_LazyConst(infos.version);
			var version;
			if(o1[1] == 0) {
				var v1 = o1[2];
				version = v1;
			} else {
				version = l1.get();
			}
			if(name == null) {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Could not determine library name for " + tink__$Url_Url_$Impl_$.toString(a1.job.normalized),{ fileName : "Libraries.hx", lineNumber : 103, className : "lix.client.Libraries", methodName : "installArchive"})));
			}
			var hxml = haxeshim_Resolver.libHxml(_gthis.scope.scopeLibDir,name);
			haxeshim_Fs.ensureDir(hxml);
			_gthis.log("mounting as " + name + "#" + version);
			var DOWNLOAD_LOCATION = "$" + "{" + "HAXE_LIBCACHE" + "}/" + a1.relRoot;
			var interpolate = function(s) {
				return haxeshim_Resolver.interpolate(s,function(__tink_tmp2) {
					if(__tink_tmp2 == "DOWNLOAD_LOCATION") {
						return DOWNLOAD_LOCATION;
					} else {
						return null;
					}
				});
			};
			var exec = function(hook,cmd,cwd) {
				if(cmd != null) {
					cmd = _gthis.scope.interpolate(interpolate(cmd));
					if(cwd == null) {
						cwd = _gthis.scope.cwd;
					}
					_gthis.log("Running " + hook + " hook:");
					_gthis.log("> " + cmd);
					return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_core_OutcomeTools.map(haxeshim_Exec.shell(cmd,_gthis.scope.interpolate(cwd),_gthis.scope.haxeInstallation.env()),function(_) {
						return tink_core_Noise.Noise;
					})));
				} else {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
				}
			};
			var saveHxml = function(value) {
				return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_core_TypedError.catchExceptions(function() {
					var directives = ["-D " + name + "=" + version,"# @" + "install" + ": lix --silent download \"" + tink__$Url_Url_$Impl_$.toString(a1.job.normalized) + "\" into " + a1.relRoot];
					var _g1 = infos.postDownload;
					if(_g1 != null) {
						var v2 = _g1;
						directives.push("# @" + "post-install" + ": cd " + DOWNLOAD_LOCATION + " && " + interpolate(v2));
					}
					var _g2 = infos.runAs({ libRoot : _gthis.scope.interpolate(DOWNLOAD_LOCATION)});
					switch(_g2[1]) {
					case 0:
						var v3 = _g2[2];
						directives.push("# @run: " + interpolate(v3));
						break;
					case 1:
						break;
					}
					var __tmp = [];
					var _g3 = 0;
					var _g4 = infos.dependencies;
					while(_g3 < _g4.length) {
						var lib = _g4[_g3];
						++_g3;
						__tmp.push("-lib " + lib.name);
					}
					var content = "-cp " + DOWNLOAD_LOCATION + "/" + infos.classPath;
					var content1 = directives.concat(__tmp).concat([content,extra]).join("\n");
					js_node_Fs.writeFileSync(hxml,content1);
					return value;
				},null,{ fileName : "Libraries.hx", lineNumber : 142, className : "lix.client.Libraries", methodName : "installArchive"})));
			};
			saveHxml();
			var __tmp1 = [];
			var iterator___tink_tmp3 = HxOverrides.iter(infos.dependencies);
			while(iterator___tink_tmp3.hasNext()) {
				var __tink_tmp3 = iterator___tink_tmp3.next();
				var url = [__tink_tmp3.value];
				var lib1 = [__tink_tmp3.name];
				__tmp1.push(tink_core__$Future_Future_$Impl_$.async((function(lib2,url1) {
					return function(done) {
						if(sys_FileSystem.exists("" + _gthis.scope.scopeLibDir + "/" + lib2[0] + ".hxml")) {
							done(tink_core_Outcome.Success(tink_core_Noise.Noise));
						} else {
							_gthis.installUrl(url1[0],new lix_client_LibVersion(haxe_ds_Option.Some(lib2[0]),haxe_ds_Option.None)).handle(done);
						}
					};
				})(lib1,url),true));
			}
			return tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Future_Future_$Impl_$.next(tink_core__$Future_Future_$Impl_$.ofMany(__tmp1),function(results) {
				var __tmp2 = [];
				var iterator___tink_tmp4 = HxOverrides.iter(results);
				while(iterator___tink_tmp4.hasNext()) {
					var __tink_tmp4 = iterator___tink_tmp4.next();
					if(__tink_tmp4[1] == 1) {
						var e = __tink_tmp4[2];
						__tmp2.push(e);
					}
				}
				var _g11 = __tmp2;
				if(_g11.length == 0) {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
				} else {
					var errors = _g11;
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(tink_core_TypedError.withData(null,"Failed to install dependencies:\n  " + errors.map(function(e1) {
						return e1.message;
					}).join("\n  "),errors,{ fileName : "Libraries.hx", lineNumber : 187, className : "lix.client.Libraries", methodName : "installArchive"})));
				}
			}),function(_1) {
				if(!a1.alreadyDownloaded) {
					return exec("post download",infos.postDownload,DOWNLOAD_LOCATION);
				} else {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
				}
			}),saveHxml),function(_2) {
				return exec("post install",infos.postInstall);
			});
		});
	}
	,__class__: lix_client_Libraries
};
var lix_client_haxe__$Official_Official_$Impl_$ = {};
$hxClasses["lix.client.haxe._Official.Official_Impl_"] = lix_client_haxe__$Official_Official_$Impl_$;
lix_client_haxe__$Official_Official_$Impl_$.__name__ = ["lix","client","haxe","_Official","Official_Impl_"];
lix_client_haxe__$Official_Official_$Impl_$.get_isPrerelease = function(this1) {
	return this1.indexOf("-") != -1;
};
lix_client_haxe__$Official_Official_$Impl_$.isNumber = function(s) {
	return new EReg("^[0-9]*$","").match(s);
};
lix_client_haxe__$Official_Official_$Impl_$.fragment = function(a,b) {
	if(lix_client_haxe__$Official_Official_$Impl_$.isNumber(a) && lix_client_haxe__$Official_Official_$Impl_$.isNumber(b)) {
		return Std.parseInt(a) - Std.parseInt(b);
	} else {
		return Reflect.compare(a,b);
	}
};
lix_client_haxe__$Official_Official_$Impl_$.compare = function(a,b) {
	var a1 = a.split("-");
	var b1 = b.split("-");
	var i = 0;
	while(i < a1.length && i < b1.length) {
		var a2 = a1[i].split(".");
		var b2 = b1[i++].split(".");
		var i1 = 0;
		while(i1 < a2.length && i1 < b2.length) {
			var _g = lix_client_haxe__$Official_Official_$Impl_$.fragment(a2[i1],b2[i1]);
			if(_g == 0) {
				++i1;
			} else {
				var v = _g;
				return -v;
			}
		}
		var _g1 = a2.length - b2.length;
		if(_g1 != 0) {
			var v1 = _g1;
			return -v1;
		}
	}
	return (a1.length - b1.length) * (i == 1 ? 1 : -1);
};
var lix_client_haxe_ResolvedUserVersionData = $hxClasses["lix.client.haxe.ResolvedUserVersionData"] = { __ename__ : ["lix","client","haxe","ResolvedUserVersionData"], __constructs__ : ["RNightly","ROfficial","RCustom"] };
lix_client_haxe_ResolvedUserVersionData.RNightly = function(nightly) { var $x = ["RNightly",0,nightly]; $x.__enum__ = lix_client_haxe_ResolvedUserVersionData; $x.toString = $estr; return $x; };
lix_client_haxe_ResolvedUserVersionData.ROfficial = function(version) { var $x = ["ROfficial",1,version]; $x.__enum__ = lix_client_haxe_ResolvedUserVersionData; $x.toString = $estr; return $x; };
lix_client_haxe_ResolvedUserVersionData.RCustom = function(path) { var $x = ["RCustom",2,path]; $x.__enum__ = lix_client_haxe_ResolvedUserVersionData; $x.toString = $estr; return $x; };
var lix_client_haxe__$ResolvedVersion_ResolvedVersion_$Impl_$ = {};
$hxClasses["lix.client.haxe._ResolvedVersion.ResolvedVersion_Impl_"] = lix_client_haxe__$ResolvedVersion_ResolvedVersion_$Impl_$;
lix_client_haxe__$ResolvedVersion_ResolvedVersion_$Impl_$.__name__ = ["lix","client","haxe","_ResolvedVersion","ResolvedVersion_Impl_"];
lix_client_haxe__$ResolvedVersion_ResolvedVersion_$Impl_$.get_id = function(this1) {
	switch(this1[1]) {
	case 0:
		var v = this1[2].hash;
		return v;
	case 1:
		var v1 = this1[2];
		return v1;
	case 2:
		var v2 = this1[2];
		return v2;
	}
};
lix_client_haxe__$ResolvedVersion_ResolvedVersion_$Impl_$.toString = function(this1) {
	return lix_client_haxe__$UserVersion_UserVersion_$Impl_$.toString(lix_client_haxe__$UserVersion_UserVersion_$Impl_$.ofResolved(this1));
};
var lix_client_haxe_PickOfficial = $hxClasses["lix.client.haxe.PickOfficial"] = { __ename__ : ["lix","client","haxe","PickOfficial"], __constructs__ : ["StableOnly","IncludePrereleases"] };
lix_client_haxe_PickOfficial.StableOnly = ["StableOnly",0];
lix_client_haxe_PickOfficial.StableOnly.toString = $estr;
lix_client_haxe_PickOfficial.StableOnly.__enum__ = lix_client_haxe_PickOfficial;
lix_client_haxe_PickOfficial.IncludePrereleases = ["IncludePrereleases",1];
lix_client_haxe_PickOfficial.IncludePrereleases.toString = $estr;
lix_client_haxe_PickOfficial.IncludePrereleases.__enum__ = lix_client_haxe_PickOfficial;
var lix_client_haxe_Switcher = function(scope,silent,log) {
	this.scope = scope;
	this.silent = silent;
	this.log = log;
	haxeshim_Fs.ensureDir(haxe_io_Path.addTrailingSlash(scope.versionDir));
	haxeshim_Fs.ensureDir(haxe_io_Path.addTrailingSlash(scope.haxelibRepo));
	haxeshim_Fs.ensureDir(this.downloads = scope.haxeshimRoot + "/downloads/");
};
$hxClasses["lix.client.haxe.Switcher"] = lix_client_haxe_Switcher;
lix_client_haxe_Switcher.__name__ = ["lix","client","haxe","Switcher"];
lix_client_haxe_Switcher.linkToNightly = function(hash,date) {
	var extension = lix_client_haxe_Switcher.PLATFORM == "windows" && date.getTime() > 1494460800000 ? "zip" : "tar.gz";
	return DateTools.format(date,"" + lix_client_haxe_Switcher.NIGHTLIES + "/" + lix_client_haxe_Switcher.PLATFORM + "/haxe_%Y-%m-%d_development_" + hash + "." + extension);
};
lix_client_haxe_Switcher.sortedOfficial = function(kind,versions) {
	if(kind == lix_client_haxe_PickOfficial.StableOnly) {
		var _g = [];
		var _g1 = 0;
		while(_g1 < versions.length) {
			var v = versions[_g1];
			++_g1;
			if(!lix_client_haxe__$Official_Official_$Impl_$.get_isPrerelease(v)) {
				_g.push(v);
			}
		}
		versions = _g;
	}
	versions.sort(lix_client_haxe__$Official_Official_$Impl_$.compare);
	return versions;
};
lix_client_haxe_Switcher.officialOnline = function(kind) {
	return tink_core__$Promise_Promise_$Impl_$.next(lix_client_Download.text("https://raw.githubusercontent.com/HaxeFoundation/haxe.org/staging/downloads/versions.json"),function(s) {
		var d = JSON.parse(s).versions.map(function(v) {
			return v.version;
		});
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(lix_client_haxe_Switcher.sortedOfficial(kind,d)));
	});
};
lix_client_haxe_Switcher.sortedNightlies = function(raw) {
	raw.sort(function(a,b) {
		return Reflect.compare(b.published.getTime(),a.published.getTime());
	});
	return raw;
};
lix_client_haxe_Switcher.nightliesOnline = function() {
	return tink_core__$Promise_Promise_$Impl_$.next(lix_client_Download.text("" + lix_client_haxe_Switcher.NIGHTLIES + "/" + lix_client_haxe_Switcher.PLATFORM + "/"),tink_core__$Promise_Next_$Impl_$.ofSafeSync(function(s) {
		var lines = s.split("------------------\n").pop().split("\n");
		var ret = [];
		var _g = 0;
		while(_g < lines.length) {
			var l = lines[_g];
			++_g;
			var _g1 = StringTools.trim(l);
			if(_g1 != "") {
				var v = _g1;
				if(v.indexOf("_development_") != -1) {
					var _g11 = v.indexOf("   ");
					var _hx_tmp;
					if(_g11 != -1) {
						_hx_tmp = HxOverrides.substr(v,0,_g11).split(" ");
						if(_hx_tmp.length == 2) {
							var _hx_tmp1 = _hx_tmp[0].split("-").map(Std.parseInt);
							if(_hx_tmp1.length == 3) {
								if(_hx_tmp1[0] == null) {
									if(_hx_tmp1[1] == null) {
										if(_hx_tmp1[2] == null) {
											var _hx_tmp2 = _hx_tmp[1].split(":").map(Std.parseInt);
											if(_hx_tmp2.length == 3) {
												var ss = _hx_tmp2[2];
												var mm = _hx_tmp2[1];
												var hh = _hx_tmp2[0];
												var y = _hx_tmp1[0];
												var m = _hx_tmp1[1];
												var d = _hx_tmp1[2];
												ret.push({ hash : v.split("_development_").pop().split(".").shift(), published : new Date(y,m - 1,d,hh,mm,ss)});
											}
										} else {
											var _hx_tmp3 = _hx_tmp[1].split(":").map(Std.parseInt);
											if(_hx_tmp3.length == 3) {
												var ss1 = _hx_tmp3[2];
												var mm1 = _hx_tmp3[1];
												var hh1 = _hx_tmp3[0];
												var y1 = _hx_tmp1[0];
												var m1 = _hx_tmp1[1];
												var d1 = _hx_tmp1[2];
												ret.push({ hash : v.split("_development_").pop().split(".").shift(), published : new Date(y1,m1 - 1,d1,hh1,mm1,ss1)});
											}
										}
									} else if(_hx_tmp1[2] == null) {
										var _hx_tmp4 = _hx_tmp[1].split(":").map(Std.parseInt);
										if(_hx_tmp4.length == 3) {
											var ss2 = _hx_tmp4[2];
											var mm2 = _hx_tmp4[1];
											var hh2 = _hx_tmp4[0];
											var y2 = _hx_tmp1[0];
											var m2 = _hx_tmp1[1];
											var d2 = _hx_tmp1[2];
											ret.push({ hash : v.split("_development_").pop().split(".").shift(), published : new Date(y2,m2 - 1,d2,hh2,mm2,ss2)});
										}
									} else {
										var _hx_tmp5 = _hx_tmp[1].split(":").map(Std.parseInt);
										if(_hx_tmp5.length == 3) {
											var ss3 = _hx_tmp5[2];
											var mm3 = _hx_tmp5[1];
											var hh3 = _hx_tmp5[0];
											var y3 = _hx_tmp1[0];
											var m3 = _hx_tmp1[1];
											var d3 = _hx_tmp1[2];
											ret.push({ hash : v.split("_development_").pop().split(".").shift(), published : new Date(y3,m3 - 1,d3,hh3,mm3,ss3)});
										}
									}
								} else if(_hx_tmp1[1] == null) {
									if(_hx_tmp1[2] == null) {
										var _hx_tmp6 = _hx_tmp[1].split(":").map(Std.parseInt);
										if(_hx_tmp6.length == 3) {
											var ss4 = _hx_tmp6[2];
											var mm4 = _hx_tmp6[1];
											var hh4 = _hx_tmp6[0];
											var y4 = _hx_tmp1[0];
											var m4 = _hx_tmp1[1];
											var d4 = _hx_tmp1[2];
											ret.push({ hash : v.split("_development_").pop().split(".").shift(), published : new Date(y4,m4 - 1,d4,hh4,mm4,ss4)});
										}
									} else {
										var _hx_tmp7 = _hx_tmp[1].split(":").map(Std.parseInt);
										if(_hx_tmp7.length == 3) {
											var ss5 = _hx_tmp7[2];
											var mm5 = _hx_tmp7[1];
											var hh5 = _hx_tmp7[0];
											var y5 = _hx_tmp1[0];
											var m5 = _hx_tmp1[1];
											var d5 = _hx_tmp1[2];
											ret.push({ hash : v.split("_development_").pop().split(".").shift(), published : new Date(y5,m5 - 1,d5,hh5,mm5,ss5)});
										}
									}
								} else if(_hx_tmp1[2] == null) {
									var _hx_tmp8 = _hx_tmp[1].split(":").map(Std.parseInt);
									if(_hx_tmp8.length == 3) {
										var ss6 = _hx_tmp8[2];
										var mm6 = _hx_tmp8[1];
										var hh6 = _hx_tmp8[0];
										var y6 = _hx_tmp1[0];
										var m6 = _hx_tmp1[1];
										var d6 = _hx_tmp1[2];
										ret.push({ hash : v.split("_development_").pop().split(".").shift(), published : new Date(y6,m6 - 1,d6,hh6,mm6,ss6)});
									}
								} else {
									var _hx_tmp9 = _hx_tmp[1].split(":").map(Std.parseInt);
									if(_hx_tmp9.length == 3) {
										var ss7 = _hx_tmp9[2];
										var mm7 = _hx_tmp9[1];
										var hh7 = _hx_tmp9[0];
										var y7 = _hx_tmp1[0];
										var m7 = _hx_tmp1[1];
										var d7 = _hx_tmp1[2];
										ret.push({ hash : v.split("_development_").pop().split(".").shift(), published : new Date(y7,m7 - 1,d7,hh7,mm7,ss7)});
									}
								}
							}
						}
					}
				}
			}
		}
		return lix_client_haxe_Switcher.sortedNightlies(ret);
	}));
};
lix_client_haxe_Switcher.attempt = function(what,l) {
	var o;
	try {
		o = tink_core_Outcome.Success(l.get());
	} catch( e ) {
		o = tink_core_Outcome.Failure(new tink_core_TypedError(null,"Failed to " + what + " because " + Std.string((e instanceof js__$Boot_HaxeError) ? e.val : e),{ fileName : "Switcher.hx", lineNumber : 107, className : "lix.client.haxe.Switcher", methodName : "attempt"}));
	}
	return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(o));
};
lix_client_haxe_Switcher.pickFirst = function(kind,make) {
	return function(i) {
		var _g = $getIterator(i).next();
		if(_g == null) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"No " + kind + " build found",{ fileName : "Switcher.hx", lineNumber : 138, className : "lix.client.haxe.Switcher", methodName : "pickFirst"})));
		} else {
			var v = _g;
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(make(v)));
		}
	};
};
lix_client_haxe_Switcher.ensureNeko = function(echo) {
	var neko = haxeshim_Neko.PATH;
	if(sys_FileSystem.exists(neko)) {
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(neko));
	} else {
		echo("Neko seems to be missing. Attempting download ...");
		var _g = Sys.systemName();
		var tmp;
		switch(_g) {
		case "Mac":
			tmp = lix_client_Download.tar("https://github.com/HaxeFoundation/neko/releases/download/v2-2-0/neko-2.2.0-osx64.tar.gz",1,neko,true);
			break;
		case "Windows":
			tmp = lix_client_Download.zip("https://github.com/HaxeFoundation/neko/releases/download/v2-2-0/neko-2.2.0-win.zip",1,neko,true);
			break;
		default:
			tmp = lix_client_Download.tar("https://github.com/HaxeFoundation/neko/releases/download/v2-2-0/neko-2.2.0-linux64.tar.gz",1,neko,true);
		}
		return tink_core__$Promise_Promise_$Impl_$.next(tmp,function(x) {
			echo("done");
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(x));
		});
	}
};
lix_client_haxe_Switcher.prototype = {
	officialInstalled: function(kind) {
		var _g = [];
		var _g1 = 0;
		var _g2 = js_node_Fs.readdirSync(this.scope.versionDir);
		while(_g1 < _g2.length) {
			var v = _g2[_g1];
			++_g1;
			if(!lix_client_haxe__$UserVersion_UserVersion_$Impl_$.isHash(v) && sys_FileSystem.isDirectory(this.versionDir(v))) {
				_g.push(v);
			}
		}
		return lix_client_haxe_Switcher.attempt("Get installed Haxe versions",new tink_core__$Lazy_LazyConst(lix_client_haxe_Switcher.sortedOfficial(kind,_g)));
	}
	,nightliesInstalled: function() {
		var _g = [];
		var _g1 = 0;
		var _g2 = js_node_Fs.readdirSync(this.scope.versionDir).filter(lix_client_haxe__$UserVersion_UserVersion_$Impl_$.isHash);
		while(_g1 < _g2.length) {
			var v = _g2[_g1];
			++_g1;
			_g.push({ hash : v, published : HxOverrides.strDate(JSON.parse(js_node_Fs.readFileSync("" + this.versionDir(v) + "/" + lix_client_haxe_Switcher.VERSION_INFO,{ encoding : "utf8"})).published)});
		}
		return lix_client_haxe_Switcher.attempt("get installed Haxe versions",new tink_core__$Lazy_LazyConst(lix_client_haxe_Switcher.sortedNightlies(_g)));
	}
	,switchTo: function(version) {
		var _gthis = this;
		return lix_client_haxe_Switcher.attempt("save new configuration to " + this.scope.configFile,new tink_core__$Lazy_LazyFunc(function() {
			_gthis.scope.reconfigure({ version : lix_client_haxe__$ResolvedVersion_ResolvedVersion_$Impl_$.get_id(version), resolveLibs : _gthis.scope.config.resolveLibs});
			return tink_core_Noise.Noise;
		}));
	}
	,resolveInstalled: function(version) {
		return this.resolve(version,$bind(this,this.officialInstalled),$bind(this,this.nightliesInstalled));
	}
	,resolveOnline: function(version) {
		return this.resolve(version,lix_client_haxe_Switcher.officialOnline,lix_client_haxe_Switcher.nightliesOnline);
	}
	,resolve: function(version,getOfficial,getNightlies) {
		switch(version[1]) {
		case 0:
			return tink_core__$Promise_Promise_$Impl_$.next(getNightlies(),lix_client_haxe_Switcher.pickFirst("nightly",lix_client_haxe_ResolvedUserVersionData.RNightly));
		case 1:
			return tink_core__$Promise_Promise_$Impl_$.next(getOfficial(lix_client_haxe_PickOfficial.IncludePrereleases),lix_client_haxe_Switcher.pickFirst("official",lix_client_haxe_ResolvedUserVersionData.ROfficial));
		case 2:
			return tink_core__$Promise_Promise_$Impl_$.next(getOfficial(lix_client_haxe_PickOfficial.StableOnly),lix_client_haxe_Switcher.pickFirst("stable",lix_client_haxe_ResolvedUserVersionData.ROfficial));
		case 3:
			var hash = version[2];
			return tink_core__$Promise_Promise_$Impl_$.ofSpecific(tink_core__$Promise_Promise_$Impl_$.next(getNightlies(),function(v) {
				var n = $getIterator(v);
				while(n.hasNext()) {
					var n1 = n.next();
					if(n1.hash == hash) {
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(lix_client_haxe_ResolvedUserVersionData.RNightly(n1)));
					}
				}
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"Unable to resolve nightly version " + lix_client_haxe__$UserVersion_UserVersion_$Impl_$.toString(version) + " locally, install it first with `lix install haxe " + lix_client_haxe__$UserVersion_UserVersion_$Impl_$.toString(version) + "`",{ fileName : "Switcher.hx", lineNumber : 163, className : "lix.client.haxe.Switcher", methodName : "resolve"})));
			}));
		case 4:
			var version1 = version[2];
			return tink_core__$Promise_Promise_$Impl_$.ofSpecific(tink_core__$Promise_Promise_$Impl_$.next(getOfficial(lix_client_haxe_PickOfficial.IncludePrereleases),function(versions) {
				if(Lambda.has(versions,version1)) {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(lix_client_haxe_ResolvedUserVersionData.ROfficial(version1)));
				} else {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"Unable to resolve version " + version1 + " locally, install it first with `lix install haxe " + version1 + "`",{ fileName : "Switcher.hx", lineNumber : 171, className : "lix.client.haxe.Switcher", methodName : "resolve"})));
				}
			}));
		case 5:
			var path = version[2];
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(lix_client_haxe_ResolvedUserVersionData.RCustom(path)));
		}
	}
	,versionDir: function(name) {
		return this.scope.getInstallation(name).path;
	}
	,isDownloaded: function(r) {
		return sys_FileSystem.exists(this.versionDir(lix_client_haxe__$ResolvedVersion_ResolvedVersion_$Impl_$.get_id(r)));
	}
	,linkToOfficial: function(version) {
		var tmp = "http://haxe.org/website-content/downloads/" + version + "/downloads/haxe-" + version + "-";
		var _g = Sys.systemName();
		var tmp1;
		switch(_g) {
		case "Mac":
			tmp1 = "osx.tar.gz";
			break;
		case "Windows":
			tmp1 = "win.zip";
			break;
		default:
			tmp1 = version < "3" ? "linux.tar.gz" : "linux64.tar.gz";
		}
		return tmp + tmp1;
	}
	,replace: function(target,replacement,archiveAs,beforeReplace) {
		var root = replacement;
		while(true) {
			var _g = haxeshim_Fs.ls(replacement);
			if(_g.length == 1) {
				var sub = _g[0];
				replacement = sub;
			} else {
				break;
			}
		}
		if(beforeReplace != null) {
			beforeReplace(replacement);
		}
		if(sys_FileSystem.exists(target)) {
			var old = "" + this.downloads + "/" + archiveAs + "@" + Math.floor(js_node_Fs.statSync(target).ctime.getTime());
			js_node_Fs.renameSync(target,old);
			js_node_Fs.renameSync(replacement,target);
		} else {
			js_node_Fs.renameSync(replacement,target);
		}
		if(sys_FileSystem.exists(root)) {
			haxeshim_Fs["delete"](root);
		}
	}
	,install: function(version,options) {
		return tink_core__$Promise_Promise_$Impl_$.next(this.resolveAndDownload(version,options),$bind(this,this.switchTo));
	}
	,resolveAndDownload: function(version,options) {
		var _gthis = this;
		var this1;
		var _g = lix_client_haxe__$UserVersion_UserVersion_$Impl_$.ofString(version);
		switch(_g[1]) {
		case 3:case 4:
			this1 = this.resolveInstalled(lix_client_haxe__$UserVersion_UserVersion_$Impl_$.ofString(version));
			break;
		default:
			this1 = tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"" + version + " needs to be resolved online",{ fileName : "Switcher.hx", lineNumber : 229, className : "lix.client.haxe.Switcher", methodName : "resolveAndDownload"})));
		}
		var f = function(_) {
			_gthis.log("Looking up Haxe version \"" + version + "\" online");
			return tink_core__$Promise_Promise_$Impl_$.next(_gthis.resolveOnline(lix_client_haxe__$UserVersion_UserVersion_$Impl_$.ofString(version)),function(r) {
				_gthis.log("  Resolved to " + lix_client_haxe__$ResolvedVersion_ResolvedVersion_$Impl_$.toString(r) + ". Downloading ...");
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(r));
			});
		};
		var ret = this1.flatMap(function(o) {
			switch(o[1]) {
			case 0:
				var d = o[2];
				return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(o));
			case 1:
				var e = o[2];
				return f(e);
			}
		});
		return tink_core__$Promise_Promise_$Impl_$.next(ret.gather(),function(r1) {
			return tink_core__$Promise_Promise_$Impl_$.next(_gthis.download(r1,options),function(wasDownloaded) {
				_gthis.log(!wasDownloaded ? "  ... already downloaded!" : "  ... download complete!");
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(r1));
			});
		});
	}
	,download: function(version,options) {
		var _gthis = this;
		var _hx_tmp;
		switch(version[1]) {
		case 0:
			_hx_tmp = this.isDownloaded(version);
			if(_hx_tmp == true) {
				if(options.force != true) {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(false));
				} else {
					var date = version[2].published;
					var hash = version[2].hash;
					return tink_core__$Promise_Promise_$Impl_$.next(lix_client_Download.archive(lix_client_haxe_Switcher.linkToNightly(hash,date),0,"" + this.downloads + "/" + hash + "@" + Math.floor(new Date().getTime()),!_gthis.silent),function(dir) {
						var tmp = _gthis.versionDir(hash);
						_gthis.replace(tmp,dir,hash,function(dir1) {
							js_node_Fs.writeFileSync("" + dir1 + "/" + lix_client_haxe_Switcher.VERSION_INFO,JSON.stringify({ published : HxOverrides.dateStr(date)}));
						});
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(true));
					});
				}
			} else {
				var date1 = version[2].published;
				var hash1 = version[2].hash;
				return tink_core__$Promise_Promise_$Impl_$.next(lix_client_Download.archive(lix_client_haxe_Switcher.linkToNightly(hash1,date1),0,"" + this.downloads + "/" + hash1 + "@" + Math.floor(new Date().getTime()),!_gthis.silent),function(dir2) {
					var tmp1 = _gthis.versionDir(hash1);
					_gthis.replace(tmp1,dir2,hash1,function(dir3) {
						js_node_Fs.writeFileSync("" + dir3 + "/" + lix_client_haxe_Switcher.VERSION_INFO,JSON.stringify({ published : HxOverrides.dateStr(date1)}));
					});
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(true));
				});
			}
			break;
		case 1:
			_hx_tmp = this.isDownloaded(version);
			if(_hx_tmp == true) {
				if(options.force != true) {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(false));
				} else {
					var version1 = version[2];
					var url = this.linkToOfficial(version1);
					var tmp2 = "" + this.downloads + "/" + version1 + "@" + Math.floor(new Date().getTime());
					var ret = lix_client_Download.archive(url,0,tmp2,!_gthis.silent);
					return tink_core__$Promise_Promise_$Impl_$.next(ret,function(v) {
						var tmp3 = _gthis.versionDir(version1);
						_gthis.replace(tmp3,v,version1);
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(true));
					});
				}
			} else {
				var version2 = version[2];
				var url1 = this.linkToOfficial(version2);
				var tmp4 = "" + this.downloads + "/" + version2 + "@" + Math.floor(new Date().getTime());
				var ret1 = lix_client_Download.archive(url1,0,tmp4,!_gthis.silent);
				return tink_core__$Promise_Promise_$Impl_$.next(ret1,function(v1) {
					var tmp5 = _gthis.versionDir(version2);
					_gthis.replace(tmp5,v1,version2);
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(true));
				});
			}
			break;
		case 2:
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Cannot download custom version",{ fileName : "Switcher.hx", lineNumber : 260, className : "lix.client.haxe.Switcher", methodName : "download"})));
		}
	}
	,__class__: lix_client_haxe_Switcher
};
var lix_client_haxe__$UserVersion_UserVersion_$Impl_$ = {};
$hxClasses["lix.client.haxe._UserVersion.UserVersion_Impl_"] = lix_client_haxe__$UserVersion_UserVersion_$Impl_$;
lix_client_haxe__$UserVersion_UserVersion_$Impl_$.__name__ = ["lix","client","haxe","_UserVersion","UserVersion_Impl_"];
lix_client_haxe__$UserVersion_UserVersion_$Impl_$.ofResolved = function(v) {
	switch(v[1]) {
	case 0:
		var version = v[2].hash;
		return lix_client_haxe_UserVersionData.UNightly(version);
	case 1:
		var version1 = v[2];
		return lix_client_haxe_UserVersionData.UOfficial(version1);
	case 2:
		var v1 = v[2];
		return lix_client_haxe_UserVersionData.UCustom(v1);
	}
};
lix_client_haxe__$UserVersion_UserVersion_$Impl_$.isHash = function(version) {
	var _g1 = 0;
	var _g = version.length;
	while(_g1 < _g) {
		var i = _g1++;
		var this1 = lix_client_haxe__$UserVersion_UserVersion_$Impl_$.hex;
		var key = version.charCodeAt(i);
		if(!this1.h[key]) {
			return false;
		}
	}
	return true;
};
lix_client_haxe__$UserVersion_UserVersion_$Impl_$.toString = function(this1) {
	switch(this1[1]) {
	case 0:
		return "latest nightly build";
	case 1:
		return "latest official";
	case 2:
		return "latest stable release";
	case 3:
		var v = this1[2];
		return "nightly build " + v;
	case 4:
		var v1 = this1[2];
		return "official release " + v1;
	case 5:
		var v2 = this1[2];
		return "custom version at `" + v2 + "`";
	}
};
lix_client_haxe__$UserVersion_UserVersion_$Impl_$.isPath = function(v) {
	if(!haxe_io_Path.isAbsolute(v)) {
		return v.charAt(0) == ".";
	} else {
		return true;
	}
};
lix_client_haxe__$UserVersion_UserVersion_$Impl_$.ofString = function(s) {
	if(s == null) {
		return null;
	} else {
		var _hx_tmp;
		var _hx_tmp1;
		if(s == null) {
			_hx_tmp = lix_client_haxe__$UserVersion_UserVersion_$Impl_$.isHash(s);
			if(_hx_tmp == true) {
				return lix_client_haxe_UserVersionData.UNightly(s);
			} else {
				_hx_tmp1 = lix_client_haxe__$UserVersion_UserVersion_$Impl_$.isPath(s);
				if(_hx_tmp1 == true) {
					return lix_client_haxe_UserVersionData.UCustom(s);
				} else {
					return lix_client_haxe_UserVersionData.UOfficial(s);
				}
			}
		} else {
			switch(s) {
			case "auto":
				return null;
			case "latest":
				return lix_client_haxe_UserVersionData.ULatest;
			case "edge":case "nightly":
				return lix_client_haxe_UserVersionData.UEdge;
			case "stable":
				return lix_client_haxe_UserVersionData.UStable;
			default:
				_hx_tmp = lix_client_haxe__$UserVersion_UserVersion_$Impl_$.isHash(s);
				if(_hx_tmp == true) {
					return lix_client_haxe_UserVersionData.UNightly(s);
				} else {
					_hx_tmp1 = lix_client_haxe__$UserVersion_UserVersion_$Impl_$.isPath(s);
					if(_hx_tmp1 == true) {
						return lix_client_haxe_UserVersionData.UCustom(s);
					} else {
						return lix_client_haxe_UserVersionData.UOfficial(s);
					}
				}
			}
		}
	}
};
var lix_client_haxe_UserVersionData = $hxClasses["lix.client.haxe.UserVersionData"] = { __ename__ : ["lix","client","haxe","UserVersionData"], __constructs__ : ["UEdge","ULatest","UStable","UNightly","UOfficial","UCustom"] };
lix_client_haxe_UserVersionData.UEdge = ["UEdge",0];
lix_client_haxe_UserVersionData.UEdge.toString = $estr;
lix_client_haxe_UserVersionData.UEdge.__enum__ = lix_client_haxe_UserVersionData;
lix_client_haxe_UserVersionData.ULatest = ["ULatest",1];
lix_client_haxe_UserVersionData.ULatest.toString = $estr;
lix_client_haxe_UserVersionData.ULatest.__enum__ = lix_client_haxe_UserVersionData;
lix_client_haxe_UserVersionData.UStable = ["UStable",2];
lix_client_haxe_UserVersionData.UStable.toString = $estr;
lix_client_haxe_UserVersionData.UStable.__enum__ = lix_client_haxe_UserVersionData;
lix_client_haxe_UserVersionData.UNightly = function(hash) { var $x = ["UNightly",3,hash]; $x.__enum__ = lix_client_haxe_UserVersionData; $x.toString = $estr; return $x; };
lix_client_haxe_UserVersionData.UOfficial = function(version) { var $x = ["UOfficial",4,version]; $x.__enum__ = lix_client_haxe_UserVersionData; $x.toString = $estr; return $x; };
lix_client_haxe_UserVersionData.UCustom = function(path) { var $x = ["UCustom",5,path]; $x.__enum__ = lix_client_haxe_UserVersionData; $x.toString = $estr; return $x; };
var lix_client_sources_Git = function(github,gitlab,scope) {
	this.github = github;
	this.gitlab = gitlab;
	this.scope = scope;
};
$hxClasses["lix.client.sources.Git"] = lix_client_sources_Git;
lix_client_sources_Git.__name__ = ["lix","client","sources","Git"];
lix_client_sources_Git["eval"] = function(cmd,cwd,args,env) {
	var _g = js_node_ChildProcess.spawnSync(cmd,args,{ cwd : cwd, stdio : ["inherit","pipe","inherit"], env : haxeshim__$Env_Env_$Impl_$.toVars(haxeshim_Exec.mergeEnv(env))});
	var x = _g;
	if(x.error == null) {
		return tink_core_Outcome.Success({ status : x.status, stdout : x.stdout.toString()});
	} else {
		var e = _g.error;
		return tink_core_Outcome.Failure(new tink_core_TypedError(null,"Failed to call " + cmd + " because " + Std.string(e),{ fileName : "Git.hx", lineNumber : 25, className : "lix.client.sources.Git", methodName : "eval"}));
	}
};
lix_client_sources_Git.cli = function(cwd) {
	haxeshim_Fs.ensureDir(haxe_io_Path.addTrailingSlash(cwd));
	return { call : function(args) {
		return tink_core__$Promise_Promise_$Impl_$.next(new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(haxeshim_Exec.sync("git",cwd,args))),function(code) {
			if(code == 0) {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
			} else {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(code,"git " + args[0] + " failed",{ fileName : "Git.hx", lineNumber : 33, className : "lix.client.sources.Git", methodName : "cli"})));
			}
		});
	}, 'eval' : function(args1) {
		return tink_core__$Promise_Promise_$Impl_$.next(new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(lix_client_sources_Git["eval"]("git",cwd,args1))),function(o) {
			if(o.status == 0) {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(o.stdout.toString()));
			} else {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(o.status,"git " + args1[0] + " failed",{ fileName : "Git.hx", lineNumber : 40, className : "lix.client.sources.Git", methodName : "cli"})));
			}
		});
	}};
};
lix_client_sources_Git.prototype = {
	schemes: function() {
		return ["git"];
	}
	,processUrl: function(raw) {
		var _gthis = this;
		var _g = raw.payload;
		var gh = _g;
		if(StringTools.startsWith(gh,"https://github.com")) {
			var tmp = this.github;
			var v = gh;
			var tmp1;
			if(StringTools.endsWith(v,".git")) {
				tmp1 = tink__$Url_Url_$Impl_$.fromString(HxOverrides.substr(v,0,v.length - 4));
			} else {
				var v1 = gh;
				tmp1 = tink__$Url_Url_$Impl_$.fromString(v1);
			}
			return tmp.processUrl(tmp1);
		} else {
			var gl = _g;
			if(StringTools.startsWith(gl,"https://gitlab.com")) {
				var tmp2 = this.gitlab;
				var v2 = gl;
				var tmp3;
				if(StringTools.endsWith(v2,".git")) {
					tmp3 = tink__$Url_Url_$Impl_$.fromString(HxOverrides.substr(v2,0,v2.length - 4));
				} else {
					var v3 = gl;
					tmp3 = tink__$Url_Url_$Impl_$.fromString(v3);
				}
				return tmp2.processUrl(tmp3);
			} else {
				var _hx_tmp = tink__$Url_Url_$Impl_$.fromString(_g);
				var url = _hx_tmp;
				var origin = tink__$Url_Url_$Impl_$.resolve(url,tink__$Url_Url_$Impl_$.fromString(""));
				var version;
				var _g1 = url.hash;
				if(_g1 == null) {
					version = "HEAD";
				} else if(_g1 == "") {
					version = "HEAD";
				} else {
					var v4 = _g1;
					version = v4;
				}
				var git = lix_client_sources_Git.cli(".");
				var sha = version.length != 40 ? tink_core__$Promise_Promise_$Impl_$.next(git["eval"](["ls-remote",tink__$Url_Url_$Impl_$.toString(origin),version]),function(s) {
					var _g11 = StringTools.trim(s);
					if(_g11 == "") {
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Cannot resolve version " + version,{ fileName : "Git.hx", lineNumber : 73, className : "lix.client.sources.Git", methodName : "processUrl"})));
					} else {
						var v5 = _g11;
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(HxOverrides.substr(v5,0,40)));
					}
				}) : tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(version));
				return tink_core__$Promise_Promise_$Impl_$.next(sha,tink_core__$Promise_Next_$Impl_$.ofSafeSync(function(sha1) {
					var tmp4 = tink__$Url_Url_$Impl_$.fromString(raw.scheme + ":" + tink__$Url_Url_$Impl_$.toString(tink__$Url_Url_$Impl_$.resolve(url,tink__$Url_Url_$Impl_$.fromString("#" + sha1))));
					var tmp5 = lix_client_ArchiveDestination.Computed(function(l) {
						return [l.name,l.version,"git",sha1];
					});
					var tmp6 = new lix_client_LibVersion(haxe_ds_Option.None,haxe_ds_Option.None);
					var tmp7 = lix_client_ArchiveKind.Custom(function(ctx) {
						var repo = haxe_io_Path.join([_gthis.scope.libCache,".gitrepos",lix_client_DownloadedArchive.escape(tink__$Url_Url_$Impl_$.toString(origin))]);
						var git1 = lix_client_sources_Git.cli(repo);
						var git2 = git1;
						var tmp8 = sys_FileSystem.exists("" + repo + "/.git") ? ["fetch",tink__$Url_Url_$Impl_$.toString(origin)] : ["clone",tink__$Url_Url_$Impl_$.toString(origin),"."];
						return tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Promise_Promise_$Impl_$.next(git2.call(tmp8),function(_) {
							return git1.call(["checkout",sha1]);
						}),function(_1) {
							haxeshim_Fs.copy(repo,ctx.dest,function(name) {
								return name != "" + repo + "/.git";
							});
							return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
						}),function(_2) {
							return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(ctx.dest));
						});
					});
					return { url : raw, normalized : tmp4, dest : tmp5, lib : tmp6, kind : tmp7};
				}));
			}
		}
	}
	,__class__: lix_client_sources_Git
};
var lix_client_sources_GitHub = function(credentials) {
	this.credentials = credentials;
};
$hxClasses["lix.client.sources.GitHub"] = lix_client_sources_GitHub;
lix_client_sources_GitHub.__name__ = ["lix","client","sources","GitHub"];
lix_client_sources_GitHub.prototype = {
	schemes: function() {
		return ["github","gh"];
	}
	,grabCommit: function(owner,project,version) {
		var this1 = this.credentials;
		return tink_core__$Promise_Promise_$Impl_$.next(lix_client_Download.text("https://" + (this1 == null ? "" : "" + this1 + "@") + "api.github.com/repos/" + owner + "/" + project + "/commits?sha=" + version),function(s) {
			try {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(JSON.parse(s)[0].sha));
			} catch( e ) {
				var e1 = (e instanceof js__$Boot_HaxeError) ? e.val : e;
				var s1;
				if(version == null) {
					s1 = "";
				} else if(version == "") {
					s1 = "";
				} else {
					var v = version;
					s1 = "#" + v;
				}
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Failed to lookup sha for github:" + owner + "/" + project + s1,{ fileName : "GitHub.hx", lineNumber : 25, className : "lix.client.sources.GitHub", methodName : "grabCommit"})));
			}
		});
	}
	,getArchive: function(owner,project,commitish,credentials) {
		var _gthis = this;
		var doGet = function(sha) {
			return _gthis.getArchive(owner,project,sha,credentials);
		};
		if(commitish == null) {
			return tink_core__$Promise_Promise_$Impl_$.next(this.grabCommit(owner,project,""),doGet);
		} else {
			var sha1 = commitish;
			if(sha1.length == 40) {
				console.log("GitHub.hx:36:","gh://" + (credentials == null ? "" : "" + credentials + "@") + "github.com/" + owner + "/" + project + "#" + sha1);
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success({ normalized : tink__$Url_Url_$Impl_$.fromString("gh://" + (credentials == null ? "" : "" + credentials + "@") + "github.com/" + owner + "/" + project + "#" + sha1), dest : lix_client_ArchiveDestination.Computed(function(l) {
					return [l.name,l.version,"github",sha1];
				}), url : tink__$Url_Url_$Impl_$.fromString("https://" + (credentials == null ? "" : "" + credentials + "@") + "github.com/" + owner + "/" + project + "/archive/" + sha1 + ".tar.gz"), lib : new lix_client_LibVersion(haxe_ds_Option.Some(project),haxe_ds_Option.None)}));
			} else {
				var v = commitish;
				return tink_core__$Promise_Promise_$Impl_$.next(this.grabCommit(owner,project,v),doGet);
			}
		}
	}
	,processUrl: function(url) {
		var _g = url.path;
		var _hx_tmp;
		if(_g == null) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"invalid github url " + tink__$Url_Url_$Impl_$.toString(url),{ fileName : "GitHub.hx", lineNumber : 50, className : "lix.client.sources.GitHub", methodName : "processUrl"})));
		} else {
			_hx_tmp = tink_url__$PortionArray_PortionArray_$Impl_$.toStringArray(tink_url__$Path_Path_$Impl_$.parts(_g));
			if(_hx_tmp.length == 2) {
				var project = _hx_tmp[1];
				var owner = _hx_tmp[0];
				return this.getArchive(owner,project,url.hash,url.auth);
			} else {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"invalid github url " + tink__$Url_Url_$Impl_$.toString(url),{ fileName : "GitHub.hx", lineNumber : 53, className : "lix.client.sources.GitHub", methodName : "processUrl"})));
			}
		}
	}
	,__class__: lix_client_sources_GitHub
};
var lix_client_sources_GitLab = function(privateToken) {
	if(privateToken == null) {
		privateToken = "";
	}
	var _g = StringTools.trim(privateToken);
	var tmp;
	if(_g == "") {
		tmp = "";
	} else {
		var v = _g;
		tmp = "private_token=" + v;
	}
	this.privateToken = tmp;
};
$hxClasses["lix.client.sources.GitLab"] = lix_client_sources_GitLab;
lix_client_sources_GitLab.__name__ = ["lix","client","sources","GitLab"];
lix_client_sources_GitLab.host = function(options) {
	if(options == null) {
		return "gitlab.com";
	} else if(options.host == null) {
		return "gitlab.com";
	} else {
		var v = options.host;
		return v;
	}
};
lix_client_sources_GitLab.prototype = {
	schemes: function() {
		return ["gitlab"];
	}
	,grabCommit: function(owner,project,version,options) {
		return tink_core__$Promise_Promise_$Impl_$.next(lix_client_Download.text("https://" + lix_client_sources_GitLab.host(options) + "/api/v4/projects/" + owner + "%2F" + project + "/repository/commits/" + version + "?" + this.privateToken),function(s) {
			try {
				var parsed = JSON.parse(s);
				if(version == "") {
					parsed = parsed[0];
				}
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(parsed.id));
			} catch( e ) {
				var e1 = (e instanceof js__$Boot_HaxeError) ? e.val : e;
				var s1;
				if(version == null) {
					s1 = "";
				} else if(version == "") {
					s1 = "";
				} else {
					var v = version;
					s1 = "#" + v;
				}
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Failed to lookup sha for gitlab:" + owner + "/" + project + s1,{ fileName : "GitLab.hx", lineNumber : 35, className : "lix.client.sources.GitLab", methodName : "grabCommit"})));
			}
		});
	}
	,getArchive: function(owner,project,commitish,options) {
		if(commitish == null) {
			var f = $bind(this,this.getArchive);
			var owner1 = owner;
			var project1 = project;
			var options1 = options;
			var tmp = function(commitish1) {
				return f(owner1,project1,commitish1,options1);
			};
			return tink_core__$Promise_Promise_$Impl_$.next(this.grabCommit(owner,project,"",options),tmp);
		} else {
			var sha = commitish;
			if(sha.length == 40) {
				var d = lix_client_ArchiveDestination.Computed(function(l) {
					return [l.name,l.version,"gitlab",sha];
				});
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success({ normalized : tink__$Url_Url_$Impl_$.fromString("https://" + lix_client_sources_GitLab.host(options) + "/" + owner + "/" + project + "/repository/archive.tar.gz?ref=" + sha + "&" + this.privateToken), dest : d, url : tink__$Url_Url_$Impl_$.fromString("https://" + lix_client_sources_GitLab.host(options) + "/" + owner + "/" + project + "/repository/archive.tar.gz?ref=" + sha + "&" + this.privateToken), lib : new lix_client_LibVersion(haxe_ds_Option.Some(project),haxe_ds_Option.None)}));
			} else {
				var v = commitish;
				var f1 = $bind(this,this.getArchive);
				var owner2 = owner;
				var project2 = project;
				var options2 = options;
				var tmp1 = function(commitish2) {
					return f1(owner2,project2,commitish2,options2);
				};
				return tink_core__$Promise_Promise_$Impl_$.next(this.grabCommit(owner,project,v,options),tmp1);
			}
		}
	}
	,processUrl: function(url) {
		var _g = url.path;
		var _hx_tmp;
		if(_g == null) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"invalid gitlab url " + tink__$Url_Url_$Impl_$.toString(url),{ fileName : "GitLab.hx", lineNumber : 56, className : "lix.client.sources.GitLab", methodName : "processUrl"})));
		} else {
			_hx_tmp = tink_url__$PortionArray_PortionArray_$Impl_$.toStringArray(tink_url__$Path_Path_$Impl_$.parts(_g));
			if(_hx_tmp.length == 2) {
				var project = _hx_tmp[1];
				var owner = _hx_tmp[0];
				return this.getArchive(owner,project,url.hash,{ host : url.host});
			} else {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"invalid gitlab url " + tink__$Url_Url_$Impl_$.toString(url),{ fileName : "GitLab.hx", lineNumber : 58, className : "lix.client.sources.GitLab", methodName : "processUrl"})));
			}
		}
	}
	,__class__: lix_client_sources_GitLab
};
var lix_client_sources_haxelib_Async_$Repo = function(c) {
	this.__cnx = c;
};
$hxClasses["lix.client.sources.haxelib.Async_Repo"] = lix_client_sources_haxelib_Async_$Repo;
lix_client_sources_haxelib_Async_$Repo.__name__ = ["lix","client","sources","haxelib","Async_Repo"];
lix_client_sources_haxelib_Async_$Repo.prototype = {
	getLatestVersion: function(project,__callb) {
		this.__cnx.resolve("getLatestVersion").call([project],__callb);
	}
	,__class__: lix_client_sources_haxelib_Async_$Repo
};
var lix_client_sources__$Haxelib_Proxy = function(c) {
	lix_client_sources_haxelib_Async_$Repo.call(this,c);
};
$hxClasses["lix.client.sources._Haxelib.Proxy"] = lix_client_sources__$Haxelib_Proxy;
lix_client_sources__$Haxelib_Proxy.__name__ = ["lix","client","sources","_Haxelib","Proxy"];
lix_client_sources__$Haxelib_Proxy.__super__ = lix_client_sources_haxelib_Async_$Repo;
lix_client_sources__$Haxelib_Proxy.prototype = $extend(lix_client_sources_haxelib_Async_$Repo.prototype,{
	__class__: lix_client_sources__$Haxelib_Proxy
});
var lix_client_sources_Haxelib = function(baseURL) {
	if(baseURL == null) {
		baseURL = lix_client_sources_Haxelib.OFFICIAL;
	}
	this.lazy_isOfficial = new tink_core__$Lazy_LazyFunc(function() {
		return lix_client_sources_Haxelib.OFFICIAL == baseURL;
	});
	this.baseURL = baseURL;
};
$hxClasses["lix.client.sources.Haxelib"] = lix_client_sources_Haxelib;
lix_client_sources_Haxelib.__name__ = ["lix","client","sources","Haxelib"];
lix_client_sources_Haxelib.prototype = {
	getBaseUrl: function(options) {
		if(options == null) {
			return tink__$Url_Url_$Impl_$.fromString(this.baseURL);
		} else if(options.host == null) {
			return tink__$Url_Url_$Impl_$.fromString(this.baseURL);
		} else {
			var h = options.host;
			return tink__$Url_Url_$Impl_$.fromString("" + (tink_url__$Host_Host_$Impl_$.get_port(h) == null ? "https" : "http") + "://" + h + "/");
		}
	}
	,resolve: function(url,options) {
		return tink__$Url_Url_$Impl_$.resolve(this.getBaseUrl(options),url);
	}
	,schemes: function() {
		return ["haxelib"];
	}
	,processUrl: function(url) {
		var _this = tink_url__$Query_Query_$Impl_$.toMap(url.query);
		var _g = tink_url__$Portion_Portion_$Impl_$.toString(__map_reserved["url"] != null ? _this.getReserved("url") : _this.h["url"]);
		var _hx_tmp = _g == null || _g == this.baseURL;
		if(_hx_tmp == true) {
			var _g1 = url.path;
			var _hx_tmp1;
			if(_g1 == null) {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"invalid haxelib url " + tink__$Url_Url_$Impl_$.toString(url),{ fileName : "Haxelib.hx", lineNumber : 32, className : "lix.client.sources.Haxelib", methodName : "processUrl"})));
			} else {
				_hx_tmp1 = tink_url__$PortionArray_PortionArray_$Impl_$.toStringArray(tink_url__$Path_Path_$Impl_$.parts(_g1));
				if(_hx_tmp1.length == 1) {
					var v = _hx_tmp1[0];
					return this.getArchive(v,url.hash,{ host : url.host});
				} else {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"invalid haxelib url " + tink__$Url_Url_$Impl_$.toString(url),{ fileName : "Haxelib.hx", lineNumber : 34, className : "lix.client.sources.Haxelib", methodName : "processUrl"})));
				}
			}
		} else {
			var v1 = _g;
			return new lix_client_sources_Haxelib(v1).processUrl(url);
		}
	}
	,getArchive: function(name,version,options) {
		if(version == null) {
			var f = $bind(this,this.getArchive);
			var name1 = name;
			var options1 = options;
			var tmp = function(version1) {
				return f(name1,version1,options1);
			};
			return tink_core__$Promise_Promise_$Impl_$.next(this.resolveVersion(name,options),tmp);
		} else {
			var v = version;
			var host;
			if(options == null) {
				host = haxe_ds_Option.None;
			} else if(options.host == null) {
				host = haxe_ds_Option.None;
			} else {
				var h = options.host;
				host = haxe_ds_Option.Some(h);
			}
			var isCustom = !(host == haxe_ds_Option.None && this.get_isOfficial());
			var d = this.resolve(tink__$Url_Url_$Impl_$.fromString("/files/3.0/" + StringTools.replace(name,".",",") + "-" + StringTools.replace(version,".",",") + ".zip"),options);
			var d1;
			if(host[1] == 0) {
				var v1 = host[2];
				d1 = v1;
			} else {
				d1 = null;
			}
			var d2 = tink__$Url_Url_$Impl_$.make({ scheme : "haxelib", host : d1, path : tink_url__$Path_Path_$Impl_$.ofString("/" + name), hash : version, query : isCustom ? tink_url__$Query_Query_$Impl_$.ofObj({ url : this.baseURL}) : null});
			var d3;
			if(isCustom) {
				var s = tink__$Url_Url_$Impl_$.toString(this.getBaseUrl(options));
				d3 = "@" + encodeURIComponent(s);
			} else {
				d3 = "";
			}
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success({ url : d, normalized : d2, dest : lix_client_ArchiveDestination.Fixed([name,version,"haxelib" + d3]), kind : lix_client_ArchiveKind.Zip, lib : new lix_client_LibVersion(haxe_ds_Option.Some(name),haxe_ds_Option.Some(version))}));
		}
	}
	,resolveVersion: function(name,options) {
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			var cnx = haxe_remoting_HttpAsyncConnection.urlConnect(tink__$Url_Url_$Impl_$.toString(_gthis.resolve(tink__$Url_Url_$Impl_$.fromString("/api/3.0/index.n"),options)));
			cnx.setErrorHandler(function(e) {
				var tmp = tink_core_Outcome.Failure(tink_core_TypedError.withData(null,"Failed to get version information from haxelib because " + e,e,{ fileName : "Haxelib.hx", lineNumber : 74, className : "lix.client.sources.Haxelib", methodName : "resolveVersion"}));
				cb(tmp);
			});
			var repo = new lix_client_sources__$Haxelib_Proxy(cnx.resolve("api"));
			repo.getLatestVersion(name,function(s) {
				cb(tink_core_Outcome.Success(s));
			});
		});
	}
	,get_isOfficial: function() {
		return this.lazy_isOfficial.get();
	}
	,__class__: lix_client_sources_Haxelib
};
var lix_client_sources_Lix = function() {
};
$hxClasses["lix.client.sources.Lix"] = lix_client_sources_Lix;
lix_client_sources_Lix.__name__ = ["lix","client","sources","Lix"];
lix_client_sources_Lix.prototype = {
	schemes: function() {
		return ["lix"];
	}
	,processUrl: function(url) {
		var _g = url.path;
		var _hx_tmp;
		if(_g == null) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"invalid lix url " + tink__$Url_Url_$Impl_$.toString(url),{ fileName : "Lix.hx", lineNumber : 15, className : "lix.client.sources.Lix", methodName : "processUrl"})));
		} else {
			_hx_tmp = tink_url__$PortionArray_PortionArray_$Impl_$.toStringArray(tink_url__$Path_Path_$Impl_$.parts(_g));
			if(_hx_tmp.length == 2) {
				var project = _hx_tmp[1];
				var owner = _hx_tmp[0];
				return this.getArchive(owner,project,url.hash);
			} else {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"invalid lix url " + tink__$Url_Url_$Impl_$.toString(url),{ fileName : "Lix.hx", lineNumber : 18, className : "lix.client.sources.Lix", methodName : "processUrl"})));
			}
		}
	}
	,getArchive: function(owner,name,version) {
		var client = new tink_http_clients_SecureNodeClient();
		var this1 = new tink_web_proxy_Remote0(client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$._new(lix_util_Config.API_SERVER_HOST));
		var remote = this1;
		var versions = remote.owners().byName(owner).projects().byName(name).versions();
		var api = version == null ? versions.latest() : versions.byVersion(tink_core_OutcomeTools.sure(tink_semver__$Version_Version_$Impl_$.parse(version)));
		return tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Promise_Promise_$Impl_$.and(api.get(),api.download()),function(o) {
			var d = tink__$Url_Url_$Impl_$.fromString(o.b.url);
			var d1 = tink__$Url_Url_$Impl_$.make({ scheme : "lix", path : tink_url__$Path_Path_$Impl_$.ofString("" + owner + "/" + name), hash : o.a.version.toString()});
			var d2 = o.a.version.toString();
			var _g = haxe_ds_Option.Some(name);
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success({ url : d, normalized : d1, dest : lix_client_ArchiveDestination.Fixed([name,d2,"lix",owner]), kind : lix_client_ArchiveKind.Zip, lib : new lix_client_LibVersion(_g,haxe_ds_Option.Some(o.a.version.toString()))}));
		});
	}
	,__class__: lix_client_sources_Lix
};
var lix_client_sources_Web = function() { };
$hxClasses["lix.client.sources.Web"] = lix_client_sources_Web;
lix_client_sources_Web.__name__ = ["lix","client","sources","Web"];
lix_client_sources_Web.schemes = function() {
	return ["http","https"];
};
lix_client_sources_Web.processUrl = function(url) {
	var lib = lix_client_LibVersion.parse(url.hash);
	if(lib != null) {
		url = tink__$Url_Url_$Impl_$.fromString(tink__$Url_Url_$Impl_$.toString(url).split("#")[0]);
	}
	var d = lix_client_ArchiveDestination.Computed(function(l) {
		return [l.name,l.version,tink__$Url_Url_$Impl_$.toString(url)];
	});
	return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success({ url : url, dest : d, normalized : url, lib : lib}));
};
var lix_client_uncompress_Tar = function() { };
$hxClasses["lix.client.uncompress.Tar"] = lix_client_uncompress_Tar;
lix_client_uncompress_Tar.__name__ = ["lix","client","uncompress","Tar"];
lix_client_uncompress_Tar.parse = function(source,onentry) {
	return tink_core__$Future_Future_$Impl_$.async(function(cb) {
		var parse = new lix_client_uncompress_TarParse({ onentry : onentry});
		source.pipe(parse,{ end : true});
		parse.on("end",function() {
			cb(tink_core_Outcome.Success(tink_core_Noise.Noise));
		});
		parse.on("error",function(e) {
			var tmp = tink_core_Outcome.Failure(new tink_core_TypedError(null,e.message,{ fileName : "Tar.hx", lineNumber : 14, className : "lix.client.uncompress.Tar", methodName : "parse"}));
			cb(tmp);
		});
	});
};
var lix_client_uncompress_TarParse = require("tar").Parse;
var lix_client_uncompress_Yauzl = require("yauzl");
var tink_url__$Host_Host_$Impl_$ = {};
$hxClasses["tink.url._Host.Host_Impl_"] = tink_url__$Host_Host_$Impl_$;
tink_url__$Host_Host_$Impl_$.__name__ = ["tink","url","_Host","Host_Impl_"];
tink_url__$Host_Host_$Impl_$._new = function(name,port) {
	var this1;
	if(port == null) {
		this1 = name;
	} else if(port > 65535 || port <= 0) {
		throw new js__$Boot_HaxeError("Invalid port");
	} else {
		this1 = "" + name + ":" + port;
	}
	return this1;
};
tink_url__$Host_Host_$Impl_$.get_name = function(this1) {
	if(this1 == null) {
		return null;
	} else {
		var _g = this1.split("]");
		switch(_g.length) {
		case 1:
			var v = _g[0];
			return v.split(":")[0];
		case 2:
			var v1 = _g[0];
			return v1 + "]";
		default:
			throw new js__$Boot_HaxeError("assert");
		}
	}
};
tink_url__$Host_Host_$Impl_$.get_port = function(this1) {
	if(this1 == null) {
		return null;
	} else {
		var _g = this1.split("]");
		switch(_g.length) {
		case 1:
			var v = _g[0];
			var _g1 = v.split(":")[1];
			if(_g1 == null) {
				return null;
			} else {
				var p = _g1;
				return Std.parseInt(p);
			}
			break;
		case 2:
			var v1 = _g[1];
			var _g2 = v1.split(":")[1];
			if(_g2 == null) {
				return null;
			} else {
				var p1 = _g2;
				return Std.parseInt(p1);
			}
			break;
		default:
			throw new js__$Boot_HaxeError("assert");
		}
	}
};
var lix_util_Config = function() { };
$hxClasses["lix.util.Config"] = lix_util_Config;
lix_util_Config.__name__ = ["lix","util","Config"];
var sys_FileSystem = function() { };
$hxClasses["sys.FileSystem"] = sys_FileSystem;
sys_FileSystem.__name__ = ["sys","FileSystem"];
sys_FileSystem.exists = function(path) {
	try {
		js_node_Fs.accessSync(path);
		return true;
	} catch( _ ) {
		var _1 = (_ instanceof js__$Boot_HaxeError) ? _.val : _;
		return false;
	}
};
sys_FileSystem.isDirectory = function(path) {
	try {
		return js_node_Fs.statSync(path).isDirectory();
	} catch( e ) {
		var e1 = (e instanceof js__$Boot_HaxeError) ? e.val : e;
		return false;
	}
};
sys_FileSystem.createDirectory = function(path) {
	try {
		js_node_Fs.mkdirSync(path);
	} catch( e ) {
		var e1 = (e instanceof js__$Boot_HaxeError) ? e.val : e;
		if(e1.code == "ENOENT") {
			sys_FileSystem.createDirectory(js_node_Path.dirname(path));
			js_node_Fs.mkdirSync(path);
		} else {
			var stat;
			try {
				stat = js_node_Fs.statSync(path);
			} catch( _ ) {
				var _1 = (_ instanceof js__$Boot_HaxeError) ? _.val : _;
				throw e1;
			}
			if(!stat.isDirectory()) {
				throw e1;
			}
		}
	}
};
var sys_io_File = function() { };
$hxClasses["sys.io.File"] = sys_io_File;
sys_io_File.__name__ = ["sys","io","File"];
sys_io_File.copy = function(srcPath,dstPath) {
	var src = js_node_Fs.openSync(srcPath,"r");
	var stat = js_node_Fs.fstatSync(src);
	var dst = js_node_Fs.openSync(dstPath,"w",stat.mode);
	var bytesRead;
	var pos = 0;
	while(true) {
		bytesRead = js_node_Fs.readSync(src,sys_io_File.copyBuf,0,65536,pos);
		if(!(bytesRead > 0)) {
			break;
		}
		js_node_Fs.writeSync(dst,sys_io_File.copyBuf,0,bytesRead);
		pos += bytesRead;
	}
	js_node_Fs.closeSync(src);
	js_node_Fs.closeSync(dst);
};
var tink_chunk_ChunkBase = function() { };
$hxClasses["tink.chunk.ChunkBase"] = tink_chunk_ChunkBase;
tink_chunk_ChunkBase.__name__ = ["tink","chunk","ChunkBase"];
tink_chunk_ChunkBase.prototype = {
	getCursor: function() {
		if(this.flattened == null) {
			this.flatten(this.flattened = []);
		}
		return tink_chunk_ChunkCursor.create(this.flattened.slice());
	}
	,flatten: function(into) {
	}
	,__class__: tink_chunk_ChunkBase
};
var tink_chunk_ChunkObject = function() { };
$hxClasses["tink.chunk.ChunkObject"] = tink_chunk_ChunkObject;
tink_chunk_ChunkObject.__name__ = ["tink","chunk","ChunkObject"];
tink_chunk_ChunkObject.prototype = {
	__class__: tink_chunk_ChunkObject
};
var tink__$Chunk_EmptyChunk = function() {
};
$hxClasses["tink._Chunk.EmptyChunk"] = tink__$Chunk_EmptyChunk;
tink__$Chunk_EmptyChunk.__name__ = ["tink","_Chunk","EmptyChunk"];
tink__$Chunk_EmptyChunk.__interfaces__ = [tink_chunk_ChunkObject];
tink__$Chunk_EmptyChunk.__super__ = tink_chunk_ChunkBase;
tink__$Chunk_EmptyChunk.prototype = $extend(tink_chunk_ChunkBase.prototype,{
	getLength: function() {
		return 0;
	}
	,blitTo: function(target,offset) {
	}
	,toString: function() {
		return "";
	}
	,toBytes: function() {
		return tink__$Chunk_EmptyChunk.EMPTY;
	}
	,__class__: tink__$Chunk_EmptyChunk
});
var tink__$Chunk_CompoundChunk = function(left,right) {
	this.left = left;
	this.right = right;
	this.split = left.getLength();
	this.length = this.split + right.getLength();
};
$hxClasses["tink._Chunk.CompoundChunk"] = tink__$Chunk_CompoundChunk;
tink__$Chunk_CompoundChunk.__name__ = ["tink","_Chunk","CompoundChunk"];
tink__$Chunk_CompoundChunk.__interfaces__ = [tink_chunk_ChunkObject];
tink__$Chunk_CompoundChunk.__super__ = tink_chunk_ChunkBase;
tink__$Chunk_CompoundChunk.prototype = $extend(tink_chunk_ChunkBase.prototype,{
	getLength: function() {
		return this.length;
	}
	,flatten: function(into) {
		this.left.flatten(into);
		this.right.flatten(into);
	}
	,blitTo: function(target,offset) {
		this.left.blitTo(target,offset);
		this.right.blitTo(target,offset + this.split);
	}
	,toString: function() {
		return this.toBytes().toString();
	}
	,toBytes: function() {
		var ret = new haxe_io_Bytes(new ArrayBuffer(this.length));
		this.blitTo(ret,0);
		return ret;
	}
	,__class__: tink__$Chunk_CompoundChunk
});
var tink__$Chunk_Chunk_$Impl_$ = {};
$hxClasses["tink._Chunk.Chunk_Impl_"] = tink__$Chunk_Chunk_$Impl_$;
tink__$Chunk_Chunk_$Impl_$.__name__ = ["tink","_Chunk","Chunk_Impl_"];
tink__$Chunk_Chunk_$Impl_$.concat = function(this1,that) {
	var _g = that.getLength();
	var _g1 = this1.getLength();
	if(_g1 == 0) {
		if(_g == 0) {
			return tink__$Chunk_Chunk_$Impl_$.EMPTY;
		} else {
			return that;
		}
	} else if(_g == 0) {
		return this1;
	} else {
		return new tink__$Chunk_CompoundChunk(this1,that);
	}
};
tink__$Chunk_Chunk_$Impl_$.join = function(chunks) {
	if(chunks == null) {
		return tink__$Chunk_Chunk_$Impl_$.EMPTY;
	} else {
		switch(chunks.length) {
		case 0:
			return tink__$Chunk_Chunk_$Impl_$.EMPTY;
		case 1:
			var v = chunks[0];
			return v;
		default:
			var v1 = chunks;
			var ret = tink__$Chunk_Chunk_$Impl_$.catChunk(v1[0],v1[1]);
			var _g1 = 2;
			var _g = v1.length;
			while(_g1 < _g) {
				var i = _g1++;
				ret = tink__$Chunk_Chunk_$Impl_$.catChunk(ret,v1[i]);
			}
			return ret;
		}
	}
};
tink__$Chunk_Chunk_$Impl_$.ofBytes = function(b) {
	return tink_chunk_ByteChunk.of(b);
};
tink__$Chunk_Chunk_$Impl_$.catChunk = function(a,b) {
	return tink__$Chunk_Chunk_$Impl_$.concat(a,b);
};
var tink__$Stringly_Stringly_$Impl_$ = {};
$hxClasses["tink._Stringly.Stringly_Impl_"] = tink__$Stringly_Stringly_$Impl_$;
tink__$Stringly_Stringly_$Impl_$.__name__ = ["tink","_Stringly","Stringly_Impl_"];
tink__$Stringly_Stringly_$Impl_$.isNumber = function(s,allowFloat) {
	if(s.length == 0) {
		return false;
	}
	var pos = 0;
	var max = s.length;
	if(pos < max && s.charCodeAt(pos) == 45) {
		++pos;
	}
	if(!allowFloat) {
		if(pos < max && s.charCodeAt(pos) == 48 && pos++ > -1) {
			if(pos < max && s.charCodeAt(pos) == 120) {
				++pos;
			}
		}
	}
	while(pos < max && (s.charCodeAt(pos) ^ 48) < 10) ++pos;
	if(allowFloat && pos < max) {
		if(pos < max && s.charCodeAt(pos) == 46 && pos++ > -1) {
			while(pos < max && (s.charCodeAt(pos) ^ 48) < 10) ++pos;
		}
		if(pos < max && s.charCodeAt(pos) == 101 && pos++ > -1 || pos < max && s.charCodeAt(pos) == 69 && pos++ > -1) {
			if(!(pos < max && s.charCodeAt(pos) == 43 && pos++ > -1)) {
				if(pos < max && s.charCodeAt(pos) == 45) {
					++pos;
				}
			}
			while(pos < max && (s.charCodeAt(pos) ^ 48) < 10) ++pos;
		}
	}
	return pos == max;
};
tink__$Stringly_Stringly_$Impl_$.parseInt = function(this1) {
	var _g = StringTools.trim(this1);
	var v = _g;
	if(tink__$Stringly_Stringly_$Impl_$.isNumber(v,false)) {
		return tink_core_Outcome.Success(Std.parseInt(v));
	} else {
		var v1 = _g;
		return tink_core_Outcome.Failure(new tink_core_TypedError(422,"" + v1 + " (encoded as " + this1 + ") is not a valid integer",{ fileName : "tink/Stringly.hx", lineNumber : 71, className : "tink._Stringly.Stringly_Impl_", methodName : "parseInt"}));
	}
};
var tink__$Url_Url_$Impl_$ = {};
$hxClasses["tink._Url.Url_Impl_"] = tink__$Url_Url_$Impl_$;
tink__$Url_Url_$Impl_$.__name__ = ["tink","_Url","Url_Impl_"];
tink__$Url_Url_$Impl_$.resolve = function(this1,that) {
	if(that.scheme != null) {
		return that;
	} else if(that.host != null) {
		if(that.scheme != null) {
			return that;
		} else {
			var copy = Reflect.copy(that);
			copy.scheme = this1.scheme;
			return copy;
		}
	} else {
		var parts = { path : tink_url__$Path_Path_$Impl_$.join(this1.path,that.path), payload : "", scheme : this1.scheme, query : that.query, auth : this1.auth, host : this1.host, hash : that.hash};
		tink__$Url_Url_$Impl_$.makePayload(parts);
		var this2 = parts;
		return this2;
	}
};
tink__$Url_Url_$Impl_$.makePayload = function(parts) {
	var payload = "";
	if(parts.auth == null) {
		if(parts.host != null) {
			var host = parts.host;
			payload += "//" + host;
		}
	} else if(parts.host == null) {
		var auth = parts.auth;
		payload += "//" + (auth == null ? "" : "" + auth + "@");
	} else {
		var auth1 = parts.auth;
		var host1 = parts.host;
		payload += "//" + (auth1 == null ? "" : "" + auth1 + "@") + host1;
	}
	payload += parts.path;
	var _g = parts.query;
	if(_g != null) {
		var v = _g;
		payload += "?" + v;
	}
	var _g1 = parts.hash;
	if(_g1 != null) {
		var v1 = _g1;
		payload += "#" + v1;
	}
	parts.payload = payload.toString();
};
tink__$Url_Url_$Impl_$.toString = function(this1) {
	var _g = this1.scheme;
	if(_g == null) {
		return this1.payload;
	} else {
		return "" + this1.scheme + ":" + this1.payload;
	}
};
tink__$Url_Url_$Impl_$.fromString = function(s) {
	return tink__$Url_Url_$Impl_$.parse(s);
};
tink__$Url_Url_$Impl_$.noop = function(_) {
};
tink__$Url_Url_$Impl_$.parse = function(s,onError) {
	if(s == null) {
		return tink__$Url_Url_$Impl_$.parse("");
	}
	if(onError == null) {
		onError = tink__$Url_Url_$Impl_$.noop;
	}
	s = StringTools.trim(s);
	if(StringTools.startsWith(s,"data:")) {
		var this1 = { scheme : "data", payload : HxOverrides.substr(s,5,null)};
		return this1;
	}
	var FORMAT = new EReg("^(([a-zA-Z][a-zA-Z0-9\\-+.]*):)?((//(([^@/]+)@)?([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?)$","");
	var HOST = new EReg("^(\\[(.*)\\]|([^:]*))(:(.*))?$","");
	FORMAT.match(s);
	var hosts;
	var _g = FORMAT.matched(7);
	if(_g == null) {
		hosts = [];
	} else {
		var v = _g;
		var _g1 = [];
		var _g11 = 0;
		var _g2 = v.split(",");
		while(_g11 < _g2.length) {
			var host = _g2[_g11];
			++_g11;
			HOST.match(host);
			var host1;
			var _g3 = HOST.matched(2);
			var _g4 = HOST.matched(3);
			if(_g3 == null) {
				var ipv4 = _g4;
				host1 = ipv4;
			} else if(_g4 == null) {
				var ipv6 = _g3;
				host1 = "[" + ipv6 + "]";
			} else {
				onError("invalid host " + host);
				host1 = null;
			}
			var port;
			var _g5 = HOST.matched(5);
			if(_g5 == null) {
				port = null;
			} else {
				var v1 = _g5;
				var _g51 = Std.parseInt(v1);
				if(_g51 == null) {
					onError("invalid port " + v1);
					port = null;
				} else {
					var p = _g51;
					port = p;
				}
			}
			_g1.push(tink_url__$Host_Host_$Impl_$._new(host1,port));
		}
		hosts = _g1;
	}
	var path = FORMAT.matched(8);
	if(hosts.length > 0 && path.charAt(0) != "/") {
		path = "/" + path;
	}
	var this2 = { scheme : FORMAT.matched(2), payload : FORMAT.matched(3), host : hosts[0], hosts : hosts, auth : FORMAT.matched(6), path : tink_url__$Path_Path_$Impl_$.ofString(path), query : FORMAT.matched(10), hash : FORMAT.matched(12)};
	return this2;
};
tink__$Url_Url_$Impl_$.make = function(parts) {
	var parts1 = { payload : "", path : parts.path, query : parts.query, host : parts.host, hosts : parts.hosts, auth : parts.auth, scheme : parts.scheme, hash : parts.hash};
	tink__$Url_Url_$Impl_$.makePayload(parts1);
	var this1 = parts1;
	return this1;
};
var tink_await_OutcomeTools = function() { };
$hxClasses["tink.await.OutcomeTools"] = tink_await_OutcomeTools;
tink_await_OutcomeTools.__name__ = ["tink","await","OutcomeTools"];
tink_await_OutcomeTools.getOutcome = function(outcome,value) {
	if(outcome == null) {
		return tink_core_Outcome.Success(value);
	}
	return outcome;
};
var tink_chunk_ByteChunk = function(data,from,to) {
	this.data = data;
	this.from = from;
	this.to = to;
};
$hxClasses["tink.chunk.ByteChunk"] = tink_chunk_ByteChunk;
tink_chunk_ByteChunk.__name__ = ["tink","chunk","ByteChunk"];
tink_chunk_ByteChunk.__interfaces__ = [tink_chunk_ChunkObject];
tink_chunk_ByteChunk.of = function(b) {
	if(b.length == 0) {
		return tink__$Chunk_Chunk_$Impl_$.EMPTY;
	}
	var ret = new tink_chunk_ByteChunk(b.b.bufferValue,0,b.length);
	ret.wrapped = b;
	return ret;
};
tink_chunk_ByteChunk.__super__ = tink_chunk_ChunkBase;
tink_chunk_ByteChunk.prototype = $extend(tink_chunk_ChunkBase.prototype,{
	flatten: function(into) {
		into.push(this);
	}
	,getLength: function() {
		return this.to - this.from;
	}
	,getSlice: function(from,to) {
		if(to > this.to - this.from) {
			to = this.to - this.from;
		}
		if(from < 0) {
			from = 0;
		}
		if(to <= from) {
			return null;
		} else if(to == this.to - this.from && from == 0) {
			return this;
		} else {
			return new tink_chunk_ByteChunk(this.data,this.from + from,to + this.from);
		}
	}
	,slice: function(from,to) {
		var _g = this.getSlice(from,to);
		if(_g == null) {
			return tink__$Chunk_Chunk_$Impl_$.EMPTY;
		} else {
			var v = _g;
			return v;
		}
	}
	,blitTo: function(target,offset) {
		if(this.wrapped == null) {
			this.wrapped = haxe_io_Bytes.ofData(this.data);
		}
		target.blit(offset,this.wrapped,this.from,this.to - this.from);
	}
	,toBytes: function() {
		if(this.wrapped == null) {
			this.wrapped = haxe_io_Bytes.ofData(this.data);
		}
		return this.wrapped.sub(this.from,this.to - this.from);
	}
	,toString: function() {
		if(this.wrapped == null) {
			this.wrapped = haxe_io_Bytes.ofData(this.data);
		}
		return this.wrapped.getString(this.from,this.to - this.from);
	}
	,__class__: tink_chunk_ByteChunk
});
var tink_chunk_ChunkCursor = function() {
	this.currentByte = -1;
	this.currentPos = 0;
	this.length = 0;
	this.curLength = 0;
	this.curOffset = 0;
	this.curPartIndex = 0;
};
$hxClasses["tink.chunk.ChunkCursor"] = tink_chunk_ChunkCursor;
tink_chunk_ChunkCursor.__name__ = ["tink","chunk","ChunkCursor"];
tink_chunk_ChunkCursor.create = function(parts) {
	var ret = new tink_chunk_ChunkCursor();
	ret.parts = parts;
	ret.reset();
	return ret;
};
tink_chunk_ChunkCursor.prototype = {
	reset: function() {
		this.length = 0;
		this.currentPos = 0;
		this.currentByte = -1;
		this.curOffset = 0;
		var _g = 0;
		var _g1 = this.parts;
		while(_g < _g1.length) {
			var p = _g1[_g];
			++_g;
			this.length += p.to - p.from;
		}
		this.curPart = this.parts[this.curPartIndex = 0];
		if(this.curPart != null) {
			var _this = this.curPart;
			this.curLength = _this.to - _this.from;
			var _this1 = this.curPart;
			this.currentByte = _this1.data.bytes[_this1.from];
		}
	}
	,flush: function() {
		var ret = this.left();
		this.shift();
		return ret;
	}
	,add: function(chunk) {
		chunk.flatten(this.parts);
		this.reset();
	}
	,shift: function(chunk) {
		this.parts.splice(0,this.curPartIndex);
		var _g = this.parts[0];
		if(_g != null) {
			var chunk1 = _g;
			var _g1 = chunk1.getSlice(this.curOffset,this.curLength);
			if(_g1 == null) {
				this.parts.shift();
			} else {
				var rest = _g1;
				this.parts[0] = rest;
			}
		}
		if(chunk != null) {
			this.add(chunk);
		} else {
			this.reset();
		}
	}
	,left: function() {
		if(this.curPart == null) {
			return tink__$Chunk_Chunk_$Impl_$.EMPTY;
		}
		var _g = [];
		var _g2 = 0;
		var _g1 = this.curPartIndex;
		while(_g2 < _g1) {
			var i = _g2++;
			_g.push(this.parts[i]);
		}
		var left = _g;
		left.push(this.curPart.slice(0,this.curOffset));
		return tink__$Chunk_Chunk_$Impl_$.join(left);
	}
	,right: function() {
		if(this.curPart == null) {
			return tink__$Chunk_Chunk_$Impl_$.EMPTY;
		}
		var _g = [];
		var _g2 = this.curPartIndex;
		var _g1 = this.parts.length;
		while(_g2 < _g1) {
			var i = _g2++;
			_g.push(this.parts[i]);
		}
		var right = _g;
		if(right.length > 0) {
			right[0] = this.curPart.slice(this.curOffset,this.curLength);
		}
		return tink__$Chunk_Chunk_$Impl_$.join(right);
	}
	,ffwd: function() {
		this.currentByte = -1;
		this.curLength = 0;
		this.curOffset = 0;
		this.curPart = null;
		this.curPartIndex = this.parts.length;
	}
	,next: function() {
		if(this.currentPos == this.length) {
			return false;
		}
		this.currentPos++;
		if(this.currentPos == this.length) {
			this.ffwd();
			return false;
		}
		if(this.curOffset == this.curLength - 1) {
			this.curOffset = 0;
			this.curPart = this.parts[++this.curPartIndex];
			var _this = this.curPart;
			this.curLength = _this.to - _this.from;
			var _this1 = this.curPart;
			this.currentByte = _this1.data.bytes[_this1.from];
		} else {
			var _this2 = this.curPart;
			this.currentByte = _this2.data.bytes[_this2.from + ++this.curOffset];
		}
		return true;
	}
	,__class__: tink_chunk_ChunkCursor
};
var tink_core_Annex = function(target) {
	this.target = target;
	this.registry = new haxe_ds_ObjectMap();
};
$hxClasses["tink.core.Annex"] = tink_core_Annex;
tink_core_Annex.__name__ = ["tink","core","Annex"];
tink_core_Annex.prototype = {
	__class__: tink_core_Annex
};
var tink_core__$Callback_Callback_$Impl_$ = {};
$hxClasses["tink.core._Callback.Callback_Impl_"] = tink_core__$Callback_Callback_$Impl_$;
tink_core__$Callback_Callback_$Impl_$.__name__ = ["tink","core","_Callback","Callback_Impl_"];
tink_core__$Callback_Callback_$Impl_$.invoke = function(this1,data) {
	if(tink_core__$Callback_Callback_$Impl_$.depth < 1000) {
		tink_core__$Callback_Callback_$Impl_$.depth++;
		this1(data);
		tink_core__$Callback_Callback_$Impl_$.depth--;
	} else {
		var _e = this1;
		var f = function(data1) {
			tink_core__$Callback_Callback_$Impl_$.invoke(_e,data1);
		};
		var data2 = data;
		tink_core__$Callback_Callback_$Impl_$.defer(function() {
			f(data2);
		});
	}
};
tink_core__$Callback_Callback_$Impl_$.fromNiladic = function(f) {
	return f;
};
tink_core__$Callback_Callback_$Impl_$.defer = function(f) {
	process.nextTick(f);
};
var tink_core__$Callback_LinkObject = function() { };
$hxClasses["tink.core._Callback.LinkObject"] = tink_core__$Callback_LinkObject;
tink_core__$Callback_LinkObject.__name__ = ["tink","core","_Callback","LinkObject"];
tink_core__$Callback_LinkObject.prototype = {
	__class__: tink_core__$Callback_LinkObject
};
var tink_core__$Callback_CallbackLink_$Impl_$ = {};
$hxClasses["tink.core._Callback.CallbackLink_Impl_"] = tink_core__$Callback_CallbackLink_$Impl_$;
tink_core__$Callback_CallbackLink_$Impl_$.__name__ = ["tink","core","_Callback","CallbackLink_Impl_"];
tink_core__$Callback_CallbackLink_$Impl_$.fromMany = function(callbacks) {
	var this1 = new tink_core__$Callback_SimpleLink(function() {
		var _g = 0;
		while(_g < callbacks.length) {
			var cb = callbacks[_g];
			++_g;
			if(cb != null) {
				cb.cancel();
			}
		}
	});
	return this1;
};
var tink_core__$Callback_SimpleLink = function(f) {
	this.f = f;
};
$hxClasses["tink.core._Callback.SimpleLink"] = tink_core__$Callback_SimpleLink;
tink_core__$Callback_SimpleLink.__name__ = ["tink","core","_Callback","SimpleLink"];
tink_core__$Callback_SimpleLink.__interfaces__ = [tink_core__$Callback_LinkObject];
tink_core__$Callback_SimpleLink.prototype = {
	cancel: function() {
		if(this.f != null) {
			this.f();
			this.f = null;
		}
	}
	,__class__: tink_core__$Callback_SimpleLink
};
var tink_core__$Callback_ListCell = function(cb,list) {
	if(cb == null) {
		throw new js__$Boot_HaxeError("callback expected but null received");
	}
	this.cb = cb;
	this.list = list;
};
$hxClasses["tink.core._Callback.ListCell"] = tink_core__$Callback_ListCell;
tink_core__$Callback_ListCell.__name__ = ["tink","core","_Callback","ListCell"];
tink_core__$Callback_ListCell.__interfaces__ = [tink_core__$Callback_LinkObject];
tink_core__$Callback_ListCell.prototype = {
	clear: function() {
		this.list = null;
		this.cb = null;
	}
	,cancel: function() {
		var _g = this.list;
		if(_g != null) {
			var v = _g;
			this.clear();
			HxOverrides.remove(v,this);
		}
	}
	,__class__: tink_core__$Callback_ListCell
};
var tink_core__$Callback_CallbackList_$Impl_$ = {};
$hxClasses["tink.core._Callback.CallbackList_Impl_"] = tink_core__$Callback_CallbackList_$Impl_$;
tink_core__$Callback_CallbackList_$Impl_$.__name__ = ["tink","core","_Callback","CallbackList_Impl_"];
tink_core__$Callback_CallbackList_$Impl_$.add = function(this1,cb) {
	var node = new tink_core__$Callback_ListCell(cb,this1);
	this1.push(node);
	return node;
};
tink_core__$Callback_CallbackList_$Impl_$.invoke = function(this1,data) {
	var _g = 0;
	var _g1 = this1.slice();
	while(_g < _g1.length) {
		var cell = _g1[_g];
		++_g;
		if(cell.cb != null) {
			tink_core__$Callback_Callback_$Impl_$.invoke(cell.cb,data);
		}
	}
};
tink_core__$Callback_CallbackList_$Impl_$.clear = function(this1) {
	var _g = 0;
	var _g1 = this1.splice(0,this1.length);
	while(_g < _g1.length) {
		var cell = _g1[_g];
		++_g;
		cell.clear();
	}
};
var tink_core_TypedError = function(code,message,pos) {
	if(code == null) {
		code = 500;
	}
	this.isTinkError = true;
	this.code = code;
	this.message = message;
	this.pos = pos;
	this.exceptionStack = [];
	this.callStack = [];
};
$hxClasses["tink.core.TypedError"] = tink_core_TypedError;
tink_core_TypedError.__name__ = ["tink","core","TypedError"];
tink_core_TypedError.withData = function(code,message,data,pos) {
	return tink_core_TypedError.typed(code,message,data,pos);
};
tink_core_TypedError.typed = function(code,message,data,pos) {
	var ret = new tink_core_TypedError(code,message,pos);
	ret.data = data;
	return ret;
};
tink_core_TypedError.ofJsError = function(e,pos) {
	return tink_core_TypedError.withData(500,e.message,e,pos);
};
tink_core_TypedError.asError = function(v) {
	if(v != null && v.isTinkError) {
		return v;
	} else {
		return null;
	}
};
tink_core_TypedError.catchExceptions = function(f,report,pos) {
	try {
		return tink_core_Outcome.Success(f());
	} catch( e ) {
		var e1 = (e instanceof js__$Boot_HaxeError) ? e.val : e;
		var _g = tink_core_TypedError.asError(e1);
		var tmp;
		if(_g == null) {
			tmp = report == null ? tink_core_TypedError.withData(null,"Unexpected Error",e1,pos) : report(e1);
		} else {
			var e2 = _g;
			tmp = e2;
		}
		return tink_core_Outcome.Failure(tmp);
	}
};
tink_core_TypedError.reporter = function(code,message,pos) {
	return function(e) {
		return tink_core_TypedError.withData(code,message,e,pos);
	};
};
tink_core_TypedError.rethrow = function(any) {
	throw js__$Boot_HaxeError.wrap(any);
};
tink_core_TypedError.tryFinally = function(f,cleanup) {
	try { return f(); } finally { cleanup(); }
	return null;
};
tink_core_TypedError.prototype = {
	printPos: function() {
		return this.pos.className + "." + this.pos.methodName + ":" + this.pos.lineNumber;
	}
	,toString: function() {
		var ret = "Error#" + this.code + ": " + this.message;
		if(this.pos != null) {
			ret += " @ " + this.printPos();
		}
		return ret;
	}
	,throwSelf: function() {
		throw new js__$Boot_HaxeError(this);
	}
	,__class__: tink_core_TypedError
};
var tink_core__$Future_FutureObject = function() { };
$hxClasses["tink.core._Future.FutureObject"] = tink_core__$Future_FutureObject;
tink_core__$Future_FutureObject.__name__ = ["tink","core","_Future","FutureObject"];
tink_core__$Future_FutureObject.prototype = {
	__class__: tink_core__$Future_FutureObject
};
var tink_core__$Future_SyncFuture = function(value) {
	this.value = value;
};
$hxClasses["tink.core._Future.SyncFuture"] = tink_core__$Future_SyncFuture;
tink_core__$Future_SyncFuture.__name__ = ["tink","core","_Future","SyncFuture"];
tink_core__$Future_SyncFuture.__interfaces__ = [tink_core__$Future_FutureObject];
tink_core__$Future_SyncFuture.prototype = {
	map: function(f) {
		return new tink_core__$Future_SyncFuture(this.value.map(f));
	}
	,flatMap: function(f) {
		var l = this.value.map(f);
		return new tink_core__$Future_SimpleFuture(function(cb) {
			return l.get().handle(cb);
		});
	}
	,handle: function(cb) {
		tink_core__$Callback_Callback_$Impl_$.invoke(cb,this.value.get());
		return null;
	}
	,eager: function() {
		return this;
	}
	,gather: function() {
		return this;
	}
	,__class__: tink_core__$Future_SyncFuture
};
var tink_core_Noise = $hxClasses["tink.core.Noise"] = { __ename__ : ["tink","core","Noise"], __constructs__ : ["Noise"] };
tink_core_Noise.Noise = ["Noise",0];
tink_core_Noise.Noise.toString = $estr;
tink_core_Noise.Noise.__enum__ = tink_core_Noise;
var tink_core__$Future_Future_$Impl_$ = {};
$hxClasses["tink.core._Future.Future_Impl_"] = tink_core__$Future_Future_$Impl_$;
tink_core__$Future_Future_$Impl_$.__name__ = ["tink","core","_Future","Future_Impl_"];
tink_core__$Future_Future_$Impl_$.first = function(this1,other) {
	var ret = new tink_core_FutureTrigger();
	var l1 = this1.handle($bind(ret,ret.trigger));
	var l2 = other.handle($bind(ret,ret.trigger));
	var ret1 = ret;
	if(l1 != null) {
		var this2 = l1;
		ret1.handle(function(_) {
			this2.cancel();
		});
	}
	if(l2 != null) {
		var this3 = l2;
		ret1.handle(function(_1) {
			this3.cancel();
		});
	}
	return ret1;
};
tink_core__$Future_Future_$Impl_$.next = function(this1,n) {
	return this1.flatMap(function(v) {
		return n(v);
	});
};
tink_core__$Future_Future_$Impl_$.flatten = function(f) {
	return new tink_core__$Future_NestedFuture(f);
};
tink_core__$Future_Future_$Impl_$.ofMany = function(futures,gather) {
	if(gather == null) {
		gather = true;
	}
	var ret = new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst([]));
	var _g = 0;
	while(_g < futures.length) {
		var f = [futures[_g]];
		++_g;
		var ret1 = ret.flatMap((function(f1) {
			return function(results) {
				var ret2 = (function() {
					return function(result) {
						return results.concat([result]);
					};
				})();
				var ret3 = f1[0].map(ret2);
				return ret3;
			};
		})(f));
		ret = ret1;
	}
	if(gather) {
		return ret.gather();
	} else {
		return ret;
	}
};
tink_core__$Future_Future_$Impl_$.async = function(f,lazy) {
	if(lazy == null) {
		lazy = false;
	}
	if(lazy) {
		return new tink_core__$Future_LazyTrigger(f);
	} else {
		var op = new tink_core_FutureTrigger();
		var wrapped = f;
		tink_core__$Callback_Callback_$Impl_$.invoke(wrapped,$bind(op,op.trigger));
		return op;
	}
};
tink_core__$Future_Future_$Impl_$._tryMap = function(f,map) {
	var ret = f.map(function(o) {
		return tink_core_OutcomeTools.map(o,map);
	});
	return ret.gather();
};
var tink_core__$Future_SimpleFuture = function(f) {
	this.f = f;
};
$hxClasses["tink.core._Future.SimpleFuture"] = tink_core__$Future_SimpleFuture;
tink_core__$Future_SimpleFuture.__name__ = ["tink","core","_Future","SimpleFuture"];
tink_core__$Future_SimpleFuture.__interfaces__ = [tink_core__$Future_FutureObject];
tink_core__$Future_SimpleFuture.prototype = {
	handle: function(callback) {
		return this.f(callback);
	}
	,map: function(f) {
		var _gthis = this;
		return new tink_core__$Future_SimpleFuture(function(cb) {
			return _gthis.f(function(v) {
				var tmp = f(v);
				tink_core__$Callback_Callback_$Impl_$.invoke(cb,tmp);
			});
		});
	}
	,flatMap: function(f) {
		var f1 = f;
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.flatten(new tink_core__$Future_SimpleFuture(function(cb) {
			return _gthis.f(function(v) {
				var tmp = f1(v);
				tink_core__$Callback_Callback_$Impl_$.invoke(cb,tmp);
			});
		}));
	}
	,gather: function() {
		if(this.gathered != null) {
			return this.gathered;
		} else {
			return this.gathered = tink_core_FutureTrigger.gatherFuture(this);
		}
	}
	,eager: function() {
		var ret = this.gathered != null ? this.gathered : this.gathered = tink_core_FutureTrigger.gatherFuture(this);
		ret.handle(tink_core__$Callback_Callback_$Impl_$.fromNiladic(function() {
		}));
		return ret;
	}
	,__class__: tink_core__$Future_SimpleFuture
};
var tink_core__$Future_NestedFuture = function(outer) {
	this.outer = outer;
};
$hxClasses["tink.core._Future.NestedFuture"] = tink_core__$Future_NestedFuture;
tink_core__$Future_NestedFuture.__name__ = ["tink","core","_Future","NestedFuture"];
tink_core__$Future_NestedFuture.__interfaces__ = [tink_core__$Future_FutureObject];
tink_core__$Future_NestedFuture.prototype = {
	map: function(f) {
		var ret = this.outer.flatMap(function(inner) {
			var ret1 = inner.map(f);
			return ret1.gather();
		});
		return ret.gather();
	}
	,flatMap: function(f) {
		var ret = this.outer.flatMap(function(inner) {
			var ret1 = inner.flatMap(f);
			return ret1.gather();
		});
		return ret.gather();
	}
	,gather: function() {
		if(this.gathered != null) {
			return this.gathered;
		} else {
			return this.gathered = tink_core_FutureTrigger.gatherFuture(this);
		}
	}
	,eager: function() {
		var ret = this.gathered != null ? this.gathered : this.gathered = tink_core_FutureTrigger.gatherFuture(this);
		ret.handle(tink_core__$Callback_Callback_$Impl_$.fromNiladic(function() {
		}));
		return ret;
	}
	,handle: function(cb) {
		var ret = null;
		ret = this.outer.handle(function(inner) {
			ret = inner.handle(function(result) {
				tink_core__$Callback_Callback_$Impl_$.invoke(cb,result);
			});
		});
		return ret;
	}
	,__class__: tink_core__$Future_NestedFuture
};
var tink_core_FutureTrigger = function() {
	var this1 = [];
	this.list = this1;
};
$hxClasses["tink.core.FutureTrigger"] = tink_core_FutureTrigger;
tink_core_FutureTrigger.__name__ = ["tink","core","FutureTrigger"];
tink_core_FutureTrigger.__interfaces__ = [tink_core__$Future_FutureObject];
tink_core_FutureTrigger.gatherFuture = function(f) {
	var op = null;
	var this1 = new tink_core__$Future_SimpleFuture(function(cb) {
		if(op == null) {
			op = new tink_core_FutureTrigger();
			f.handle($bind(op,op.trigger));
			f = null;
		}
		return op.handle(cb);
	});
	return this1;
};
tink_core_FutureTrigger.prototype = {
	handle: function(callback) {
		var _g = this.list;
		if(_g == null) {
			tink_core__$Callback_Callback_$Impl_$.invoke(callback,this.result);
			return null;
		} else {
			var v = _g;
			return tink_core__$Callback_CallbackList_$Impl_$.add(v,callback);
		}
	}
	,map: function(f) {
		var _g = this.list;
		if(_g == null) {
			return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(f(this.result)));
		} else {
			var v = _g;
			var ret = new tink_core_FutureTrigger();
			tink_core__$Callback_CallbackList_$Impl_$.add(this.list,function(v1) {
				var tmp = f(v1);
				ret.trigger(tmp);
			});
			return ret;
		}
	}
	,flatMap: function(f) {
		var _g = this.list;
		if(_g == null) {
			return f(this.result);
		} else {
			var v = _g;
			var ret = new tink_core_FutureTrigger();
			tink_core__$Callback_CallbackList_$Impl_$.add(this.list,function(v1) {
				f(v1).handle($bind(ret,ret.trigger));
			});
			return ret;
		}
	}
	,gather: function() {
		return this;
	}
	,eager: function() {
		return this;
	}
	,trigger: function(result) {
		if(this.list == null) {
			return false;
		} else {
			var list = this.list;
			this.list = null;
			this.result = result;
			tink_core__$Callback_CallbackList_$Impl_$.invoke(list,result);
			tink_core__$Callback_CallbackList_$Impl_$.clear(list);
			return true;
		}
	}
	,__class__: tink_core_FutureTrigger
};
var tink_core__$Future_LazyTrigger = function(op) {
	this.op = op;
	tink_core_FutureTrigger.call(this);
};
$hxClasses["tink.core._Future.LazyTrigger"] = tink_core__$Future_LazyTrigger;
tink_core__$Future_LazyTrigger.__name__ = ["tink","core","_Future","LazyTrigger"];
tink_core__$Future_LazyTrigger.__super__ = tink_core_FutureTrigger;
tink_core__$Future_LazyTrigger.prototype = $extend(tink_core_FutureTrigger.prototype,{
	eager: function() {
		if(this.op != null) {
			var op = this.op;
			this.op = null;
			tink_core__$Callback_Callback_$Impl_$.invoke(op,$bind(this,this.trigger));
		}
		return this;
	}
	,map: function(f) {
		var _gthis = this;
		if(this.op == null) {
			return tink_core_FutureTrigger.prototype.map.call(this,f);
		} else {
			return tink_core__$Future_Future_$Impl_$.async(function(cb) {
				_gthis.handle(function(v) {
					var tmp = f(v);
					cb(tmp);
				});
			},true);
		}
	}
	,flatMap: function(f) {
		var _gthis = this;
		if(this.op == null) {
			return tink_core_FutureTrigger.prototype.flatMap.call(this,f);
		} else {
			return tink_core__$Future_Future_$Impl_$.async(function(cb) {
				_gthis.handle(function(v) {
					f(v).handle(cb);
				});
			},true);
		}
	}
	,handle: function(cb) {
		this.eager();
		return tink_core_FutureTrigger.prototype.handle.call(this,cb);
	}
	,__class__: tink_core__$Future_LazyTrigger
});
var tink_core__$Lazy_LazyFunc = function(f) {
	this.f = f;
};
$hxClasses["tink.core._Lazy.LazyFunc"] = tink_core__$Lazy_LazyFunc;
tink_core__$Lazy_LazyFunc.__name__ = ["tink","core","_Lazy","LazyFunc"];
tink_core__$Lazy_LazyFunc.__interfaces__ = [tink_core__$Lazy_LazyObject];
tink_core__$Lazy_LazyFunc.prototype = {
	get: function() {
		if(this.f != null) {
			this.result = this.f();
			this.f = null;
		}
		return this.result;
	}
	,map: function(f) {
		var _gthis = this;
		return new tink_core__$Lazy_LazyFunc(function() {
			var tmp = _gthis.get();
			return f(tmp);
		});
	}
	,__class__: tink_core__$Lazy_LazyFunc
};
var tink_core_NamedWith = function(name,value) {
	this.name = name;
	this.value = value;
};
$hxClasses["tink.core.NamedWith"] = tink_core_NamedWith;
tink_core_NamedWith.__name__ = ["tink","core","NamedWith"];
tink_core_NamedWith.prototype = {
	__class__: tink_core_NamedWith
};
var tink_core_Outcome = $hxClasses["tink.core.Outcome"] = { __ename__ : ["tink","core","Outcome"], __constructs__ : ["Success","Failure"] };
tink_core_Outcome.Success = function(data) { var $x = ["Success",0,data]; $x.__enum__ = tink_core_Outcome; $x.toString = $estr; return $x; };
tink_core_Outcome.Failure = function(failure) { var $x = ["Failure",1,failure]; $x.__enum__ = tink_core_Outcome; $x.toString = $estr; return $x; };
var tink_core_OutcomeTools = function() { };
$hxClasses["tink.core.OutcomeTools"] = tink_core_OutcomeTools;
tink_core_OutcomeTools.__name__ = ["tink","core","OutcomeTools"];
tink_core_OutcomeTools.sure = function(outcome) {
	switch(outcome[1]) {
	case 0:
		var data = outcome[2];
		return data;
	case 1:
		var failure = outcome[2];
		var _g = tink_core_TypedError.asError(failure);
		if(_g == null) {
			throw new js__$Boot_HaxeError(failure);
		} else {
			var e = _g;
			return e.throwSelf();
		}
		break;
	}
};
tink_core_OutcomeTools.map = function(outcome,transform) {
	switch(outcome[1]) {
	case 0:
		var a = outcome[2];
		return tink_core_Outcome.Success(transform(a));
	case 1:
		var f = outcome[2];
		return tink_core_Outcome.Failure(f);
	}
};
var tink_core_MPair = function(a,b) {
	this.a = a;
	this.b = b;
};
$hxClasses["tink.core.MPair"] = tink_core_MPair;
tink_core_MPair.__name__ = ["tink","core","MPair"];
tink_core_MPair.prototype = {
	__class__: tink_core_MPair
};
var tink_core__$Promise_Promise_$Impl_$ = {};
$hxClasses["tink.core._Promise.Promise_Impl_"] = tink_core__$Promise_Promise_$Impl_$;
tink_core__$Promise_Promise_$Impl_$.__name__ = ["tink","core","_Promise","Promise_Impl_"];
tink_core__$Promise_Promise_$Impl_$.noise = function(this1) {
	return tink_core__$Promise_Promise_$Impl_$.next(this1,function(v) {
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
	});
};
tink_core__$Promise_Promise_$Impl_$.next = function(this1,f,gather) {
	if(gather == null) {
		gather = true;
	}
	var ret = this1.flatMap(function(o) {
		switch(o[1]) {
		case 0:
			var d = o[2];
			return f(d);
		case 1:
			var f1 = o[2];
			return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_core_Outcome.Failure(f1)));
		}
	});
	if(gather) {
		return ret.gather();
	} else {
		return ret;
	}
};
tink_core__$Promise_Promise_$Impl_$.merge = function(this1,other,merger,gather) {
	if(gather == null) {
		gather = true;
	}
	return tink_core__$Promise_Promise_$Impl_$.next(this1,function(t) {
		return tink_core__$Promise_Promise_$Impl_$.next(other,function(a) {
			return merger(t,a);
		},false);
	},gather);
};
tink_core__$Promise_Promise_$Impl_$.and = function(a,b) {
	return tink_core__$Promise_Promise_$Impl_$.merge(a,b,function(a1,b1) {
		var this1 = new tink_core_MPair(a1,b1);
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(this1));
	});
};
tink_core__$Promise_Promise_$Impl_$.ofSpecific = function(s) {
	return s;
};
tink_core__$Promise_Promise_$Impl_$.ofOutcome = function(o) {
	return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(o));
};
tink_core__$Promise_Promise_$Impl_$.inParallel = function(a,concurrency,lazy) {
	if(a.length == 0) {
		return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_core_Outcome.Success([])));
	} else {
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			var result = [];
			var pending = a.length;
			var links = null;
			var linkArray = [];
			var sync = false;
			var i = 0;
			var iter = HxOverrides.iter(a);
			var next = null;
			var done = function(o) {
				if(links == null) {
					sync = true;
				} else if(links != null) {
					links.cancel();
				}
				cb(o);
			};
			var fail = function(e) {
				pending = 0;
				done(tink_core_Outcome.Failure(e));
			};
			var set = function(index,value) {
				result[index] = value;
				if((pending -= 1) == 0) {
					done(tink_core_Outcome.Success(result));
				} else if(iter.hasNext() && pending > 0) {
					next();
				}
			};
			next = function() {
				i += 1;
				var index1 = i - 1;
				var next1 = iter.next().handle(function(o1) {
					switch(o1[1]) {
					case 0:
						var v = o1[2];
						set(index1,v);
						break;
					case 1:
						var e1 = o1[2];
						fail(e1);
						break;
					}
				});
				linkArray.push(next1);
			};
			while(true) {
				var tmp;
				if(iter.hasNext() && pending > 0) {
					if(concurrency != null) {
						concurrency -= 1;
						tmp = concurrency + 1 > 0;
					} else {
						tmp = true;
					}
				} else {
					tmp = false;
				}
				if(!tmp) {
					break;
				}
				next();
			}
			links = tink_core__$Callback_CallbackLink_$Impl_$.fromMany(linkArray);
			if(sync) {
				if(links != null) {
					links.cancel();
				}
			}
		},lazy);
	}
};
tink_core__$Promise_Promise_$Impl_$.inSequence = function(a) {
	var loop = null;
	loop = function(index) {
		if(index == a.length) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success([]));
		} else {
			return tink_core__$Promise_Promise_$Impl_$.next(a[index],function(head) {
				return tink_core__$Promise_Promise_$Impl_$.next(loop(index + 1),function(tail) {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success([head].concat(tail)));
				});
			});
		}
	};
	var loop1 = loop;
	return loop1(0);
};
var tink_core__$Promise_Next_$Impl_$ = {};
$hxClasses["tink.core._Promise.Next_Impl_"] = tink_core__$Promise_Next_$Impl_$;
tink_core__$Promise_Next_$Impl_$.__name__ = ["tink","core","_Promise","Next_Impl_"];
tink_core__$Promise_Next_$Impl_$.ofSafeSync = function(f) {
	return function(x) {
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(f(x)));
	};
};
var tink_core__$Promise_Recover_$Impl_$ = {};
$hxClasses["tink.core._Promise.Recover_Impl_"] = tink_core__$Promise_Recover_$Impl_$;
tink_core__$Promise_Recover_$Impl_$.__name__ = ["tink","core","_Promise","Recover_Impl_"];
tink_core__$Promise_Recover_$Impl_$.ofSync = function(f) {
	return function(e) {
		return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(f(e)));
	};
};
var tink_core__$Signal_Signal_$Impl_$ = {};
$hxClasses["tink.core._Signal.Signal_Impl_"] = tink_core__$Signal_Signal_$Impl_$;
tink_core__$Signal_Signal_$Impl_$.__name__ = ["tink","core","_Signal","Signal_Impl_"];
tink_core__$Signal_Signal_$Impl_$.trigger = function() {
	return new tink_core_SignalTrigger();
};
var tink_core_SignalObject = function() { };
$hxClasses["tink.core.SignalObject"] = tink_core_SignalObject;
tink_core_SignalObject.__name__ = ["tink","core","SignalObject"];
var tink_core_SignalTrigger = function() {
};
$hxClasses["tink.core.SignalTrigger"] = tink_core_SignalTrigger;
tink_core_SignalTrigger.__name__ = ["tink","core","SignalTrigger"];
tink_core_SignalTrigger.__interfaces__ = [tink_core_SignalObject];
tink_core_SignalTrigger.prototype = {
	__class__: tink_core_SignalTrigger
};
var tink_io_StreamParserObject = function() { };
$hxClasses["tink.io.StreamParserObject"] = tink_io_StreamParserObject;
tink_io_StreamParserObject.__name__ = ["tink","io","StreamParserObject"];
tink_io_StreamParserObject.prototype = {
	__class__: tink_io_StreamParserObject
};
var tink_http_Container = function() { };
$hxClasses["tink.http.Container"] = tink_http_Container;
tink_http_Container.__name__ = ["tink","http","Container"];
var tink_http_ContainerResult = $hxClasses["tink.http.ContainerResult"] = { __ename__ : ["tink","http","ContainerResult"], __constructs__ : ["Running","Failed","Shutdown"] };
tink_http_ContainerResult.Running = function(running) { var $x = ["Running",0,running]; $x.__enum__ = tink_http_ContainerResult; $x.toString = $estr; return $x; };
tink_http_ContainerResult.Failed = function(e) { var $x = ["Failed",1,e]; $x.__enum__ = tink_http_ContainerResult; $x.toString = $estr; return $x; };
tink_http_ContainerResult.Shutdown = ["Shutdown",2];
tink_http_ContainerResult.Shutdown.toString = $estr;
tink_http_ContainerResult.Shutdown.__enum__ = tink_http_ContainerResult;
var tink_http_Fetch = function() { };
$hxClasses["tink.http.Fetch"] = tink_http_Fetch;
tink_http_Fetch.__name__ = ["tink","http","Fetch"];
tink_http_Fetch.fetch = function(url,options) {
	return tink_core__$Future_Future_$Impl_$.async(function(cb) {
		var uri = url.path;
		if(url.query != null) {
			uri += "?" + url.query;
		}
		var method = "GET";
		var headers = null;
		var body = tink_io__$Source_Source_$Impl_$.EMPTY;
		var type = tink_http_ClientType.Default;
		var followRedirect = true;
		if(options != null) {
			if(options.method != null) {
				method = options.method;
			}
			if(options.headers != null) {
				headers = options.headers;
			}
			if(options.body != null) {
				body = options.body;
			}
			if(options.client != null) {
				type = options.client;
			}
			if(options.followRedirect == false) {
				followRedirect = false;
			}
		}
		var client = tink_http_Fetch.getClient(type,url.scheme == "https");
		client.request(new tink_http_OutgoingRequest(new tink_http_OutgoingRequestHeader(method,url,null,headers),body)).handle(function(res) {
			switch(res[1]) {
			case 0:
				var res1 = res[2];
				var _g = res1.header.statusCode;
				switch(_g) {
				case 301:case 302:case 303:case 307:case 308:
					var code = _g;
					if(followRedirect) {
						tink_core__$Promise_Promise_$Impl_$.next(new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(res1.header.byName(tink_http__$Header_HeaderName_$Impl_$.ofString("location")))),function(location) {
							var this1 = tink__$Url_Url_$Impl_$.resolve(url,tink__$Url_Url_$Impl_$.fromString(location));
							var this2;
							if(code == 303) {
								var __ret = { method : "GET"};
								var _g1 = options.body;
								if(_g1 != null) {
									var v = _g1;
									__ret.body = v;
								}
								var _g11 = options.client;
								if(_g11 != null) {
									var v1 = _g11;
									__ret.client = v1;
								}
								var _g2 = options.followRedirect;
								if(_g2 != null) {
									var v2 = _g2;
									__ret.followRedirect = v2;
								}
								var _g3 = options.headers;
								if(_g3 != null) {
									var v3 = _g3;
									__ret.headers = v3;
								}
								this2 = __ret;
							} else {
								this2 = options;
							}
							return tink_http_Fetch.fetch(this1,this2);
						}).handle(cb);
					} else {
						cb(tink_core_Outcome.Success(res1));
					}
					break;
				default:
					cb(tink_core_Outcome.Success(res1));
				}
				break;
			case 1:
				var e = res[2];
				cb(tink_core_Outcome.Failure(e));
				break;
			}
		});
	});
};
tink_http_Fetch.getClient = function(type,secure) {
	var cache = secure ? tink_http_Fetch.sclient : tink_http_Fetch.client;
	if(!cache.exists(type)) {
		var c;
		switch(type[1]) {
		case 0:
			c = secure ? new tink_http_clients_SecureNodeClient() : new tink_http_clients_NodeClient();
			break;
		case 1:
			var c1 = type[2];
			c = new tink_http_clients_LocalContainerClient(c1);
			break;
		case 2:
			c = secure ? new tink_http_clients_SecureCurlClient() : new tink_http_clients_CurlClient();
			break;
		case 3:
			c = secure ? new tink_http_clients_StdClient() : new tink_http_clients_StdClient();
			break;
		case 4:
			var c2 = type[2];
			c = c2;
			break;
		}
		cache.set(type,c);
	}
	return cache.get(type);
};
var tink_http_ClientType = $hxClasses["tink.http.ClientType"] = { __ename__ : ["tink","http","ClientType"], __constructs__ : ["Default","Local","Curl","StdLib","Custom"] };
tink_http_ClientType.Default = ["Default",0];
tink_http_ClientType.Default.toString = $estr;
tink_http_ClientType.Default.__enum__ = tink_http_ClientType;
tink_http_ClientType.Local = function(container) { var $x = ["Local",1,container]; $x.__enum__ = tink_http_ClientType; $x.toString = $estr; return $x; };
tink_http_ClientType.Curl = ["Curl",2];
tink_http_ClientType.Curl.toString = $estr;
tink_http_ClientType.Curl.__enum__ = tink_http_ClientType;
tink_http_ClientType.StdLib = ["StdLib",3];
tink_http_ClientType.StdLib.toString = $estr;
tink_http_ClientType.StdLib.__enum__ = tink_http_ClientType;
tink_http_ClientType.Custom = function(v) { var $x = ["Custom",4,v]; $x.__enum__ = tink_http_ClientType; $x.toString = $estr; return $x; };
var tink_http__$Fetch_FetchResponse_$Impl_$ = {};
$hxClasses["tink.http._Fetch.FetchResponse_Impl_"] = tink_http__$Fetch_FetchResponse_$Impl_$;
tink_http__$Fetch_FetchResponse_$Impl_$.__name__ = ["tink","http","_Fetch","FetchResponse_Impl_"];
tink_http__$Fetch_FetchResponse_$Impl_$.all = function(this1) {
	return tink_core__$Promise_Promise_$Impl_$.next(this1,function(r) {
		return tink_core__$Promise_Promise_$Impl_$.next(tink_io_RealSourceTools.all(r.body),function(chunk) {
			if(r.header.statusCode >= 400) {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(tink_core_TypedError.withData(r.header.statusCode,r.header.reason,chunk.toString(),{ fileName : "tink/http/Fetch.hx", lineNumber : 131, className : "tink.http._Fetch.FetchResponse_Impl_", methodName : "all"})));
			} else {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(new tink_http_Message(r.header,chunk)));
			}
		});
	});
};
var tink_http_HandlerObject = function() { };
$hxClasses["tink.http.HandlerObject"] = tink_http_HandlerObject;
tink_http_HandlerObject.__name__ = ["tink","http","HandlerObject"];
tink_http_HandlerObject.prototype = {
	__class__: tink_http_HandlerObject
};
var tink_http_SimpleHandler = function(f) {
	this.f = f;
};
$hxClasses["tink.http.SimpleHandler"] = tink_http_SimpleHandler;
tink_http_SimpleHandler.__name__ = ["tink","http","SimpleHandler"];
tink_http_SimpleHandler.__interfaces__ = [tink_http_HandlerObject];
tink_http_SimpleHandler.prototype = {
	process: function(req) {
		return this.f(req);
	}
	,__class__: tink_http_SimpleHandler
};
var tink_http_Header = function(fields) {
	var tmp;
	if(fields == null) {
		tmp = [];
	} else {
		var v = fields;
		tmp = v;
	}
	this.fields = tmp;
};
$hxClasses["tink.http.Header"] = tink_http_Header;
tink_http_Header.__name__ = ["tink","http","Header"];
tink_http_Header.prototype = {
	get: function(name) {
		var _g = [];
		var _g1 = 0;
		var _g2 = this.fields;
		while(_g1 < _g2.length) {
			var f = _g2[_g1];
			++_g1;
			if(f.name == name) {
				_g.push(f.value);
			}
		}
		return _g;
	}
	,byName: function(name) {
		var _g = this.get(name);
		switch(_g.length) {
		case 0:
			return tink_core_Outcome.Failure(new tink_core_TypedError(422,"No " + name + " header found",{ fileName : "tink/http/Header.hx", lineNumber : 91, className : "tink.http.Header", methodName : "byName"}));
		case 1:
			var v = _g[0];
			return tink_core_Outcome.Success(v);
		default:
			var v1 = _g;
			return tink_core_Outcome.Failure(new tink_core_TypedError(422,"Multiple entries for " + name + " header",{ fileName : "tink/http/Header.hx", lineNumber : 95, className : "tink.http.Header", methodName : "byName"}));
		}
	}
	,toString: function() {
		var _g = [];
		var _g1 = 0;
		var _g2 = this.fields;
		while(_g1 < _g2.length) {
			var f = _g2[_g1];
			++_g1;
			_g.push(f.toString());
		}
		return _g.join("\r\n") + "\r\n" + "\r\n";
	}
	,__class__: tink_http_Header
};
var tink_http__$Header_HeaderValue_$Impl_$ = {};
$hxClasses["tink.http._Header.HeaderValue_Impl_"] = tink_http__$Header_HeaderValue_$Impl_$;
tink_http__$Header_HeaderValue_$Impl_$.__name__ = ["tink","http","_Header","HeaderValue_Impl_"];
tink_http__$Header_HeaderValue_$Impl_$.parse = function(this1) {
	return tink_http__$Header_HeaderValue_$Impl_$.parseWith(this1,function(_,params) {
		var _g = new haxe_ds_StringMap();
		var p = params;
		while(p.hasNext()) {
			var p1 = p.next();
			var key = p1.name;
			var value;
			var _g1 = tink_url__$Portion_Portion_$Impl_$.toString(p1.value);
			var quoted = _g1;
			if(HxOverrides.cca(quoted,0) == 34) {
				value = HxOverrides.substr(quoted,1,quoted.length - 2);
			} else {
				var v = _g1;
				value = v;
			}
			if(__map_reserved[key] != null) {
				_g.setReserved(key,value);
			} else {
				_g.h[key] = value;
			}
		}
		return _g;
	});
};
tink_http__$Header_HeaderValue_$Impl_$.parseWith = function(this1,parseExtension) {
	var _g = [];
	var _g1 = 0;
	var _g2 = this1.split(",");
	while(_g1 < _g2.length) {
		var v = _g2[_g1];
		++_g1;
		v = StringTools.trim(v);
		var i;
		var _g3 = v.indexOf(";");
		if(_g3 == -1) {
			i = v.length;
		} else {
			var i1 = _g3;
			i = i1;
		}
		var value = HxOverrides.substr(v,0,i);
		_g.push({ value : value, extensions : parseExtension(value,new tink_url__$Query_QueryStringParser(v,";","=",i + 1))});
	}
	return _g;
};
tink_http__$Header_HeaderValue_$Impl_$.ofInt = function(i) {
	if(i == null) {
		return "null";
	} else {
		return "" + i;
	}
};
var tink_http__$Header_HeaderName_$Impl_$ = {};
$hxClasses["tink.http._Header.HeaderName_Impl_"] = tink_http__$Header_HeaderName_$Impl_$;
tink_http__$Header_HeaderName_$Impl_$.__name__ = ["tink","http","_Header","HeaderName_Impl_"];
tink_http__$Header_HeaderName_$Impl_$.ofString = function(s) {
	var this1 = s.toLowerCase();
	return this1;
};
var tink_http_HeaderField = function(name,value) {
	tink_core_NamedWith.call(this,name,value);
};
$hxClasses["tink.http.HeaderField"] = tink_http_HeaderField;
tink_http_HeaderField.__name__ = ["tink","http","HeaderField"];
tink_http_HeaderField.ofString = function(s) {
	var _g = s.indexOf(":");
	if(_g == -1) {
		return new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString(s),null);
	} else {
		var v = _g;
		var name = HxOverrides.substr(s,0,v);
		return new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString(name),StringTools.trim(HxOverrides.substr(s,v + 1,null)));
	}
};
tink_http_HeaderField.__super__ = tink_core_NamedWith;
tink_http_HeaderField.prototype = $extend(tink_core_NamedWith.prototype,{
	toString: function() {
		if(this.value == null) {
			return this.name;
		} else {
			return "" + this.name + ": " + this.value;
		}
	}
	,__class__: tink_http_HeaderField
});
var tink_io_BytewiseParser = function() { };
$hxClasses["tink.io.BytewiseParser"] = tink_io_BytewiseParser;
tink_io_BytewiseParser.__name__ = ["tink","io","BytewiseParser"];
tink_io_BytewiseParser.__interfaces__ = [tink_io_StreamParserObject];
tink_io_BytewiseParser.prototype = {
	read: function(char) {
		throw new js__$Boot_HaxeError("abstract");
	}
	,progress: function(cursor) {
		while(true) {
			var _g = this.read(cursor.currentByte);
			switch(_g[1]) {
			case 0:
				break;
			case 1:
				var r = _g[2];
				cursor.next();
				return tink_io_ParseStep.Done(r);
			case 2:
				var e = _g[2];
				return tink_io_ParseStep.Failed(e);
			}
			if(!cursor.next()) {
				break;
			}
		}
		return tink_io_ParseStep.Progressed;
	}
	,eof: function(rest) {
		var _g = this.read(-1);
		switch(_g[1]) {
		case 0:
			return tink_core_Outcome.Failure(new tink_core_TypedError(422,"Unexpected end of input",{ fileName : "tink/io/StreamParser.hx", lineNumber : 180, className : "tink.io.BytewiseParser", methodName : "eof"}));
		case 1:
			var r = _g[2];
			return tink_core_Outcome.Success(r);
		case 2:
			var e = _g[2];
			return tink_core_Outcome.Failure(e);
		}
	}
	,__class__: tink_io_BytewiseParser
};
var tink_io_ParseStep = $hxClasses["tink.io.ParseStep"] = { __ename__ : ["tink","io","ParseStep"], __constructs__ : ["Progressed","Done","Failed"] };
tink_io_ParseStep.Progressed = ["Progressed",0];
tink_io_ParseStep.Progressed.toString = $estr;
tink_io_ParseStep.Progressed.__enum__ = tink_io_ParseStep;
tink_io_ParseStep.Done = function(r) { var $x = ["Done",1,r]; $x.__enum__ = tink_io_ParseStep; $x.toString = $estr; return $x; };
tink_io_ParseStep.Failed = function(e) { var $x = ["Failed",2,e]; $x.__enum__ = tink_io_ParseStep; $x.toString = $estr; return $x; };
var tink_http_HeaderParser = function(makeHeader) {
	this.last = -1;
	this.buf = new StringBuf();
	this.makeHeader = makeHeader;
};
$hxClasses["tink.http.HeaderParser"] = tink_http_HeaderParser;
tink_http_HeaderParser.__name__ = ["tink","http","HeaderParser"];
tink_http_HeaderParser.__super__ = tink_io_BytewiseParser;
tink_http_HeaderParser.prototype = $extend(tink_io_BytewiseParser.prototype,{
	read: function(c) {
		var _g = this.last;
		switch(c) {
		case -1:
			return this.nextLine();
		case 10:
			if(_g == 13) {
				return this.nextLine();
			} else {
				var other = c;
				this.last = other;
				this.buf.b += String.fromCharCode(other);
				return tink_io_ParseStep.Progressed;
			}
			break;
		case 13:
			if(_g == 13) {
				this.buf.b += String.fromCharCode(this.last);
				return tink_io_ParseStep.Progressed;
			} else {
				this.last = 13;
				return tink_io_ParseStep.Progressed;
			}
			break;
		default:
			if(_g == 13) {
				var other1 = c;
				this.buf.b += String.fromCharCode(this.last);
				this.buf.b += String.fromCharCode(other1);
				this.last = -1;
				return tink_io_ParseStep.Progressed;
			} else {
				var other2 = c;
				this.last = other2;
				this.buf.b += String.fromCharCode(other2);
				return tink_io_ParseStep.Progressed;
			}
		}
	}
	,nextLine: function() {
		var line = this.buf.b;
		this.buf = new StringBuf();
		this.last = -1;
		if(line == "") {
			if(this.header == null) {
				return tink_io_ParseStep.Progressed;
			} else {
				return tink_io_ParseStep.Done(this.header);
			}
		} else if(this.header == null) {
			var _g = this.makeHeader(line,this.fields = []);
			switch(_g[1]) {
			case 0:
				if(_g[2] == null) {
					return tink_io_ParseStep.Done(this.header = null);
				} else {
					var v = _g[2];
					this.header = v;
					return tink_io_ParseStep.Progressed;
				}
				break;
			case 1:
				var e = _g[2];
				return tink_io_ParseStep.Failed(e);
			}
		} else {
			this.fields.push(tink_http_HeaderField.ofString(line));
			return tink_io_ParseStep.Progressed;
		}
	}
	,__class__: tink_http_HeaderParser
});
var tink_http_Message = function(header,body) {
	this.header = header;
	this.body = body;
};
$hxClasses["tink.http.Message"] = tink_http_Message;
tink_http_Message.__name__ = ["tink","http","Message"];
tink_http_Message.prototype = {
	__class__: tink_http_Message
};
var tink_http_RequestHeader = function(method,url,protocol,fields) {
	if(protocol == null) {
		protocol = "HTTP/1.1";
	}
	this.method = method;
	this.url = url;
	this.protocol = protocol;
	tink_http_Header.call(this,fields);
};
$hxClasses["tink.http.RequestHeader"] = tink_http_RequestHeader;
tink_http_RequestHeader.__name__ = ["tink","http","RequestHeader"];
tink_http_RequestHeader.__super__ = tink_http_Header;
tink_http_RequestHeader.prototype = $extend(tink_http_Header.prototype,{
	toString: function() {
		var this1 = this.url;
		return "" + this.method + " " + (this1.query == null ? this1.path : this1.path + "?" + this1.query) + " " + this.protocol + "\r\n" + tink_http_Header.prototype.toString.call(this);
	}
	,__class__: tink_http_RequestHeader
});
var tink_http_IncomingRequestHeader = function(method,url,protocol,fields) {
	tink_http_RequestHeader.call(this,method,url,protocol,fields);
};
$hxClasses["tink.http.IncomingRequestHeader"] = tink_http_IncomingRequestHeader;
tink_http_IncomingRequestHeader.__name__ = ["tink","http","IncomingRequestHeader"];
tink_http_IncomingRequestHeader.fromIncomingMessage = function(req) {
	var req1 = req.method;
	var tmp = tink__$Url_Url_$Impl_$.fromString(req.url);
	var tmp1 = "HTTP/" + req.httpVersion;
	var _g = [];
	var _g2 = 0;
	var _g1 = req.rawHeaders.length / 2 | 0;
	while(_g2 < _g1) {
		var i = _g2++;
		_g.push(new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString(req.rawHeaders[2 * i]),req.rawHeaders[2 * i + 1]));
	}
	return new tink_http_IncomingRequestHeader(req1,tmp,tmp1,_g);
};
tink_http_IncomingRequestHeader.__super__ = tink_http_RequestHeader;
tink_http_IncomingRequestHeader.prototype = $extend(tink_http_RequestHeader.prototype,{
	__class__: tink_http_IncomingRequestHeader
});
var tink_http_OutgoingRequestHeader = function(method,url,protocol,fields) {
	tink_http_RequestHeader.call(this,method,url,protocol,fields);
};
$hxClasses["tink.http.OutgoingRequestHeader"] = tink_http_OutgoingRequestHeader;
tink_http_OutgoingRequestHeader.__name__ = ["tink","http","OutgoingRequestHeader"];
tink_http_OutgoingRequestHeader.__super__ = tink_http_RequestHeader;
tink_http_OutgoingRequestHeader.prototype = $extend(tink_http_RequestHeader.prototype,{
	concat: function(fields) {
		return new tink_http_OutgoingRequestHeader(this.method,this.url,this.protocol,this.fields.concat(fields));
	}
	,__class__: tink_http_OutgoingRequestHeader
});
var tink_http_OutgoingRequest = function(header,body) {
	tink_http_Message.call(this,header,body);
};
$hxClasses["tink.http.OutgoingRequest"] = tink_http_OutgoingRequest;
tink_http_OutgoingRequest.__name__ = ["tink","http","OutgoingRequest"];
tink_http_OutgoingRequest.__super__ = tink_http_Message;
tink_http_OutgoingRequest.prototype = $extend(tink_http_Message.prototype,{
	__class__: tink_http_OutgoingRequest
});
var tink_http_IncomingRequest = function(clientIp,header,body) {
	this.clientIp = clientIp;
	tink_http_Message.call(this,header,body);
};
$hxClasses["tink.http.IncomingRequest"] = tink_http_IncomingRequest;
tink_http_IncomingRequest.__name__ = ["tink","http","IncomingRequest"];
tink_http_IncomingRequest.__super__ = tink_http_Message;
tink_http_IncomingRequest.prototype = $extend(tink_http_Message.prototype,{
	__class__: tink_http_IncomingRequest
});
var tink_http_IncomingRequestBody = $hxClasses["tink.http.IncomingRequestBody"] = { __ename__ : ["tink","http","IncomingRequestBody"], __constructs__ : ["Plain","Parsed"] };
tink_http_IncomingRequestBody.Plain = function(source) { var $x = ["Plain",0,source]; $x.__enum__ = tink_http_IncomingRequestBody; $x.toString = $estr; return $x; };
tink_http_IncomingRequestBody.Parsed = function(parts) { var $x = ["Parsed",1,parts]; $x.__enum__ = tink_http_IncomingRequestBody; $x.toString = $estr; return $x; };
var tink_http_ResponseHeaderBase = function(statusCode,reason,fields,protocol) {
	if(protocol == null) {
		protocol = "HTTP/1.1";
	}
	this.statusCode = statusCode;
	var tmp;
	if(reason == null) {
		var this1 = httpstatus__$HttpStatusMessage_HttpStatusMessage_$Impl_$.fromCode(statusCode);
		tmp = this1;
	} else {
		tmp = reason;
	}
	this.reason = tmp;
	this.protocol = protocol;
	tink_http_Header.call(this,fields);
};
$hxClasses["tink.http.ResponseHeaderBase"] = tink_http_ResponseHeaderBase;
tink_http_ResponseHeaderBase.__name__ = ["tink","http","ResponseHeaderBase"];
tink_http_ResponseHeaderBase.parser = function() {
	return new tink_http_HeaderParser(function(line,headers) {
		var _g = line.split(" ");
		var v = _g;
		if(v.length >= 3) {
			var this1 = new tink_http_ResponseHeaderBase(Std.parseInt(v[1]),v.slice(2).join(" "),headers,v[0]);
			return tink_core_Outcome.Success(this1);
		} else {
			return tink_core_Outcome.Failure(new tink_core_TypedError(422,"Invalid HTTP response header",{ fileName : "tink/http/Response.hx", lineNumber : 56, className : "tink.http.ResponseHeaderBase", methodName : "parser"}));
		}
	});
};
tink_http_ResponseHeaderBase.__super__ = tink_http_Header;
tink_http_ResponseHeaderBase.prototype = $extend(tink_http_Header.prototype,{
	toString: function() {
		return "" + this.protocol + " " + this.statusCode + " " + this.reason + "\r\n" + tink_http_Header.prototype.toString.call(this);
	}
	,__class__: tink_http_ResponseHeaderBase
});
var tink_http__$Response_OutgoingResponseData = function(header,body) {
	tink_http_Message.call(this,header,body);
};
$hxClasses["tink.http._Response.OutgoingResponseData"] = tink_http__$Response_OutgoingResponseData;
tink_http__$Response_OutgoingResponseData.__name__ = ["tink","http","_Response","OutgoingResponseData"];
tink_http__$Response_OutgoingResponseData.__super__ = tink_http_Message;
tink_http__$Response_OutgoingResponseData.prototype = $extend(tink_http_Message.prototype,{
	__class__: tink_http__$Response_OutgoingResponseData
});
var tink_http__$Response_OutgoingResponse_$Impl_$ = {};
$hxClasses["tink.http._Response.OutgoingResponse_Impl_"] = tink_http__$Response_OutgoingResponse_$Impl_$;
tink_http__$Response_OutgoingResponse_$Impl_$.__name__ = ["tink","http","_Response","OutgoingResponse_Impl_"];
tink_http__$Response_OutgoingResponse_$Impl_$.blob = function(code,chunk,contentType,headers) {
	if(code == null) {
		code = 200;
	}
	var this1 = httpstatus__$HttpStatusMessage_HttpStatusMessage_$Impl_$.fromCode(code);
	var fields = new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString("Content-Type"),contentType);
	var fields1 = tink_http__$Header_HeaderName_$Impl_$.ofString("Content-Length");
	var fields2 = Std.string(chunk.getLength());
	var fields3;
	if(headers == null) {
		fields3 = [];
	} else {
		var v = headers;
		fields3 = v;
	}
	var this2 = new tink_http_ResponseHeaderBase(code,this1,[fields,new tink_http_HeaderField(fields1,fields2)].concat(fields3),"HTTP/1.1");
	var this3 = new tink_http__$Response_OutgoingResponseData(this2,new tink_streams_Single(new tink_core__$Lazy_LazyConst(chunk)));
	return this3;
};
tink_http__$Response_OutgoingResponse_$Impl_$.reportError = function(e) {
	var this1 = new tink_http_ResponseHeaderBase(e.code,httpstatus__$HttpStatusMessage_HttpStatusMessage_$Impl_$.fromCode(e.code),[new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString("Content-Type"),"application/json")],"HTTP/1.1");
	var this2 = new tink_http__$Response_OutgoingResponseData(this1,tink_io__$Source_Source_$Impl_$.ofChunk(tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(JSON.stringify({ error : e.message, details : e.data})))));
	return this2;
};
var tink_http_IncomingResponse = function(header,body) {
	tink_http_Message.call(this,header,body);
};
$hxClasses["tink.http.IncomingResponse"] = tink_http_IncomingResponse;
tink_http_IncomingResponse.__name__ = ["tink","http","IncomingResponse"];
tink_http_IncomingResponse.__super__ = tink_http_Message;
tink_http_IncomingResponse.prototype = $extend(tink_http_Message.prototype,{
	__class__: tink_http_IncomingResponse
});
var tink_http_BodyPart = $hxClasses["tink.http.BodyPart"] = { __ename__ : ["tink","http","BodyPart"], __constructs__ : ["Value","File"] };
tink_http_BodyPart.Value = function(v) { var $x = ["Value",0,v]; $x.__enum__ = tink_http_BodyPart; $x.toString = $estr; return $x; };
tink_http_BodyPart.File = function(handle) { var $x = ["File",1,handle]; $x.__enum__ = tink_http_BodyPart; $x.toString = $estr; return $x; };
var tink_http_clients_CurlClient = function(curl) {
	this.protocol = "http";
	this.curl = curl != null ? curl : function(args,body) {
		args.push("--data-binary");
		args.push("@-");
		var $process = js_node_ChildProcess.spawn("curl",args);
		var sink = tink_io_nodejs_NodejsSink.wrap("stdin",$process.stdin);
		tink_io__$Source_Source_$Impl_$.pipeTo(body,sink,{ end : true}).eager();
		var options = null;
		if(options == null) {
			options = { };
		}
		return tink_io_nodejs_NodejsSource.wrap("stdout",$process.stdout,options.chunkSize,options.onEnd);
	};
};
$hxClasses["tink.http.clients.CurlClient"] = tink_http_clients_CurlClient;
tink_http_clients_CurlClient.__name__ = ["tink","http","clients","CurlClient"];
tink_http_clients_CurlClient.__interfaces__ = [tink_http_ClientObject];
tink_http_clients_CurlClient.prototype = {
	request: function(req) {
		var args = [];
		args.push("-is");
		args.push("-X");
		args.push(req.header.method);
		var _g = req.header.protocol;
		switch(_g) {
		case "HTTP/1.0":
			args.push("--http1.0");
			break;
		case "HTTP/1.1":
			args.push("--http1.1");
			break;
		case "HTTP/2":
			args.push("--http2");
			break;
		default:
		}
		var header = HxOverrides.iter(req.header.fields);
		while(header.hasNext()) {
			var header1 = header.next();
			args.push("-H");
			args.push("" + header1.name + ": " + header1.value);
		}
		args.push(tink__$Url_Url_$Impl_$.toString(req.header.url));
		return tink_core__$Promise_Promise_$Impl_$.next(tink_io_RealSourceTools.parse(this.curl(args,req.body),tink_http_ResponseHeaderBase.parser()),function(p) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(new tink_http_IncomingResponse(p.a,p.b)));
		});
	}
	,__class__: tink_http_clients_CurlClient
};
var tink_http_clients_LocalContainerClient = function(container) {
	this.container = container;
};
$hxClasses["tink.http.clients.LocalContainerClient"] = tink_http_clients_LocalContainerClient;
tink_http_clients_LocalContainerClient.__name__ = ["tink","http","clients","LocalContainerClient"];
tink_http_clients_LocalContainerClient.__interfaces__ = [tink_http_ClientObject];
tink_http_clients_LocalContainerClient.prototype = {
	request: function(req) {
		var this1 = req.header.url;
		return tink_core__$Future_Future_$Impl_$.next(this.container.serve(new tink_http_IncomingRequest("127.0.0.1",new tink_http_IncomingRequestHeader(req.header.method,tink__$Url_Url_$Impl_$.fromString(this1.query == null ? this1.path : this1.path + "?" + this1.query),"HTTP/1.1",req.header.fields),tink_http_IncomingRequestBody.Plain(req.body))),function(res) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(new tink_http_IncomingResponse(res.header,res.body)));
		});
	}
	,__class__: tink_http_clients_LocalContainerClient
};
var tink_http_clients_NodeClient = function() {
};
$hxClasses["tink.http.clients.NodeClient"] = tink_http_clients_NodeClient;
tink_http_clients_NodeClient.__name__ = ["tink","http","clients","NodeClient"];
tink_http_clients_NodeClient.__interfaces__ = [tink_http_ClientObject];
tink_http_clients_NodeClient.prototype = {
	request: function(req) {
		var req1 = req.header.method;
		var this1 = req.header.url;
		var options = this1.query == null ? this1.path : this1.path + "?" + this1.query;
		var options1 = tink_url__$Host_Host_$Impl_$.get_name(req.header.url.host);
		var options2 = tink_url__$Host_Host_$Impl_$.get_port(req.header.url.host);
		var this2 = { };
		var map = this2;
		var h = HxOverrides.iter(req.header.fields);
		while(h.hasNext()) {
			var h1 = h.next();
			map[h1.name] = h1.value;
		}
		var options3 = { method : req1, path : options, host : options1, port : options2, headers : map, agent : false};
		return this.nodeRequest(js_node_Http,options3,req);
	}
	,nodeRequest: function(agent,options,req) {
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			var fwd = agent.request(options,function(msg) {
				var statusCode = msg.statusCode;
				var reason = msg.statusMessage;
				var _g = [];
				var _g2 = 0;
				var _g1 = msg.rawHeaders.length >> 1;
				while(_g2 < _g1) {
					var i = _g2++;
					_g.push(new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString(msg.rawHeaders[2 * i]),msg.rawHeaders[2 * i + 1]));
				}
				var this1 = new tink_http_ResponseHeaderBase(statusCode,reason,_g,"HTTP/1.1");
				var name = "Response from " + tink__$Url_Url_$Impl_$.toString(req.header.url);
				var options1 = null;
				if(options1 == null) {
					options1 = { };
				}
				var fwd1 = tink_core_Outcome.Success(new tink_http_IncomingResponse(this1,tink_io_nodejs_NodejsSource.wrap(name,msg,options1.chunkSize,options1.onEnd)));
				cb(fwd1);
			});
			var fail = function(e) {
				cb(tink_core_Outcome.Failure(e));
			};
			fwd.on("error",function(e1) {
				var tmp = tink_core_TypedError.withData(null,e1.message,e1,{ fileName : "tink/http/clients/NodeClient.hx", lineNumber : 58, className : "tink.http.clients.NodeClient", methodName : "nodeRequest"});
				fail(tmp);
			});
			tink_io__$Source_Source_$Impl_$.pipeTo(req.body,tink_io_nodejs_NodejsSink.wrap("Request to " + tink__$Url_Url_$Impl_$.toString(req.header.url),fwd)).handle(function(res) {
				fwd.end();
				switch(res[1]) {
				case 0:
					break;
				case 1:
					fail(new tink_core_TypedError(502,"Gateway Error",{ fileName : "tink/http/clients/NodeClient.hx", lineNumber : 67, className : "tink.http.clients.NodeClient", methodName : "nodeRequest"}));
					break;
				case 2:
					var e2 = res[2];
					fail(e2);
					break;
				}
			});
		});
	}
	,__class__: tink_http_clients_NodeClient
};
var tink_http_clients_SecureCurlClient = function(curl) {
	tink_http_clients_CurlClient.call(this,curl);
	this.protocol = "https";
};
$hxClasses["tink.http.clients.SecureCurlClient"] = tink_http_clients_SecureCurlClient;
tink_http_clients_SecureCurlClient.__name__ = ["tink","http","clients","SecureCurlClient"];
tink_http_clients_SecureCurlClient.__super__ = tink_http_clients_CurlClient;
tink_http_clients_SecureCurlClient.prototype = $extend(tink_http_clients_CurlClient.prototype,{
	__class__: tink_http_clients_SecureCurlClient
});
var tink_http_clients_SecureNodeClient = function() {
	tink_http_clients_NodeClient.call(this);
};
$hxClasses["tink.http.clients.SecureNodeClient"] = tink_http_clients_SecureNodeClient;
tink_http_clients_SecureNodeClient.__name__ = ["tink","http","clients","SecureNodeClient"];
tink_http_clients_SecureNodeClient.__super__ = tink_http_clients_NodeClient;
tink_http_clients_SecureNodeClient.prototype = $extend(tink_http_clients_NodeClient.prototype,{
	request: function(req) {
		var req1 = req.header.method;
		var this1 = req.header.url;
		var options = this1.query == null ? this1.path : this1.path + "?" + this1.query;
		var options1 = tink_url__$Host_Host_$Impl_$.get_name(req.header.url.host);
		var options2 = tink_url__$Host_Host_$Impl_$.get_port(req.header.url.host);
		var this2 = { };
		var map = this2;
		var h = HxOverrides.iter(req.header.fields);
		while(h.hasNext()) {
			var h1 = h.next();
			map[h1.name] = h1.value;
		}
		var options3 = { method : req1, path : options, host : options1, port : options2, headers : map, agent : false};
		return this.nodeRequest(js_node_Https,options3,req);
	}
	,__class__: tink_http_clients_SecureNodeClient
});
var tink_http_clients_StdClient = function(worker) {
	this.worker = tink_io__$Worker_Worker_$Impl_$.ensure(worker);
};
$hxClasses["tink.http.clients.StdClient"] = tink_http_clients_StdClient;
tink_http_clients_StdClient.__name__ = ["tink","http","clients","StdClient"];
tink_http_clients_StdClient.__interfaces__ = [tink_http_ClientObject];
tink_http_clients_StdClient.prototype = {
	request: function(req) {
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			var r = new haxe_Http(tink__$Url_Url_$Impl_$.toString(req.header.url));
			var send = function(post) {
				var code = 200;
				r.onStatus = function(c) {
					code = c;
				};
				var headers = function() {
					return [];
				};
				r.onError = function(msg) {
					if(code == 200) {
						code = 500;
					}
					tink_io__$Worker_Worker_$Impl_$.work(_gthis.worker,new tink_core__$Lazy_LazyConst(true)).handle(tink_core__$Callback_Callback_$Impl_$.fromNiladic(function() {
						var send1 = tink_core_Outcome.Failure(new tink_core_TypedError(code,msg,{ fileName : "tink/http/clients/StdClient.hx", lineNumber : 44, className : "tink.http.clients.StdClient", methodName : "request"}));
						cb(send1);
					}));
				};
				r.onData = function(data) {
					tink_io__$Worker_Worker_$Impl_$.work(_gthis.worker,new tink_core__$Lazy_LazyConst(true)).handle(tink_core__$Callback_Callback_$Impl_$.fromNiladic(function() {
						var fields = headers();
						var this1 = new tink_http_ResponseHeaderBase(code,"OK",fields,"HTTP/1.1");
						var send2 = tink_core_Outcome.Success(new tink_http_IncomingResponse(this1,tink_io__$Source_Source_$Impl_$.ofChunk(tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(data)))));
						cb(send2);
					}));
				};
				tink_io__$Worker_Worker_$Impl_$.work(_gthis.worker,new tink_core__$Lazy_LazyFunc(function() {
					r.request(post);
				}));
			};
			var h = HxOverrides.iter(req.header.fields);
			while(h.hasNext()) {
				var h1 = h.next();
				r.setHeader(h1.name,h1.value);
			}
			var _g = req.header.method;
			switch(_g) {
			case "GET":case "HEAD":case "OPTIONS":
				send(false);
				break;
			default:
				tink_io_IdealSourceTools.all(req.body).handle(function(bytes) {
					var tmp = bytes.toString();
					r.setPostData(tmp);
					send(true);
				});
			}
		});
	}
	,__class__: tink_http_clients_StdClient
};
var tink_http_containers_LocalContainer = function() {
};
$hxClasses["tink.http.containers.LocalContainer"] = tink_http_containers_LocalContainer;
tink_http_containers_LocalContainer.__name__ = ["tink","http","containers","LocalContainer"];
tink_http_containers_LocalContainer.__interfaces__ = [tink_http_Container];
tink_http_containers_LocalContainer.prototype = {
	serve: function(req) {
		if(!this.running) {
			var this1 = new tink_http_ResponseHeaderBase(503,"Server stopped",[],"HTTP/1.1");
			var this2 = new tink_http__$Response_OutgoingResponseData(this1,tink_io__$Source_Source_$Impl_$.EMPTY);
			return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(this2));
		}
		return this.handler.process(req);
	}
	,__class__: tink_http_containers_LocalContainer
};
var tink_http_containers_NodeContainer = function(kind) {
	this.kind = kind;
};
$hxClasses["tink.http.containers.NodeContainer"] = tink_http_containers_NodeContainer;
tink_http_containers_NodeContainer.__name__ = ["tink","http","containers","NodeContainer"];
tink_http_containers_NodeContainer.__interfaces__ = [tink_http_Container];
tink_http_containers_NodeContainer.toNodeHandler = function(handler) {
	return function(req,res) {
		var req1 = req.socket.remoteAddress;
		var tmp = tink_http_IncomingRequestHeader.fromIncomingMessage(req);
		var options = null;
		if(options == null) {
			options = { };
		}
		var tmp1 = tink_http_IncomingRequestBody.Plain(tink_io_nodejs_NodejsSource.wrap("Incoming HTTP message from " + req.socket.remoteAddress,req,options.chunkSize,options.onEnd));
		handler.process(new tink_http_IncomingRequest(req1,tmp,tmp1)).handle(function(out) {
			var out1 = out.header.statusCode;
			var out2 = out.header.reason;
			var _g = [];
			var h = HxOverrides.iter(out.header.fields);
			while(h.hasNext()) {
				var h1 = h.next();
				_g.push([h1.name,h1.value]);
			}
			res.writeHead(out1,out2,_g);
			tink_io__$Source_Source_$Impl_$.pipeTo(out.body,tink_io_nodejs_NodejsSink.wrap("Outgoing HTTP response to " + req.socket.remoteAddress,res)).handle(function(x) {
				res.end();
			});
		});
	};
};
tink_http_containers_NodeContainer.toUpgradeHandler = function(handler) {
	return function(req,socket,head) {
		var req1 = req.socket.remoteAddress;
		var tmp = tink_http_IncomingRequestHeader.fromIncomingMessage(req);
		var options = null;
		if(options == null) {
			options = { };
		}
		var tmp1 = tink_http_IncomingRequestBody.Plain(tink_io_nodejs_NodejsSource.wrap("Incoming HTTP message from " + req.socket.remoteAddress,socket,options.chunkSize,options.onEnd));
		handler.process(new tink_http_IncomingRequest(req1,tmp,tmp1)).handle(function(out) {
			tink_io__$Source_Source_$Impl_$.pipeTo(out.body.prepend(tink_io__$Source_Source_$Impl_$.ofChunk(tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(out.header.toString())))),tink_io_nodejs_NodejsSink.wrap("Outgoing HTTP response to " + req.socket.remoteAddress,socket)).handle(function(_) {
				socket.end();
			});
		});
	};
};
tink_http_containers_NodeContainer.prototype = {
	run: function(handler) {
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			var failures = tink_core__$Signal_Signal_$Impl_$.trigger();
			var server;
			var _g = _gthis.kind;
			switch(_g[1]) {
			case 0:
				var server1 = _g[2];
				server = server1;
				break;
			case 1:
				var port = _g[2];
				var server2 = new js_node_http_Server();
				server2.listen(port);
				server = server2;
				break;
			case 2:
				var host = _g[2];
				var server3 = new js_node_http_Server();
				server3.listen(tink_url__$Host_Host_$Impl_$.get_port(host),tink_url__$Host_Host_$Impl_$.get_name(host));
				server = server3;
				break;
			case 3:
				var path = _g[2];
				var server4 = new js_node_http_Server();
				server4.listen(path);
				server = server4;
				break;
			case 4:
				var fd = _g[2];
				var server5 = new js_node_http_Server();
				server5.listen(fd);
				server = server5;
				break;
			}
			var tinkify = function(e) {
				return tink_core_TypedError.withData(null,e.message,e,{ fileName : "tink/http/containers/NodeContainer.hx", lineNumber : 80, className : "tink.http.containers.NodeContainer", methodName : "run"});
			};
			server.on("error",function(e1) {
				cb(tink_http_ContainerResult.Failed(e1));
			});
			var tmp = tink_http_containers_NodeContainer.toUpgradeHandler(handler);
			server.on("upgrade",tmp);
			var onListen = function() {
				var onListen1 = tink_http_ContainerResult.Running({ shutdown : function(hard) {
					if(hard) {
						console.log("tink/http/containers/NodeContainer.hx:92:","Warning: hard shutdown not implemented");
					}
					var ret = tink_core__$Future_Future_$Impl_$.async(function(cb1) {
						server.close(function() {
							cb1(true);
						});
					}).map(tink_core_Outcome.Success);
					return ret.gather();
				}, failures : failures});
				cb(onListen1);
			};
			if(server.listening) {
				onListen();
			} else {
				server.on("listening",onListen);
			}
			var tmp1 = tink_http_containers_NodeContainer.toNodeHandler(handler);
			server.on("request",tmp1);
			server.on("error",function(e2) {
				cb(tink_http_ContainerResult.Failed(e2));
			});
		});
	}
	,__class__: tink_http_containers_NodeContainer
};
var tink_http_containers__$NodeContainer_ServerKindBase = $hxClasses["tink.http.containers._NodeContainer.ServerKindBase"] = { __ename__ : ["tink","http","containers","_NodeContainer","ServerKindBase"], __constructs__ : ["Instance","Port","Host","Path","Fd"] };
tink_http_containers__$NodeContainer_ServerKindBase.Instance = function(server) { var $x = ["Instance",0,server]; $x.__enum__ = tink_http_containers__$NodeContainer_ServerKindBase; $x.toString = $estr; return $x; };
tink_http_containers__$NodeContainer_ServerKindBase.Port = function(port) { var $x = ["Port",1,port]; $x.__enum__ = tink_http_containers__$NodeContainer_ServerKindBase; $x.toString = $estr; return $x; };
tink_http_containers__$NodeContainer_ServerKindBase.Host = function(host) { var $x = ["Host",2,host]; $x.__enum__ = tink_http_containers__$NodeContainer_ServerKindBase; $x.toString = $estr; return $x; };
tink_http_containers__$NodeContainer_ServerKindBase.Path = function(path) { var $x = ["Path",3,path]; $x.__enum__ = tink_http_containers__$NodeContainer_ServerKindBase; $x.toString = $estr; return $x; };
tink_http_containers__$NodeContainer_ServerKindBase.Fd = function(fd) { var $x = ["Fd",4,fd]; $x.__enum__ = tink_http_containers__$NodeContainer_ServerKindBase; $x.toString = $estr; return $x; };
var tink_io_PipeResult = $hxClasses["tink.io.PipeResult"] = { __ename__ : ["tink","io","PipeResult"], __constructs__ : ["AllWritten","SinkEnded","SinkFailed","SourceFailed"] };
tink_io_PipeResult.AllWritten = ["AllWritten",0];
tink_io_PipeResult.AllWritten.toString = $estr;
tink_io_PipeResult.AllWritten.__enum__ = tink_io_PipeResult;
tink_io_PipeResult.SinkEnded = function(result,rest) { var $x = ["SinkEnded",1,result,rest]; $x.__enum__ = tink_io_PipeResult; $x.toString = $estr; return $x; };
tink_io_PipeResult.SinkFailed = function(e,rest) { var $x = ["SinkFailed",2,e,rest]; $x.__enum__ = tink_io_PipeResult; $x.toString = $estr; return $x; };
tink_io_PipeResult.SourceFailed = function(e) { var $x = ["SourceFailed",3,e]; $x.__enum__ = tink_io_PipeResult; $x.toString = $estr; return $x; };
var tink_io_PipeResultTools = function() { };
$hxClasses["tink.io.PipeResultTools"] = tink_io_PipeResultTools;
tink_io_PipeResultTools.__name__ = ["tink","io","PipeResultTools"];
tink_io_PipeResultTools.toResult = function(c,result,buffered) {
	var mk = function(s) {
		if(buffered == null) {
			return s;
		} else {
			var v = buffered;
			return s.prepend(new tink_streams_Single(new tink_core__$Lazy_LazyConst(v)));
		}
	};
	switch(c[1]) {
	case 0:
		var rest = c[2];
		return tink_io_PipeResult.SinkEnded(result,mk(rest));
	case 1:
		var rest1 = c[3];
		var e = c[2];
		return tink_io_PipeResult.SinkFailed(e,mk(rest1));
	case 2:
		var e1 = c[2];
		return tink_io_PipeResult.SourceFailed(e1);
	case 3:
		return tink_io_PipeResult.AllWritten;
	}
};
var tink_io_SinkObject = function() { };
$hxClasses["tink.io.SinkObject"] = tink_io_SinkObject;
tink_io_SinkObject.__name__ = ["tink","io","SinkObject"];
tink_io_SinkObject.prototype = {
	__class__: tink_io_SinkObject
};
var tink_io_SinkBase = function() { };
$hxClasses["tink.io.SinkBase"] = tink_io_SinkBase;
tink_io_SinkBase.__name__ = ["tink","io","SinkBase"];
tink_io_SinkBase.__interfaces__ = [tink_io_SinkObject];
tink_io_SinkBase.prototype = {
	consume: function(source,options) {
		throw new js__$Boot_HaxeError("not implemented");
	}
	,__class__: tink_io_SinkBase
};
var tink_streams_StreamObject = function() { };
$hxClasses["tink.streams.StreamObject"] = tink_streams_StreamObject;
tink_streams_StreamObject.__name__ = ["tink","streams","StreamObject"];
tink_streams_StreamObject.prototype = {
	__class__: tink_streams_StreamObject
};
var tink_streams_StreamBase = function() {
};
$hxClasses["tink.streams.StreamBase"] = tink_streams_StreamBase;
tink_streams_StreamBase.__name__ = ["tink","streams","StreamBase"];
tink_streams_StreamBase.__interfaces__ = [tink_streams_StreamObject];
tink_streams_StreamBase.prototype = {
	get_depleted: function() {
		return false;
	}
	,regroup: function(f) {
		return new tink_streams__$Stream_RegroupStream(this,f);
	}
	,filter: function(f) {
		return this.regroup(f);
	}
	,prepend: function(other) {
		if(this.get_depleted()) {
			return other;
		} else {
			return tink_streams__$Stream_CompoundStream.of([other,this]);
		}
	}
	,decompose: function(into) {
		if(!this.get_depleted()) {
			into.push(this);
		}
	}
	,reduce: function(initial,reducer) {
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			_gthis.forEach(tink_streams__$Stream_Handler_$Impl_$.ofUnknown(function(item) {
				var ret = reducer(initial,item).map(function(o) {
					switch(o[1]) {
					case 0:
						var v = o[2];
						initial = v;
						return tink_streams_Handled.Resume;
					case 1:
						var e = o[2];
						return tink_streams_Handled.Clog(e);
					}
				});
				return ret.gather();
			})).handle(function(c) {
				switch(c[1]) {
				case 0:
					throw new js__$Boot_HaxeError("assert");
				case 1:
					var rest = c[3];
					var e1 = c[2];
					cb(tink_streams_Reduction.Crashed(e1,rest));
					break;
				case 2:
					var e2 = c[2];
					cb(tink_streams_Reduction.Failed(e2));
					break;
				case 3:
					cb(tink_streams_Reduction.Reduced(initial));
					break;
				}
			});
		},true);
	}
	,forEach: function(handler) {
		throw new js__$Boot_HaxeError("not implemented");
	}
	,__class__: tink_streams_StreamBase
};
var tink_streams_Empty = function() {
	tink_streams_StreamBase.call(this);
};
$hxClasses["tink.streams.Empty"] = tink_streams_Empty;
tink_streams_Empty.__name__ = ["tink","streams","Empty"];
tink_streams_Empty.make = function() {
	return tink_streams_Empty.inst;
};
tink_streams_Empty.__super__ = tink_streams_StreamBase;
tink_streams_Empty.prototype = $extend(tink_streams_StreamBase.prototype,{
	get_depleted: function() {
		return true;
	}
	,forEach: function(handler) {
		return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_streams_Conclusion.Depleted));
	}
	,__class__: tink_streams_Empty
});
var tink_io__$Source_Source_$Impl_$ = {};
$hxClasses["tink.io._Source.Source_Impl_"] = tink_io__$Source_Source_$Impl_$;
tink_io__$Source_Source_$Impl_$.__name__ = ["tink","io","_Source","Source_Impl_"];
tink_io__$Source_Source_$Impl_$.toNodeStream = function(this1) {
	var native = new js_node_stream_PassThrough();
	var source = tink_io__$Source_Source_$Impl_$.chunked(this1);
	var write = null;
	write = function() {
		source.forEach(tink_streams__$Stream_Handler_$Impl_$.ofSafe(function(chunk) {
			var b = chunk.toBytes();
			var data = b.b;
			var ok = new js_node_buffer_Buffer(data.buffer,data.byteOffset,b.length);
			var ok1 = native.write(ok);
			if(ok1) {
				return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_streams_Handled.Resume));
			} else {
				return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_streams_Handled.Finish));
			}
		})).handle(function(o) {
			switch(o[1]) {
			case 0:
				var rest = o[2];
				source = rest;
				native.once("drain",write);
				break;
			case 2:
				var e = o[2];
				native.emit("error",new Error(e.message));
				break;
			case 3:
				native.end();
				break;
			}
		});
	};
	var write1 = write;
	write1();
	return native;
};
tink_io__$Source_Source_$Impl_$.chunked = function(this1) {
	return this1;
};
tink_io__$Source_Source_$Impl_$.concatAll = function(s) {
	return s.reduce(tink__$Chunk_Chunk_$Impl_$.EMPTY,tink_streams__$Stream_Reducer_$Impl_$.ofSafe(function(res,cur) {
		return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_streams_ReductionStep.Progress(tink__$Chunk_Chunk_$Impl_$.catChunk(res,cur))));
	}));
};
tink_io__$Source_Source_$Impl_$.pipeTo = function(this1,target,options) {
	return target.consume(this1,options);
};
tink_io__$Source_Source_$Impl_$.ofChunk = function(chunk) {
	return new tink_streams_Single(new tink_core__$Lazy_LazyConst(chunk));
};
var tink_io_RealSourceTools = function() { };
$hxClasses["tink.io.RealSourceTools"] = tink_io_RealSourceTools;
tink_io_RealSourceTools.__name__ = ["tink","io","RealSourceTools"];
tink_io_RealSourceTools.all = function(s) {
	var ret = tink_io__$Source_Source_$Impl_$.concatAll(s).map(function(o) {
		switch(o[1]) {
		case 1:
			var e = o[2];
			return tink_core_Outcome.Failure(e);
		case 2:
			var c = o[2];
			return tink_core_Outcome.Success(c);
		}
	});
	return ret.gather();
};
tink_io_RealSourceTools.parse = function(s,p) {
	var ret = tink_io__$StreamParser_StreamParser_$Impl_$.parse(s,p).map(function(r) {
		switch(r[1]) {
		case 0:
			var rest = r[3];
			var data = r[2];
			var this1 = new tink_core_MPair(data,rest);
			return tink_core_Outcome.Success(this1);
		case 1:
			var e = r[2];
			return tink_core_Outcome.Failure(e);
		case 2:
			var e1 = r[2];
			return tink_core_Outcome.Failure(e1);
		}
	});
	return ret.gather();
};
var tink_io_IdealSourceTools = function() { };
$hxClasses["tink.io.IdealSourceTools"] = tink_io_IdealSourceTools;
tink_io_IdealSourceTools.__name__ = ["tink","io","IdealSourceTools"];
tink_io_IdealSourceTools.all = function(s) {
	var ret = tink_io__$Source_Source_$Impl_$.concatAll(s).map(function(o) {
		var c = o[2];
		return c;
	});
	return ret.gather();
};
var tink_io_ParseResult = $hxClasses["tink.io.ParseResult"] = { __ename__ : ["tink","io","ParseResult"], __constructs__ : ["Parsed","Invalid","Broke"] };
tink_io_ParseResult.Parsed = function(data,rest) { var $x = ["Parsed",0,data,rest]; $x.__enum__ = tink_io_ParseResult; $x.toString = $estr; return $x; };
tink_io_ParseResult.Invalid = function(e,rest) { var $x = ["Invalid",1,e,rest]; $x.__enum__ = tink_io_ParseResult; $x.toString = $estr; return $x; };
tink_io_ParseResult.Broke = function(e) { var $x = ["Broke",2,e]; $x.__enum__ = tink_io_ParseResult; $x.toString = $estr; return $x; };
var tink_io__$StreamParser_StreamParser_$Impl_$ = {};
$hxClasses["tink.io._StreamParser.StreamParser_Impl_"] = tink_io__$StreamParser_StreamParser_$Impl_$;
tink_io__$StreamParser_StreamParser_$Impl_$.__name__ = ["tink","io","_StreamParser","StreamParser_Impl_"];
tink_io__$StreamParser_StreamParser_$Impl_$.doParse = function(source,p,consume,ff) {
	var cursor = tink__$Chunk_Chunk_$Impl_$.EMPTY.getCursor();
	var resume = true;
	var mk = function(source1) {
		if(cursor.currentPos < cursor.length) {
			return source1.prepend(new tink_streams_Single(new tink_core__$Lazy_LazyConst(cursor.right())));
		} else {
			return source1;
		}
	};
	var flush = function() {
		var _g = cursor.flush();
		var c = _g;
		if(c.getLength() == 0) {
			return tink_io__$Source_Source_$Impl_$.EMPTY;
		} else {
			var c1 = _g;
			return new tink_streams_Single(new tink_core__$Lazy_LazyConst(c1));
		}
	};
	var ret = source.forEach(tink_streams__$Stream_Handler_$Impl_$.ofUnknown(function(chunk) {
		if(chunk.getLength() == 0) {
			return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_streams_Handled.Resume));
		}
		cursor.shift(chunk);
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			var next = null;
			next = function() {
				cursor.shift();
				var lastPos = cursor.currentPos;
				var _g1 = p.progress(cursor);
				switch(_g1[1]) {
				case 0:
					if(lastPos != cursor.currentPos && cursor.currentPos < cursor.length) {
						next();
					} else {
						cb(tink_streams_Handled.Resume);
					}
					break;
				case 1:
					var v = _g1[2];
					var ret1 = consume(v).map(function(o) {
						resume = o.resume;
						if(resume) {
							if(lastPos != cursor.currentPos && cursor.currentPos < cursor.length) {
								next();
							} else {
								cb(tink_streams_Handled.Resume);
							}
						} else {
							cb(tink_streams_Handled.Finish);
						}
					});
					ret1.gather();
					break;
				case 2:
					var e = _g1[2];
					cb(tink_streams_Handled.Clog(e));
					break;
				}
			};
			var next1 = next;
			next1();
		});
	})).flatMap(function(c2) {
		switch(c2[1]) {
		case 0:
			var rest = c2[2];
			return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_io_ParseResult.Parsed(ff(),mk(rest))));
		case 1:
			var rest1 = c2[3];
			var e1 = c2[2];
			return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_io_ParseResult.Invalid(e1,mk(rest1))));
		case 2:
			var e2 = c2[2];
			return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_io_ParseResult.Broke(e2)));
		case 3:
			if(cursor.currentPos < cursor.length) {
				var v1 = ff();
				var v2 = new tink_streams_Single(new tink_core__$Lazy_LazyConst(tink__$Chunk_Chunk_$Impl_$.EMPTY));
				return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_io_ParseResult.Parsed(v1,mk(v2))));
			} else if(!resume) {
				return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_io_ParseResult.Parsed(ff(),flush())));
			} else {
				var _g2 = p.eof(cursor);
				switch(_g2[1]) {
				case 0:
					var result = _g2[2];
					var ret2 = consume(result).map(function(_) {
						return tink_io_ParseResult.Parsed(ff(),flush());
					});
					return ret2.gather();
				case 1:
					var e3 = _g2[2];
					return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_io_ParseResult.Invalid(e3,flush())));
				}
			}
			break;
		}
	});
	return ret.gather();
};
tink_io__$StreamParser_StreamParser_$Impl_$.parse = function(s,p) {
	var res = null;
	var onResult = function(r) {
		res = r;
		return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst({ resume : false}));
	};
	return tink_io__$StreamParser_StreamParser_$Impl_$.doParse(s,p,onResult,function() {
		return res;
	});
};
var tink_io_WorkerObject = function() { };
$hxClasses["tink.io.WorkerObject"] = tink_io_WorkerObject;
tink_io_WorkerObject.__name__ = ["tink","io","WorkerObject"];
tink_io_WorkerObject.prototype = {
	__class__: tink_io_WorkerObject
};
var tink_io__$Worker_EagerWorker = function() {
};
$hxClasses["tink.io._Worker.EagerWorker"] = tink_io__$Worker_EagerWorker;
tink_io__$Worker_EagerWorker.__name__ = ["tink","io","_Worker","EagerWorker"];
tink_io__$Worker_EagerWorker.__interfaces__ = [tink_io_WorkerObject];
tink_io__$Worker_EagerWorker.prototype = {
	work: function(task) {
		return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(task.get()));
	}
	,__class__: tink_io__$Worker_EagerWorker
};
var tink_io__$Worker_Worker_$Impl_$ = {};
$hxClasses["tink.io._Worker.Worker_Impl_"] = tink_io__$Worker_Worker_$Impl_$;
tink_io__$Worker_Worker_$Impl_$.__name__ = ["tink","io","_Worker","Worker_Impl_"];
tink_io__$Worker_Worker_$Impl_$.ensure = function(this1) {
	if(this1 == null) {
		return tink_io__$Worker_Worker_$Impl_$.get();
	} else {
		return this1;
	}
};
tink_io__$Worker_Worker_$Impl_$.get = function() {
	return tink_io__$Worker_Worker_$Impl_$.pool[Std.random(tink_io__$Worker_Worker_$Impl_$.pool.length)];
};
tink_io__$Worker_Worker_$Impl_$.work = function(this1,task) {
	return this1.work(task);
};
var tink_io_nodejs_NodejsSink = function(target) {
	this.target = target;
};
$hxClasses["tink.io.nodejs.NodejsSink"] = tink_io_nodejs_NodejsSink;
tink_io_nodejs_NodejsSink.__name__ = ["tink","io","nodejs","NodejsSink"];
tink_io_nodejs_NodejsSink.wrap = function(name,native) {
	return new tink_io_nodejs_NodejsSink(new tink_io_nodejs_WrappedWritable(name,native));
};
tink_io_nodejs_NodejsSink.__super__ = tink_io_SinkBase;
tink_io_nodejs_NodejsSink.prototype = $extend(tink_io_SinkBase.prototype,{
	consume: function(source,options) {
		var _gthis = this;
		var ret = source.forEach(tink_streams__$Stream_Handler_$Impl_$.ofUnknown(function(c) {
			var ret1 = _gthis.target.write(c).map(function(w) {
				switch(w[1]) {
				case 0:
					switch(w[2]) {
					case false:
						return tink_streams_Handled.BackOff;
					case true:
						return tink_streams_Handled.Resume;
					}
					break;
				case 1:
					var e = w[2];
					return tink_streams_Handled.Clog(e);
				}
			});
			return ret1.gather();
		}));
		if(options != null && options.end) {
			ret.handle(function(end) {
				_gthis.target.end();
			});
		}
		var ret2 = ret.map(function(c1) {
			return tink_io_PipeResultTools.toResult(c1,tink_core_Noise.Noise);
		});
		return ret2.gather();
	}
	,__class__: tink_io_nodejs_NodejsSink
});
var tink_streams_Generator = function(upcoming) {
	tink_streams_StreamBase.call(this);
	this.upcoming = upcoming;
};
$hxClasses["tink.streams.Generator"] = tink_streams_Generator;
tink_streams_Generator.__name__ = ["tink","streams","Generator"];
tink_streams_Generator.stream = function(step) {
	return new tink_streams_Generator(tink_core__$Future_Future_$Impl_$.async(step,true));
};
tink_streams_Generator.__super__ = tink_streams_StreamBase;
tink_streams_Generator.prototype = $extend(tink_streams_StreamBase.prototype,{
	forEach: function(handler) {
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			_gthis.upcoming.handle(function(e) {
				switch(e[1]) {
				case 0:
					var then = e[3];
					var v = e[2];
					handler(v).handle(function(s) {
						switch(s[1]) {
						case 0:
							cb(tink_streams_Conclusion.Halted(_gthis));
							break;
						case 1:
							cb(tink_streams_Conclusion.Halted(then));
							break;
						case 2:
							then.forEach(handler).handle(cb);
							break;
						case 3:
							var e1 = s[2];
							cb(tink_streams_Conclusion.Clogged(e1,_gthis));
							break;
						}
					});
					break;
				case 1:
					var e2 = e[2];
					cb(tink_streams_Conclusion.Failed(e2));
					break;
				case 2:
					cb(tink_streams_Conclusion.Depleted);
					break;
				}
			});
		},true);
	}
	,__class__: tink_streams_Generator
});
var tink_io_nodejs_NodejsSource = function(target) {
	tink_streams_Generator.call(this,tink_core__$Future_Future_$Impl_$.async(function(cb) {
		target.read().handle(function(o) {
			var tmp;
			switch(o[1]) {
			case 0:
				if(o[2] == null) {
					tmp = tink_streams_Step.End;
				} else {
					var chunk = o[2];
					tmp = tink_streams_Step.Link(chunk,new tink_io_nodejs_NodejsSource(target));
				}
				break;
			case 1:
				var e = o[2];
				tmp = tink_streams_Step.Fail(e);
				break;
			}
			cb(tmp);
		});
	},true));
};
$hxClasses["tink.io.nodejs.NodejsSource"] = tink_io_nodejs_NodejsSource;
tink_io_nodejs_NodejsSource.__name__ = ["tink","io","nodejs","NodejsSource"];
tink_io_nodejs_NodejsSource.wrap = function(name,native,chunkSize,onEnd) {
	return new tink_io_nodejs_NodejsSource(new tink_io_nodejs_WrappedReadable(name,native,chunkSize,onEnd));
};
tink_io_nodejs_NodejsSource.__super__ = tink_streams_Generator;
tink_io_nodejs_NodejsSource.prototype = $extend(tink_streams_Generator.prototype,{
	__class__: tink_io_nodejs_NodejsSource
});
var tink_io_nodejs_WrappedBuffer = function(buffer) {
	this.buffer = buffer;
};
$hxClasses["tink.io.nodejs.WrappedBuffer"] = tink_io_nodejs_WrappedBuffer;
tink_io_nodejs_WrappedBuffer.__name__ = ["tink","io","nodejs","WrappedBuffer"];
tink_io_nodejs_WrappedBuffer.__interfaces__ = [tink_chunk_ChunkObject];
tink_io_nodejs_WrappedBuffer.prototype = {
	getCursor: function() {
		return tink_chunk_ByteChunk.of(this.toBytes()).getCursor();
	}
	,flatten: function(into) {
		tink_chunk_ByteChunk.of(this.toBytes()).flatten(into);
	}
	,getLength: function() {
		return this.buffer.length;
	}
	,toString: function() {
		return this.buffer.toString();
	}
	,toBytes: function() {
		var copy = tink_io_nodejs_WrappedBuffer.alloc(this.buffer.length);
		this.buffer.copy(copy);
		return js_node_buffer__$Buffer_Helper.bytesOfBuffer(copy);
	}
	,blitTo: function(target,offset) {
		var data = target.b;
		this.buffer.copy(new js_node_buffer_Buffer(data.buffer,data.byteOffset,target.length),offset);
		return;
	}
	,__class__: tink_io_nodejs_WrappedBuffer
};
var tink_io_nodejs_WrappedReadable = function(name,native,chunkSize,onEnd) {
	this.name = name;
	this.native = native;
	this.chunkSize = chunkSize;
	this.end = tink_core__$Future_Future_$Impl_$.async(function(cb) {
		native.once("end",function() {
			cb(tink_core_Outcome.Success(null));
		});
		native.once("error",function(e) {
			var tmp = tink_core_Outcome.Failure(new tink_core_TypedError(null,"" + e.code + " - Failed reading from " + name + " because " + e.message,{ fileName : "tink/io/nodejs/WrappedReadable.hx", lineNumber : 21, className : "tink.io.nodejs.WrappedReadable", methodName : "new"}));
			cb(tmp);
		});
	});
	if(onEnd != null) {
		this.end.handle(tink_core__$Callback_Callback_$Impl_$.fromNiladic(function() {
			process.nextTick(onEnd);
		}));
	}
};
$hxClasses["tink.io.nodejs.WrappedReadable"] = tink_io_nodejs_WrappedReadable;
tink_io_nodejs_WrappedReadable.__name__ = ["tink","io","nodejs","WrappedReadable"];
tink_io_nodejs_WrappedReadable.prototype = {
	read: function() {
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.first(tink_core__$Future_Future_$Impl_$.async(function(cb) {
			var attempt = null;
			attempt = function() {
				try {
					var _g = _gthis.native.read(_gthis.chunkSize);
					if(_g == null) {
						_gthis.native.once("readable",attempt);
					} else {
						var chunk = _g;
						var buf = typeof(chunk) == "string" ? new js_node_buffer_Buffer(chunk) : chunk;
						var attempt1 = tink_core_Outcome.Success(new tink_io_nodejs_WrappedBuffer(buf));
						cb(attempt1);
					}
				} catch( e ) {
					var attempt2 = tink_core_Outcome.Failure(tink_core_TypedError.withData(null,"Error while reading from " + _gthis.name,(e instanceof js__$Boot_HaxeError) ? e.val : e,{ fileName : "tink/io/nodejs/WrappedReadable.hx", lineNumber : 46, className : "tink.io.nodejs.WrappedReadable", methodName : "read"}));
					cb(attempt2);
				}
			};
			var attempt3 = attempt;
			attempt3();
		}),this.end);
	}
	,__class__: tink_io_nodejs_WrappedReadable
};
var tink_io_nodejs_WrappedWritable = function(name,native) {
	this.name = name;
	this.native = native;
	this.ended = tink_core__$Future_Future_$Impl_$.async(function(cb) {
		native.once("end",function() {
			cb(tink_core_Outcome.Success(false));
		});
		native.once("finish",function() {
			cb(tink_core_Outcome.Success(false));
		});
		native.once("close",function() {
			cb(tink_core_Outcome.Success(false));
		});
		native.on("error",function(e) {
			var tmp = tink_core_Outcome.Failure(new tink_core_TypedError(null,"" + e.code + ": " + e.message,{ fileName : "tink/io/nodejs/WrappedWritable.hx", lineNumber : 22, className : "tink.io.nodejs.WrappedWritable", methodName : "new"}));
			cb(tmp);
		});
	});
};
$hxClasses["tink.io.nodejs.WrappedWritable"] = tink_io_nodejs_WrappedWritable;
tink_io_nodejs_WrappedWritable.__name__ = ["tink","io","nodejs","WrappedWritable"];
tink_io_nodejs_WrappedWritable.prototype = {
	end: function() {
		var didEnd = false;
		var this1 = this.ended.handle(tink_core__$Callback_Callback_$Impl_$.fromNiladic(function() {
			didEnd = true;
		}));
		if(this1 != null) {
			this1.cancel();
		}
		if(didEnd) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(false));
		}
		this.native.end();
		return tink_core__$Promise_Promise_$Impl_$.next(this.ended,function(_) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(true));
		});
	}
	,write: function(chunk) {
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.first(tink_core__$Future_Future_$Impl_$.async(function(cb) {
			if(chunk.getLength() == 0) {
				cb(tink_core_Outcome.Success(true));
				return;
			}
			var buf;
			if(js_node_buffer_Buffer.isBuffer(chunk.buffer)) {
				buf = chunk.buffer;
			} else {
				var b = chunk.toBytes();
				var data = b.b;
				buf = new js_node_buffer_Buffer(data.buffer,data.byteOffset,b.length);
			}
			var f = cb;
			var a1 = tink_core_Outcome.Success(true);
			var tmp = function() {
				f(a1);
			};
			_gthis.native.write(buf,tmp);
		}),this.ended);
	}
	,__class__: tink_io_nodejs_WrappedWritable
};
var tink_json__$Parser_SliceData = function(source,min,max) {
	this.source = source;
	this.min = min;
	this.max = max;
};
$hxClasses["tink.json._Parser.SliceData"] = tink_json__$Parser_SliceData;
tink_json__$Parser_SliceData.__name__ = ["tink","json","_Parser","SliceData"];
tink_json__$Parser_SliceData.prototype = {
	__class__: tink_json__$Parser_SliceData
};
var tink_json__$Parser_JsonString_$Impl_$ = {};
$hxClasses["tink.json._Parser.JsonString_Impl_"] = tink_json__$Parser_JsonString_$Impl_$;
tink_json__$Parser_JsonString_$Impl_$.__name__ = ["tink","json","_Parser","JsonString_Impl_"];
tink_json__$Parser_JsonString_$Impl_$.contains = function(this1,s) {
	var _g = this1.source.indexOf(s,this1.min);
	if(_g == -1) {
		return false;
	} else {
		var outside = _g;
		if(outside > this1.max) {
			return false;
		} else {
			var v = _g;
			return true;
		}
	}
};
tink_json__$Parser_JsonString_$Impl_$.toString = function(this1) {
	if(tink_json__$Parser_JsonString_$Impl_$.contains(this1,"\\")) {
		return JSON.parse(this1.source.substring(this1.min - 1,this1.max + 1));
	} else {
		return this1.source.substring(this1.min,this1.max);
	}
};
var tink_json_BasicParser = function() {
	this.plugins = new tink_core_Annex(this);
};
$hxClasses["tink.json.BasicParser"] = tink_json_BasicParser;
tink_json_BasicParser.__name__ = ["tink","json","BasicParser"];
tink_json_BasicParser.prototype = {
	init: function(source) {
		this.source = source;
		this.pos = 0;
		this.max = source.length;
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
	}
	,parseDynamic: function() {
		var start = this.pos;
		this.skipValue();
		return JSON.parse(this.source.substring(start,this.pos));
	}
	,parseString: function() {
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var e;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 34) {
			this.pos += 1;
			e = true;
		} else {
			e = false;
		}
		var e1 = !e ? this.die("Expected string") : null;
		return this.parseRestOfString();
	}
	,parseRestOfString: function() {
		return this.slice(this.skipString(),this.pos - 1);
	}
	,skipString: function() {
		var start = this.pos;
		while(true) {
			var _g = this.source.indexOf("\"",this.pos);
			if(_g == -1) {
				this.die("unterminated string",start);
			} else {
				var v = _g;
				this.pos = v + 1;
				var p = this.pos - 2;
				while(this.source.charCodeAt(p) == 92) --p;
				if((p - this.pos & 1) == 0) {
					break;
				}
			}
		}
		return start;
	}
	,parseNumber: function() {
		var char = this.source.charCodeAt(this.pos);
		if(char == 46 || char == 45 || char < 58 && char > 47) {
			return this.doParseNumber();
		} else {
			return this.die("number expected");
		}
	}
	,doParseNumber: function() {
		return this.slice(this.skipNumber(this.source.charCodeAt(this.pos++)),this.pos);
	}
	,invalidNumber: function(start) {
		return this.die("Invalid number " + this.source.substring(start,this.pos),start);
	}
	,skipNumber: function(c) {
		var start = this.pos - 1;
		var minus = c == 45;
		var digit = !minus;
		var zero = c == 48;
		var point = false;
		var e = false;
		var pm = false;
		var end = false;
		while(true) {
			c = this.source.charCodeAt(this.pos++);
			switch(c) {
			case 43:case 45:
				if(!e || pm) {
					this.invalidNumber(start);
				}
				digit = false;
				pm = true;
				break;
			case 46:
				if(minus || point) {
					this.invalidNumber(start);
				}
				digit = false;
				point = true;
				break;
			case 48:
				if(zero && !point) {
					this.invalidNumber(start);
				}
				if(minus) {
					minus = false;
					zero = true;
				}
				digit = true;
				break;
			case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:
				if(zero && !point) {
					this.invalidNumber(start);
				}
				if(minus) {
					minus = false;
				}
				digit = true;
				zero = false;
				break;
			case 69:case 101:
				if(minus || zero || e) {
					this.invalidNumber(start);
				}
				digit = false;
				e = true;
				break;
			default:
				if(!digit) {
					this.invalidNumber(start);
				}
				this.pos--;
				end = true;
			}
			if(end) {
				break;
			}
		}
		return start;
	}
	,slice: function(from,to) {
		return new tink_json__$Parser_SliceData(this.source,from,to);
	}
	,skipArray: function() {
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp = true;
		} else {
			tmp = false;
		}
		if(tmp) {
			return;
		}
		while(true) {
			this.skipValue();
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp1;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp1 = true;
			} else {
				tmp1 = false;
			}
			if(!tmp1) {
				break;
			}
		}
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp2;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
			this.pos += 1;
			tmp2 = true;
		} else {
			tmp2 = false;
		}
		if(!tmp2) {
			this.die("Expected ]");
		}
	}
	,skipValue: function() {
		var _gthis = this;
		var _g = this.source.charCodeAt(this.pos++);
		switch(_g) {
		case 34:
			this.skipString();
			break;
		case 91:
			this.skipArray();
			break;
		case 102:
			var tmp;
			if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 97 && this.source.charCodeAt(this.pos + 1) == 108 && this.source.charCodeAt(this.pos + 2) == 115 && this.source.charCodeAt(this.pos + 3) == 101) {
				this.pos += 4;
				tmp = true;
			} else {
				tmp = false;
			}
			if(!tmp) {
				this.die("Expected alse");
			}
			break;
		case 110:
			var tmp1;
			if(this.max > this.pos + 2 && this.source.charCodeAt(this.pos) == 117 && this.source.charCodeAt(this.pos + 1) == 108 && this.source.charCodeAt(this.pos + 2) == 108) {
				this.pos += 3;
				tmp1 = true;
			} else {
				tmp1 = false;
			}
			if(!tmp1) {
				this.die("Expected ull");
			}
			break;
		case 116:
			var tmp2;
			if(this.max > this.pos + 2 && this.source.charCodeAt(this.pos) == 114 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 101) {
				this.pos += 3;
				tmp2 = true;
			} else {
				tmp2 = false;
			}
			if(!tmp2) {
				this.die("Expected rue");
			}
			break;
		case 123:
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp3;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp3 = true;
			} else {
				tmp3 = false;
			}
			if(tmp3) {
				return;
			}
			while(true) {
				if(_gthis.source.charCodeAt(_gthis.pos++) != 34) {
					_gthis.die("expected string",_gthis.pos - 1);
				}
				_gthis.skipString();
				while(_gthis.pos < _gthis.max && _gthis.source.charCodeAt(_gthis.pos) < 33) _gthis.pos++;
				var tmp4;
				if(_gthis.max > _gthis.pos && _gthis.source.charCodeAt(_gthis.pos) == 58) {
					_gthis.pos += 1;
					while(_gthis.pos < _gthis.max && _gthis.source.charCodeAt(_gthis.pos) < 33) _gthis.pos++;
					tmp4 = true;
				} else {
					tmp4 = false;
				}
				if(!tmp4) {
					_gthis.die("Expected :");
				}
				_gthis.skipValue();
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp5;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp5 = true;
				} else {
					tmp5 = false;
				}
				if(!tmp5) {
					break;
				}
			}
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp6;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				tmp6 = true;
			} else {
				tmp6 = false;
			}
			if(!tmp6) {
				this.die("Expected }");
			}
			break;
		default:
			var char = _g;
			if(char == 46 || char == 45 || char < 58 && char > 47) {
				this.skipNumber(char);
			} else {
				this.invalidChar(char);
			}
		}
	}
	,invalidChar: function(c) {
		return this.die("invalid char " + StringTools.hex(c,2),this.pos - 1);
	}
	,die: function(s,pos,end) {
		if(pos == null) {
			pos = this.pos;
			end = pos;
		} else if(end == null) {
			end = this.pos;
		}
		if(end <= pos) {
			end = pos + 1;
		}
		var range = end > pos + 1 ? "characters " + pos + " - " + end : "character " + pos;
		var clip = function(s1,maxLength,left) {
			if(s1.length > maxLength) {
				if(left) {
					return "... " + HxOverrides.substr(s1,s1.length - maxLength,null);
				} else {
					return HxOverrides.substr(s1,0,maxLength) + " ...";
				}
			} else {
				return s1;
			}
		};
		var center = pos + end >> 1;
		var context = clip(this.source.substring(0,pos),20,true) + "  ---->  " + clip(this.source.substring(pos,center),20,false) + clip(this.source.substring(center,end),20,true) + "  <----  " + clip(this.source.substring(end),20,false);
		return tink_core_TypedError.withData(422,s + (" at " + range + " in " + context),{ source : this.source, start : pos, end : end},{ fileName : "tink/json/Parser.hx", lineNumber : 331, className : "tink.json.BasicParser", methodName : "die"}).throwSelf();
	}
	,__class__: tink_json_BasicParser
};
var tink_json_Parser0 = function() {
	tink_json_BasicParser.call(this);
};
$hxClasses["tink.json.Parser0"] = tink_json_Parser0;
tink_json_Parser0.__name__ = ["tink","json","Parser0"];
tink_json_Parser0.__super__ = tink_json_BasicParser;
tink_json_Parser0.prototype = $extend(tink_json_BasicParser.prototype,{
	parse0: function() {
		var _gthis = this;
		var v_dependencies = null;
		var hasv_dependencies = false;
		var v_deprecated = null;
		var v_haxe = null;
		var hasv_haxe = false;
		var v_published = null;
		var hasv_published = false;
		var v_version = null;
		var hasv_version = false;
		var __start__ = this.pos;
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 123) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp = true;
		} else {
			tmp = false;
		}
		if(!tmp) {
			this.die("Expected {");
		}
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp1;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp1 = true;
		} else {
			tmp1 = false;
		}
		if(!tmp1) {
			while(true) {
				var __name__ = this.parseString();
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp2;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 58) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp2 = true;
				} else {
					tmp2 = false;
				}
				if(!tmp2) {
					this.die("Expected :");
				}
				if("version".length == __name__.max - __name__.min && __name__.source.startsWith("version",__name__.min)) {
					var __start__1 = this.pos;
					var rep = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					try {
						var this1 = rep;
						v_version = tink_core_OutcomeTools.sure(tink_semver__$Version_Version_$Impl_$.parse(tink_json__$Representation_Representation_$Impl_$.get(this1)));
					} catch( e ) {
						v_version = this.die(Std.string((e instanceof js__$Boot_HaxeError) ? e.val : e),__start__1);
					}
					hasv_version = true;
				} else if("published".length == __name__.max - __name__.min && __name__.source.startsWith("published",__name__.min)) {
					var this2 = this.parseNumber();
					v_published = new Date(parseFloat(this2.source.substring(this2.min,this2.max)));
					hasv_published = true;
				} else if("haxe".length == __name__.max - __name__.min && __name__.source.startsWith("haxe",__name__.min)) {
					var __start__2 = this.pos;
					var rep1 = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					try {
						var this3 = rep1;
						v_haxe = tink_semver__$Constraint_Constraint_$Impl_$.fromString(tink_json__$Representation_Representation_$Impl_$.get(this3));
					} catch( e1 ) {
						v_haxe = this.die(Std.string((e1 instanceof js__$Boot_HaxeError) ? e1.val : e1),__start__2);
					}
					hasv_haxe = true;
				} else if("deprecated".length == __name__.max - __name__.min && __name__.source.startsWith("deprecated",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_deprecated1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_deprecated1 = true;
					} else {
						v_deprecated1 = false;
					}
					v_deprecated = v_deprecated1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("dependencies".length == __name__.max - __name__.min && __name__.source.startsWith("dependencies",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_dependencies1;
					if(this.max > this.pos && this.source.charCodeAt(this.pos) == 91) {
						this.pos += 1;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_dependencies1 = true;
					} else {
						v_dependencies1 = false;
					}
					if(!v_dependencies1) {
						this.die("Expected [");
					}
					var __ret = [];
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_dependencies2;
					if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
						this.pos += 1;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_dependencies2 = true;
					} else {
						v_dependencies2 = false;
					}
					if(!v_dependencies2) {
						while(true) {
							__ret.push(this.parse1());
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							var v_dependencies3;
							if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
								this.pos += 1;
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								v_dependencies3 = true;
							} else {
								v_dependencies3 = false;
							}
							if(!v_dependencies3) {
								break;
							}
						}
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_dependencies4;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_dependencies4 = true;
						} else {
							v_dependencies4 = false;
						}
						if(!v_dependencies4) {
							this.die("Expected ]");
						}
					}
					v_dependencies = __ret;
					hasv_dependencies = true;
				} else {
					this.skipValue();
				}
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp3;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp3 = true;
				} else {
					tmp3 = false;
				}
				if(!tmp3) {
					break;
				}
			}
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp4;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp4 = true;
			} else {
				tmp4 = false;
			}
			if(!tmp4) {
				this.die("Expected }");
			}
		}
		var __missing__ = function(field) {
			return _gthis.die("missing field \"" + field + "\"",__start__);
		};
		return { dependencies : hasv_dependencies ? v_dependencies : __missing__("dependencies"), deprecated : v_deprecated, haxe : hasv_haxe ? v_haxe : __missing__("haxe"), published : hasv_published ? v_published : __missing__("published"), version : hasv_version ? v_version : __missing__("version")};
	}
	,parse1: function() {
		var _gthis = this;
		var v_constraint = null;
		var v_name = null;
		var hasv_name = false;
		var __start__ = this.pos;
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 123) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp = true;
		} else {
			tmp = false;
		}
		if(!tmp) {
			this.die("Expected {");
		}
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp1;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp1 = true;
		} else {
			tmp1 = false;
		}
		if(!tmp1) {
			while(true) {
				var __name__ = this.parseString();
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp2;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 58) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp2 = true;
				} else {
					tmp2 = false;
				}
				if(!tmp2) {
					this.die("Expected :");
				}
				if("name".length == __name__.max - __name__.min && __name__.source.startsWith("name",__name__.min)) {
					v_name = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					hasv_name = true;
				} else if("constraint".length == __name__.max - __name__.min && __name__.source.startsWith("constraint",__name__.min)) {
					var __start__1 = this.pos;
					var rep = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					try {
						var this1 = rep;
						v_constraint = tink_semver__$Constraint_Constraint_$Impl_$.fromString(tink_json__$Representation_Representation_$Impl_$.get(this1));
					} catch( e ) {
						v_constraint = this.die(Std.string((e instanceof js__$Boot_HaxeError) ? e.val : e),__start__1);
					}
				} else {
					this.skipValue();
				}
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp3;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp3 = true;
				} else {
					tmp3 = false;
				}
				if(!tmp3) {
					break;
				}
			}
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp4;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp4 = true;
			} else {
				tmp4 = false;
			}
			if(!tmp4) {
				this.die("Expected }");
			}
		}
		var __missing__ = function(field) {
			return _gthis.die("missing field \"" + field + "\"",__start__);
		};
		return { constraint : v_constraint, name : hasv_name ? v_name : __missing__("name")};
	}
	,parse: function(source) {
		this.init(source);
		return this.parse0();
	}
	,tryParse: function(source) {
		var _gthis = this;
		return tink_core_TypedError.catchExceptions(function() {
			return _gthis.parse(source);
		},null,{ fileName : "tink/json/macros/Macro.hx", lineNumber : 67, className : "tink.json.Parser0", methodName : "tryParse"});
	}
	,__class__: tink_json_Parser0
});
var tink_json_Parser1 = function() {
	tink_json_BasicParser.call(this);
};
$hxClasses["tink.json.Parser1"] = tink_json_Parser1;
tink_json_Parser1.__name__ = ["tink","json","Parser1"];
tink_json_Parser1.__super__ = tink_json_BasicParser;
tink_json_Parser1.prototype = $extend(tink_json_BasicParser.prototype,{
	parse0: function() {
		var _gthis = this;
		var v_method = null;
		var hasv_method = false;
		var v_url = null;
		var hasv_url = false;
		var __start__ = this.pos;
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 123) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp = true;
		} else {
			tmp = false;
		}
		if(!tmp) {
			this.die("Expected {");
		}
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp1;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp1 = true;
		} else {
			tmp1 = false;
		}
		if(!tmp1) {
			while(true) {
				var __name__ = this.parseString();
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp2;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 58) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp2 = true;
				} else {
					tmp2 = false;
				}
				if(!tmp2) {
					this.die("Expected :");
				}
				if("url".length == __name__.max - __name__.min && __name__.source.startsWith("url",__name__.min)) {
					v_url = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					hasv_url = true;
				} else if("method".length == __name__.max - __name__.min && __name__.source.startsWith("method",__name__.min)) {
					var v = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					switch(v) {
					case "DELETE":case "GET":case "HEAD":case "OPTIONS":case "PATCH":case "POST":case "PUT":
						v_method = v;
						break;
					default:
						var list = ["GET","HEAD","OPTIONS","POST","PUT","PATCH","DELETE"];
						throw new js__$Boot_HaxeError(new tink_core_TypedError(422,"Unrecognized enum value: " + v + ". Accepted values are: " + new tink_json_Writer0().write(list),{ fileName : "tink/json/macros/GenReader.hx", lineNumber : 327, className : "tink.json.Parser1", methodName : "parse0"}));
					}
					hasv_method = true;
				} else {
					this.skipValue();
				}
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp3;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp3 = true;
				} else {
					tmp3 = false;
				}
				if(!tmp3) {
					break;
				}
			}
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp4;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp4 = true;
			} else {
				tmp4 = false;
			}
			if(!tmp4) {
				this.die("Expected }");
			}
		}
		var __missing__ = function(field) {
			return _gthis.die("missing field \"" + field + "\"",__start__);
		};
		return { method : hasv_method ? v_method : __missing__("method"), url : hasv_url ? v_url : __missing__("url")};
	}
	,parse: function(source) {
		this.init(source);
		return this.parse0();
	}
	,tryParse: function(source) {
		var _gthis = this;
		return tink_core_TypedError.catchExceptions(function() {
			return _gthis.parse(source);
		},null,{ fileName : "tink/json/macros/Macro.hx", lineNumber : 67, className : "tink.json.Parser1", methodName : "tryParse"});
	}
	,__class__: tink_json_Parser1
});
var tink_json_Parser2 = function() {
	tink_json_BasicParser.call(this);
};
$hxClasses["tink.json.Parser2"] = tink_json_Parser2;
tink_json_Parser2.__name__ = ["tink","json","Parser2"];
tink_json_Parser2.__super__ = tink_json_BasicParser;
tink_json_Parser2.prototype = $extend(tink_json_BasicParser.prototype,{
	parse0: function() {
		var _gthis = this;
		var v_id = 0;
		var hasv_id = false;
		var v_nickname = null;
		var v_username = null;
		var __start__ = this.pos;
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 123) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp = true;
		} else {
			tmp = false;
		}
		if(!tmp) {
			this.die("Expected {");
		}
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp1;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp1 = true;
		} else {
			tmp1 = false;
		}
		if(!tmp1) {
			while(true) {
				var __name__ = this.parseString();
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp2;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 58) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp2 = true;
				} else {
					tmp2 = false;
				}
				if(!tmp2) {
					this.die("Expected :");
				}
				if("username".length == __name__.max - __name__.min && __name__.source.startsWith("username",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_username1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_username1 = true;
					} else {
						v_username1 = false;
					}
					v_username = v_username1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("nickname".length == __name__.max - __name__.min && __name__.source.startsWith("nickname",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_nickname1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_nickname1 = true;
					} else {
						v_nickname1 = false;
					}
					v_nickname = v_nickname1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("id".length == __name__.max - __name__.min && __name__.source.startsWith("id",__name__.min)) {
					var this1 = this.parseNumber();
					v_id = Std.parseInt(this1.source.substring(this1.min,this1.max));
					hasv_id = true;
				} else {
					this.skipValue();
				}
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp3;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp3 = true;
				} else {
					tmp3 = false;
				}
				if(!tmp3) {
					break;
				}
			}
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp4;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp4 = true;
			} else {
				tmp4 = false;
			}
			if(!tmp4) {
				this.die("Expected }");
			}
		}
		var __missing__ = function(field) {
			return _gthis.die("missing field \"" + field + "\"",__start__);
		};
		return { id : hasv_id ? v_id : __missing__("id"), nickname : v_nickname, username : v_username};
	}
	,parse: function(source) {
		this.init(source);
		return this.parse0();
	}
	,tryParse: function(source) {
		var _gthis = this;
		return tink_core_TypedError.catchExceptions(function() {
			return _gthis.parse(source);
		},null,{ fileName : "tink/json/macros/Macro.hx", lineNumber : 67, className : "tink.json.Parser2", methodName : "tryParse"});
	}
	,__class__: tink_json_Parser2
});
var tink_json_Parser3 = function() {
	tink_json_BasicParser.call(this);
};
$hxClasses["tink.json.Parser3"] = tink_json_Parser3;
tink_json_Parser3.__name__ = ["tink","json","Parser3"];
tink_json_Parser3.__super__ = tink_json_BasicParser;
tink_json_Parser3.prototype = $extend(tink_json_BasicParser.prototype,{
	parse0: function() {
		var _gthis = this;
		var v_authors = null;
		var v_classPaths = null;
		var hasv_classPaths = false;
		var v_custom = null;
		var v_dependencies = null;
		var hasv_dependencies = false;
		var v_description = null;
		var v_haxe = null;
		var hasv_haxe = false;
		var v_hooks = null;
		var v_license = null;
		var v_name = null;
		var hasv_name = false;
		var v_owner = null;
		var v_tags = null;
		var v_url = null;
		var v_version = null;
		var hasv_version = false;
		var __start__ = this.pos;
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 123) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp = true;
		} else {
			tmp = false;
		}
		if(!tmp) {
			this.die("Expected {");
		}
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp1;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp1 = true;
		} else {
			tmp1 = false;
		}
		if(!tmp1) {
			while(true) {
				var __name__ = this.parseString();
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp2;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 58) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp2 = true;
				} else {
					tmp2 = false;
				}
				if(!tmp2) {
					this.die("Expected :");
				}
				if("version".length == __name__.max - __name__.min && __name__.source.startsWith("version",__name__.min)) {
					var __start__1 = this.pos;
					var rep = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					try {
						var this1 = rep;
						v_version = tink_core_OutcomeTools.sure(tink_semver__$Version_Version_$Impl_$.parse(tink_json__$Representation_Representation_$Impl_$.get(this1)));
					} catch( e ) {
						v_version = this.die(Std.string((e instanceof js__$Boot_HaxeError) ? e.val : e),__start__1);
					}
					hasv_version = true;
				} else if("url".length == __name__.max - __name__.min && __name__.source.startsWith("url",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_url1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_url1 = true;
					} else {
						v_url1 = false;
					}
					v_url = v_url1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("tags".length == __name__.max - __name__.min && __name__.source.startsWith("tags",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_tags1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_tags1 = true;
					} else {
						v_tags1 = false;
					}
					if(v_tags1) {
						v_tags = null;
					} else {
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_tags2;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 91) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_tags2 = true;
						} else {
							v_tags2 = false;
						}
						if(!v_tags2) {
							this.die("Expected [");
						}
						var __ret = [];
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_tags3;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_tags3 = true;
						} else {
							v_tags3 = false;
						}
						if(!v_tags3) {
							while(true) {
								__ret.push(tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString()));
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								var v_tags4;
								if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
									this.pos += 1;
									while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
									v_tags4 = true;
								} else {
									v_tags4 = false;
								}
								if(!v_tags4) {
									break;
								}
							}
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							var v_tags5;
							if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
								this.pos += 1;
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								v_tags5 = true;
							} else {
								v_tags5 = false;
							}
							if(!v_tags5) {
								this.die("Expected ]");
							}
						}
						v_tags = __ret;
					}
				} else if("owner".length == __name__.max - __name__.min && __name__.source.startsWith("owner",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_owner1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_owner1 = true;
					} else {
						v_owner1 = false;
					}
					v_owner = v_owner1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("name".length == __name__.max - __name__.min && __name__.source.startsWith("name",__name__.min)) {
					v_name = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					hasv_name = true;
				} else if("license".length == __name__.max - __name__.min && __name__.source.startsWith("license",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_license1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_license1 = true;
					} else {
						v_license1 = false;
					}
					v_license = v_license1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("hooks".length == __name__.max - __name__.min && __name__.source.startsWith("hooks",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_hooks1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_hooks1 = true;
					} else {
						v_hooks1 = false;
					}
					v_hooks = v_hooks1 ? null : this.parse2();
				} else if("haxe".length == __name__.max - __name__.min && __name__.source.startsWith("haxe",__name__.min)) {
					var __start__2 = this.pos;
					var rep1 = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					try {
						var this2 = rep1;
						v_haxe = tink_semver__$Constraint_Constraint_$Impl_$.fromString(tink_json__$Representation_Representation_$Impl_$.get(this2));
					} catch( e1 ) {
						v_haxe = this.die(Std.string((e1 instanceof js__$Boot_HaxeError) ? e1.val : e1),__start__2);
					}
					hasv_haxe = true;
				} else if("description".length == __name__.max - __name__.min && __name__.source.startsWith("description",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_description1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_description1 = true;
					} else {
						v_description1 = false;
					}
					v_description = v_description1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("dependencies".length == __name__.max - __name__.min && __name__.source.startsWith("dependencies",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_dependencies1;
					if(this.max > this.pos && this.source.charCodeAt(this.pos) == 91) {
						this.pos += 1;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_dependencies1 = true;
					} else {
						v_dependencies1 = false;
					}
					if(!v_dependencies1) {
						this.die("Expected [");
					}
					var __ret1 = [];
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_dependencies2;
					if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
						this.pos += 1;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_dependencies2 = true;
					} else {
						v_dependencies2 = false;
					}
					if(!v_dependencies2) {
						while(true) {
							__ret1.push(this.parse1());
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							var v_dependencies3;
							if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
								this.pos += 1;
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								v_dependencies3 = true;
							} else {
								v_dependencies3 = false;
							}
							if(!v_dependencies3) {
								break;
							}
						}
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_dependencies4;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_dependencies4 = true;
						} else {
							v_dependencies4 = false;
						}
						if(!v_dependencies4) {
							this.die("Expected ]");
						}
					}
					v_dependencies = __ret1;
					hasv_dependencies = true;
				} else if("custom".length == __name__.max - __name__.min && __name__.source.startsWith("custom",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_custom1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_custom1 = true;
					} else {
						v_custom1 = false;
					}
					if(v_custom1) {
						v_custom = null;
					} else {
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_custom2;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 123) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_custom2 = true;
						} else {
							v_custom2 = false;
						}
						if(!v_custom2) {
							this.die("Expected {");
						}
						var this3 = { };
						var __ret2 = this3;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_custom3;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_custom3 = true;
						} else {
							v_custom3 = false;
						}
						if(!v_custom3) {
							while(true) {
								var key = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								var e2;
								if(this.max > this.pos && this.source.charCodeAt(this.pos) == 58) {
									this.pos += 1;
									while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
									e2 = true;
								} else {
									e2 = false;
								}
								var e3 = !e2 ? this.die("Expected :") : null;
								__ret2[key] = this.parseDynamic();
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								var v_custom4;
								if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
									this.pos += 1;
									while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
									v_custom4 = true;
								} else {
									v_custom4 = false;
								}
								if(!v_custom4) {
									break;
								}
							}
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							var v_custom5;
							if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
								this.pos += 1;
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								v_custom5 = true;
							} else {
								v_custom5 = false;
							}
							if(!v_custom5) {
								this.die("Expected }");
							}
						}
						v_custom = __ret2;
					}
				} else if("classPaths".length == __name__.max - __name__.min && __name__.source.startsWith("classPaths",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_classPaths1;
					if(this.max > this.pos && this.source.charCodeAt(this.pos) == 91) {
						this.pos += 1;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_classPaths1 = true;
					} else {
						v_classPaths1 = false;
					}
					if(!v_classPaths1) {
						this.die("Expected [");
					}
					var __ret3 = [];
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_classPaths2;
					if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
						this.pos += 1;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_classPaths2 = true;
					} else {
						v_classPaths2 = false;
					}
					if(!v_classPaths2) {
						while(true) {
							__ret3.push(tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString()));
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							var v_classPaths3;
							if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
								this.pos += 1;
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								v_classPaths3 = true;
							} else {
								v_classPaths3 = false;
							}
							if(!v_classPaths3) {
								break;
							}
						}
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_classPaths4;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_classPaths4 = true;
						} else {
							v_classPaths4 = false;
						}
						if(!v_classPaths4) {
							this.die("Expected ]");
						}
					}
					v_classPaths = __ret3;
					hasv_classPaths = true;
				} else if("authors".length == __name__.max - __name__.min && __name__.source.startsWith("authors",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_authors1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_authors1 = true;
					} else {
						v_authors1 = false;
					}
					if(v_authors1) {
						v_authors = null;
					} else {
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_authors2;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 91) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_authors2 = true;
						} else {
							v_authors2 = false;
						}
						if(!v_authors2) {
							this.die("Expected [");
						}
						var __ret4 = [];
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_authors3;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_authors3 = true;
						} else {
							v_authors3 = false;
						}
						if(!v_authors3) {
							while(true) {
								__ret4.push(tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString()));
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								var v_authors4;
								if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
									this.pos += 1;
									while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
									v_authors4 = true;
								} else {
									v_authors4 = false;
								}
								if(!v_authors4) {
									break;
								}
							}
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							var v_authors5;
							if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
								this.pos += 1;
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								v_authors5 = true;
							} else {
								v_authors5 = false;
							}
							if(!v_authors5) {
								this.die("Expected ]");
							}
						}
						v_authors = __ret4;
					}
				} else {
					this.skipValue();
				}
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp3;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp3 = true;
				} else {
					tmp3 = false;
				}
				if(!tmp3) {
					break;
				}
			}
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp4;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp4 = true;
			} else {
				tmp4 = false;
			}
			if(!tmp4) {
				this.die("Expected }");
			}
		}
		var __missing__ = function(field) {
			return _gthis.die("missing field \"" + field + "\"",__start__);
		};
		return { authors : v_authors, classPaths : hasv_classPaths ? v_classPaths : __missing__("classPaths"), custom : v_custom, dependencies : hasv_dependencies ? v_dependencies : __missing__("dependencies"), description : v_description, haxe : hasv_haxe ? v_haxe : __missing__("haxe"), hooks : v_hooks, license : v_license, name : hasv_name ? v_name : __missing__("name"), owner : v_owner, tags : v_tags, url : v_url, version : hasv_version ? v_version : __missing__("version")};
	}
	,parse1: function() {
		var _gthis = this;
		var v_name = null;
		var hasv_name = false;
		var v_version = null;
		var hasv_version = false;
		var __start__ = this.pos;
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 123) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp = true;
		} else {
			tmp = false;
		}
		if(!tmp) {
			this.die("Expected {");
		}
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp1;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp1 = true;
		} else {
			tmp1 = false;
		}
		if(!tmp1) {
			while(true) {
				var __name__ = this.parseString();
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp2;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 58) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp2 = true;
				} else {
					tmp2 = false;
				}
				if(!tmp2) {
					this.die("Expected :");
				}
				if("version".length == __name__.max - __name__.min && __name__.source.startsWith("version",__name__.min)) {
					var __start__1 = this.pos;
					var rep = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					try {
						var this1 = rep;
						v_version = tink_semver__$Constraint_Constraint_$Impl_$.fromString(tink_json__$Representation_Representation_$Impl_$.get(this1));
					} catch( e ) {
						v_version = this.die(Std.string((e instanceof js__$Boot_HaxeError) ? e.val : e),__start__1);
					}
					hasv_version = true;
				} else if("name".length == __name__.max - __name__.min && __name__.source.startsWith("name",__name__.min)) {
					v_name = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					hasv_name = true;
				} else {
					this.skipValue();
				}
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp3;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp3 = true;
				} else {
					tmp3 = false;
				}
				if(!tmp3) {
					break;
				}
			}
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp4;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp4 = true;
			} else {
				tmp4 = false;
			}
			if(!tmp4) {
				this.die("Expected }");
			}
		}
		var __missing__ = function(field) {
			return _gthis.die("missing field \"" + field + "\"",__start__);
		};
		return { name : hasv_name ? v_name : __missing__("name"), version : hasv_version ? v_version : __missing__("version")};
	}
	,parse2: function() {
		var _gthis = this;
		var v_postDownload = null;
		var v_postInstall = null;
		var __start__ = this.pos;
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 123) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp = true;
		} else {
			tmp = false;
		}
		if(!tmp) {
			this.die("Expected {");
		}
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp1;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp1 = true;
		} else {
			tmp1 = false;
		}
		if(!tmp1) {
			while(true) {
				var __name__ = this.parseString();
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp2;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 58) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp2 = true;
				} else {
					tmp2 = false;
				}
				if(!tmp2) {
					this.die("Expected :");
				}
				if("postInstall".length == __name__.max - __name__.min && __name__.source.startsWith("postInstall",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_postInstall1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_postInstall1 = true;
					} else {
						v_postInstall1 = false;
					}
					v_postInstall = v_postInstall1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("postDownload".length == __name__.max - __name__.min && __name__.source.startsWith("postDownload",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_postDownload1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_postDownload1 = true;
					} else {
						v_postDownload1 = false;
					}
					v_postDownload = v_postDownload1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else {
					this.skipValue();
				}
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp3;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp3 = true;
				} else {
					tmp3 = false;
				}
				if(!tmp3) {
					break;
				}
			}
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp4;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp4 = true;
			} else {
				tmp4 = false;
			}
			if(!tmp4) {
				this.die("Expected }");
			}
		}
		var __missing__ = function(field) {
			return _gthis.die("missing field \"" + field + "\"",__start__);
		};
		return { postDownload : v_postDownload, postInstall : v_postInstall};
	}
	,parse: function(source) {
		this.init(source);
		return this.parse0();
	}
	,__class__: tink_json_Parser3
});
var tink_json_Parser4 = function() {
	tink_json_BasicParser.call(this);
};
$hxClasses["tink.json.Parser4"] = tink_json_Parser4;
tink_json_Parser4.__name__ = ["tink","json","Parser4"];
tink_json_Parser4.__super__ = tink_json_BasicParser;
tink_json_Parser4.prototype = $extend(tink_json_BasicParser.prototype,{
	parse0: function() {
		var _gthis = this;
		var v_authors = null;
		var v_deprecated = null;
		var v_description = null;
		var v_id = 0;
		var hasv_id = false;
		var v_name = null;
		var hasv_name = false;
		var v_owner = null;
		var hasv_owner = false;
		var v_tags = null;
		var v_url = null;
		var __start__ = this.pos;
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 123) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp = true;
		} else {
			tmp = false;
		}
		if(!tmp) {
			this.die("Expected {");
		}
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp1;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp1 = true;
		} else {
			tmp1 = false;
		}
		if(!tmp1) {
			while(true) {
				var __name__ = this.parseString();
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp2;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 58) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp2 = true;
				} else {
					tmp2 = false;
				}
				if(!tmp2) {
					this.die("Expected :");
				}
				if("url".length == __name__.max - __name__.min && __name__.source.startsWith("url",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_url1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_url1 = true;
					} else {
						v_url1 = false;
					}
					v_url = v_url1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("tags".length == __name__.max - __name__.min && __name__.source.startsWith("tags",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_tags1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_tags1 = true;
					} else {
						v_tags1 = false;
					}
					if(v_tags1) {
						v_tags = null;
					} else {
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_tags2;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 91) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_tags2 = true;
						} else {
							v_tags2 = false;
						}
						if(!v_tags2) {
							this.die("Expected [");
						}
						var __ret = [];
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_tags3;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_tags3 = true;
						} else {
							v_tags3 = false;
						}
						if(!v_tags3) {
							while(true) {
								__ret.push(tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString()));
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								var v_tags4;
								if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
									this.pos += 1;
									while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
									v_tags4 = true;
								} else {
									v_tags4 = false;
								}
								if(!v_tags4) {
									break;
								}
							}
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							var v_tags5;
							if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
								this.pos += 1;
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								v_tags5 = true;
							} else {
								v_tags5 = false;
							}
							if(!v_tags5) {
								this.die("Expected ]");
							}
						}
						v_tags = __ret;
					}
				} else if("owner".length == __name__.max - __name__.min && __name__.source.startsWith("owner",__name__.min)) {
					v_owner = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					hasv_owner = true;
				} else if("name".length == __name__.max - __name__.min && __name__.source.startsWith("name",__name__.min)) {
					v_name = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					hasv_name = true;
				} else if("id".length == __name__.max - __name__.min && __name__.source.startsWith("id",__name__.min)) {
					var this1 = this.parseNumber();
					v_id = Std.parseInt(this1.source.substring(this1.min,this1.max));
					hasv_id = true;
				} else if("description".length == __name__.max - __name__.min && __name__.source.startsWith("description",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_description1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_description1 = true;
					} else {
						v_description1 = false;
					}
					v_description = v_description1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("deprecated".length == __name__.max - __name__.min && __name__.source.startsWith("deprecated",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_deprecated1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_deprecated1 = true;
					} else {
						v_deprecated1 = false;
					}
					v_deprecated = v_deprecated1 ? null : tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
				} else if("authors".length == __name__.max - __name__.min && __name__.source.startsWith("authors",__name__.min)) {
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					var v_authors1;
					if(this.max > this.pos + 3 && this.source.charCodeAt(this.pos) == 110 && this.source.charCodeAt(this.pos + 1) == 117 && this.source.charCodeAt(this.pos + 2) == 108 && this.source.charCodeAt(this.pos + 3) == 108) {
						this.pos += 4;
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						v_authors1 = true;
					} else {
						v_authors1 = false;
					}
					if(v_authors1) {
						v_authors = null;
					} else {
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_authors2;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 91) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_authors2 = true;
						} else {
							v_authors2 = false;
						}
						if(!v_authors2) {
							this.die("Expected [");
						}
						var __ret1 = [];
						while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
						var v_authors3;
						if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
							this.pos += 1;
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							v_authors3 = true;
						} else {
							v_authors3 = false;
						}
						if(!v_authors3) {
							while(true) {
								__ret1.push(tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString()));
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								var v_authors4;
								if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
									this.pos += 1;
									while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
									v_authors4 = true;
								} else {
									v_authors4 = false;
								}
								if(!v_authors4) {
									break;
								}
							}
							while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
							var v_authors5;
							if(this.max > this.pos && this.source.charCodeAt(this.pos) == 93) {
								this.pos += 1;
								while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
								v_authors5 = true;
							} else {
								v_authors5 = false;
							}
							if(!v_authors5) {
								this.die("Expected ]");
							}
						}
						v_authors = __ret1;
					}
				} else {
					this.skipValue();
				}
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp3;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp3 = true;
				} else {
					tmp3 = false;
				}
				if(!tmp3) {
					break;
				}
			}
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp4;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp4 = true;
			} else {
				tmp4 = false;
			}
			if(!tmp4) {
				this.die("Expected }");
			}
		}
		var __missing__ = function(field) {
			return _gthis.die("missing field \"" + field + "\"",__start__);
		};
		return { authors : v_authors, deprecated : v_deprecated, description : v_description, id : hasv_id ? v_id : __missing__("id"), name : hasv_name ? v_name : __missing__("name"), owner : hasv_owner ? v_owner : __missing__("owner"), tags : v_tags, url : v_url};
	}
	,parse: function(source) {
		this.init(source);
		return this.parse0();
	}
	,tryParse: function(source) {
		var _gthis = this;
		return tink_core_TypedError.catchExceptions(function() {
			return _gthis.parse(source);
		},null,{ fileName : "tink/json/macros/Macro.hx", lineNumber : 67, className : "tink.json.Parser4", methodName : "tryParse"});
	}
	,__class__: tink_json_Parser4
});
var tink_json_Parser5 = function() {
	tink_json_BasicParser.call(this);
};
$hxClasses["tink.json.Parser5"] = tink_json_Parser5;
tink_json_Parser5.__name__ = ["tink","json","Parser5"];
tink_json_Parser5.__super__ = tink_json_BasicParser;
tink_json_Parser5.prototype = $extend(tink_json_BasicParser.prototype,{
	parse0: function() {
		var _gthis = this;
		var v_id = 0;
		var hasv_id = false;
		var v_name = null;
		var hasv_name = false;
		var __start__ = this.pos;
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 123) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp = true;
		} else {
			tmp = false;
		}
		if(!tmp) {
			this.die("Expected {");
		}
		while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
		var tmp1;
		if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
			this.pos += 1;
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			tmp1 = true;
		} else {
			tmp1 = false;
		}
		if(!tmp1) {
			while(true) {
				var __name__ = this.parseString();
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp2;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 58) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp2 = true;
				} else {
					tmp2 = false;
				}
				if(!tmp2) {
					this.die("Expected :");
				}
				if("name".length == __name__.max - __name__.min && __name__.source.startsWith("name",__name__.min)) {
					v_name = tink_json__$Parser_JsonString_$Impl_$.toString(this.parseString());
					hasv_name = true;
				} else if("id".length == __name__.max - __name__.min && __name__.source.startsWith("id",__name__.min)) {
					var this1 = this.parseNumber();
					v_id = Std.parseInt(this1.source.substring(this1.min,this1.max));
					hasv_id = true;
				} else {
					this.skipValue();
				}
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				var tmp3;
				if(this.max > this.pos && this.source.charCodeAt(this.pos) == 44) {
					this.pos += 1;
					while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
					tmp3 = true;
				} else {
					tmp3 = false;
				}
				if(!tmp3) {
					break;
				}
			}
			while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
			var tmp4;
			if(this.max > this.pos && this.source.charCodeAt(this.pos) == 125) {
				this.pos += 1;
				while(this.pos < this.max && this.source.charCodeAt(this.pos) < 33) this.pos++;
				tmp4 = true;
			} else {
				tmp4 = false;
			}
			if(!tmp4) {
				this.die("Expected }");
			}
		}
		var __missing__ = function(field) {
			return _gthis.die("missing field \"" + field + "\"",__start__);
		};
		return { id : hasv_id ? v_id : __missing__("id"), name : hasv_name ? v_name : __missing__("name")};
	}
	,parse: function(source) {
		this.init(source);
		return this.parse0();
	}
	,tryParse: function(source) {
		var _gthis = this;
		return tink_core_TypedError.catchExceptions(function() {
			return _gthis.parse(source);
		},null,{ fileName : "tink/json/macros/Macro.hx", lineNumber : 67, className : "tink.json.Parser5", methodName : "tryParse"});
	}
	,__class__: tink_json_Parser5
});
var tink_json__$Representation_Representation_$Impl_$ = {};
$hxClasses["tink.json._Representation.Representation_Impl_"] = tink_json__$Representation_Representation_$Impl_$;
tink_json__$Representation_Representation_$Impl_$.__name__ = ["tink","json","_Representation","Representation_Impl_"];
tink_json__$Representation_Representation_$Impl_$.get = function(this1) {
	return this1;
};
var tink_json_Value = $hxClasses["tink.json.Value"] = { __ename__ : ["tink","json","Value"], __constructs__ : ["VNumber","VString","VNull","VBool","VArray","VObject"] };
tink_json_Value.VNumber = function(f) { var $x = ["VNumber",0,f]; $x.__enum__ = tink_json_Value; $x.toString = $estr; return $x; };
tink_json_Value.VString = function(s) { var $x = ["VString",1,s]; $x.__enum__ = tink_json_Value; $x.toString = $estr; return $x; };
tink_json_Value.VNull = ["VNull",2];
tink_json_Value.VNull.toString = $estr;
tink_json_Value.VNull.__enum__ = tink_json_Value;
tink_json_Value.VBool = function(b) { var $x = ["VBool",3,b]; $x.__enum__ = tink_json_Value; $x.toString = $estr; return $x; };
tink_json_Value.VArray = function(a) { var $x = ["VArray",4,a]; $x.__enum__ = tink_json_Value; $x.toString = $estr; return $x; };
tink_json_Value.VObject = function(a) { var $x = ["VObject",5,a]; $x.__enum__ = tink_json_Value; $x.toString = $estr; return $x; };
var tink_json_BasicWriter = function() {
	this.plugins = new tink_core_Annex(this);
};
$hxClasses["tink.json.BasicWriter"] = tink_json_BasicWriter;
tink_json_BasicWriter.__name__ = ["tink","json","BasicWriter"];
tink_json_BasicWriter.prototype = {
	init: function() {
		var this1 = "";
		this.buf = this1;
	}
	,__class__: tink_json_BasicWriter
};
var tink_json_Writer0 = function() {
	tink_json_BasicWriter.call(this);
};
$hxClasses["tink.json.Writer0"] = tink_json_Writer0;
tink_json_Writer0.__name__ = ["tink","json","Writer0"];
tink_json_Writer0.__super__ = tink_json_BasicWriter;
tink_json_Writer0.prototype = $extend(tink_json_BasicWriter.prototype,{
	write: function(value) {
		this.init();
		this.buf += "[";
		var first = true;
		var _g = 0;
		while(_g < value.length) {
			var value1 = value[_g];
			++_g;
			if(first) {
				first = false;
			} else {
				this.buf += ",";
			}
			var value2 = value1;
			var s = JSON.stringify(value2);
			this.buf += s;
		}
		this.buf += "]";
		return this.buf.toString();
	}
	,__class__: tink_json_Writer0
});
var tink_json_Writer1 = function() {
	tink_json_BasicWriter.call(this);
};
$hxClasses["tink.json.Writer1"] = tink_json_Writer1;
tink_json_Writer1.__name__ = ["tink","json","Writer1"];
tink_json_Writer1.__super__ = tink_json_BasicWriter;
tink_json_Writer1.prototype = $extend(tink_json_BasicWriter.prototype,{
	parse0: function(value) {
		var __first = true;
		this.buf += "{";
		var _g = value.nickname;
		if(_g != null) {
			switch(_g[1]) {
			case 0:
				var value1 = _g[2];
				if(__first) {
					__first = false;
				} else {
					this.buf += ",";
				}
				this.buf += "\"nickname\":";
				var s = JSON.stringify(value1);
				this.buf += s;
				break;
			case 1:
				break;
			}
		}
		var _g1 = value.username;
		if(_g1 != null) {
			switch(_g1[1]) {
			case 0:
				var value2 = _g1[2];
				if(__first) {
					__first = false;
				} else {
					this.buf += ",";
				}
				this.buf += "\"username\":";
				var s1 = JSON.stringify(value2);
				this.buf += s1;
				break;
			case 1:
				break;
			}
		}
		this.buf += "}";
	}
	,write: function(value) {
		this.init();
		this.parse0(value);
		return this.buf.toString();
	}
	,__class__: tink_json_Writer1
});
var tink_json_Writer2 = function() {
	tink_json_BasicWriter.call(this);
};
$hxClasses["tink.json.Writer2"] = tink_json_Writer2;
tink_json_Writer2.__name__ = ["tink","json","Writer2"];
tink_json_Writer2.__super__ = tink_json_BasicWriter;
tink_json_Writer2.prototype = $extend(tink_json_BasicWriter.prototype,{
	parse0: function(value) {
		var __first = true;
		this.buf += "{";
		var value1 = value.name;
		if(__first) {
			__first = false;
		} else {
			this.buf += ",";
		}
		this.buf += "\"name\":";
		var s = JSON.stringify(value1);
		this.buf += s;
		var _g = value.authors;
		if(_g != null) {
			var value2 = _g;
			if(__first) {
				__first = false;
			} else {
				this.buf += ",";
			}
			this.buf += "\"authors\":";
			if(value2 == null) {
				this.buf += "null";
			} else {
				this.buf += "[";
				var first = true;
				var _g1 = 0;
				while(_g1 < value2.length) {
					var value3 = value2[_g1];
					++_g1;
					if(first) {
						first = false;
					} else {
						this.buf += ",";
					}
					var s1 = JSON.stringify(value3);
					this.buf += s1;
				}
				this.buf += "]";
			}
		}
		var _g11 = value.description;
		if(_g11 != null) {
			var value4 = _g11;
			if(__first) {
				__first = false;
			} else {
				this.buf += ",";
			}
			this.buf += "\"description\":";
			if(value4 == null) {
				this.buf += "null";
			} else {
				var s2 = JSON.stringify(value4);
				this.buf += s2;
			}
		}
		var _g2 = value.tags;
		if(_g2 != null) {
			var value5 = _g2;
			if(__first) {
				__first = false;
			} else {
				this.buf += ",";
			}
			this.buf += "\"tags\":";
			if(value5 == null) {
				this.buf += "null";
			} else {
				this.buf += "[";
				var first1 = true;
				var _g21 = 0;
				while(_g21 < value5.length) {
					var value6 = value5[_g21];
					++_g21;
					if(first1) {
						first1 = false;
					} else {
						this.buf += ",";
					}
					var s3 = JSON.stringify(value6);
					this.buf += s3;
				}
				this.buf += "]";
			}
		}
		var _g3 = value.url;
		if(_g3 != null) {
			var value7 = _g3;
			if(__first) {
				__first = false;
			} else {
				this.buf += ",";
			}
			this.buf += "\"url\":";
			if(value7 == null) {
				this.buf += "null";
			} else {
				var s4 = JSON.stringify(value7);
				this.buf += s4;
			}
		}
		this.buf += "}";
	}
	,write: function(value) {
		this.init();
		this.parse0(value);
		return this.buf.toString();
	}
	,__class__: tink_json_Writer2
});
var tink_json_Writer3 = function() {
	tink_json_BasicWriter.call(this);
};
$hxClasses["tink.json.Writer3"] = tink_json_Writer3;
tink_json_Writer3.__name__ = ["tink","json","Writer3"];
tink_json_Writer3.__super__ = tink_json_BasicWriter;
tink_json_Writer3.prototype = $extend(tink_json_BasicWriter.prototype,{
	parse0: function(value) {
		var __first = true;
		this.buf += "{";
		var value1 = value.dependencies;
		if(__first) {
			__first = false;
		} else {
			this.buf += ",";
		}
		this.buf += "\"dependencies\":";
		this.buf += "[";
		var first = true;
		var value2 = HxOverrides.iter(value1);
		while(value2.hasNext()) {
			var value3 = value2.next();
			if(first) {
				first = false;
			} else {
				this.buf += ",";
			}
			this.parse1(value3);
		}
		this.buf += "]";
		var value4 = value.haxe;
		if(__first) {
			__first = false;
		} else {
			this.buf += ",";
		}
		this.buf += "\"haxe\":";
		var this1 = tink_semver__$Constraint_Constraint_$Impl_$.toString(value4);
		var value5 = tink_json__$Representation_Representation_$Impl_$.get(this1);
		var s = JSON.stringify(value5);
		this.buf += s;
		var value6 = value.version;
		if(__first) {
			__first = false;
		} else {
			this.buf += ",";
		}
		this.buf += "\"version\":";
		var this2 = value6.toString();
		var value7 = tink_json__$Representation_Representation_$Impl_$.get(this2);
		var s1 = JSON.stringify(value7);
		this.buf += s1;
		this.buf += "}";
	}
	,parse1: function(value) {
		var __first = true;
		this.buf += "{";
		var value1 = value.name;
		if(__first) {
			__first = false;
		} else {
			this.buf += ",";
		}
		this.buf += "\"name\":";
		var s = JSON.stringify(value1);
		this.buf += s;
		var _g = value.constraint;
		if(_g != null) {
			var value2 = _g;
			if(__first) {
				__first = false;
			} else {
				this.buf += ",";
			}
			this.buf += "\"constraint\":";
			var this1 = tink_semver__$Constraint_Constraint_$Impl_$.toString(value2);
			var value3 = tink_json__$Representation_Representation_$Impl_$.get(this1);
			var s1 = JSON.stringify(value3);
			this.buf += s1;
		}
		this.buf += "}";
	}
	,write: function(value) {
		this.init();
		this.parse0(value);
		return this.buf.toString();
	}
	,__class__: tink_json_Writer3
});
var tink_json_Writer4 = function() {
	tink_json_BasicWriter.call(this);
};
$hxClasses["tink.json.Writer4"] = tink_json_Writer4;
tink_json_Writer4.__name__ = ["tink","json","Writer4"];
tink_json_Writer4.__super__ = tink_json_BasicWriter;
tink_json_Writer4.prototype = $extend(tink_json_BasicWriter.prototype,{
	parse0: function(value) {
		var __first = true;
		this.buf += "{";
		var value1 = value.name;
		if(__first) {
			__first = false;
		} else {
			this.buf += ",";
		}
		this.buf += "\"name\":";
		var s = JSON.stringify(value1);
		this.buf += s;
		this.buf += "}";
	}
	,write: function(value) {
		this.init();
		this.parse0(value);
		return this.buf.toString();
	}
	,__class__: tink_json_Writer4
});
var tink_parse_Char = function() { };
$hxClasses["tink.parse.Char"] = tink_parse_Char;
tink_parse_Char.__name__ = ["tink","parse","Char"];
var tink_parse_ParserBase = function(source) {
	this.source = source;
	this.max = source.length;
	this.pos = 0;
};
$hxClasses["tink.parse.ParserBase"] = tink_parse_ParserBase;
tink_parse_ParserBase.__name__ = ["tink","parse","ParserBase"];
tink_parse_ParserBase.prototype = {
	skipIgnored: function() {
		while(this.lastSkip != this.pos) {
			this.lastSkip = this.pos;
			this.doSkipIgnored();
		}
		this.lastSkip = this.pos;
		return null;
	}
	,doSkipIgnored: function() {
	}
	,allow: function(s) {
		var e = this.skipIgnored();
		return this.allowHere(s);
	}
	,allowHere: function(s) {
		if(tink_parse__$StringSlice_StringSlice_$Impl_$.hasSub(this.source,s,this.pos)) {
			this.pos += s.length;
			return true;
		} else {
			return false;
		}
	}
	,die: function(message,range) {
		if(range == null) {
			range = new IntIterator(this.pos,this.pos + 1);
		}
		var from = range.min;
		var to = range.max;
		throw new js__$Boot_HaxeError(this.makeError(message,this.doMakePos(from,to == null ? from + 1 : to)));
	}
	,makeError: function(message,pos) {
		throw new js__$Boot_HaxeError("ni");
	}
	,doMakePos: function(from,to) {
		throw new js__$Boot_HaxeError("ni");
	}
	,__class__: tink_parse_ParserBase
};
var tink_parse__$StringSlice_Data = function(string,start,end) {
	this.string = string;
	this.start = start;
	this.end = end;
	if((this.length = end - start) < 0) {
		this.length = 0;
		this.end = this.start;
	}
};
$hxClasses["tink.parse._StringSlice.Data"] = tink_parse__$StringSlice_Data;
tink_parse__$StringSlice_Data.__name__ = ["tink","parse","_StringSlice","Data"];
tink_parse__$StringSlice_Data.prototype = {
	toString: function() {
		if(this.representation == null) {
			this.representation = this.string.substring(this.start,this.end);
		}
		return this.representation;
	}
	,__class__: tink_parse__$StringSlice_Data
};
var tink_parse__$StringSlice_StringSlice_$Impl_$ = {};
$hxClasses["tink.parse._StringSlice.StringSlice_Impl_"] = tink_parse__$StringSlice_StringSlice_$Impl_$;
tink_parse__$StringSlice_StringSlice_$Impl_$.__name__ = ["tink","parse","_StringSlice","StringSlice_Impl_"];
tink_parse__$StringSlice_StringSlice_$Impl_$._new = function(string,start,end) {
	var this1 = new tink_parse__$StringSlice_Data(string,start == string.length ? start : start < 0 ? start % string.length + string.length : start % string.length,end == string.length ? end : end < 0 ? end % string.length + string.length : end % string.length);
	return this1;
};
tink_parse__$StringSlice_StringSlice_$Impl_$.clamp = function(this1,index) {
	if(index < 0) {
		if(-index > this1.length) {
			return 0;
		} else {
			return index + this1.length;
		}
	} else if(index > this1.length) {
		return this1.length;
	} else {
		return index;
	}
};
tink_parse__$StringSlice_StringSlice_$Impl_$.wrap = function(this1,index) {
	if(this1.length == 0) {
		return 0;
	} else if(index < 0) {
		return index % this1.length + this1.length;
	} else {
		return index % this1.length;
	}
};
tink_parse__$StringSlice_StringSlice_$Impl_$.ofString = function(s) {
	if(s == null || s == "") {
		return tink_parse__$StringSlice_StringSlice_$Impl_$.EMPTY;
	} else if(s.length == 1) {
		var _g = s.charCodeAt(0);
		var ascii = _g;
		if(ascii < tink_parse__$StringSlice_StringSlice_$Impl_$.CHARS.length) {
			return tink_parse__$StringSlice_StringSlice_$Impl_$.CHARS[ascii];
		} else {
			return new tink_parse__$StringSlice_Data(s,0,s.length);
		}
	} else {
		return new tink_parse__$StringSlice_Data(s,0,s.length);
	}
};
tink_parse__$StringSlice_StringSlice_$Impl_$.hasSub = function(this1,other,at) {
	if(at == null) {
		at = 0;
	}
	at = tink_parse__$StringSlice_StringSlice_$Impl_$.wrap(this1,at);
	if(at + other.length > this1.length) {
		return false;
	}
	var a = this1;
	var b = other;
	return tink_parse__$StringSlice_StringSlice_$Impl_$.isEqual(a.string,a.start + at,other.length,b.string,b.start,b.length);
};
tink_parse__$StringSlice_StringSlice_$Impl_$.isEqual = function(s1,p1,l1,s2,p2,l2) {
	if(l2 != l1) {
		return false;
	}
	var _g1 = 0;
	var _g = l2;
	while(_g1 < _g) {
		var i = _g1++;
		if(s1.charCodeAt(p1 + i) != s2.charCodeAt(p2 + i)) {
			return false;
		}
	}
	return true;
};
var tink_querystring__$Builder_DefaultBuffer_$Impl_$ = {};
$hxClasses["tink.querystring._Builder.DefaultBuffer_Impl_"] = tink_querystring__$Builder_DefaultBuffer_$Impl_$;
tink_querystring__$Builder_DefaultBuffer_$Impl_$.__name__ = ["tink","querystring","_Builder","DefaultBuffer_Impl_"];
tink_querystring__$Builder_DefaultBuffer_$Impl_$.flush = function(this1) {
	return this1.join("&");
};
var tink_querystring_Builder0 = function() {
};
$hxClasses["tink.querystring.Builder0"] = tink_querystring_Builder0;
tink_querystring_Builder0.__name__ = ["tink","querystring","Builder0"];
tink_querystring_Builder0.prototype = {
	stringify: function(data) {
		var prefix = "";
		var this1 = [];
		var this2 = this1;
		var buffer = this2;
		this.parse0(prefix,buffer,data);
		return tink_querystring__$Builder_DefaultBuffer_$Impl_$.flush(buffer);
	}
	,parse0: function(prefix,buffer,data) {
		var prefix1;
		if(prefix == "") {
			prefix1 = "access_token";
		} else {
			var v = prefix;
			prefix1 = v + ".access_token";
		}
		var data1 = data.access_token;
		buffer.push(tink_url__$Portion_Portion_$Impl_$.ofString(prefix1) + "=" + tink_url__$Portion_Portion_$Impl_$.ofString(data1));
		var prefix2;
		if(prefix == "") {
			prefix2 = "expires_in";
		} else {
			var v1 = prefix;
			prefix2 = v1 + ".expires_in";
		}
		var data2 = data.expires_in;
		buffer.push(tink_url__$Portion_Portion_$Impl_$.ofString(prefix2) + "=" + tink_url__$Portion_Portion_$Impl_$.ofString(data2 == null ? "null" : "" + data2));
		var prefix3;
		if(prefix == "") {
			prefix3 = "id_token";
		} else {
			var v2 = prefix;
			prefix3 = v2 + ".id_token";
		}
		var data3 = data.id_token;
		buffer.push(tink_url__$Portion_Portion_$Impl_$.ofString(prefix3) + "=" + tink_url__$Portion_Portion_$Impl_$.ofString(data3));
		var prefix4;
		if(prefix == "") {
			prefix4 = "refresh_token";
		} else {
			var v3 = prefix;
			prefix4 = v3 + ".refresh_token";
		}
		var data4 = data.refresh_token;
		if(data4 != null) {
			buffer.push(tink_url__$Portion_Portion_$Impl_$.ofString(prefix4) + "=" + tink_url__$Portion_Portion_$Impl_$.ofString(data4));
		}
		var prefix5;
		if(prefix == "") {
			prefix5 = "token_type";
		} else {
			var v4 = prefix;
			prefix5 = v4 + ".token_type";
		}
		var data5 = data.token_type;
		buffer.push(tink_url__$Portion_Portion_$Impl_$.ofString(prefix5) + "=" + tink_url__$Portion_Portion_$Impl_$.ofString(data5));
	}
	,__class__: tink_querystring_Builder0
};
var tink_querystring_ParserBase = function(onError,pos) {
	this.pos = pos;
	var tmp;
	if(onError == null) {
		tmp = $bind(this,this.abort);
	} else {
		var v = onError;
		tmp = v;
	}
	this.onError = tmp;
};
$hxClasses["tink.querystring.ParserBase"] = tink_querystring_ParserBase;
tink_querystring_ParserBase.__name__ = ["tink","querystring","ParserBase"];
tink_querystring_ParserBase.prototype = {
	init: function(input,name,value) {
		this.params = new haxe_ds_StringMap();
		this.exists = new haxe_ds_StringMap();
		if(input != null) {
			var pair = input;
			while(pair.hasNext()) {
				var pair1 = pair.next();
				var name1 = name(pair1);
				var this1 = this.params;
				var v = value(pair1);
				var _this = this1;
				if(__map_reserved[name1] != null) {
					_this.setReserved(name1,v);
				} else {
					_this.h[name1] = v;
				}
				var end = name1.length;
				while(end > 0) {
					name1 = name1.substring(0,end);
					var _this1 = this.exists;
					if(__map_reserved[name1] != null ? _this1.getReserved(name1) : _this1.h[name1]) {
						break;
					}
					var _this2 = this.exists;
					if(__map_reserved[name1] != null) {
						_this2.setReserved(name1,true);
					} else {
						_this2.h[name1] = true;
					}
					var _g = name1.lastIndexOf(".",end - 1);
					var _g1 = name1.lastIndexOf("[",end - 1);
					var b = _g;
					var a = _g1;
					if(a > b) {
						end = a;
					} else {
						var b1 = _g;
						end = b1;
					}
				}
			}
		}
	}
	,abort: function(e) {
		throw new js__$Boot_HaxeError(this.error("" + e.reason + " for " + e.name));
	}
	,parse: function(input) {
		throw new js__$Boot_HaxeError(tink_core_TypedError.withData(501,"not implemented",this.pos,{ fileName : "tink/querystring/Parser.hx", lineNumber : 58, className : "tink.querystring.ParserBase", methodName : "parse"}));
	}
	,tryParse: function(input) {
		try {
			return tink_core_Outcome.Success(this.parse(input));
		} catch( e ) {
			var e1 = (e instanceof js__$Boot_HaxeError) ? e.val : e;
			if((e1 instanceof tink_core_TypedError)) {
				return tink_core_Outcome.Failure(e1);
			} else {
				return tink_core_Outcome.Failure(this.error("Parse Error",e1));
			}
		}
	}
	,attempt: function(field,o) {
		switch(o[1]) {
		case 0:
			var v = o[2];
			return v;
		case 1:
			var e = o[2];
			return this.fail(field,e.message);
		}
	}
	,error: function(reason,data) {
		return tink_core_TypedError.withData(422,reason,data,this.pos);
	}
	,fail: function(field,reason) {
		tink_core__$Callback_Callback_$Impl_$.invoke(this.onError,{ name : field, reason : reason});
		return null;
	}
	,missing: function(name) {
		return this.fail(name,"Missing value");
	}
	,__class__: tink_querystring_ParserBase
};
var tink_querystring_Parser0 = function(onError,pos) {
	tink_querystring_ParserBase.call(this,onError,pos);
};
$hxClasses["tink.querystring.Parser0"] = tink_querystring_Parser0;
tink_querystring_Parser0.__name__ = ["tink","querystring","Parser0"];
tink_querystring_Parser0.__super__ = tink_querystring_ParserBase;
tink_querystring_Parser0.prototype = $extend(tink_querystring_ParserBase.prototype,{
	getName: function(p) {
		return p.name;
	}
	,getValue: function(p) {
		return p.value;
	}
	,parse: function(input) {
		var prefix = "";
		this.init(input,$bind(this,this.getName),$bind(this,this.getValue));
		return this.parse0(prefix);
	}
	,parse0: function(prefix) {
		var prefix1;
		if(prefix == "") {
			prefix1 = "access_token";
		} else {
			var v = prefix;
			prefix1 = v + ".access_token";
		}
		var __o;
		var _this = this.exists;
		if(__map_reserved[prefix1] != null ? _this.getReserved(prefix1) : _this.h[prefix1]) {
			var _this1 = this.params;
			__o = tink_url__$Portion_Portion_$Impl_$.stringly(__map_reserved[prefix1] != null ? _this1.getReserved(prefix1) : _this1.h[prefix1]);
		} else {
			__o = this.missing(prefix1);
		}
		var prefix2;
		if(prefix == "") {
			prefix2 = "expires_in";
		} else {
			var v1 = prefix;
			prefix2 = v1 + ".expires_in";
		}
		var __o1;
		var _this2 = this.exists;
		if(__map_reserved[prefix2] != null ? _this2.getReserved(prefix2) : _this2.h[prefix2]) {
			var _this3 = this.params;
			__o1 = tink_url__$Portion_Portion_$Impl_$.stringly(__map_reserved[prefix2] != null ? _this3.getReserved(prefix2) : _this3.h[prefix2]);
		} else {
			__o1 = this.missing(prefix2);
		}
		var __o2 = this.attempt(prefix2,tink__$Stringly_Stringly_$Impl_$.parseInt(__o1));
		var prefix3;
		if(prefix == "") {
			prefix3 = "id_token";
		} else {
			var v2 = prefix;
			prefix3 = v2 + ".id_token";
		}
		var __o3;
		var _this4 = this.exists;
		if(__map_reserved[prefix3] != null ? _this4.getReserved(prefix3) : _this4.h[prefix3]) {
			var _this5 = this.params;
			__o3 = tink_url__$Portion_Portion_$Impl_$.stringly(__map_reserved[prefix3] != null ? _this5.getReserved(prefix3) : _this5.h[prefix3]);
		} else {
			__o3 = this.missing(prefix3);
		}
		var prefix4;
		if(prefix == "") {
			prefix4 = "refresh_token";
		} else {
			var v3 = prefix;
			prefix4 = v3 + ".refresh_token";
		}
		var __o4;
		var _this6 = this.exists;
		if(__map_reserved[prefix4] != null ? _this6.getReserved(prefix4) : _this6.h[prefix4]) {
			var _this7 = this.exists;
			if(__map_reserved[prefix4] != null ? _this7.getReserved(prefix4) : _this7.h[prefix4]) {
				var _this8 = this.exists;
				if(__map_reserved[prefix4] != null ? _this8.getReserved(prefix4) : _this8.h[prefix4]) {
					var _this9 = this.params;
					__o4 = tink_url__$Portion_Portion_$Impl_$.stringly(__map_reserved[prefix4] != null ? _this9.getReserved(prefix4) : _this9.h[prefix4]);
				} else {
					__o4 = this.missing(prefix4);
				}
			} else {
				__o4 = null;
			}
		} else {
			__o4 = null;
		}
		var prefix5;
		if(prefix == "") {
			prefix5 = "token_type";
		} else {
			var v4 = prefix;
			prefix5 = v4 + ".token_type";
		}
		var __o5;
		var _this10 = this.exists;
		if(__map_reserved[prefix5] != null ? _this10.getReserved(prefix5) : _this10.h[prefix5]) {
			var _this11 = this.params;
			__o5 = tink_url__$Portion_Portion_$Impl_$.stringly(__map_reserved[prefix5] != null ? _this11.getReserved(prefix5) : _this11.h[prefix5]);
		} else {
			__o5 = this.missing(prefix5);
		}
		var __o6 = { access_token : __o, expires_in : __o2, id_token : __o3, refresh_token : __o4, token_type : __o5};
		return __o6;
	}
	,__class__: tink_querystring_Parser0
});
var tink_semver_Bound = $hxClasses["tink.semver.Bound"] = { __ename__ : ["tink","semver","Bound"], __constructs__ : ["Unbounded","Exlusive","Inclusive"] };
tink_semver_Bound.Unbounded = ["Unbounded",0];
tink_semver_Bound.Unbounded.toString = $estr;
tink_semver_Bound.Unbounded.__enum__ = tink_semver_Bound;
tink_semver_Bound.Exlusive = function(limit) { var $x = ["Exlusive",1,limit]; $x.__enum__ = tink_semver_Bound; $x.toString = $estr; return $x; };
tink_semver_Bound.Inclusive = function(limit) { var $x = ["Inclusive",2,limit]; $x.__enum__ = tink_semver_Bound; $x.toString = $estr; return $x; };
var tink_semver_BoundTools = function() { };
$hxClasses["tink.semver.BoundTools"] = tink_semver_BoundTools;
tink_semver_BoundTools.__name__ = ["tink","semver","BoundTools"];
tink_semver_BoundTools.isLowerThan = function(a,b) {
	switch(a[1]) {
	case 1:
		switch(b[1]) {
		case 1:
			var a1 = a[2];
			var b1 = b[2];
			if(tink_semver__$Version_Version_$Impl_$.eq(a1,b1)) {
				return false;
			} else {
				var a2 = a[2];
				var b2 = b[2];
				if(tink_semver__$Version_Version_$Impl_$.gt(a2,b2)) {
					return false;
				} else {
					return true;
				}
			}
			break;
		case 2:
			var a3 = a[2];
			var b3 = b[2];
			if(tink_semver__$Version_Version_$Impl_$.gt(a3,b3)) {
				return false;
			} else {
				return true;
			}
			break;
		default:
			return true;
		}
		break;
	case 2:
		switch(b[1]) {
		case 1:
			var a4 = a[2];
			var b4 = b[2];
			if(tink_semver__$Version_Version_$Impl_$.eq(a4,b4)) {
				return false;
			} else {
				var a5 = a[2];
				var b5 = b[2];
				if(tink_semver__$Version_Version_$Impl_$.gt(a5,b5)) {
					return false;
				} else {
					return true;
				}
			}
			break;
		case 2:
			var a6 = a[2];
			var b6 = b[2];
			if(tink_semver__$Version_Version_$Impl_$.gt(a6,b6)) {
				return false;
			} else {
				return true;
			}
			break;
		default:
			return true;
		}
		break;
	default:
		return true;
	}
};
tink_semver_BoundTools.min = function(a,b,kind) {
	switch(a[1]) {
	case 0:
		var v = b;
		if(kind == tink_semver_ExtremumKind.Lower) {
			return tink_semver_Bound.Unbounded;
		} else {
			return v;
		}
		break;
	case 1:
		switch(b[1]) {
		case 0:
			var v1 = a;
			if(kind == tink_semver_ExtremumKind.Lower) {
				return tink_semver_Bound.Unbounded;
			} else {
				return v1;
			}
			break;
		case 1:
			var x = a[2];
			var y = b[2];
			if(tink_semver__$Version_Version_$Impl_$.lt(x,y)) {
				return a;
			} else {
				return b;
			}
			break;
		case 2:
			var x1 = a[2];
			var y1 = b[2];
			if(tink_semver__$Version_Version_$Impl_$.eq(x1,y1)) {
				if(kind == tink_semver_ExtremumKind.Lower) {
					return b;
				} else {
					return a;
				}
			} else {
				var x2 = a[2];
				var y2 = b[2];
				if(tink_semver__$Version_Version_$Impl_$.lt(x2,y2)) {
					return a;
				} else {
					return b;
				}
			}
			break;
		}
		break;
	case 2:
		switch(b[1]) {
		case 0:
			var v2 = a;
			if(kind == tink_semver_ExtremumKind.Lower) {
				return tink_semver_Bound.Unbounded;
			} else {
				return v2;
			}
			break;
		case 1:
			var y3 = a[2];
			var x3 = b[2];
			if(tink_semver__$Version_Version_$Impl_$.eq(x3,y3)) {
				if(kind == tink_semver_ExtremumKind.Lower) {
					return a;
				} else {
					return b;
				}
			} else {
				var x4 = a[2];
				var y4 = b[2];
				if(tink_semver__$Version_Version_$Impl_$.lt(x4,y4)) {
					return a;
				} else {
					return b;
				}
			}
			break;
		case 2:
			var x5 = a[2];
			var y5 = b[2];
			if(tink_semver__$Version_Version_$Impl_$.lt(x5,y5)) {
				return a;
			} else {
				return b;
			}
			break;
		}
		break;
	}
};
tink_semver_BoundTools.max = function(a,b,kind) {
	switch(a[1]) {
	case 0:
		var v = b;
		if(kind == tink_semver_ExtremumKind.Upper) {
			return tink_semver_Bound.Unbounded;
		} else {
			return v;
		}
		break;
	case 1:
		switch(b[1]) {
		case 0:
			var v1 = a;
			if(kind == tink_semver_ExtremumKind.Upper) {
				return tink_semver_Bound.Unbounded;
			} else {
				return v1;
			}
			break;
		case 1:
			var x = a[2];
			var y = b[2];
			if(tink_semver__$Version_Version_$Impl_$.gt(x,y)) {
				return a;
			} else {
				return b;
			}
			break;
		case 2:
			var x1 = a[2];
			var y1 = b[2];
			if(tink_semver__$Version_Version_$Impl_$.eq(x1,y1)) {
				if(kind == tink_semver_ExtremumKind.Upper) {
					return b;
				} else {
					return a;
				}
			} else {
				var x2 = a[2];
				var y2 = b[2];
				if(tink_semver__$Version_Version_$Impl_$.gt(x2,y2)) {
					return a;
				} else {
					return b;
				}
			}
			break;
		}
		break;
	case 2:
		switch(b[1]) {
		case 0:
			var v2 = a;
			if(kind == tink_semver_ExtremumKind.Upper) {
				return tink_semver_Bound.Unbounded;
			} else {
				return v2;
			}
			break;
		case 1:
			var y3 = a[2];
			var x3 = b[2];
			if(tink_semver__$Version_Version_$Impl_$.eq(x3,y3)) {
				if(kind == tink_semver_ExtremumKind.Upper) {
					return a;
				} else {
					return b;
				}
			} else {
				var x4 = a[2];
				var y4 = b[2];
				if(tink_semver__$Version_Version_$Impl_$.gt(x4,y4)) {
					return a;
				} else {
					return b;
				}
			}
			break;
		case 2:
			var x5 = a[2];
			var y5 = b[2];
			if(tink_semver__$Version_Version_$Impl_$.gt(x5,y5)) {
				return a;
			} else {
				return b;
			}
			break;
		}
		break;
	}
};
var tink_semver_ExtremumKind = $hxClasses["tink.semver.ExtremumKind"] = { __ename__ : ["tink","semver","ExtremumKind"], __constructs__ : ["Upper","Lower"] };
tink_semver_ExtremumKind.Upper = ["Upper",0];
tink_semver_ExtremumKind.Upper.toString = $estr;
tink_semver_ExtremumKind.Upper.__enum__ = tink_semver_ExtremumKind;
tink_semver_ExtremumKind.Lower = ["Lower",1];
tink_semver_ExtremumKind.Lower.toString = $estr;
tink_semver_ExtremumKind.Lower.__enum__ = tink_semver_ExtremumKind;
var tink_semver__$Constraint_Constraint_$Impl_$ = {};
$hxClasses["tink.semver._Constraint.Constraint_Impl_"] = tink_semver__$Constraint_Constraint_$Impl_$;
tink_semver__$Constraint_Constraint_$Impl_$.__name__ = ["tink","semver","_Constraint","Constraint_Impl_"];
tink_semver__$Constraint_Constraint_$Impl_$.parse = function(s) {
	if(s == null) {
		return tink_core_Outcome.Success(tink_semver__$Constraint_Constraint_$Impl_$.WILDCARD);
	} else if(s == "") {
		return tink_core_Outcome.Success(tink_semver__$Constraint_Constraint_$Impl_$.WILDCARD);
	} else {
		return tink_core_TypedError.catchExceptions(($_=new tink_semver_Parser(tink_parse__$StringSlice_StringSlice_$Impl_$.ofString(s)),$bind($_,$_.parseConstraint)),null,{ fileName : "tink/semver/Constraint.hx", lineNumber : 23, className : "tink.semver._Constraint.Constraint_Impl_", methodName : "parse"});
	}
};
tink_semver__$Constraint_Constraint_$Impl_$.create = function(ranges) {
	var merged = [];
	var _g = 0;
	while(_g < ranges.length) {
		var r = ranges[_g];
		++_g;
		var _g1 = tink_semver_RangeTools.nonEmpty(r);
		switch(_g1[1]) {
		case 0:
			var nu = _g1[2];
			var next = [];
			var _g11 = 0;
			while(_g11 < merged.length) {
				var old = merged[_g11];
				++_g11;
				var _g2 = tink_semver_RangeTools.merge(old,nu);
				switch(_g2[1]) {
				case 0:
					var v = _g2[2];
					nu = v;
					break;
				case 1:
					next.push(old);
					break;
				}
			}
			next.push(nu);
			merged = next;
			break;
		case 1:
			break;
		}
	}
	var this1 = merged;
	return this1;
};
tink_semver__$Constraint_Constraint_$Impl_$.exact = function(version) {
	var this1 = [{ min : tink_semver_Bound.Inclusive(version), max : tink_semver_Bound.Inclusive(version)}];
	return this1;
};
tink_semver__$Constraint_Constraint_$Impl_$.range = function(min,max) {
	var o = tink_semver_RangeTools.nonEmpty({ min : tink_semver_Bound.Inclusive(min), max : tink_semver_Bound.Exlusive(max)});
	var v;
	if(o[1] == 0) {
		var v1 = o[2];
		v = [v1];
	} else {
		v = [];
	}
	var this1 = v;
	return this1;
};
tink_semver__$Constraint_Constraint_$Impl_$.fromString = function(v) {
	return tink_core_OutcomeTools.sure(tink_semver__$Constraint_Constraint_$Impl_$.parse(v));
};
tink_semver__$Constraint_Constraint_$Impl_$.toString = function(this1) {
	if(this1 == null) {
		return "*";
	} else if(this1.length == 0) {
		return "<0.0.0";
	} else {
		var _g = [];
		var _g1 = 0;
		while(_g1 < this1.length) {
			var r = this1[_g1];
			++_g1;
			_g.push(tink_semver_RangeTools.toString(r));
		}
		return _g.join(" || ");
	}
};
tink_semver__$Constraint_Constraint_$Impl_$.fromRange = function(r) {
	return tink_semver__$Constraint_Constraint_$Impl_$.create([r]);
};
tink_semver__$Constraint_Constraint_$Impl_$.ofVersion = function(v) {
	if(v.preview == null) {
		if(v.major == 0) {
			return tink_semver__$Constraint_Constraint_$Impl_$.exact(v);
		} else {
			return tink_semver__$Version_Version_$Impl_$.range(v,tink_semver__$Version_Version_$Impl_$.nextMajor(v));
		}
	} else {
		switch(v.preview) {
		case "alpha":case "beta":case "rc":
			return tink_semver__$Constraint_Constraint_$Impl_$.exact(v);
		default:
			if(v.major == 0) {
				return tink_semver__$Constraint_Constraint_$Impl_$.exact(v);
			} else {
				return tink_semver__$Version_Version_$Impl_$.range(v,tink_semver__$Version_Version_$Impl_$.nextMajor(v));
			}
		}
	}
};
tink_semver__$Constraint_Constraint_$Impl_$.or = function(a,b) {
	if(a == null) {
		return null;
	} else if(b == null) {
		return null;
	} else {
		return tink_semver__$Constraint_Constraint_$Impl_$.create(a.concat(b));
	}
};
tink_semver__$Constraint_Constraint_$Impl_$.and = function(a,b) {
	if(a == null) {
		return b;
	} else if(b == null) {
		return a;
	} else {
		var ret = [];
		var a1 = HxOverrides.iter(a);
		while(a1.hasNext()) {
			var a2 = a1.next();
			var res = a2;
			var b1 = HxOverrides.iter(b);
			_hx_loop2: while(b1.hasNext()) {
				var b2 = b1.next();
				var _g = tink_semver_RangeTools.intersect(res,b2);
				switch(_g[1]) {
				case 0:
					var c = _g[2];
					res = c;
					break;
				case 1:
					res = null;
					break _hx_loop2;
				}
			}
			if(res != null) {
				ret.push(res);
			}
		}
		return tink_semver__$Constraint_Constraint_$Impl_$.create(ret);
	}
};
var tink_semver_Parser = function(source) {
	tink_parse_ParserBase.call(this,source);
};
$hxClasses["tink.semver.Parser"] = tink_semver_Parser;
tink_semver_Parser.__name__ = ["tink","semver","Parser"];
tink_semver_Parser.__super__ = tink_parse_ParserBase;
tink_semver_Parser.prototype = $extend(tink_parse_ParserBase.prototype,{
	doSkipIgnored: function() {
		var cond = tink_parse_Char.WHITE;
		while(true) {
			var tmp;
			if(this.pos < this.max) {
				var this1 = this.source;
				var value = this1.string.charCodeAt(this.pos + this1.start);
				tmp = cond == null || cond(value);
			} else {
				tmp = false;
			}
			if(!tmp) {
				break;
			}
			this.pos++;
		}
	}
	,num: function() {
		var cond = tink_parse_Char.DIGIT;
		this.skipIgnored();
		var start = this.pos;
		while(true) {
			var _g;
			if(this.pos < this.max) {
				var this1 = this.source;
				var value = this1.string.charCodeAt(this.pos + this1.start);
				_g = cond == null || cond(value);
			} else {
				_g = false;
			}
			if(!_g) {
				break;
			}
			this.pos++;
		}
		var this2 = this.source;
		var range_min = start;
		var range_max = this.pos;
		var _g1 = Std.parseInt(tink_parse__$StringSlice_StringSlice_$Impl_$._new(this2.string,tink_parse__$StringSlice_StringSlice_$Impl_$.wrap(this2,range_min) + this2.start,tink_parse__$StringSlice_StringSlice_$Impl_$.clamp(this2,range_max) + this2.start).toString());
		if(_g1 == null) {
			return -1;
		} else {
			var v = _g1;
			return v;
		}
	}
	,lower: function(f) {
		return function(v) {
			return tink_semver__$Constraint_Constraint_$Impl_$.fromRange({ min : f(v), max : tink_semver_Bound.Unbounded});
		};
	}
	,upper: function(f) {
		return function(v) {
			return tink_semver__$Constraint_Constraint_$Impl_$.fromRange({ min : tink_semver_Bound.Unbounded, max : f(v)});
		};
	}
	,parseSimple: function(f) {
		var r = f(this.parseInlineVersion());
		while(true) {
			var cond = function(v) {
				return v == 124;
			};
			this.skipIgnored();
			var tmp;
			if(this.pos < this.max) {
				var this1 = this.source;
				var value = this1.string.charCodeAt(this.pos + this1.start);
				tmp = cond == null || cond(value);
			} else {
				tmp = false;
			}
			if(!(!tmp && this.pos < this.max)) {
				break;
			}
			r = tink_semver__$Constraint_Constraint_$Impl_$.and(r,this.parseSingle());
		}
		return r;
	}
	,parseConstraint: function() {
		var ret = this.parseSingle();
		while(this.allow(tink_semver_Parser.OR)) ret = tink_semver__$Constraint_Constraint_$Impl_$.or(ret,this.parseSingle());
		return ret;
	}
	,carret: function(v) {
		return tink_semver__$Version_Version_$Impl_$.range(v,v.major == 0 ? v.minor == 0 ? tink_semver__$Version_Version_$Impl_$.nextPatch(v) : tink_semver__$Version_Version_$Impl_$.nextMinor(v) : tink_semver__$Version_Version_$Impl_$.nextMajor(v));
	}
	,parseSingle: function() {
		this.skipIgnored();
		if(this.allowHere(tink_parse__$StringSlice_StringSlice_$Impl_$.ofString("*"))) {
			return null;
		} else if(this.allowHere(tink_parse__$StringSlice_StringSlice_$Impl_$.ofString(">="))) {
			return this.parseSimple(this.lower(tink_semver_Bound.Inclusive));
		} else if(this.allowHere(tink_parse__$StringSlice_StringSlice_$Impl_$.ofString(">"))) {
			return this.parseSimple(this.lower(tink_semver_Bound.Exlusive));
		} else if(this.allowHere(tink_parse__$StringSlice_StringSlice_$Impl_$.ofString("<="))) {
			return this.parseSimple(this.upper(tink_semver_Bound.Inclusive));
		} else if(this.allowHere(tink_parse__$StringSlice_StringSlice_$Impl_$.ofString("<"))) {
			return this.parseSimple(this.upper(tink_semver_Bound.Exlusive));
		} else if(this.allowHere(tink_parse__$StringSlice_StringSlice_$Impl_$.ofString("="))) {
			return tink_semver__$Constraint_Constraint_$Impl_$.exact(this.parseInlineVersion());
		} else if(this.allowHere(tink_parse__$StringSlice_StringSlice_$Impl_$.ofString("^"))) {
			return this.parseSimple($bind(this,this.carret));
		} else {
			var p = this.parsePartial();
			if(this.allow(tink_semver_Parser.HYPHEN)) {
				var tmp = tink_semver_Bound.Inclusive(this.full(p));
				var e = this.skipIgnored();
				return tink_semver__$Constraint_Constraint_$Impl_$.fromRange({ min : tmp, max : tink_semver_Bound.Inclusive(this.parseInlineVersion())});
			} else if(p.patch < 0) {
				var v = this.full(p,true);
				return tink_semver__$Version_Version_$Impl_$.range(v,p.minor < 0 ? tink_semver__$Version_Version_$Impl_$.nextMajor(v) : tink_semver__$Version_Version_$Impl_$.nextMinor(v));
			} else {
				return tink_semver__$Constraint_Constraint_$Impl_$.ofVersion(this.full(p));
			}
		}
	}
	,parseVersion: function() {
		var ret = this.parseInlineVersion();
		this.skipIgnored();
		if(this.pos == this.max) {
			return ret;
		} else {
			return this.die("Unexpected string",new IntIterator(this.pos,this.max));
		}
	}
	,parsePartial: function() {
		var _gthis = this;
		var start = this.pos;
		var next = function() {
			if(_gthis.allowHere(tink_parse__$StringSlice_StringSlice_$Impl_$.ofString("."))) {
				return _gthis.num();
			} else {
				return -1;
			}
		};
		var major = this.num();
		var minor = next();
		var patch = next();
		var preview = null;
		var previewNum = -1;
		if(patch >= 0 && this.allowHere(tink_semver_Parser.HYPHEN)) {
			var cond = tink_parse_Char.LOWER;
			this.skipIgnored();
			var start1 = this.pos;
			while(true) {
				var preview1;
				if(this.pos < this.max) {
					var this1 = this.source;
					var value = this1.string.charCodeAt(this.pos + this1.start);
					preview1 = cond == null || cond(value);
				} else {
					preview1 = false;
				}
				if(!preview1) {
					break;
				}
				this.pos++;
			}
			var this2 = this.source;
			var range_min = start1;
			var range_max = this.pos;
			preview = tink_core_OutcomeTools.sure(tink_semver__$Preview_Preview_$Impl_$.ofString(tink_parse__$StringSlice_StringSlice_$Impl_$._new(this2.string,tink_parse__$StringSlice_StringSlice_$Impl_$.wrap(this2,range_min) + this2.start,tink_parse__$StringSlice_StringSlice_$Impl_$.clamp(this2,range_max) + this2.start).toString()));
			if(this.allowHere(tink_semver_Parser.DOT)) {
				previewNum = this.num();
			}
		}
		return { major : major, minor : minor, patch : patch, preview : preview, previewNum : previewNum, pos : new IntIterator(start,this.pos)};
	}
	,clamp: function(i) {
		if(i < 0) {
			return 0;
		} else {
			return i;
		}
	}
	,full: function(p,clamped) {
		if(clamped != true && p.patch < 0) {
			this.die("Partial version not allowed",p.pos);
		}
		var ret = tink_semver__$Version_Version_$Impl_$._new(p.major,this.clamp(p.minor),this.clamp(p.patch));
		if(p.preview != null) {
			return new tink_semver__$Version_Data(ret.major,ret.minor,ret.patch,p.preview,p.previewNum);
		} else {
			return ret;
		}
	}
	,parseInlineVersion: function() {
		return this.full(this.parsePartial());
	}
	,makeError: function(message,pos) {
		var this1 = this.source;
		return new tink_core_TypedError(null,"" + message + " at " + ("\"" + tink_parse__$StringSlice_StringSlice_$Impl_$._new(this1.string,tink_parse__$StringSlice_StringSlice_$Impl_$.wrap(this1,pos.min) + this1.start,tink_parse__$StringSlice_StringSlice_$Impl_$.clamp(this1,pos.max) + this1.start).toString() + "\"(" + pos.min + "-" + pos.max + ")") + (" in \"" + this.source.toString() + "\""),{ fileName : "tink/semver/Parser.hx", lineNumber : 149, className : "tink.semver.Parser", methodName : "makeError"});
	}
	,doMakePos: function(from,to) {
		return new IntIterator(from,to);
	}
	,__class__: tink_semver_Parser
});
var tink_semver__$Preview_Preview_$Impl_$ = {};
$hxClasses["tink.semver._Preview.Preview_Impl_"] = tink_semver__$Preview_Preview_$Impl_$;
tink_semver__$Preview_Preview_$Impl_$.__name__ = ["tink","semver","_Preview","Preview_Impl_"];
tink_semver__$Preview_Preview_$Impl_$.ofString = function(s) {
	switch(s) {
	case "alpha":
		return tink_core_Outcome.Success("alpha");
	case "beta":
		return tink_core_Outcome.Success("beta");
	case "rc":
		return tink_core_Outcome.Success("rc");
	default:
		return tink_core_Outcome.Failure(new tink_core_TypedError(422,"" + s + " should be alpha | beta | rc",{ fileName : "tink/semver/Preview.hx", lineNumber : 14, className : "tink.semver._Preview.Preview_Impl_", methodName : "ofString"}));
	}
};
var tink_semver_RangeTools = function() { };
$hxClasses["tink.semver.RangeTools"] = tink_semver_RangeTools;
tink_semver_RangeTools.__name__ = ["tink","semver","RangeTools"];
tink_semver_RangeTools.toString = function(a) {
	var _g = a.max;
	var _g1 = a.min;
	if(_g1[1] == 2) {
		switch(_g[1]) {
		case 1:
			var min = _g1[2];
			var max = _g[2];
			if(tink_semver__$Version_Version_$Impl_$.eq(tink_semver__$Version_Version_$Impl_$.nextMajor(min),max) && min.major > 0) {
				return "^" + min.toString();
			} else {
				var min1 = _g1[2];
				var max1 = _g[2];
				if(tink_semver__$Version_Version_$Impl_$.eq(tink_semver__$Version_Version_$Impl_$.nextMinor(min1),max1) && min1.major == 0) {
					return "^" + min1.toString();
				} else {
					var _g2 = a.min;
					var tmp;
					switch(_g2[1]) {
					case 0:
						tmp = "";
						break;
					case 1:
						var v = _g2[2];
						tmp = ">" + v.toString();
						break;
					case 2:
						var v1 = _g2[2];
						tmp = ">=" + v1.toString();
						break;
					}
					var tmp1 = tmp + " ";
					var _g11 = a.max;
					var tmp2;
					switch(_g11[1]) {
					case 0:
						tmp2 = "";
						break;
					case 1:
						var v2 = _g11[2];
						tmp2 = "<" + v2.toString();
						break;
					case 2:
						var v3 = _g11[2];
						tmp2 = "<=" + v3.toString();
						break;
					}
					return tmp1 + tmp2;
				}
			}
			break;
		case 2:
			var a1 = _g1[2];
			var b = _g[2];
			if(tink_semver__$Version_Version_$Impl_$.eq(a1,b)) {
				return "=" + a1.toString();
			} else {
				return "" + a1.toString() + " - " + b.toString();
			}
			break;
		default:
			var _g3 = a.min;
			var tmp3;
			switch(_g3[1]) {
			case 0:
				tmp3 = "";
				break;
			case 1:
				var v4 = _g3[2];
				tmp3 = ">" + v4.toString();
				break;
			case 2:
				var v5 = _g3[2];
				tmp3 = ">=" + v5.toString();
				break;
			}
			var tmp4 = tmp3 + " ";
			var _g12 = a.max;
			var tmp5;
			switch(_g12[1]) {
			case 0:
				tmp5 = "";
				break;
			case 1:
				var v6 = _g12[2];
				tmp5 = "<" + v6.toString();
				break;
			case 2:
				var v7 = _g12[2];
				tmp5 = "<=" + v7.toString();
				break;
			}
			return tmp4 + tmp5;
		}
	} else {
		var _g4 = a.min;
		var tmp6;
		switch(_g4[1]) {
		case 0:
			tmp6 = "";
			break;
		case 1:
			var v8 = _g4[2];
			tmp6 = ">" + v8.toString();
			break;
		case 2:
			var v9 = _g4[2];
			tmp6 = ">=" + v9.toString();
			break;
		}
		var tmp7 = tmp6 + " ";
		var _g13 = a.max;
		var tmp8;
		switch(_g13[1]) {
		case 0:
			tmp8 = "";
			break;
		case 1:
			var v10 = _g13[2];
			tmp8 = "<" + v10.toString();
			break;
		case 2:
			var v11 = _g13[2];
			tmp8 = "<=" + v11.toString();
			break;
		}
		return tmp7 + tmp8;
	}
};
tink_semver_RangeTools.merge = function(a,b) {
	switch(a.max[1]) {
	case 1:
		if(b.min[1] == 2) {
			var v1 = a.max[2];
			var min = a.min;
			var max = b.max;
			var v2 = b.min[2];
			if(tink_semver__$Version_Version_$Impl_$.eq(v1,v2)) {
				return haxe_ds_Option.Some({ min : min, max : max});
			} else {
				switch(b.max[1]) {
				case 1:
					if(a.min[1] == 2) {
						var v21 = b.max[2];
						var v11 = a.min[2];
						var max1 = a.max;
						var min1 = b.min;
						if(tink_semver__$Version_Version_$Impl_$.eq(v11,v21)) {
							return haxe_ds_Option.Some({ min : min1, max : max1});
						} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
							return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
						} else {
							return haxe_ds_Option.None;
						}
					} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
						return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
					} else {
						return haxe_ds_Option.None;
					}
					break;
				case 2:
					if(a.min[1] == 1) {
						var v22 = b.max[2];
						var v12 = a.min[2];
						var max2 = a.max;
						var min2 = b.min;
						if(tink_semver__$Version_Version_$Impl_$.eq(v12,v22)) {
							return haxe_ds_Option.Some({ min : min2, max : max2});
						} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
							return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
						} else {
							return haxe_ds_Option.None;
						}
					} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
						return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
					} else {
						return haxe_ds_Option.None;
					}
					break;
				default:
					if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
						return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
					} else {
						return haxe_ds_Option.None;
					}
				}
			}
		} else {
			switch(b.max[1]) {
			case 1:
				if(a.min[1] == 2) {
					var v23 = b.max[2];
					var v13 = a.min[2];
					var max3 = a.max;
					var min3 = b.min;
					if(tink_semver__$Version_Version_$Impl_$.eq(v13,v23)) {
						return haxe_ds_Option.Some({ min : min3, max : max3});
					} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
						return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
					} else {
						return haxe_ds_Option.None;
					}
				} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
					return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
				} else {
					return haxe_ds_Option.None;
				}
				break;
			case 2:
				if(a.min[1] == 1) {
					var v24 = b.max[2];
					var v14 = a.min[2];
					var max4 = a.max;
					var min4 = b.min;
					if(tink_semver__$Version_Version_$Impl_$.eq(v14,v24)) {
						return haxe_ds_Option.Some({ min : min4, max : max4});
					} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
						return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
					} else {
						return haxe_ds_Option.None;
					}
				} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
					return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
				} else {
					return haxe_ds_Option.None;
				}
				break;
			default:
				if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
					return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
				} else {
					return haxe_ds_Option.None;
				}
			}
		}
		break;
	case 2:
		if(b.min[1] == 1) {
			var v15 = a.max[2];
			var min5 = a.min;
			var max5 = b.max;
			var v25 = b.min[2];
			if(tink_semver__$Version_Version_$Impl_$.eq(v15,v25)) {
				return haxe_ds_Option.Some({ min : min5, max : max5});
			} else {
				switch(b.max[1]) {
				case 1:
					if(a.min[1] == 2) {
						var v26 = b.max[2];
						var v16 = a.min[2];
						var max6 = a.max;
						var min6 = b.min;
						if(tink_semver__$Version_Version_$Impl_$.eq(v16,v26)) {
							return haxe_ds_Option.Some({ min : min6, max : max6});
						} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
							return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
						} else {
							return haxe_ds_Option.None;
						}
					} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
						return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
					} else {
						return haxe_ds_Option.None;
					}
					break;
				case 2:
					if(a.min[1] == 1) {
						var v27 = b.max[2];
						var v17 = a.min[2];
						var max7 = a.max;
						var min7 = b.min;
						if(tink_semver__$Version_Version_$Impl_$.eq(v17,v27)) {
							return haxe_ds_Option.Some({ min : min7, max : max7});
						} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
							return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
						} else {
							return haxe_ds_Option.None;
						}
					} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
						return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
					} else {
						return haxe_ds_Option.None;
					}
					break;
				default:
					if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
						return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
					} else {
						return haxe_ds_Option.None;
					}
				}
			}
		} else {
			switch(b.max[1]) {
			case 1:
				if(a.min[1] == 2) {
					var v28 = b.max[2];
					var v18 = a.min[2];
					var max8 = a.max;
					var min8 = b.min;
					if(tink_semver__$Version_Version_$Impl_$.eq(v18,v28)) {
						return haxe_ds_Option.Some({ min : min8, max : max8});
					} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
						return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
					} else {
						return haxe_ds_Option.None;
					}
				} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
					return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
				} else {
					return haxe_ds_Option.None;
				}
				break;
			case 2:
				if(a.min[1] == 1) {
					var v29 = b.max[2];
					var v19 = a.min[2];
					var max9 = a.max;
					var min9 = b.min;
					if(tink_semver__$Version_Version_$Impl_$.eq(v19,v29)) {
						return haxe_ds_Option.Some({ min : min9, max : max9});
					} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
						return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
					} else {
						return haxe_ds_Option.None;
					}
				} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
					return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
				} else {
					return haxe_ds_Option.None;
				}
				break;
			default:
				if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
					return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
				} else {
					return haxe_ds_Option.None;
				}
			}
		}
		break;
	default:
		switch(a.min[1]) {
		case 1:
			if(b.max[1] == 2) {
				var v110 = a.min[2];
				var min10 = b.min;
				var v210 = b.max[2];
				var max10 = a.max;
				if(tink_semver__$Version_Version_$Impl_$.eq(v110,v210)) {
					return haxe_ds_Option.Some({ min : min10, max : max10});
				} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
					return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
				} else {
					return haxe_ds_Option.None;
				}
			} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
				return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
			} else {
				return haxe_ds_Option.None;
			}
			break;
		case 2:
			if(b.max[1] == 1) {
				var v111 = a.min[2];
				var min11 = b.min;
				var v211 = b.max[2];
				var max11 = a.max;
				if(tink_semver__$Version_Version_$Impl_$.eq(v111,v211)) {
					return haxe_ds_Option.Some({ min : min11, max : max11});
				} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
					return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
				} else {
					return haxe_ds_Option.None;
				}
			} else if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
				return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
			} else {
				return haxe_ds_Option.None;
			}
			break;
		default:
			if(tink_semver_RangeTools.intersect(a,b) != haxe_ds_Option.None) {
				return haxe_ds_Option.Some({ min : tink_semver_BoundTools.min(a.min,b.min,tink_semver_ExtremumKind.Lower), max : tink_semver_BoundTools.max(a.max,b.max,tink_semver_ExtremumKind.Upper)});
			} else {
				return haxe_ds_Option.None;
			}
		}
	}
};
tink_semver_RangeTools.nonEmpty = function(r) {
	if(tink_semver_BoundTools.isLowerThan(r.min,r.max)) {
		return haxe_ds_Option.Some(r);
	} else {
		return haxe_ds_Option.None;
	}
};
tink_semver_RangeTools.intersect = function(a,b) {
	var min = tink_semver_BoundTools.max(a.min,b.min,tink_semver_ExtremumKind.Lower);
	var max = tink_semver_BoundTools.min(a.max,b.max,tink_semver_ExtremumKind.Upper);
	return tink_semver_RangeTools.nonEmpty({ min : min, max : max});
};
var tink_semver__$Version_Version_$Impl_$ = {};
$hxClasses["tink.semver._Version.Version_Impl_"] = tink_semver__$Version_Version_$Impl_$;
tink_semver__$Version_Version_$Impl_$.__name__ = ["tink","semver","_Version","Version_Impl_"];
tink_semver__$Version_Version_$Impl_$._new = function(major,minor,patch) {
	if(patch == null) {
		patch = 0;
	}
	if(minor == null) {
		minor = 0;
	}
	var this1 = new tink_semver__$Version_Data(major,minor,patch);
	return this1;
};
tink_semver__$Version_Version_$Impl_$.nextMajor = function(this1) {
	return new tink_semver__$Version_Data(this1.major + 1,0,0);
};
tink_semver__$Version_Version_$Impl_$.nextMinor = function(this1) {
	return new tink_semver__$Version_Data(this1.major,this1.minor + 1,0);
};
tink_semver__$Version_Version_$Impl_$.nextPatch = function(this1) {
	return new tink_semver__$Version_Data(this1.major,this1.minor,this1.patch + 1);
};
tink_semver__$Version_Version_$Impl_$.compare = function(this1,that) {
	var i = this1.major - that.major;
	var i1 = this1.minor - that.minor;
	var tmp = tink_semver__$Version_Comparison_$Impl_$.chain(i > 0 ? 1 : i < 0 ? -1 : 0,i1 > 0 ? 1 : i1 < 0 ? -1 : 0);
	var i2 = this1.patch - that.patch;
	var tmp1 = tink_semver__$Version_Comparison_$Impl_$.chain(tmp,i2 > 0 ? 1 : i2 < 0 ? -1 : 0);
	var i3 = tink_semver__$Version_Version_$Impl_$.idx(this1,this1.preview) - tink_semver__$Version_Version_$Impl_$.idx(this1,that.preview);
	var tmp2 = tink_semver__$Version_Comparison_$Impl_$.chain(tmp1,i3 > 0 ? 1 : i3 < 0 ? -1 : 0);
	var i4 = this1.previewNum - that.previewNum;
	return tink_semver__$Version_Comparison_$Impl_$.chain(tmp2,i4 > 0 ? 1 : i4 < 0 ? -1 : 0);
};
tink_semver__$Version_Version_$Impl_$.idx = function(this1,p) {
	if(p == null) {
		return 100;
	} else {
		switch(p) {
		case "alpha":
			return 1;
		case "beta":
			return 2;
		case "rc":
			return 3;
		}
	}
};
tink_semver__$Version_Version_$Impl_$.eq = function(a,b) {
	return tink_semver__$Version_Version_$Impl_$.compare(a,b) == 0;
};
tink_semver__$Version_Version_$Impl_$.gt = function(a,b) {
	return tink_semver__$Version_Version_$Impl_$.compare(a,b) == 1;
};
tink_semver__$Version_Version_$Impl_$.lt = function(a,b) {
	return tink_semver__$Version_Version_$Impl_$.compare(a,b) == -1;
};
tink_semver__$Version_Version_$Impl_$.range = function(a,b) {
	return tink_semver__$Constraint_Constraint_$Impl_$.range(a,b);
};
tink_semver__$Version_Version_$Impl_$.parse = function(s) {
	return tink_core_TypedError.catchExceptions(($_=new tink_semver_Parser(tink_parse__$StringSlice_StringSlice_$Impl_$.ofString(s)),$bind($_,$_.parseVersion)),tink_semver__$Version_Version_$Impl_$.reportError,{ fileName : "tink/semver/Version.hx", lineNumber : 97, className : "tink.semver._Version.Version_Impl_", methodName : "parse"});
};
tink_semver__$Version_Version_$Impl_$.reportError = function(d) {
	if(typeof(d) == "string") {
		return new tink_core_TypedError(422,d,{ fileName : "tink/semver/Version.hx", lineNumber : 103, className : "tink.semver._Version.Version_Impl_", methodName : "reportError"});
	} else {
		return tink_core_TypedError.withData(422,Std.string(d),d,{ fileName : "tink/semver/Version.hx", lineNumber : 105, className : "tink.semver._Version.Version_Impl_", methodName : "reportError"});
	}
};
var tink_semver__$Version_Data = function(major,minor,patch,preview,previewNum) {
	if(previewNum == null) {
		previewNum = -1;
	}
	if(major < 0 || minor < 0 || patch < 0) {
		throw new js__$Boot_HaxeError("version components must not be negative");
	}
	this.major = major;
	this.minor = minor;
	this.patch = patch;
	this.preview = preview;
	this.previewNum = previewNum;
};
$hxClasses["tink.semver._Version.Data"] = tink_semver__$Version_Data;
tink_semver__$Version_Data.__name__ = ["tink","semver","_Version","Data"];
tink_semver__$Version_Data.prototype = {
	toString: function() {
		var ret = "" + this.major + "." + this.minor + "." + this.patch;
		if(this.preview != null) {
			ret += "-" + this.preview;
			if(this.previewNum != -1) {
				ret += "." + this.previewNum;
			}
		}
		return ret;
	}
	,__class__: tink_semver__$Version_Data
};
var tink_semver__$Version_Comparison_$Impl_$ = {};
$hxClasses["tink.semver._Version.Comparison_Impl_"] = tink_semver__$Version_Comparison_$Impl_$;
tink_semver__$Version_Comparison_$Impl_$.__name__ = ["tink","semver","_Version","Comparison_Impl_"];
tink_semver__$Version_Comparison_$Impl_$.chain = function(a,b) {
	if(a == 0) {
		return b;
	} else {
		return a;
	}
};
var tink_sql_ExprData = $hxClasses["tink.sql.ExprData"] = { __ename__ : ["tink","sql","ExprData"], __constructs__ : ["EUnOp","EBinOp","EField","ECall","EValue","EQuery"] };
tink_sql_ExprData.EUnOp = function(op,a,postfix) { var $x = ["EUnOp",0,op,a,postfix]; $x.__enum__ = tink_sql_ExprData; $x.toString = $estr; return $x; };
tink_sql_ExprData.EBinOp = function(op,a,b) { var $x = ["EBinOp",1,op,a,b]; $x.__enum__ = tink_sql_ExprData; $x.toString = $estr; return $x; };
tink_sql_ExprData.EField = function(table,name) { var $x = ["EField",2,table,name]; $x.__enum__ = tink_sql_ExprData; $x.toString = $estr; return $x; };
tink_sql_ExprData.ECall = function(name,args) { var $x = ["ECall",3,name,args]; $x.__enum__ = tink_sql_ExprData; $x.toString = $estr; return $x; };
tink_sql_ExprData.EValue = function(value,type) { var $x = ["EValue",4,value,type]; $x.__enum__ = tink_sql_ExprData; $x.toString = $estr; return $x; };
tink_sql_ExprData.EQuery = function(query) { var $x = ["EQuery",5,query]; $x.__enum__ = tink_sql_ExprData; $x.toString = $estr; return $x; };
var tink_sql_ValueType = $hxClasses["tink.sql.ValueType"] = { __ename__ : ["tink","sql","ValueType"], __constructs__ : ["VString","VBool","VFloat","VInt","VArray","VBytes","VDate","VGeometry"] };
tink_sql_ValueType.VString = ["VString",0];
tink_sql_ValueType.VString.toString = $estr;
tink_sql_ValueType.VString.__enum__ = tink_sql_ValueType;
tink_sql_ValueType.VBool = ["VBool",1];
tink_sql_ValueType.VBool.toString = $estr;
tink_sql_ValueType.VBool.__enum__ = tink_sql_ValueType;
tink_sql_ValueType.VFloat = ["VFloat",2];
tink_sql_ValueType.VFloat.toString = $estr;
tink_sql_ValueType.VFloat.__enum__ = tink_sql_ValueType;
tink_sql_ValueType.VInt = ["VInt",3];
tink_sql_ValueType.VInt.toString = $estr;
tink_sql_ValueType.VInt.__enum__ = tink_sql_ValueType;
tink_sql_ValueType.VArray = function(type) { var $x = ["VArray",4,type]; $x.__enum__ = tink_sql_ValueType; $x.toString = $estr; return $x; };
tink_sql_ValueType.VBytes = ["VBytes",5];
tink_sql_ValueType.VBytes.toString = $estr;
tink_sql_ValueType.VBytes.__enum__ = tink_sql_ValueType;
tink_sql_ValueType.VDate = ["VDate",6];
tink_sql_ValueType.VDate.toString = $estr;
tink_sql_ValueType.VDate.__enum__ = tink_sql_ValueType;
tink_sql_ValueType.VGeometry = function(type) { var $x = ["VGeometry",7,type]; $x.__enum__ = tink_sql_ValueType; $x.toString = $estr; return $x; };
var tink_sql_BinOp = $hxClasses["tink.sql.BinOp"] = { __ename__ : ["tink","sql","BinOp"], __constructs__ : ["Add","Subt","Mult","Mod","Div","Greater","Equals","And","Or","Like","In"] };
tink_sql_BinOp.Add = ["Add",0];
tink_sql_BinOp.Add.toString = $estr;
tink_sql_BinOp.Add.__enum__ = tink_sql_BinOp;
tink_sql_BinOp.Subt = ["Subt",1];
tink_sql_BinOp.Subt.toString = $estr;
tink_sql_BinOp.Subt.__enum__ = tink_sql_BinOp;
tink_sql_BinOp.Mult = ["Mult",2];
tink_sql_BinOp.Mult.toString = $estr;
tink_sql_BinOp.Mult.__enum__ = tink_sql_BinOp;
tink_sql_BinOp.Mod = ["Mod",3];
tink_sql_BinOp.Mod.toString = $estr;
tink_sql_BinOp.Mod.__enum__ = tink_sql_BinOp;
tink_sql_BinOp.Div = ["Div",4];
tink_sql_BinOp.Div.toString = $estr;
tink_sql_BinOp.Div.__enum__ = tink_sql_BinOp;
tink_sql_BinOp.Greater = ["Greater",5];
tink_sql_BinOp.Greater.toString = $estr;
tink_sql_BinOp.Greater.__enum__ = tink_sql_BinOp;
tink_sql_BinOp.Equals = ["Equals",6];
tink_sql_BinOp.Equals.toString = $estr;
tink_sql_BinOp.Equals.__enum__ = tink_sql_BinOp;
tink_sql_BinOp.And = ["And",7];
tink_sql_BinOp.And.toString = $estr;
tink_sql_BinOp.And.__enum__ = tink_sql_BinOp;
tink_sql_BinOp.Or = ["Or",8];
tink_sql_BinOp.Or.toString = $estr;
tink_sql_BinOp.Or.__enum__ = tink_sql_BinOp;
tink_sql_BinOp.Like = ["Like",9];
tink_sql_BinOp.Like.toString = $estr;
tink_sql_BinOp.Like.__enum__ = tink_sql_BinOp;
tink_sql_BinOp.In = ["In",10];
tink_sql_BinOp.In.toString = $estr;
tink_sql_BinOp.In.__enum__ = tink_sql_BinOp;
var tink_sql_UnOp = $hxClasses["tink.sql.UnOp"] = { __ename__ : ["tink","sql","UnOp"], __constructs__ : ["Not","IsNull","Neg"] };
tink_sql_UnOp.Not = ["Not",0];
tink_sql_UnOp.Not.toString = $estr;
tink_sql_UnOp.Not.__enum__ = tink_sql_UnOp;
tink_sql_UnOp.IsNull = ["IsNull",1];
tink_sql_UnOp.IsNull.toString = $estr;
tink_sql_UnOp.IsNull.__enum__ = tink_sql_UnOp;
tink_sql_UnOp.Neg = ["Neg",2];
tink_sql_UnOp.Neg.toString = $estr;
tink_sql_UnOp.Neg.__enum__ = tink_sql_UnOp;
var tink_sql_TableInfo = function() { };
$hxClasses["tink.sql.TableInfo"] = tink_sql_TableInfo;
tink_sql_TableInfo.__name__ = ["tink","sql","TableInfo"];
var tink_sql_Key = $hxClasses["tink.sql.Key"] = { __ename__ : ["tink","sql","Key"], __constructs__ : ["Primary","Unique","Index"] };
tink_sql_Key.Primary = function(fields) { var $x = ["Primary",0,fields]; $x.__enum__ = tink_sql_Key; $x.toString = $estr; return $x; };
tink_sql_Key.Unique = function(name,fields) { var $x = ["Unique",1,name,fields]; $x.__enum__ = tink_sql_Key; $x.toString = $estr; return $x; };
tink_sql_Key.Index = function(name,fields) { var $x = ["Index",2,name,fields]; $x.__enum__ = tink_sql_Key; $x.toString = $estr; return $x; };
var tink_sql_Query = $hxClasses["tink.sql.Query"] = { __ename__ : ["tink","sql","Query"], __constructs__ : ["Union","Select","Insert","Update","Delete","CreateTable","DropTable","AlterTable","ShowColumns","ShowIndex"] };
tink_sql_Query.Union = function(union) { var $x = ["Union",0,union]; $x.__enum__ = tink_sql_Query; $x.toString = $estr; return $x; };
tink_sql_Query.Select = function(select) { var $x = ["Select",1,select]; $x.__enum__ = tink_sql_Query; $x.toString = $estr; return $x; };
tink_sql_Query.Insert = function(insert) { var $x = ["Insert",2,insert]; $x.__enum__ = tink_sql_Query; $x.toString = $estr; return $x; };
tink_sql_Query.Update = function(update) { var $x = ["Update",3,update]; $x.__enum__ = tink_sql_Query; $x.toString = $estr; return $x; };
tink_sql_Query.Delete = function($delete) { var $x = ["Delete",4,$delete]; $x.__enum__ = tink_sql_Query; $x.toString = $estr; return $x; };
tink_sql_Query.CreateTable = function(table,ifNotExists) { var $x = ["CreateTable",5,table,ifNotExists]; $x.__enum__ = tink_sql_Query; $x.toString = $estr; return $x; };
tink_sql_Query.DropTable = function(table) { var $x = ["DropTable",6,table]; $x.__enum__ = tink_sql_Query; $x.toString = $estr; return $x; };
tink_sql_Query.AlterTable = function(table,changes) { var $x = ["AlterTable",7,table,changes]; $x.__enum__ = tink_sql_Query; $x.toString = $estr; return $x; };
tink_sql_Query.ShowColumns = function(from) { var $x = ["ShowColumns",8,from]; $x.__enum__ = tink_sql_Query; $x.toString = $estr; return $x; };
tink_sql_Query.ShowIndex = function(from) { var $x = ["ShowIndex",9,from]; $x.__enum__ = tink_sql_Query; $x.toString = $estr; return $x; };
var tink_sql_AlterTableOperation = $hxClasses["tink.sql.AlterTableOperation"] = { __ename__ : ["tink","sql","AlterTableOperation"], __constructs__ : ["AddColumn","AddKey","AlterColumn","DropColumn","DropKey"] };
tink_sql_AlterTableOperation.AddColumn = function(col) { var $x = ["AddColumn",0,col]; $x.__enum__ = tink_sql_AlterTableOperation; $x.toString = $estr; return $x; };
tink_sql_AlterTableOperation.AddKey = function(key) { var $x = ["AddKey",1,key]; $x.__enum__ = tink_sql_AlterTableOperation; $x.toString = $estr; return $x; };
tink_sql_AlterTableOperation.AlterColumn = function(to,from) { var $x = ["AlterColumn",2,to,from]; $x.__enum__ = tink_sql_AlterTableOperation; $x.toString = $estr; return $x; };
tink_sql_AlterTableOperation.DropColumn = function(col) { var $x = ["DropColumn",3,col]; $x.__enum__ = tink_sql_AlterTableOperation; $x.toString = $estr; return $x; };
tink_sql_AlterTableOperation.DropKey = function(key) { var $x = ["DropKey",4,key]; $x.__enum__ = tink_sql_AlterTableOperation; $x.toString = $estr; return $x; };
var tink_streams__$Stream_Stream_$Impl_$ = {};
$hxClasses["tink.streams._Stream.Stream_Impl_"] = tink_streams__$Stream_Stream_$Impl_$;
tink_streams__$Stream_Stream_$Impl_$.__name__ = ["tink","streams","_Stream","Stream_Impl_"];
tink_streams__$Stream_Stream_$Impl_$.dirty = function(this1) {
	return this1;
};
tink_streams__$Stream_Stream_$Impl_$.single = function(i) {
	return new tink_streams_Single(new tink_core__$Lazy_LazyConst(i));
};
tink_streams__$Stream_Stream_$Impl_$.ofIterator = function(i) {
	var next = null;
	next = function(step) {
		step(i.hasNext() ? tink_streams_Step.Link(i.next(),tink_streams_Generator.stream(next)) : tink_streams_Step.End);
	};
	var next1 = next;
	return tink_streams_Generator.stream(next);
};
tink_streams__$Stream_Stream_$Impl_$.flatten = function(f) {
	return new tink_streams_FutureStream(f);
};
tink_streams__$Stream_Stream_$Impl_$.promise = function(f) {
	var ret = f.map(function(o) {
		switch(o[1]) {
		case 0:
			var s = o[2];
			return tink_streams__$Stream_Stream_$Impl_$.dirty(s);
		case 1:
			var e = o[2];
			return tink_streams__$Stream_Stream_$Impl_$.ofError(e);
		}
	});
	return tink_streams__$Stream_Stream_$Impl_$.flatten(ret.gather());
};
tink_streams__$Stream_Stream_$Impl_$.ofError = function(e) {
	return new tink_streams__$Stream_ErrorStream(e);
};
var tink_streams_RegroupStatus = $hxClasses["tink.streams.RegroupStatus"] = { __ename__ : ["tink","streams","RegroupStatus"], __constructs__ : ["Flowing","Errored","Ended"] };
tink_streams_RegroupStatus.Flowing = ["Flowing",0];
tink_streams_RegroupStatus.Flowing.toString = $estr;
tink_streams_RegroupStatus.Flowing.__enum__ = tink_streams_RegroupStatus;
tink_streams_RegroupStatus.Errored = function(e) { var $x = ["Errored",1,e]; $x.__enum__ = tink_streams_RegroupStatus; $x.toString = $estr; return $x; };
tink_streams_RegroupStatus.Ended = ["Ended",2];
tink_streams_RegroupStatus.Ended.toString = $estr;
tink_streams_RegroupStatus.Ended.__enum__ = tink_streams_RegroupStatus;
var tink_streams_RegroupResult = $hxClasses["tink.streams.RegroupResult"] = { __ename__ : ["tink","streams","RegroupResult"], __constructs__ : ["Converted","Terminated","Untouched","Errored"] };
tink_streams_RegroupResult.Converted = function(data) { var $x = ["Converted",0,data]; $x.__enum__ = tink_streams_RegroupResult; $x.toString = $estr; return $x; };
tink_streams_RegroupResult.Terminated = function(data) { var $x = ["Terminated",1,data]; $x.__enum__ = tink_streams_RegroupResult; $x.toString = $estr; return $x; };
tink_streams_RegroupResult.Untouched = ["Untouched",2];
tink_streams_RegroupResult.Untouched.toString = $estr;
tink_streams_RegroupResult.Untouched.__enum__ = tink_streams_RegroupResult;
tink_streams_RegroupResult.Errored = function(e) { var $x = ["Errored",3,e]; $x.__enum__ = tink_streams_RegroupResult; $x.toString = $estr; return $x; };
var tink_streams__$Stream_CompoundStream = function(parts) {
	tink_streams_StreamBase.call(this);
	this.parts = parts;
};
$hxClasses["tink.streams._Stream.CompoundStream"] = tink_streams__$Stream_CompoundStream;
tink_streams__$Stream_CompoundStream.__name__ = ["tink","streams","_Stream","CompoundStream"];
tink_streams__$Stream_CompoundStream.consumeParts = function(parts,handler,cb) {
	if(parts.length == 0) {
		cb(tink_streams_Conclusion.Depleted);
	} else {
		parts[0].forEach(handler).handle(function(o) {
			switch(o[1]) {
			case 0:
				var rest = o[2];
				parts = parts.slice();
				parts[0] = rest;
				var tmp = tink_streams_Conclusion.Halted(new tink_streams__$Stream_CompoundStream(parts));
				cb(tmp);
				break;
			case 1:
				var at = o[3];
				var e = o[2];
				if(at.get_depleted()) {
					parts = parts.slice(1);
				} else {
					parts = parts.slice();
					parts[0] = at;
				}
				var tmp1 = tink_streams_Conclusion.Clogged(e,new tink_streams__$Stream_CompoundStream(parts));
				cb(tmp1);
				break;
			case 2:
				var e1 = o[2];
				cb(tink_streams_Conclusion.Failed(e1));
				break;
			case 3:
				tink_streams__$Stream_CompoundStream.consumeParts(parts.slice(1),handler,cb);
				break;
			}
		});
	}
};
tink_streams__$Stream_CompoundStream.of = function(streams) {
	var ret = [];
	var _g = 0;
	while(_g < streams.length) {
		var s = streams[_g];
		++_g;
		s.decompose(ret);
	}
	if(ret.length == 0) {
		return tink_streams_Empty.inst;
	} else {
		return new tink_streams__$Stream_CompoundStream(ret);
	}
};
tink_streams__$Stream_CompoundStream.__super__ = tink_streams_StreamBase;
tink_streams__$Stream_CompoundStream.prototype = $extend(tink_streams_StreamBase.prototype,{
	get_depleted: function() {
		var _g = this.parts.length;
		switch(_g) {
		case 0:
			return true;
		case 1:
			return this.parts[0].get_depleted();
		default:
			return false;
		}
	}
	,decompose: function(into) {
		var _g = 0;
		var _g1 = this.parts;
		while(_g < _g1.length) {
			var p = _g1[_g];
			++_g;
			p.decompose(into);
		}
	}
	,forEach: function(handler) {
		var parts = this.parts;
		var handler1 = handler;
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			tink_streams__$Stream_CompoundStream.consumeParts(parts,handler1,cb);
		});
	}
	,__class__: tink_streams__$Stream_CompoundStream
});
var tink_streams__$Stream_RegroupStream = function(source,f,prev) {
	if(prev == null) {
		prev = tink_streams_Empty.inst;
	}
	var ret = null;
	var terminated = false;
	var buf = [];
	var ret1 = source.forEach(tink_streams__$Stream_Handler_$Impl_$.ofUnknown(function(item) {
		buf.push(item);
		var ret2 = f.apply(buf,tink_streams_RegroupStatus.Flowing).map(function(o) {
			switch(o[1]) {
			case 0:
				var v = o[2];
				ret = v;
				return tink_streams_Handled.Finish;
			case 1:
				var v1 = o[2];
				var l = new tink_core__$Lazy_LazyFunc(tink_streams_Empty.make);
				if(v1[1] == 0) {
					var v2 = v1[2];
					ret = v2;
				} else {
					ret = l.get();
				}
				terminated = true;
				return tink_streams_Handled.Finish;
			case 2:
				return tink_streams_Handled.Resume;
			case 3:
				var e = o[2];
				return tink_streams_Handled.Clog(e);
			}
		});
		return ret2.gather();
	})).map(function(o1) {
		switch(o1[1]) {
		case 0:
			if(terminated) {
				return ret;
			} else {
				var rest = o1[2];
				return new tink_streams__$Stream_RegroupStream(rest,f,ret);
			}
			break;
		case 1:
			var rest1 = o1[3];
			var e1 = o1[2];
			return new tink_streams__$Stream_CloggedStream(tink_streams__$Stream_Stream_$Impl_$.ofError(e1),rest1);
		case 2:
			var e2 = o1[2];
			return tink_streams__$Stream_Stream_$Impl_$.ofError(e2);
		case 3:
			if(buf.length == 0) {
				return tink_streams_Empty.inst;
			} else {
				var ret3 = f.apply(buf,tink_streams_RegroupStatus.Ended).map(function(o2) {
					switch(o2[1]) {
					case 0:
						var v3 = o2[2];
						return v3;
					case 1:
						var v4 = o2[2];
						var l1 = new tink_core__$Lazy_LazyFunc(tink_streams_Empty.make);
						if(v4[1] == 0) {
							var v5 = v4[2];
							return v5;
						} else {
							return l1.get();
						}
						break;
					case 2:
						return tink_streams_Empty.inst;
					case 3:
						var e3 = o2[2];
						return tink_streams__$Stream_Stream_$Impl_$.ofError(e3);
					}
				});
				return tink_streams__$Stream_Stream_$Impl_$.flatten(ret3.gather());
			}
			break;
		}
	});
	var next = tink_streams__$Stream_Stream_$Impl_$.flatten(ret1.gather());
	tink_streams__$Stream_CompoundStream.call(this,[prev,next]);
};
$hxClasses["tink.streams._Stream.RegroupStream"] = tink_streams__$Stream_RegroupStream;
tink_streams__$Stream_RegroupStream.__name__ = ["tink","streams","_Stream","RegroupStream"];
tink_streams__$Stream_RegroupStream.__super__ = tink_streams__$Stream_CompoundStream;
tink_streams__$Stream_RegroupStream.prototype = $extend(tink_streams__$Stream_CompoundStream.prototype,{
	__class__: tink_streams__$Stream_RegroupStream
});
var tink_streams_Handled = $hxClasses["tink.streams.Handled"] = { __ename__ : ["tink","streams","Handled"], __constructs__ : ["BackOff","Finish","Resume","Clog"] };
tink_streams_Handled.BackOff = ["BackOff",0];
tink_streams_Handled.BackOff.toString = $estr;
tink_streams_Handled.BackOff.__enum__ = tink_streams_Handled;
tink_streams_Handled.Finish = ["Finish",1];
tink_streams_Handled.Finish.toString = $estr;
tink_streams_Handled.Finish.__enum__ = tink_streams_Handled;
tink_streams_Handled.Resume = ["Resume",2];
tink_streams_Handled.Resume.toString = $estr;
tink_streams_Handled.Resume.__enum__ = tink_streams_Handled;
tink_streams_Handled.Clog = function(e) { var $x = ["Clog",3,e]; $x.__enum__ = tink_streams_Handled; $x.toString = $estr; return $x; };
var tink_streams_Conclusion = $hxClasses["tink.streams.Conclusion"] = { __ename__ : ["tink","streams","Conclusion"], __constructs__ : ["Halted","Clogged","Failed","Depleted"] };
tink_streams_Conclusion.Halted = function(rest) { var $x = ["Halted",0,rest]; $x.__enum__ = tink_streams_Conclusion; $x.toString = $estr; return $x; };
tink_streams_Conclusion.Clogged = function(error,at) { var $x = ["Clogged",1,error,at]; $x.__enum__ = tink_streams_Conclusion; $x.toString = $estr; return $x; };
tink_streams_Conclusion.Failed = function(error) { var $x = ["Failed",2,error]; $x.__enum__ = tink_streams_Conclusion; $x.toString = $estr; return $x; };
tink_streams_Conclusion.Depleted = ["Depleted",3];
tink_streams_Conclusion.Depleted.toString = $estr;
tink_streams_Conclusion.Depleted.__enum__ = tink_streams_Conclusion;
var tink_streams_ReductionStep = $hxClasses["tink.streams.ReductionStep"] = { __ename__ : ["tink","streams","ReductionStep"], __constructs__ : ["Progress","Crash"] };
tink_streams_ReductionStep.Progress = function(result) { var $x = ["Progress",0,result]; $x.__enum__ = tink_streams_ReductionStep; $x.toString = $estr; return $x; };
tink_streams_ReductionStep.Crash = function(e) { var $x = ["Crash",1,e]; $x.__enum__ = tink_streams_ReductionStep; $x.toString = $estr; return $x; };
var tink_streams_Reduction = $hxClasses["tink.streams.Reduction"] = { __ename__ : ["tink","streams","Reduction"], __constructs__ : ["Crashed","Failed","Reduced"] };
tink_streams_Reduction.Crashed = function(error,at) { var $x = ["Crashed",0,error,at]; $x.__enum__ = tink_streams_Reduction; $x.toString = $estr; return $x; };
tink_streams_Reduction.Failed = function(error) { var $x = ["Failed",1,error]; $x.__enum__ = tink_streams_Reduction; $x.toString = $estr; return $x; };
tink_streams_Reduction.Reduced = function(result) { var $x = ["Reduced",2,result]; $x.__enum__ = tink_streams_Reduction; $x.toString = $estr; return $x; };
var tink_streams__$Stream_CloggedStream = function(rest,error) {
	tink_streams_StreamBase.call(this);
	this.rest = rest;
	this.error = error;
};
$hxClasses["tink.streams._Stream.CloggedStream"] = tink_streams__$Stream_CloggedStream;
tink_streams__$Stream_CloggedStream.__name__ = ["tink","streams","_Stream","CloggedStream"];
tink_streams__$Stream_CloggedStream.__super__ = tink_streams_StreamBase;
tink_streams__$Stream_CloggedStream.prototype = $extend(tink_streams_StreamBase.prototype,{
	forEach: function(handler) {
		return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_streams_Conclusion.Clogged(this.error,this.rest)));
	}
	,__class__: tink_streams__$Stream_CloggedStream
});
var tink_streams__$Stream_ErrorStream = function(error) {
	tink_streams_StreamBase.call(this);
	this.error = error;
};
$hxClasses["tink.streams._Stream.ErrorStream"] = tink_streams__$Stream_ErrorStream;
tink_streams__$Stream_ErrorStream.__name__ = ["tink","streams","_Stream","ErrorStream"];
tink_streams__$Stream_ErrorStream.__super__ = tink_streams_StreamBase;
tink_streams__$Stream_ErrorStream.prototype = $extend(tink_streams_StreamBase.prototype,{
	forEach: function(handler) {
		return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_streams_Conclusion.Failed(this.error)));
	}
	,__class__: tink_streams__$Stream_ErrorStream
});
var tink_streams__$Stream_Filter_$Impl_$ = {};
$hxClasses["tink.streams._Stream.Filter_Impl_"] = tink_streams__$Stream_Filter_$Impl_$;
tink_streams__$Stream_Filter_$Impl_$.__name__ = ["tink","streams","_Stream","Filter_Impl_"];
tink_streams__$Stream_Filter_$Impl_$.ofPlain = function(f) {
	var this1 = { apply : function(i,_) {
		return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_streams_RegroupResult.Converted(f(i[0]) ? tink_streams__$Stream_Stream_$Impl_$.single(i[0]) : tink_streams_Empty.inst)));
	}};
	return this1;
};
var tink_streams_Single = function(value) {
	tink_streams_StreamBase.call(this);
	this.value = value;
};
$hxClasses["tink.streams.Single"] = tink_streams_Single;
tink_streams_Single.__name__ = ["tink","streams","Single"];
tink_streams_Single.__super__ = tink_streams_StreamBase;
tink_streams_Single.prototype = $extend(tink_streams_StreamBase.prototype,{
	forEach: function(handle) {
		var _gthis = this;
		var ret = handle(this.value.get()).map(function(step) {
			switch(step[1]) {
			case 0:
				return tink_streams_Conclusion.Halted(_gthis);
			case 1:
				return tink_streams_Conclusion.Halted(tink_streams_Empty.inst);
			case 2:
				return tink_streams_Conclusion.Depleted;
			case 3:
				var e = step[2];
				return tink_streams_Conclusion.Clogged(e,_gthis);
			}
		});
		return ret.gather();
	}
	,__class__: tink_streams_Single
});
var tink_streams__$Stream_Handler_$Impl_$ = {};
$hxClasses["tink.streams._Stream.Handler_Impl_"] = tink_streams__$Stream_Handler_$Impl_$;
tink_streams__$Stream_Handler_$Impl_$.__name__ = ["tink","streams","_Stream","Handler_Impl_"];
tink_streams__$Stream_Handler_$Impl_$.ofSafe = function(f) {
	var this1 = f;
	return this1;
};
tink_streams__$Stream_Handler_$Impl_$.ofUnknown = function(f) {
	var this1 = f;
	return this1;
};
var tink_streams__$Stream_Reducer_$Impl_$ = {};
$hxClasses["tink.streams._Stream.Reducer_Impl_"] = tink_streams__$Stream_Reducer_$Impl_$;
tink_streams__$Stream_Reducer_$Impl_$.__name__ = ["tink","streams","_Stream","Reducer_Impl_"];
tink_streams__$Stream_Reducer_$Impl_$.ofSafe = function(f) {
	var this1 = f;
	return this1;
};
var tink_streams_FutureStream = function(f) {
	tink_streams_StreamBase.call(this);
	this.f = f;
};
$hxClasses["tink.streams.FutureStream"] = tink_streams_FutureStream;
tink_streams_FutureStream.__name__ = ["tink","streams","FutureStream"];
tink_streams_FutureStream.__super__ = tink_streams_StreamBase;
tink_streams_FutureStream.prototype = $extend(tink_streams_StreamBase.prototype,{
	forEach: function(handler) {
		var _gthis = this;
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			_gthis.f.handle(function(s) {
				s.forEach(handler).handle(cb);
			});
		});
	}
	,__class__: tink_streams_FutureStream
});
var tink_streams_Step = $hxClasses["tink.streams.Step"] = { __ename__ : ["tink","streams","Step"], __constructs__ : ["Link","Fail","End"] };
tink_streams_Step.Link = function(value,next) { var $x = ["Link",0,value,next]; $x.__enum__ = tink_streams_Step; $x.toString = $estr; return $x; };
tink_streams_Step.Fail = function(e) { var $x = ["Fail",1,e]; $x.__enum__ = tink_streams_Step; $x.toString = $estr; return $x; };
tink_streams_Step.End = ["End",2];
tink_streams_Step.End.toString = $estr;
tink_streams_Step.End.__enum__ = tink_streams_Step;
var tink_url__$Path_Path_$Impl_$ = {};
$hxClasses["tink.url._Path.Path_Impl_"] = tink_url__$Path_Path_$Impl_$;
tink_url__$Path_Path_$Impl_$.__name__ = ["tink","url","_Path","Path_Impl_"];
tink_url__$Path_Path_$Impl_$.parts = function(this1) {
	var _g = [];
	var _g1 = 0;
	var _g2 = this1.split("/");
	while(_g1 < _g2.length) {
		var p = _g2[_g1];
		++_g1;
		if(p != "") {
			var this2 = p;
			_g.push(this2);
		}
	}
	return _g;
};
tink_url__$Path_Path_$Impl_$.join = function(this1,that) {
	if(that == "") {
		return this1;
	} else if(that.charAt(0) == "/") {
		return that;
	} else if(this1.charAt(this1.length - 1) == "/") {
		return tink_url__$Path_Path_$Impl_$.ofString(this1 + that);
	} else {
		var _g = this1.lastIndexOf("/");
		if(_g == -1) {
			return that;
		} else {
			var v = _g;
			return tink_url__$Path_Path_$Impl_$.ofString(HxOverrides.substr(this1,0,v + 1) + that);
		}
	}
};
tink_url__$Path_Path_$Impl_$.ofString = function(s) {
	var this1 = tink_url__$Path_Path_$Impl_$.normalize(s);
	return this1;
};
tink_url__$Path_Path_$Impl_$.normalize = function(s) {
	s = StringTools.trim(StringTools.replace(s,"\\","/"));
	if(s == ".") {
		return "./";
	}
	var isDir = StringTools.endsWith(s,"/..") || StringTools.endsWith(s,"/") || StringTools.endsWith(s,"/.");
	var parts = [];
	var isAbsolute = StringTools.startsWith(s,"/");
	var up = 0;
	var _g = 0;
	var _g1 = s.split("/");
	while(_g < _g1.length) {
		var part = _g1[_g];
		++_g;
		var _g2 = StringTools.trim(part);
		switch(_g2) {
		case "":
			break;
		case ".":
			break;
		case "..":
			if(parts.pop() == null) {
				++up;
			}
			break;
		default:
			var v = _g2;
			parts.push(v);
		}
	}
	if(isAbsolute) {
		parts.unshift("");
	} else {
		var _g11 = 0;
		var _g3 = up;
		while(_g11 < _g3) {
			var i = _g11++;
			parts.unshift("..");
		}
	}
	if(isDir) {
		parts.push("");
	}
	return parts.join("/");
};
var tink_url__$Portion_Portion_$Impl_$ = {};
$hxClasses["tink.url._Portion.Portion_Impl_"] = tink_url__$Portion_Portion_$Impl_$;
tink_url__$Portion_Portion_$Impl_$.__name__ = ["tink","url","_Portion","Portion_Impl_"];
tink_url__$Portion_Portion_$Impl_$.stringly = function(this1) {
	return tink_url__$Portion_Portion_$Impl_$.toString(this1);
};
tink_url__$Portion_Portion_$Impl_$.toString = function(this1) {
	if(this1 == null) {
		return null;
	} else {
		return decodeURIComponent(this1.split("+").join(" "));
	}
};
tink_url__$Portion_Portion_$Impl_$.ofString = function(s) {
	var this1 = s == null ? "" : encodeURIComponent(s);
	return this1;
};
var tink_url__$PortionArray_PortionArray_$Impl_$ = {};
$hxClasses["tink.url._PortionArray.PortionArray_Impl_"] = tink_url__$PortionArray_PortionArray_$Impl_$;
tink_url__$PortionArray_PortionArray_$Impl_$.__name__ = ["tink","url","_PortionArray","PortionArray_Impl_"];
tink_url__$PortionArray_PortionArray_$Impl_$.toStringArray = function(this1) {
	var _g = [];
	var _g1 = 0;
	while(_g1 < this1.length) {
		var p = this1[_g1];
		++_g1;
		_g.push(tink_url__$Portion_Portion_$Impl_$.toString(p));
	}
	return _g;
};
var tink_url__$Query_Query_$Impl_$ = {};
$hxClasses["tink.url._Query.Query_Impl_"] = tink_url__$Query_Query_$Impl_$;
tink_url__$Query_Query_$Impl_$.__name__ = ["tink","url","_Query","Query_Impl_"];
tink_url__$Query_Query_$Impl_$.toMap = function(this1) {
	var _g = new haxe_ds_StringMap();
	var p = new tink_url__$Query_QueryStringParser(this1,"&","=",0);
	while(p.hasNext()) {
		var p1 = p.next();
		var key = p1.name.toString();
		var value = p1.value;
		if(__map_reserved[key] != null) {
			_g.setReserved(key,value);
		} else {
			_g.h[key] = value;
		}
	}
	return _g;
};
tink_url__$Query_Query_$Impl_$.ofObj = function(v) {
	var this1 = [];
	var ret = this1;
	var v1 = v;
	var _g = 0;
	var _g1 = Reflect.fields(v1);
	while(_g < _g1.length) {
		var k = _g1[_g];
		++_g;
		ret.push(tink_url__$Portion_Portion_$Impl_$.ofString(k) + "=" + tink_url__$Portion_Portion_$Impl_$.ofString(v1[k]));
	}
	return ret.join("&");
};
var tink_url__$Query_QueryStringParser = function(s,sep,set,pos) {
	this.s = s == null ? "" : s;
	this.sep = sep;
	this.set = set;
	this.pos = pos;
};
$hxClasses["tink.url._Query.QueryStringParser"] = tink_url__$Query_QueryStringParser;
tink_url__$Query_QueryStringParser.__name__ = ["tink","url","_Query","QueryStringParser"];
tink_url__$Query_QueryStringParser.trimmedSub = function(s,start,end) {
	if(start >= s.length) {
		var this1 = "";
		return this1;
	}
	while(s.charCodeAt(start) < 33) ++start;
	if(end < s.length - 1) {
		while(s.charCodeAt(end - 1) < 33) --end;
	}
	var this2 = s.substring(start,end);
	return this2;
};
tink_url__$Query_QueryStringParser.prototype = {
	hasNext: function() {
		return this.pos < this.s.length;
	}
	,next: function() {
		var next = this.s.indexOf(this.sep,this.pos);
		if(next == -1) {
			next = this.s.length;
		}
		var split = this.s.indexOf(this.set,this.pos);
		var start = this.pos;
		this.pos = next + this.sep.length;
		if(split == -1 || split > next) {
			return new tink_core_NamedWith(tink_url__$Portion_Portion_$Impl_$.stringly(tink_url__$Query_QueryStringParser.trimmedSub(this.s,start,next)),tink_url__$Portion_Portion_$Impl_$.ofString(""));
		} else {
			return new tink_core_NamedWith(tink_url__$Portion_Portion_$Impl_$.stringly(tink_url__$Query_QueryStringParser.trimmedSub(this.s,start,split)),tink_url__$Query_QueryStringParser.trimmedSub(this.s,split + this.set.length,next));
		}
	}
	,__class__: tink_url__$Query_QueryStringParser
};
var tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$ = {};
$hxClasses["tink.web.proxy._Remote.RemoteEndpoint_Impl_"] = tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$;
tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.__name__ = ["tink","web","proxy","_Remote","RemoteEndpoint_Impl_"];
tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$._new = function(host) {
	var this1 = { host : host};
	return this1;
};
tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.concat = function(a,b) {
	if(a == null) {
		var r = b;
		return r;
	} else if(b == null) {
		var r1 = a;
		return r1;
	} else {
		return a.concat(b);
	}
};
tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub = function(this1,options) {
	return { host : this1.host, headers : tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.concat(this1.headers,options.headers), query : tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.concat(this1.query,options.query), path : tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.concat(this1.path,options.path)};
};
tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.uri = function(this1) {
	var _g = this1.path;
	var tmp;
	if(_g == null) {
		tmp = "";
	} else {
		var v = _g;
		tmp = tink_url__$Path_Path_$Impl_$.normalize(v.join("/"));
	}
	return "/" + tmp + tink_web_proxy__$Remote_QueryParams_$Impl_$.toString(this1.query);
};
tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.request = function(this1,client,method,body,reader) {
	return tink_core__$Promise_Promise_$Impl_$.next(client.request(new tink_http_OutgoingRequest(new tink_http_OutgoingRequestHeader(method,tink__$Url_Url_$Impl_$.fromString("//" + this1.host + tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.uri(this1)),null,this1.headers),body)),function(response) {
		return (tink_web_proxy__$Remote_ResponseReader_$Impl_$.withHeader(reader,response.header))(response.body);
	});
};
var tink_web_proxy__$Remote_ResponseReader_$Impl_$ = {};
$hxClasses["tink.web.proxy._Remote.ResponseReader_Impl_"] = tink_web_proxy__$Remote_ResponseReader_$Impl_$;
tink_web_proxy__$Remote_ResponseReader_$Impl_$.__name__ = ["tink","web","proxy","_Remote","ResponseReader_Impl_"];
tink_web_proxy__$Remote_ResponseReader_$Impl_$.withHeader = function(this1,header) {
	var f = this1;
	var a1 = header;
	return function(a2) {
		return f(a1,a2);
	};
};
tink_web_proxy__$Remote_ResponseReader_$Impl_$.ofStringReader = function(read) {
	return function(header,body) {
		return tink_core__$Promise_Promise_$Impl_$.next(tink_io_RealSourceTools.all(body),function(chunk) {
			if(header.statusCode >= 400) {
				return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(tink_core_Outcome.Failure(tink_core_TypedError.withData(header.statusCode,header.reason,chunk.toString(),{ fileName : "tink/web/proxy/Remote.hx", lineNumber : 75, className : "tink.web.proxy._Remote.ResponseReader_Impl_", methodName : "ofStringReader"}))));
			} else {
				var o = chunk.toString();
				return new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(read(o)));
			}
		});
	};
};
var tink_web_proxy__$Remote_QueryParams_$Impl_$ = {};
$hxClasses["tink.web.proxy._Remote.QueryParams_Impl_"] = tink_web_proxy__$Remote_QueryParams_$Impl_$;
tink_web_proxy__$Remote_QueryParams_$Impl_$.__name__ = ["tink","web","proxy","_Remote","QueryParams_Impl_"];
tink_web_proxy__$Remote_QueryParams_$Impl_$.toString = function(this1) {
	if(this1 == null) {
		return "";
	} else if(this1.length == 0) {
		return "";
	} else {
		var this2 = [];
		var ret = this2;
		var _g = 0;
		while(_g < this1.length) {
			var p = this1[_g];
			++_g;
			ret.push(p.name + "=" + p.value);
		}
		return "?" + ret.join("&");
	}
};
var tink_web_proxy_RemoteBase = function(client,endpoint) {
	this.client = client;
	this.endpoint = endpoint;
};
$hxClasses["tink.web.proxy.RemoteBase"] = tink_web_proxy_RemoteBase;
tink_web_proxy_RemoteBase.__name__ = ["tink","web","proxy","RemoteBase"];
tink_web_proxy_RemoteBase.prototype = {
	__class__: tink_web_proxy_RemoteBase
};
var tink_web_proxy_Remote0 = function(client,endpoint) {
	tink_web_proxy_RemoteBase.call(this,client,endpoint);
};
$hxClasses["tink.web.proxy.Remote0"] = tink_web_proxy_Remote0;
tink_web_proxy_Remote0.__name__ = ["tink","web","proxy","Remote0"];
tink_web_proxy_Remote0.__super__ = tink_web_proxy_RemoteBase;
tink_web_proxy_Remote0.prototype = $extend(tink_web_proxy_RemoteBase.prototype,{
	owners: function() {
		var this1 = "owners";
		return new tink_web_proxy_Remote1(this.client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [this1], query : []}));
	}
	,projects: function() {
		var this1 = "projects";
		return new tink_web_proxy_Remote8(this.client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [this1], query : []}));
	}
	,me: function() {
		var this1 = "me";
		return new tink_web_proxy_Remote7(this.client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [this1], query : []}));
	}
	,__class__: tink_web_proxy_Remote0
});
var tink_web_proxy_Remote1 = function(client,endpoint) {
	tink_web_proxy_RemoteBase.call(this,client,endpoint);
};
$hxClasses["tink.web.proxy.Remote1"] = tink_web_proxy_Remote1;
tink_web_proxy_Remote1.__name__ = ["tink","web","proxy","Remote1"];
tink_web_proxy_Remote1.__super__ = tink_web_proxy_RemoteBase;
tink_web_proxy_Remote1.prototype = $extend(tink_web_proxy_RemoteBase.prototype,{
	create: function(name) {
		var __body__ = tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(new tink_json_Writer4().write({ name : name})));
		return tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.request(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [], query : []}),{ headers : [new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString("content-type"),"application/json"),new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString("content-length"),tink_http__$Header_HeaderValue_$Impl_$.ofInt(__body__.getLength()))]}),this.client,"POST",new tink_streams_Single(new tink_core__$Lazy_LazyConst(__body__)),tink_web_proxy__$Remote_ResponseReader_$Impl_$.ofStringReader(($_=new tink_json_Parser5(),$bind($_,$_.tryParse))));
	}
	,byName: function(name) {
		return new tink_web_proxy_Remote2(this.client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [tink_url__$Portion_Portion_$Impl_$.ofString(name)], query : []}));
	}
	,__class__: tink_web_proxy_Remote1
});
var tink_web_proxy_Remote2 = function(client,endpoint) {
	tink_web_proxy_RemoteBase.call(this,client,endpoint);
};
$hxClasses["tink.web.proxy.Remote2"] = tink_web_proxy_Remote2;
tink_web_proxy_Remote2.__name__ = ["tink","web","proxy","Remote2"];
tink_web_proxy_Remote2.__super__ = tink_web_proxy_RemoteBase;
tink_web_proxy_Remote2.prototype = $extend(tink_web_proxy_RemoteBase.prototype,{
	projects: function() {
		var this1 = "projects";
		return new tink_web_proxy_Remote3(this.client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [this1], query : []}));
	}
	,__class__: tink_web_proxy_Remote2
});
var tink_web_proxy_Remote3 = function(client,endpoint) {
	tink_web_proxy_RemoteBase.call(this,client,endpoint);
};
$hxClasses["tink.web.proxy.Remote3"] = tink_web_proxy_Remote3;
tink_web_proxy_Remote3.__name__ = ["tink","web","proxy","Remote3"];
tink_web_proxy_Remote3.__super__ = tink_web_proxy_RemoteBase;
tink_web_proxy_Remote3.prototype = $extend(tink_web_proxy_RemoteBase.prototype,{
	create: function(data) {
		var __body__ = tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(new tink_json_Writer2().write(data)));
		return tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.request(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [], query : []}),{ headers : [new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString("content-type"),"application/json"),new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString("content-length"),tink_http__$Header_HeaderValue_$Impl_$.ofInt(__body__.getLength()))]}),this.client,"POST",new tink_streams_Single(new tink_core__$Lazy_LazyConst(__body__)),tink_web_proxy__$Remote_ResponseReader_$Impl_$.ofStringReader(($_=new tink_json_Parser4(),$bind($_,$_.tryParse))));
	}
	,byName: function(name) {
		return new tink_web_proxy_Remote4(this.client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [tink_url__$Portion_Portion_$Impl_$.ofString(name)], query : []}));
	}
	,__class__: tink_web_proxy_Remote3
});
var tink_web_proxy_Remote4 = function(client,endpoint) {
	tink_web_proxy_RemoteBase.call(this,client,endpoint);
};
$hxClasses["tink.web.proxy.Remote4"] = tink_web_proxy_Remote4;
tink_web_proxy_Remote4.__name__ = ["tink","web","proxy","Remote4"];
tink_web_proxy_Remote4.__super__ = tink_web_proxy_RemoteBase;
tink_web_proxy_Remote4.prototype = $extend(tink_web_proxy_RemoteBase.prototype,{
	info: function() {
		var __body__ = tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(""));
		return tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.request(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [], query : []}),this.client,"GET",new tink_streams_Single(new tink_core__$Lazy_LazyConst(__body__)),tink_web_proxy__$Remote_ResponseReader_$Impl_$.ofStringReader(($_=new tink_json_Parser4(),$bind($_,$_.tryParse))));
	}
	,versions: function() {
		var this1 = "versions";
		return new tink_web_proxy_Remote5(this.client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [this1], query : []}));
	}
	,__class__: tink_web_proxy_Remote4
});
var tink_web_proxy_Remote5 = function(client,endpoint) {
	tink_web_proxy_RemoteBase.call(this,client,endpoint);
};
$hxClasses["tink.web.proxy.Remote5"] = tink_web_proxy_Remote5;
tink_web_proxy_Remote5.__name__ = ["tink","web","proxy","Remote5"];
tink_web_proxy_Remote5.__super__ = tink_web_proxy_RemoteBase;
tink_web_proxy_Remote5.prototype = $extend(tink_web_proxy_RemoteBase.prototype,{
	create: function(body) {
		var __body__ = tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(new tink_json_Writer3().write(body)));
		return tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.request(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [], query : []}),{ headers : [new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString("content-type"),"application/json"),new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString("content-length"),tink_http__$Header_HeaderValue_$Impl_$.ofInt(__body__.getLength()))]}),this.client,"POST",new tink_streams_Single(new tink_core__$Lazy_LazyConst(__body__)),tink_web_proxy__$Remote_ResponseReader_$Impl_$.ofStringReader(($_=new tink_json_Parser0(),$bind($_,$_.tryParse))));
	}
	,latest: function() {
		var this1 = "latest";
		return new tink_web_proxy_Remote6(this.client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [this1], query : []}));
	}
	,byVersion: function(version) {
		return new tink_web_proxy_Remote6(this.client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [tink_url__$Portion_Portion_$Impl_$.ofString(version.toString())], query : []}));
	}
	,__class__: tink_web_proxy_Remote5
});
var tink_web_proxy_Remote6 = function(client,endpoint) {
	tink_web_proxy_RemoteBase.call(this,client,endpoint);
};
$hxClasses["tink.web.proxy.Remote6"] = tink_web_proxy_Remote6;
tink_web_proxy_Remote6.__name__ = ["tink","web","proxy","Remote6"];
tink_web_proxy_Remote6.__super__ = tink_web_proxy_RemoteBase;
tink_web_proxy_Remote6.prototype = $extend(tink_web_proxy_RemoteBase.prototype,{
	get: function() {
		var __body__ = tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(""));
		return tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.request(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [], query : []}),this.client,"GET",new tink_streams_Single(new tink_core__$Lazy_LazyConst(__body__)),tink_web_proxy__$Remote_ResponseReader_$Impl_$.ofStringReader(($_=new tink_json_Parser0(),$bind($_,$_.tryParse))));
	}
	,download: function() {
		var __body__ = tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(""));
		var this1 = "archive";
		return tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.request(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [this1], query : []}),this.client,"GET",new tink_streams_Single(new tink_core__$Lazy_LazyConst(__body__)),tink_web_proxy__$Remote_ResponseReader_$Impl_$.ofStringReader(($_=new tink_json_Parser1(),$bind($_,$_.tryParse))));
	}
	,upload: function() {
		var __body__ = tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(""));
		var this1 = "archive";
		return tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.request(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [this1], query : []}),this.client,"PUT",new tink_streams_Single(new tink_core__$Lazy_LazyConst(__body__)),tink_web_proxy__$Remote_ResponseReader_$Impl_$.ofStringReader(($_=new tink_json_Parser1(),$bind($_,$_.tryParse))));
	}
	,__class__: tink_web_proxy_Remote6
});
var tink_web_proxy_Remote7 = function(client,endpoint) {
	tink_web_proxy_RemoteBase.call(this,client,endpoint);
};
$hxClasses["tink.web.proxy.Remote7"] = tink_web_proxy_Remote7;
tink_web_proxy_Remote7.__name__ = ["tink","web","proxy","Remote7"];
tink_web_proxy_Remote7.__super__ = tink_web_proxy_RemoteBase;
tink_web_proxy_Remote7.prototype = $extend(tink_web_proxy_RemoteBase.prototype,{
	get: function() {
		var __body__ = tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(""));
		return tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.request(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [], query : []}),this.client,"GET",new tink_streams_Single(new tink_core__$Lazy_LazyConst(__body__)),tink_web_proxy__$Remote_ResponseReader_$Impl_$.ofStringReader(($_=new tink_json_Parser2(),$bind($_,$_.tryParse))));
	}
	,update: function(body) {
		var __body__ = tink__$Chunk_Chunk_$Impl_$.ofBytes(haxe_io_Bytes.ofString(new tink_json_Writer1().write(body)));
		return tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.request(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [], query : []}),{ headers : [new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString("content-type"),"application/json"),new tink_http_HeaderField(tink_http__$Header_HeaderName_$Impl_$.ofString("content-length"),tink_http__$Header_HeaderValue_$Impl_$.ofInt(__body__.getLength()))]}),this.client,"PATCH",new tink_streams_Single(new tink_core__$Lazy_LazyConst(__body__)),tink_web_proxy__$Remote_ResponseReader_$Impl_$.ofStringReader(($_=new tink_json_Parser2(),$bind($_,$_.tryParse))));
	}
	,__class__: tink_web_proxy_Remote7
});
var tink_web_proxy_Remote8 = function(client,endpoint) {
	tink_web_proxy_RemoteBase.call(this,client,endpoint);
};
$hxClasses["tink.web.proxy.Remote8"] = tink_web_proxy_Remote8;
tink_web_proxy_Remote8.__name__ = ["tink","web","proxy","Remote8"];
tink_web_proxy_Remote8.__super__ = tink_web_proxy_RemoteBase;
tink_web_proxy_Remote8.prototype = $extend(tink_web_proxy_RemoteBase.prototype,{
	byId: function(id) {
		return new tink_web_proxy_Remote4(this.client,tink_web_proxy__$Remote_RemoteEndpoint_$Impl_$.sub(this.endpoint,{ path : [tink_url__$Portion_Portion_$Impl_$.ofString(id)], query : []}));
	}
	,__class__: tink_web_proxy_Remote8
});
var tink_web_routing_Context = function(parent,accepts,request,depth,parts,params) {
	this.parent = parent;
	this.accepts = accepts;
	this.request = request;
	this.depth = depth;
	this.parts = parts;
	this.params = params;
};
$hxClasses["tink.web.routing.Context"] = tink_web_routing_Context;
tink_web_routing_Context.__name__ = ["tink","web","routing","Context"];
tink_web_routing_Context.ofRequest = function(request) {
	return new tink_web_routing_Context(null,tink_web_routing_Context.parseAcceptHeader(request.header),request,0,tink_url__$Path_Path_$Impl_$.parts(request.header.url.path),tink_url__$Query_Query_$Impl_$.toMap(request.header.url.query));
};
tink_web_routing_Context.parseAcceptHeader = function(h) {
	var _g = h.get("accept");
	if(_g.length == 0) {
		return tink_web_routing_Context.acceptsAll;
	} else {
		var values = _g;
		var _g1 = new haxe_ds_StringMap();
		var _g11 = 0;
		while(_g11 < values.length) {
			var v = values[_g11];
			++_g11;
			var _g2 = 0;
			var _g3 = tink_http__$Header_HeaderValue_$Impl_$.parse(v);
			while(_g2 < _g3.length) {
				var part = _g3[_g2];
				++_g2;
				var key = part.value;
				if(__map_reserved[key] != null) {
					_g1.setReserved(key,true);
				} else {
					_g1.h[key] = true;
				}
			}
		}
		var accepted = _g1;
		if(__map_reserved["*/*"] != null ? accepted.getReserved("*/*") : accepted.h["*/*"]) {
			return tink_web_routing_Context.acceptsAll;
		} else {
			return function(t) {
				if(__map_reserved[t] != null) {
					return accepted.existsReserved(t);
				} else {
					return accepted.h.hasOwnProperty(t);
				}
			};
		}
	}
};
tink_web_routing_Context.acceptsAll = function(s) {
	return true;
};
tink_web_routing_Context.prototype = {
	part: function(index) {
		if(this.depth + index >= this.parts.length) {
			return "";
		} else {
			return tink_url__$Portion_Portion_$Impl_$.stringly(this.parts[this.depth + index]);
		}
	}
	,__class__: tink_web_routing_Context
};
var tink_web_routing__$Response_Response_$Impl_$ = {};
$hxClasses["tink.web.routing._Response.Response_Impl_"] = tink_web_routing__$Response_Response_$Impl_$;
tink_web_routing__$Response_Response_$Impl_$.__name__ = ["tink","web","routing","_Response","Response_Impl_"];
tink_web_routing__$Response_Response_$Impl_$.binary = function(code,contentType,bytes) {
	return tink_http__$Response_OutgoingResponse_$Impl_$.blob(code,tink_chunk_ByteChunk.of(bytes),contentType);
};
tink_web_routing__$Response_Response_$Impl_$.empty = function(code) {
	if(code == null) {
		code = 200;
	}
	var this1 = httpstatus__$HttpStatusMessage_HttpStatusMessage_$Impl_$.fromCode(code);
	var this2 = new tink_http_ResponseHeaderBase(code,this1,[new tink_http_HeaderField("content-length","0")],"HTTP/1.1");
	var this3 = new tink_http__$Response_OutgoingResponseData(this2,new tink_streams_Single(new tink_core__$Lazy_LazyConst(tink__$Chunk_Chunk_$Impl_$.EMPTY)));
	return this3;
};
tink_web_routing__$Response_Response_$Impl_$.textual = function(code,contentType,string) {
	return tink_web_routing__$Response_Response_$Impl_$.binary(code,contentType,haxe_io_Bytes.ofString(string));
};
var tink_web_routing_Router0 = function(target) {
	this.target = target;
};
$hxClasses["tink.web.routing.Router0"] = tink_web_routing_Router0;
tink_web_routing_Router0.__name__ = ["tink","web","routing","Router0"];
tink_web_routing_Router0.prototype = {
	route: function(ctx) {
		var l = ctx.parts.length - ctx.depth;
		var _g = l > 1;
		var _g1 = l > 0;
		var _g2 = ctx.part(0);
		var _g3 = ctx.request.header.method;
		if(_g3 == "GET") {
			switch(_g2) {
			case "callback":
				if(_g1 == true) {
					if(_g == false) {
						return tink_core__$Promise_Promise_$Impl_$.ofSpecific(this.callback(ctx));
					} else {
						var this1 = ctx.request.header.url;
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"Not Found: [" + ctx.request.header.method + "] " + (this1.query == null ? this1.path : this1.path + "?" + this1.query),{ fileName : "lix/Auth.hx", lineNumber : 29, className : "tink.web.routing.Router0", methodName : "route"})));
					}
				} else {
					var this2 = ctx.request.header.url;
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"Not Found: [" + ctx.request.header.method + "] " + (this2.query == null ? this2.path : this2.path + "?" + this2.query),{ fileName : "lix/Auth.hx", lineNumber : 29, className : "tink.web.routing.Router0", methodName : "route"})));
				}
				break;
			case "done":
				if(_g1 == true) {
					if(_g == false) {
						return tink_core__$Promise_Promise_$Impl_$.ofSpecific(this.done(ctx));
					} else {
						var this3 = ctx.request.header.url;
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"Not Found: [" + ctx.request.header.method + "] " + (this3.query == null ? this3.path : this3.path + "?" + this3.query),{ fileName : "lix/Auth.hx", lineNumber : 29, className : "tink.web.routing.Router0", methodName : "route"})));
					}
				} else {
					var this4 = ctx.request.header.url;
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"Not Found: [" + ctx.request.header.method + "] " + (this4.query == null ? this4.path : this4.path + "?" + this4.query),{ fileName : "lix/Auth.hx", lineNumber : 29, className : "tink.web.routing.Router0", methodName : "route"})));
				}
				break;
			default:
				var this5 = ctx.request.header.url;
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"Not Found: [" + ctx.request.header.method + "] " + (this5.query == null ? this5.path : this5.path + "?" + this5.query),{ fileName : "lix/Auth.hx", lineNumber : 29, className : "tink.web.routing.Router0", methodName : "route"})));
			}
		} else {
			var this6 = ctx.request.header.url;
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"Not Found: [" + ctx.request.header.method + "] " + (this6.query == null ? this6.path : this6.path + "?" + this6.query),{ fileName : "lix/Auth.hx", lineNumber : 29, className : "tink.web.routing.Router0", methodName : "route"})));
		}
	}
	,callback: function(ctx) {
		return tink_core__$Promise_Promise_$Impl_$.next(this.target.callback(),function(__data__) {
			if(ctx.accepts("text/html")) {
				return tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success("<script>window.location.href = window.location.href.replace(\"/callback#\",\"/done?\")</script>")),function(d) {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_web_routing__$Response_Response_$Impl_$.textual(null,"text/html",d)));
				});
			}
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_web_routing__$Response_Response_$Impl_$.empty()));
		});
	}
	,done: function(ctx) {
		var _gthis = this;
		return tink_core__$Promise_Promise_$Impl_$.next(new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(new tink_querystring_Parser0().tryParse(new tink_url__$Query_QueryStringParser(ctx.request.header.url.query,"&","=",0)))),function(query) {
			return tink_core__$Promise_Promise_$Impl_$.next(_gthis.target.done(query),function(__data__) {
				if(ctx.accepts("text/html")) {
					return tink_core__$Promise_Promise_$Impl_$.next(tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success("<script>window.close()</script>")),function(d) {
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_web_routing__$Response_Response_$Impl_$.textual(null,"text/html",d)));
					});
				}
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_web_routing__$Response_Response_$Impl_$.empty()));
			});
		});
	}
	,__class__: tink_web_routing_Router0
};
function $getIterator(o) { if( o instanceof Array ) return HxOverrides.iter(o); else return o.iterator(); }
var $_, $fid = 0;
function $bind(o,m) { if( m == null ) return null; if( m.__id__ == null ) m.__id__ = $fid++; var f; if( o.hx__closures__ == null ) o.hx__closures__ = {}; else f = o.hx__closures__[m.__id__]; if( f == null ) { f = m.bind(o); o.hx__closures__[m.__id__] = f; } return f; }
function $arrayPush(x) { this.push(x); }
$hxClasses["Math"] = Math;
String.prototype.__class__ = $hxClasses["String"] = String;
String.__name__ = ["String"];
$hxClasses["Array"] = Array;
Array.__name__ = ["Array"];
Date.prototype.__class__ = $hxClasses["Date"] = Date;
Date.__name__ = ["Date"];
var Int = { };
var Dynamic = { };
var Float = Number;
var Bool = Boolean;
var Class = { };
var Enum = { };
haxe_ds_ObjectMap.count = 0;
var __map_reserved = {};
Object.defineProperty(js__$Boot_HaxeError.prototype,"message",{ get : function() {
	return String(this.val);
}});
DateTools.DAY_SHORT_NAMES = ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"];
DateTools.DAY_NAMES = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
DateTools.MONTH_SHORT_NAMES = ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];
DateTools.MONTH_NAMES = ["January","February","March","April","May","June","July","August","September","October","November","December"];
StringTools.winMetaCharacters = [32,40,41,37,33,94,34,60,62,38,124,10,13,44,59];
haxe_Serializer.USE_CACHE = false;
haxe_Serializer.USE_ENUM_INDEX = false;
haxe_Serializer.BASE64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789%:";
haxe_Unserializer.DEFAULT_RESOLVER = new haxe__$Unserializer_DefaultResolver();
haxe_Unserializer.BASE64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789%:";
haxeshim_Os.IS_WINDOWS = Sys.systemName() == "Windows";
haxeshim_Os.DELIMITER = haxeshim_Os.IS_WINDOWS ? ";" : ":";
haxeshim_HaxeInstallation.EXT = haxeshim_Os.IS_WINDOWS ? ".exe" : "";
haxeshim_Scope.CONFIG_FILE = ".haxerc";
haxeshim_Scope.DEFAULT_ROOT = (function($this) {
	var $r;
	var o = haxeshim_Scope.env("HAXE_ROOT");
	var o1 = haxeshim_Scope.env("HAXESHIM_ROOT");
	var l = new tink_core__$Lazy_LazyConst(process.env[haxeshim_Os.IS_WINDOWS ? "APPDATA" : "HOME"] + "/haxe");
	var c;
	if(o1[1] == 0) {
		var v = o1[2];
		c = v;
	} else {
		c = l.get();
	}
	var l1 = new tink_core__$Lazy_LazyConst(c);
	$r = o[1] == 0 ? (function($this) {
		var $r;
		var v1 = o[2];
		$r = v1;
		return $r;
	}($this)) : l1.get();
	return $r;
}(this));
haxeshim_Neko.PATH = haxeshim_Os.slashes(haxeshim_Scope.DEFAULT_ROOT + "/neko");
haxeshim_Neko.isset = false;
haxeshim_Neko.ENV = (function($this) {
	var $r;
	var varName;
	var _g = Sys.systemName();
	switch(_g) {
	case "Mac":
		varName = "DYLD_LIBRARY_PATH";
		break;
	case "Windows":
		varName = "PATH";
		break;
	default:
		varName = "LD_LIBRARY_PATH";
	}
	var _g1 = process.env[varName];
	$r = _g1 == null ? (function($this) {
		var $r;
		var _g11 = new haxe_ds_StringMap();
		{
			var value = haxeshim_Neko.PATH;
			if(__map_reserved[varName] != null) {
				_g11.setReserved(varName,value);
			} else {
				_g11.h[varName] = value;
			}
		}
		$r = haxeshim__$Env_Env_$Impl_$.ofMap(_g11);
		return $r;
	}($this)) : (function($this) {
		var $r;
		var withNeko = _g1;
		$r = withNeko.indexOf(haxeshim_Neko.PATH) != -1 ? haxeshim__$Env_Env_$Impl_$.ofVars({ }) : (function($this) {
			var $r;
			var v = _g1;
			var _g12 = new haxe_ds_StringMap();
			{
				var value1 = v + haxeshim_Os.DELIMITER + haxeshim_Neko.PATH;
				if(__map_reserved[varName] != null) {
					_g12.setReserved(varName,value1);
				} else {
					_g12.h[varName] = value1;
				}
			}
			$r = haxeshim__$Env_Env_$Impl_$.ofMap(_g12);
			return $r;
		}($this));
		return $r;
	}($this));
	return $r;
}(this));
js_Boot.__toStr = ({ }).toString;
lix_client_DownloadedArchive.RESERVED = "!#$&'()*+,/:;=?@[]";
lix_client_Download.USER_AGENT = "switchx";
lix_client_LibVersion.UNDEFINED = new lix_client_LibVersion(haxe_ds_Option.None,haxe_ds_Option.None);
lix_client_haxe_Switcher.VERSION_INFO = "version.json";
lix_client_haxe_Switcher.NIGHTLIES = "http://hxbuilds.s3-website-us-east-1.amazonaws.com/builds/haxe";
lix_client_haxe_Switcher.PLATFORM = (function($this) {
	var $r;
	var _g = Sys.systemName();
	$r = (function($this) {
		var $r;
		switch(_g) {
		case "Mac":
			$r = "mac";
			break;
		case "Windows":
			$r = "windows";
			break;
		default:
			$r = "linux64";
		}
		return $r;
	}($this));
	return $r;
}(this));
lix_client_haxe__$UserVersion_UserVersion_$Impl_$.hex = (function($this) {
	var $r;
	var _g = new haxe_ds_IntMap();
	{
		var _g1 = 0;
		var _g2 = "0123456789abcdefABCDEF".split("");
		while(_g1 < _g2.length) {
			var c = _g2[_g1];
			++_g1;
			_g.h[HxOverrides.cca(c,0)] = true;
		}
	}
	$r = _g;
	return $r;
}(this));
lix_client_sources_Haxelib.OFFICIAL = "https://lib.haxe.org/";
lix_util_Config.API_SERVER_HOST = tink_url__$Host_Host_$Impl_$._new("api.lix.pm",null);
sys_io_File.copyBuf = new js_node_buffer_Buffer(65536);
tink__$Chunk_EmptyChunk.EMPTY = new haxe_io_Bytes(new ArrayBuffer(0));
tink__$Chunk_Chunk_$Impl_$.EMPTY = new tink__$Chunk_EmptyChunk();
tink_core__$Callback_Callback_$Impl_$.depth = 0;
tink_core__$Future_Future_$Impl_$.NULL = new tink_core__$Future_SyncFuture(new tink_core__$Lazy_LazyConst(null));
tink_http_Fetch.client = new haxe_ds_EnumValueMap();
tink_http_Fetch.sclient = new haxe_ds_EnumValueMap();
tink_streams_Empty.inst = new tink_streams_Empty();
tink_io__$Source_Source_$Impl_$.EMPTY = tink_streams_Empty.inst;
tink_io__$Worker_Worker_$Impl_$.EAGER = new tink_io__$Worker_EagerWorker();
tink_io__$Worker_Worker_$Impl_$.pool = [tink_io__$Worker_Worker_$Impl_$.EAGER];
tink_io_nodejs_WrappedBuffer.alloc = "allocUnsafe" in Buffer ? js_node_buffer_Buffer.allocUnsafe : function(size) {
	return new js_node_buffer_Buffer(size);
};
tink_parse_Char.WHITE = function(c) {
	return c < 33;
};
tink_parse_Char.LOWER = function(c) {
	if(c >= 97) {
		return c <= 122;
	} else {
		return false;
	}
};
tink_parse_Char.DIGIT = function(c) {
	if(c >= 48) {
		return c <= 57;
	} else {
		return false;
	}
};
tink_parse__$StringSlice_StringSlice_$Impl_$.CHARS = (function($this) {
	var $r;
	var _g = [];
	{
		var _g1 = 0;
		while(_g1 < 128) {
			var i = _g1++;
			_g.push(new tink_parse__$StringSlice_Data(String.fromCharCode(i),0,1));
		}
	}
	$r = _g;
	return $r;
}(this));
tink_parse__$StringSlice_StringSlice_$Impl_$.EMPTY = new tink_parse__$StringSlice_Data("",0,0);
tink_semver_Parser.OR = tink_parse__$StringSlice_StringSlice_$Impl_$.ofString("||");
tink_semver_Parser.DOT = tink_parse__$StringSlice_StringSlice_$Impl_$.ofString(".");
tink_semver_Parser.HYPHEN = tink_parse__$StringSlice_StringSlice_$Impl_$.ofString("-");
lix_cli_Cli.main();
})(typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this);
